<?php
/*
################################
#POSTGRESTATS ENTERPRISE LICENSE
################################
Copyright 2013 NWLYNX <http://www.nwlynx.com/>.

This file is part of PostgreStats Enterprise <http://www.postgrestats.com/>.

PostgreStats Enterprise is free software: you can redistribute it and/or modify it under the terms of the GNU General Public 
License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

PostgreStats Enterprise is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
*/

########################
#REQUIRE OUR AUTH SCRIPT
########################
require("scripts/ps_auth.php");
?>
<!doctype html>
<html>
<head>
<title>PostgreStats</title>
<link href="scripts/ps_styles.css" rel="stylesheet" type="text/css">
<script type="text/javascript" src="scripts/ps_scripts.js"></script>
</head>
<body>

<!-- ====================================== -->
<!-- PRIMARY POSTGRESTATS WRAPPER -->
<!-- ====================================== -->
<div class="postgrestats_wrapper" style="width:<?php echo $site_width;?>;">

<!-- ====================================== -->
<!-- TOP SECTION START -->
<!-- ====================================== -->
<div style="background-color:#000000; border-radius:10px 10px 0 0; -webkit-border-radius:10px 10px 0 0; -moz-border-radius:10px 10px 0 0; border:1px solid #999999;">
<div style="float:left; margin:20px 0 15px 30px;"><img src="images/postgrestats_logo.png" width="315" height="72"></div>
<div style="float:right; text-align:right; margin:20px 30px 0 0;">
<span class="grey_12">Version: <?php echo $ps_version; ?> | License: <?php echo $ps_license; ?></span><br>
<span class="grey_12"><a href="http://www.postgrestats.com/">PostgreStats</a> | &copy;Copyright <?php echo $ps_copyright; ?> <a href="http://www.nwlynx.com/" target="_blank">NWLYNX</a>.</span>
<div style="margin:8px 0 0 0;">
<div style="float:right;"><img src="images/<?php echo $ssl_status_img; ?>" width="25" height="25"></span></div>
<div class="grey_12" style="float:right; margin:5px 5px 0 0;">SSL Status: <span class="orange_12" style="font-weight:bold;"><?php echo $ssl_status; ?></span></div>
<div style="clear:both;"></div>
</div>
</div>
<div style="clear:both;"></div>
<div class="grey_13" style="padding:10px 30px 15px 30px; border-top:1px solid #333333;"><?php echo $ps_nav_admin?></div>
</div>

<!-- ====================================== -->
<!-- PRIMARY STAT VIEW NAVIGATION -->
<!-- ====================================== -->
<div class="grey_15" style="padding:20px 30px 20px 30px; font-weight:bold;"><?php echo $ps_nav?></div>

<!-- ====================================== -->
<!-- PRIMARY CONTENT AREA START -->
<!-- ====================================== -->
<div class="stat_td_bg">

<!-- ====================================== -->
<!-- ====================================== -->
<!-- WELCOME SCREEN -->
<!-- ====================================== -->
<!-- ====================================== -->
<div id="welcome" <?php if($postgrestats_db_verified != true) echo " style=\"display:none;\""; ?>>
<div class="header">Welcome to PostgreStats Enterprise<div class="grey_med_12" style="font-weight:normal;margin-top:4px;">Statistics collection and monitoring for PostgreSQL Multi-server Environments.</div></div>
<div style="padding-left:30px; width:430px;">
<div style="padding-top:30px;"><img src="images/bg_welcome.png" width="430" height="144"></div>
<div style="padding-top:5px;">PostgreStats Database Verified: <span class="orange_12" style="font-weight:bold;">Yes</span></div>
<div style="padding:5px 0 5px 0;"><hr class="hr_light_grey"></div>
<div>Statistics Exist: <span class="orange_12" style="font-weight:bold;"><?php if($stats_exist == true) echo "Yes"; else echo "No"; ?></span></div>
<div style="padding:5px 0 5px 0;"><hr class="hr_light_grey"></div>
<div>Server Count: <span class="orange_12" style="font-weight:bold;"><?php echo number_format($ps_server_count); ?></span></div>
<div style="padding:5px 0 5px 0;"><hr class="hr_light_grey"></div>
<div>Database Count: <span class="orange_12" style="font-weight:bold;"><?php echo number_format($ps_db_count); ?></span></div>
<div style="padding:5px 0 5px 0;"><hr class="hr_light_grey"></div>
<div>Core Statistics Count: <span class="orange_12" style="font-weight:bold;"><?php echo number_format($ps_core_count); ?></span></div>
</div>
</div>

<!-- ====================================== -->
<!-- ====================================== -->
<!-- MONTHLY SNAPSHOT -->
<!-- ====================================== -->
<!-- ====================================== -->
<div id="monthly_snapshot" style="display:none;">
<div class="header">Statistics > Monthly Snapshot<div class="grey_med_12" style="font-weight:normal;margin-top:4px;">Stats general information on all databases and compares data (+/-) to the same day on the previous month.</div></div>
<?php if($stats_exist == true) { ?><div id="monthly_snapshot_nav" class="header_options"><?php echo $nav_monthly ?></div><?php } ?>
<div id="monthly_snapshot_error" class="header_error" style="display:none;"></div>
<div id="monthly_snapshot_data" style="padding:30px; display:none;"></div>
</div>

<!-- ====================================== -->
<!-- ====================================== -->
<!-- DAILY -->
<!-- ====================================== -->
<!-- ====================================== -->
<div id="daily" style="display:none;">
<div class="header">Statistics > Daily Individual Databases<div class="grey_med_12" style="font-weight:normal;margin-top:4px;">Stats database specific activity and compares data (+/-) with the previous day.</div></div>
<?php if($stats_exist == true) { ?><div id="daily_nav" class="header_options"><?php echo $nav_daily ?></div><?php } ?>
<div id="daily_error" class="header_error" style="display:none;"></div>
<div id="daily_data" style="padding:30px; display:none;"></div>
</div>

<!-- ====================================== -->
<!-- ====================================== -->
<!-- MONTH VS MONTH -->
<!-- ====================================== -->
<!-- ====================================== -->
<div id="versus" style="display:none;">
<div class="header">Statistics > Month VS Month Comparison<div class="grey_med_12" style="font-weight:normal;margin-top:4px;">Stats database specific activity on two VS months side-by-side showing peak days and averages on each.</div></div>
<?php if($stats_exist == true) { ?><div id="versus_nav" class="header_options"><?php echo $nav_versus ?></div><?php } ?>
<div id="versus_error" class="header_error" style="display:none;"></div>
<div id="versus_data" style="padding:30px; display:none;"></div>
</div>

<!-- ====================================== -->
<!-- ====================================== -->
<!-- WEEKLY TRENDING -->
<!-- ====================================== -->
<!-- ====================================== -->
<div id="weekly" style="display:none;">
<div class="header">Statistics > Weekly Trending<div class="grey_med_12" style="font-weight:normal;margin-top:4px;">Stats general information on all databases and groups data by days of the week.</div></div>
<?php if($stats_exist == true) { ?><div id="weekly_nav" class="header_options"><?php echo $nav_weekly ?></div><?php } ?>
<div id="weekly_error" class="header_error" style="display:none;"></div>
<div id="weekly_data" style="padding:30px; display:none;"></div>
</div>

<!-- ====================================== -->
<!-- ====================================== -->
<!-- YEARLY TRENDING -->
<!-- ====================================== -->
<!-- ====================================== -->
<div id="yearly" style="display:none;">
<div class="header">Statistics > Yearly Snapshot<div class="grey_med_12" style="font-weight:normal;margin-top:4px;">Stats general information on all databases and groups data by months of the year.</div></div>
<?php if($stats_exist == true) { ?><div id="yearly_nav" class="header_options"><?php echo $nav_yearly ?></div><?php } ?>
<div id="yearly_error" class="header_error" style="display:none;"></div>
<div id="yearly_data" style="padding:30px; display:none;"></div>
</div>

<!-- ====================================== -->
<!-- ====================================== -->
<!-- VIEW_SETUP -->
<!-- ====================================== -->
<!-- ====================================== -->
<div id="view_setup" style="display:none">
<div class="header">PostgreStats Enterprise > Set-up<div class="grey_med_12" style="font-weight:normal;margin-top:4px;">PostgreStats Enterprise is installed in a few simple steps. Follow the 1-2-3 guide below.</div></div>
<div style="padding:30px;">

<!-- ====================================== -->
<!-- ====================================== -->
<!-- POSTGRESTATS DB CONNECTION MSG -->
<!-- ====================================== -->
<!-- ====================================== -->
<?php
if(!empty($ps_connect_status))
{
?>
<div class="ps_connect_status"><?php echo $ps_connect_status; ?></div>
<?php
}
?>

<!-- ======== -->
<!-- STEP ONE -->
<!-- ======== -->
<div class="setup_div">
<div class="orange_15" style="padding-bottom:5px; font-weight:bold;">1) Create the PostgreStats database.</div>
The PostgreStats database can be installed on whatever server you like. To create the database, enter below the existing PostgreSQL user who will be accessing the PostgreStats database. This will generate the script you'll use to create the PostgreStats database on that server.
<form action="javascript:gen_ps_create_script()" method="post">
<div style="margin:25px 0 0 0px; font-weight:bold;">
<div class="black_12" style="float:left; margin:4px 10px 0 0; text-align:right; width:125px;">PostgreSQL&nbsp;User:</div>
<div style="float:left;"><input class="text_box" type="text" name="ps_user" id="ps_user"></div>
<div style="float:left; margin:0 0 0 10px;"><input class="button_orange" type="submit" value="Generate DB Creation Script"></div>
<div style="clear:both;"></div>
</div>
</form>
<div id="script_gen_result" style="margin:15px 0 0 0; display:none;"></div>
</div>

<!-- ======== -->
<!-- STEP TWO -->
<!-- ======== -->
<div class="setup_div">
<div class="orange_15" style="padding-bottom:5px; font-weight:bold;">2) Update the PostgreStats ps_conf.php file and log-in.</div>
Once your PostgreStats database is created, open up ps_conf.php located in the scripts directory of your PostgreStats install. At the top, plug-in your PostgreStats database connect credentials (user, pass, and host). Note, this user should be the same user as you indicated above when creating your PostgreStats database.
</div>

<!-- ========== -->
<!-- STEP THREE -->
<!-- ========== -->
<div class="setup_div">
<div class="orange_15" style="padding-bottom:5px; font-weight:bold;">3) Log-in to PostgreStats.</div> 
The above script will create your PostgreStats Admin account. Once you've updated postgrestats.conf in step 2, you'll now be required to log-in to your PostgreStats site on page refresh.
<div class="black_12" style="margin:20px 0 0 0; font-weight:bold;">Your temporary username: <span style="color:#FF6633;">postgrestats</span><br>
Your temporary password: <span style="color:#FF6633;">password</span></div>
</div>

<!-- ========= -->
<!-- STEP FOUR -->
<!-- ========= -->
<div class="setup_div">
<div class="orange_15" style="padding-bottom:5px; font-weight:bold;">4) Insert server &amp; database configurations.</div> 
You can now use the Servers &amp; Databases interface to add new Servers &amp; Databases to PostgreStats. When you insert a new Server, you'll then be able to add that server's databases to it. PostgreStats will then update statistics for each database on each server, each time statistics are updated VIA Cron (below).
</div>

<!-- ========= -->
<!-- STEP FIVE -->
<!-- ========= -->
<div class="setup_div" style="margin-bottom:0;">
<div class="orange_15" style="padding-bottom:5px; font-weight:bold;">5) Automate PostgreStats with Cron.</div>
PostgreStats are updated each time ps_cron.php is executed. This file is located in the scripts directory of your PostgreStats install. Enterprise was designed to collect statistics at higher frequencies or as often as you'd like (EG: once per hour) but stats should be updated at least once per day with the last execution as close to midnight as possible. We recommend you run this cron-job as root only. To install the cron-job, su to root, enter crontab edit mode by typing &quot;crontab -e&quot; and insert your new cron-job as in these examples:
<div class="black_12" style="margin:20px 0 5px 0; font-weight:bold;">55 23 * * * /usr/bin/php /path/to/postgrestatsent/scripts/ps_cron.php</div>
In the above example, root will execute ps_cron.php each night at 11:55pm. Be sure to update your path to PHP and your PostgreStats install directory path.
<div class="black_12" style="margin:20px 0 5px 0; font-weight:bold;">50 * * * * /usr/bin/php /path/to/postgrestatsent/scripts/ps_cron.php</div>
In the above example, root will execute ps_cron.php at 50 minutes past each hour. Be sure to update your path to PHP and your PostgreStats install directory path.
<div style="margin:25px 0 0 0;"><span class="orange_12" style="font-weight:bold;">NOTE:</span> It is recommended you first zero-out statistics on each database prior to running ps_cron.php. You can do this simply by logging into each database and issuing a "select pg_stat_reset();" query.</div>
</div>
</div>
</div>

<!-- ====================================== -->
<!-- ====================================== -->
<!-- VIEW_ADMIN -->
<!-- ====================================== -->
<!-- ====================================== -->
<div id="view_admin" style="display:none;">
<div class="header">PostgreStats Enterprise > Admin Account<div class="grey_med_12" style="font-weight:normal;margin-top:4px;">Set options and make changes to your PostgreStats admin account below.</div></div>
<div style="padding:30px;">

<!-- ============== -->
<!-- USERNAME RESET -->
<!-- ============== -->
<div class="setup_div">
<div class="orange_15" style="padding-bottom:5px; font-weight:bold;">Update your admin account username below.</div>
Enter a new PostgreStats admin account username below. Once updated, you'll be required to log-in with your new credentials on page refresh.
<form action="javascript:reset_admin_username()" method="post">
<div style="margin:25px 0 0 0px; font-weight:bold;">
<div class="black_12" style="float:left; margin:4px 10px 0 0; text-align:right; width:165px;">New&nbsp;Admin&nbsp;Username:</div>
<div><input name="ps_admin_new_user" type="text" class="text_box" id="ps_admin_new_user" maxlength="30"></div>
<div style="clear:both;"></div>
</div>
<div style="margin:15px 0 0 0px; font-weight:bold;">
<div class="black_12" style="float:left; margin:4px 10px 0 0; text-align:right; width:165px;">Admin&nbsp;Password:</div>
<div><input name="ps_admin_pass" type="password" class="text_box" id="ps_admin_pass" maxlength="30"></div>
<div style="clear:both;"></div>
</div>
<div style="margin:15px 0 0 175px;"><input class="button_orange" type="submit" value="Reset Admin Username"></div>
</form>
<div id="admin_user_reset_result" style="margin:15px 0 0 175px; display:none;"></div>
</div>

<!-- ============== -->
<!-- PASSWORD RESET -->
<!-- ============== -->
<div class="setup_div" style="margin-bottom:0;">
<div class="orange_15" style="padding-bottom:5px; font-weight:bold;">Update your admin account password below.</div>
Passwords stored in the PostgreStats database are salted / hashed using the SHA256 method of encryption. Once updated, you'll be required to log-in with your new credentials on page refresh.
<form action="javascript:reset_admin_password()" method="post">
<div style="margin:25px 0 0 0px; font-weight:bold;">
<div class="black_12" style="float:left; margin:4px 10px 0 0; text-align:right; width:165px;">Old&nbsp;Admin&nbsp;Password:</div>
<div><input name="ps_admin_old_pass" type="password" class="text_box" id="ps_admin_old_pass" maxlength="30"></div>
<div style="clear:both;"></div>
</div>
<div style="margin:15px 0 0 0px; font-weight:bold;">
<div class="black_12" style="float:left; margin:4px 10px 0 0; text-align:right; width:165px;">New&nbsp;Admin&nbsp;Password:</div>
<div><input name="ps_admin_new_pass_1" type="password" class="text_box" id="ps_admin_new_pass_1" maxlength="30"></div>
<div style="clear:both;"></div>
</div>
<div style="margin:15px 0 0 0px; font-weight:bold;">
<div class="black_12" style="float:left; margin:4px 10px 0 0; text-align:right; width:165px;">Re-type&nbsp;New&nbsp;Password:</div>
<div><input name="ps_admin_new_pass_2" type="password" class="text_box" id="ps_admin_new_pass_2" maxlength="30"></div>
<div style="clear:both;"></div>
</div>
<div style="margin:15px 0 0 175px;"><input class="button_orange" type="submit" value="Reset Admin Password"></div>
</form>
<div id="admin_pass_reset_result" style="margin:15px 0 0 175px; display:none;"></div>
</div>
</div>
</div>

<!-- ====================================== -->
<!-- ====================================== -->
<!-- SERVERS AND DATABASES -->
<!-- ====================================== -->
<!-- ====================================== -->
<div id="view_servers_dbs" style="display:none;">
<div class="header">PostgreStats Enterprise > Servers &amp; Databases<div class="grey_med_12" style="font-weight:normal;margin-top:4px;">Administer the servers and databases in your PostgreStats implementation.</div></div>
<div style="padding:30px;">

<!-- ================= -->
<!-- INSERT NEW SERVER -->
<!-- ================= -->
<div class="setup_div">
<div class="orange_15" style="padding-bottom:5px; font-weight:bold;">Add a new PostgreStats server below.</div>
Once a new server is added to the system, you'll then add databases from that server for which you'd like PostgreStats to collect stats for. If this server is remote, make sure PostgreSQL accepts connections from this server.
<form action="javascript:server_insert()" method="post">
<div style="margin:25px 0 0 0px; font-weight:bold;">
<div class="black_12" style="float:left; margin:4px 10px 0 0; text-align:right; width:100px;">Server&nbsp;Name:</div>
<div style="float:left;"><input name="ps_add_server_name" type="text" class="text_box" id="ps_add_server_name" maxlength="25"></div>
<div class="grey_12" style="float:left; margin:4px 0 0 10px; font-weight:normal;">(Friendly name you'll use to identify this server)</div>
<div style="clear:both;"></div>
</div>
<div style="margin:15px 0 0 0px; font-weight:bold;">
<div class="black_12" style="float:left; margin:4px 10px 0 0; text-align:right; width:100px;">Server&nbsp;Host:</div>
<div style="float:left;"><input name="ps_add_server_host" type="text" class="text_box" id="ps_add_server_host" maxlength="50"></div>
<div class="grey_12" style="float:left; margin:4px 0 0 10px; font-weight:normal;">(Either 'localhost' or valid IPV4 / IPV6 IP)</div>
<div style="clear:both;"></div>
</div>
<div style="margin:15px 0 0 0px; font-weight:bold;">
<div class="black_12" style="float:left; margin:4px 10px 0 0; text-align:right; width:100px;">Server&nbsp;Port:</div>
<div style="float:left;"><input name="ps_add_server_port" type="text" class="text_box" id="ps_add_server_port" maxlength="10"></div>
<div class="grey_12" style="float:left; margin:4px 0 0 10px; font-weight:normal;">(Default PostgreSQL port is 5432)</div>
<div style="clear:both;"></div>
</div>
<div class="orange_13" style="margin:15px 0 0 110px; font-weight:bold;"><input class="button_orange" type="submit" value="Add New Server to PostgreStats"></div>
</form>
<div id="server_insert_result" style="margin:15px 0 0 110px; display:none;"></div>
</div>

<!-- =========== -->
<!-- SERVER LIST -->
<!-- =========== -->
<div class="setup_div" style="margin-bottom:0;">
<div class="orange_15" style="padding-bottom:5px; font-weight:bold;">Edit servers and databases</div>
Modify or remove servers and install &amp; update databases in your PostgreStats implementation below.
<div id="server_list" style="display:none; margin:25px 0 0 0px; font-weight:bold;"></div>
<div id="server_result" style="margin:15px 0 0 0; display:none;"></div>

<!-- ============= -->
<!-- UPDATE SERVER -->
<!-- ============= -->
<div id="view_server_update" class="setup_div_white" style="margin:25px 0 0 0; display:none;">
<div class="orange_15" style="padding-bottom:5px; font-weight:bold;">Update Server</div>
Update this server below. Note, altering the host &amp; port fields will auto-update all databases tied to this server.
<div id="server_update_data" style="margin:25px 0 0 0px; font-weight:bold; display:none;"></div>
<div style="clear:both;"></div>
</div>

<!-- =============== -->
<!-- INSERT DATABASE -->
<!-- =============== -->
<div id="view_db_insert" class="setup_div_white" style="margin:25px 0 0 0; display:none;">
<div class="orange_15" style="padding-bottom:5px; font-weight:bold;">Insert Database</div>
Add a single database to this server or use the auto-populate feature to add all DBs this user can connect to (recommended if you connect to all DBs with a single set of credentials). PostgreStats will then start collecting statistics when the ps_cron.php script executes.
<div id="db_insert_data" style="margin:25px 0 0 0px; font-weight:bold; display:none;"></div>
<div style="clear:both;"></div>
</div>

<!-- ============== -->
<!-- LIST DATABASES -->
<!-- ============== -->
<div id="view_db_list" class="setup_div_white" style="margin:25px 0 0 0; display:none;">
<div class="orange_15" style="padding-bottom:5px; font-weight:bold;">Databases on this Server</div>
The following databases are collecting statistics on this server.
<div id="db_list_data" style="margin:25px 0 0 0px; font-weight:bold; display:none;"></div>
<div style="clear:both;"></div>
</div>
</div>

<!-- ============= -->
<!-- COMPLETE DIVS -->
<!-- ============= -->
</div>
</div>
</div>

<!-- ====================================== -->
<!-- BOTTOM SECTION START -->
<!-- ====================================== -->
<div style="height:50px; max-height:50px; background-color:#D2D2D2; border-radius:0 0 10px 10px; -webkit-border-radius:0 0 10px 10px; -moz-border-radius:0 0 10px 10px; border:1px solid #999999; border-top:0;">
<div class="white_12" id="mem" style="display:none; padding:18px 30px 0 0; font-weight:bold; text-align:right;"></div>
</div>

<!-- ====================================== -->
<!-- END PRIMARY WRAPPER -->
<!-- ====================================== -->
</div>

<!-- ====================================== -->
<!-- SHOW SET-UP IF DB NOT VERIFIED -->
<!-- ====================================== -->
<?php
#########################
#HANDLE SET-UP VISIBILITY
#########################
if(!$postgrestats_db_verified)
{
?>
<!-- =================== -->
<!-- MAKE SET-UP VISIBLE -->
<!-- =================== -->
<script type="text/javascript">javascript:stat_view(1);</script>
<?php
}
?>
</body>
</html>