<?php
/*
################################
#POSTGRESTATS ENTERPRISE LICENSE
################################
Copyright 2013 NWLYNX <http://www.nwlynx.com/>.

This file is part of PostgreStats Enterprise <http://www.postgrestats.com/>.

PostgreStats Enterprise is free software: you can redistribute it and/or modify it under the terms of the GNU General Public 
License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

PostgreStats Enterprise is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
*/

#############
#VERSION VARS
#############
$ps_version = "Enterprise 1.0 Beta";
$ps_license = "GNU-GPL";
$ps_copyright = "2013";

############################
#AUTHORIZE LOCAL FILE ACCESS
############################
$ps_base = basename($_SERVER['REQUEST_URI']);
if($ps_base != 'postgrestatsent' && $ps_base != 'index.php') { exit; }

################################
#PERFORM INSTALL INTEGRITY CHECK
################################
if(!file_exists('scripts/ps_auth.php') || !file_exists('scripts/ps_conf.php') || !file_exists('scripts/ps_cron.php') || !file_exists('scripts/ps_styles.css') || !file_exists('scripts/ps_core.php') || !file_exists('scripts/ps_scripts.js'))
{	
	##########################################
	#MAKE SURE ALL CRITICAL SCRIPT FILES EXIST
	##########################################
	$ps_integrity_status  = "<html><head><title>PostgreStats</title></head>";
	$ps_integrity_status .= "<body style=\"padding:0; margin:20px; background-color:#E8E8E8; font-family:Tahoma, Geneva, sans-serif; font-size:12px;\">";
	$ps_integrity_status .= "<div style=\"width:500px; margin:0 auto;\">";
	$ps_integrity_status .= "<div style=\"background-color:#000000; border-radius:10px 10px 0 0; -webkit-border-radius:10px 10px 0 0; -moz-border-radius:10px 10px 0 0; border:1px solid #999999;\">";
	$ps_integrity_status .= "<div style=\"margin:20px 0 15px 30px;\"><img src=\"images/postgrestats_logo.png\" width=\"315\" height=\"72\"></div></div>";
	$ps_integrity_status .= "<div style=\"color:#FF6633; margin-bottom:25px; padding:25px; background-color:#F6F6F6; border-radius:0 0 10px 10px; -webkit-border-radius:0 0 10px 10px; -moz-border-radius:0 0 10px 10px; border:1px solid #999999; border-top:0;\">";
	$ps_integrity_status .= "<div style=\"font-weight:bold; font-size:18px;\">PostgreStats Install Integrity Notice:</div>";
	$ps_integrity_status .= "<div>One or more files are missing from the scripts directory of your PostgreStats install. Please verify all original install files exist.</div>";
	$ps_integrity_status .= "<div style=\"margin:15px 0 0 20px; font-weight:bold; line-height:20px; color:#000000;\">";
	$ps_integrity_status .= "/scripts/ps_auth.php<br>/scripts/ps_conf.php<br>/scripts/ps_cron.php<br>/scripts/ps_styles.css<br>/scripts/ps_core.php<br>/scripts/ps_scripts.js<br>/index.php<br>/images/</div></div></div>";
	$ps_integrity_status .= "</body></html>";

	##################
	#POST MSG AND EXIT
	##################
	echo $ps_integrity_status;
	exit;
}

################
#INITIALIZE VARS
################
$postgrestats_db_verified = false;
$postgrestats_db_name = '';
$postgrestats_db_user = '';
$postgrestats_db_pass = '';
$postgrestats_db_host = '';
$postgrestats_db_port = '';
$ps_connect_status = '';
$ps_server_count = '0';
$ps_db_count = '0';
$ps_core_count = '0';

##############
#KICK FUNCTION
##############
function kick()
{
	$kick_notice  = "<html><head><title>PostgreStats</title></head>";
	$kick_notice .= "<body style=\"padding:0; margin:20px; background-color:#E8E8E8; font-family:Tahoma, Geneva, sans-serif; font-size:12px;\">";
	$kick_notice .= "<div style=\"width:500px; margin:0 auto;\">";
	$kick_notice .= "<div style=\"background-color:#000000; border-radius:10px 10px 0 0; -webkit-border-radius:10px 10px 0 0; -moz-border-radius:10px 10px 0 0; border:1px solid #999999;\">";
	$kick_notice .= "<div style=\"margin:20px 0 15px 30px;\"><img src=\"images/postgrestats_logo.png\" width=\"315\" height=\"72\"></div></div>";
	$kick_notice .= "<div style=\"color:#FF6633; margin-bottom:25px; padding:25px; background-color:#F6F6F6; border-radius:0 0 10px 10px; -webkit-border-radius:0 0 10px 10px; -moz-border-radius:0 0 10px 10px; border:1px solid #999999; border-top:0;\">";
	$kick_notice .= "<div style=\"font-weight:bold; font-size:18px;\">PostgreStats Enterprise Log-in Required:</div>";
	$kick_notice .= "<div style=\"color:#000000;\">You need to log-in to access this PostgreStats implementation. Please refer to the documentation for further assistance.</div>";
	$kick_notice .= "</div></div></body></html>";
	
	##################
	#POST MSG AND EXIT
	##################
	echo $kick_notice;
	exit;
}

######################
#REQUIRE OUR CONF FILE
######################
require('scripts/ps_conf.php');

##################################
#FUNCTION: DATE_GET_FRIENDLY_MONTH
##################################
function date_get_friendly_month($month)
{
	#########################################
	#GET INCOMING AND CREATE FRIENDLY VERSION
	#########################################
	switch($month)
	{
		case '01': $month_friendly = "Jan"; break;
		case '02': $month_friendly = "Feb"; break;
		case '03': $month_friendly = "Mar"; break;
		case '04': $month_friendly = "Apr"; break;
		case '05': $month_friendly = "May"; break;
		case '06': $month_friendly = "Jun"; break;
		case '07': $month_friendly = "Jul"; break;
		case '08': $month_friendly = "Aug"; break;
		case '09': $month_friendly = "Sep"; break;
		case '10': $month_friendly = "Oct"; break;
		case '11': $month_friendly = "Nov"; break;
		case '12': $month_friendly = "Dec";
	}

	##########
	#RETURN IT
	##########
	return $month_friendly;
}

#################
#DEFAULT VIEW NAV
#################
$ps_nav  = "<div style=\"float:left;\">Monthly Snapshot</div>";
$ps_nav .= "<div style=\"float:left; margin:0 10px 0 10px;\"> | </div>";
$ps_nav .= "<div style=\"float:left;\">Daily Individual</div>";
$ps_nav .= "<div style=\"float:left; margin:0 10px 0 10px;\"> | </div>";
$ps_nav .= "<div style=\"float:left;\">Month VS Month</div>";
$ps_nav .= "<div style=\"float:left; margin:0 10px 0 10px;\"> | </div>";
$ps_nav .= "<div style=\"float:left;\">Weekly Trending</div>";
$ps_nav .= "<div style=\"float:left; margin:0 10px 0 10px;\"> | </div>";
$ps_nav .= "<div style=\"float:left;\">Yearly Snapshot</div>";
$ps_nav .= "<div style=\"clear:both;\"></div>";

##################
#DEFAULT ADMIN NAV
##################
$ps_nav_admin  = "<div style=\"float:left;\">Admin Account</div>";
$ps_nav_admin .= "<div style=\"float:left; margin:0 5px 0 5px;\"> | </div>";
$ps_nav_admin .= "<div style=\"float:left;\">Servers and Databases</div>";
$ps_nav_admin .= "<div style=\"float:left; margin:0 5px 0 5px;\"> | </div>";
$ps_nav_admin .= "<div style=\"float:left;\"><span class=\"orange_13\">PostgreStats Set-up</span></div>";
$ps_nav_admin .= "<div style=\"clear:both;\"></div>";

#########################################
#VERIFY POSTGRESTATS DATABASE CREDENTIALS
#########################################
if(!empty($postgrestats_db_name) && !empty($postgrestats_db_user) && !empty($postgrestats_db_host) && !empty($postgrestats_db_port))
{
	###################################################################
	#CONNECT ATTEMPT - PASSWORD MAY NOT BE REQUIRED CONNECT ACCORDINGLY
	###################################################################
	if(!empty($postgrestats_db_pass))
	{
		########################
		#ATTEMPT CONNECT WITH PW
		########################
		$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");
	}
	else
	{
		###########################
		#ATTEMPT CONNECT WITHOUT PW
		###########################
		$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user host=$postgrestats_db_host port=$postgrestats_db_port");
	}

	#######################################################
	#IF PS_CONF.PHP HAS VALUES BUT WE ARE UNABLE TO CONNECT
	#######################################################
	if(!$pg_conn)
	{
		$ps_connect_status .= "<div style=\"font-weight:bold; font-size:18px;\">PostgreStats Connection Notice:</div>";
		$ps_connect_status .= "There was an error connecting to your PostgreStats database. Please verify the connect credentials in your ps_conf.php file located in the scripts directory of your PostgreStats install.";
	}
	else
	{
		###########################
		#GRAB OUR ADMIN CREDENTIALS
		###########################
		$sqlselect_ps_admin = @pg_query($pg_conn, "SELECT * FROM ps_user_tbl WHERE account_type = 1");

		###############
		#ERROR CHECKING
		###############
		if(!$sqlselect_ps_admin)
		{
			########################################
			#DB CONNECTS BUT CAN'T EXECUTE THE QUERY
			########################################
			$ps_connect_status .= "<div style=\"font-weight:bold; font-size:18px;\">PostgreStats Connection Notice:</div>";
			$ps_connect_status .= "PostgreStats has connected successfully with your PostgreStats DB but was unable to execute the query. Please verify your PostgreStats DB was created properly.";
		}
		elseif(pg_num_rows($sqlselect_ps_admin) == 0)
		{
			##########################################################
			#DB CONNECTS & EXECUTES QUERY BUT CAN'T FIND ADMIN ACCOUNT
			##########################################################
			$ps_connect_status .= "<div style=\"font-weight:bold; font-size:18px;\">PostgreStats Connection Notice:</div>";
			$ps_connect_status .= "PostgreStats has connected successfully with your PostgreStats DB but could not locate your Admin user. Please verify your PostgreStats DB was created properly.";
		}
		else
		{
			##############################################
			#DB CONNECTED, ADMIN QUERY EXECUTED, PULL DATA
			##############################################
			$query_data_ps_admin = pg_fetch_row($sqlselect_ps_admin);
			$user_id = $query_data_ps_admin[0];
			$salt = $query_data_ps_admin[1];
			$ps_user = $query_data_ps_admin[2];
			$ps_pass = $query_data_ps_admin[3];

			###############
			#CHECK FOR USER
			###############
			if(!isset($_SERVER['PHP_AUTH_USER']))
			{
				header("WWW-Authenticate: Basic realm=\"PostgreStats Enterprise\"");
				header("HTTP/1.0 401 Unauthorized");
				kick();
			}

			#############################
			#RE-HASH WITH USER SALT FIRST
			#############################
			if(isset($_SERVER['PHP_AUTH_PW'])) $ps_password = hash("sha256", $salt.$_SERVER['PHP_AUTH_PW']);

			############################
			#CHECK FOR USER / PASS MATCH
			############################
			if($_SERVER['PHP_AUTH_USER'] != $ps_user || $ps_password != $ps_pass)
			{
				header("WWW-Authenticate: Basic realm=\"PostgreStats Enterprise\"");
				header("HTTP/1.0 401 Unauthorized");
				kick();
			}

			#####################################
			#SET DB VERIFIED AND STATS_EXIST_VARS
			#####################################
			$postgrestats_db_verified = true;
			$stats_exist = false;

			################################
			#GRAB DB, SERVER AND CORE COUNTS
			################################
			$sqlselect_ps_counts = @pg_query($pg_conn, "SELECT (SELECT COUNT(db_id) FROM ps_db_tbl), (SELECT COUNT(server_id) FROM ps_server_tbl), (SELECT COUNT(ps_core_id) FROM ps_core_tbl)");

			#############
			#MAKE CERTAIN
			#############
			if($sqlselect_ps_counts)
			{
				##########################################
				#GRAB OUR COUNT AND UPDATE PS_DB_COUNT VAR
				##########################################
				$query_data_ps_counts = pg_fetch_row($sqlselect_ps_counts);
				$ps_db_count = $query_data_ps_counts[0];
				$ps_server_count = $query_data_ps_counts[1];
				$ps_core_count = $query_data_ps_counts[2];
			}

			##############################
			#CHECK FOR CORE STATISTICS NOW
			##############################
			if($ps_core_count > 0)
			{
				$ps_nav  = "<div style=\"float:left;\"><a href=\"javascript:stat_view(4)\">Monthly Snapshot</a></div>";
				$ps_nav .= "<div style=\"float:left; margin:0 10px 0 10px;\"> | </div>";
				$ps_nav .= "<div style=\"float:left;\"><a href=\"javascript:stat_view(5)\">Daily Individual</a></div>";
				$ps_nav .= "<div style=\"float:left; margin:0 10px 0 10px;\"> | </div>";
				$ps_nav .= "<div style=\"float:left;\"><a href=\"javascript:stat_view(6)\">Month VS Month</a></div>";
				$ps_nav .= "<div style=\"float:left; margin:0 10px 0 10px;\"> | </div>";
				$ps_nav .= "<div style=\"float:left;\"><a href=\"javascript:stat_view(7)\">Weekly Trending</a></div>";
				$ps_nav .= "<div style=\"float:left; margin:0 10px 0 10px;\"> | </div>";
				$ps_nav .= "<div style=\"float:left;\"><a href=\"javascript:stat_view(8)\">Yearly Snapshot</a></div>";
				$ps_nav .= "<div style=\"clear:both;\"></div>";

				#######################
				#UPDATE STATS_EXIST_VAR
				#######################
				$stats_exist = true;

				################################################################
				#RETRIEVE OUR SERVER LIST - ONLY SERVERS WHERE WE HAVE CORE DATA
				################################################################
				$sqlselect_servers = @pg_query($pg_conn, "SELECT server_id,server_name,server_host FROM ps_server_tbl WHERE (SELECT COUNT(server_id) FROM ps_core_tbl WHERE ps_server_tbl.server_id = ps_core_tbl.server_id) > 0 ORDER BY server_name ASC");

				#############
				#MAKE CERTAIN
				#############
				if($sqlselect_servers)
				{
					######################################################
					#IF WE HAVE RESULTS, UPDATE ALL STAT VIEW SERVER LISTS
					######################################################
					if(pg_num_rows($sqlselect_servers) > 0)
					{
						##################################
						#START THE LISTS FOR EACH NAV VIEW
						##################################
						$monthly_server_list  = "<select class=\"select_menu\" name=\"snap_servers\" id=\"snap_servers\" onChange=\"monthly_snap_retrieve_nav_dbs()\">";
						$monthly_server_list .= "<option value=\"0\">All Servers</option>";

						$daily_server_list  = "<select class=\"select_menu\" name=\"daily_servers\" id=\"daily_servers\" onChange=\"daily_select_nav_servers()\">";
						$daily_server_list .= "<option value=\"0\">All Servers</option>";

						$versus_server_list  = "<select class=\"select_menu\" name=\"versus_servers\" id=\"versus_servers\" onChange=\"versus_retrieve_nav_dbs()\">";
						$versus_server_list .= "<option value=\"0\">All Servers</option>";

						$weekly_server_list  = "<select class=\"select_menu\" name=\"weekly_servers\" id=\"weekly_servers\" onChange=\"weekly_retrieve_nav_dbs()\">";
						$weekly_server_list .= "<option value=\"0\">All Servers</option>";

						$yearly_server_list  = "<select class=\"select_menu\" name=\"yearly_servers\" id=\"yearly_servers\" onChange=\"yearly_retrieve_nav_dbs()\">";
						$yearly_server_list .= "<option value=\"0\">All Servers</option>";

						####################
						#START OUR ITERATION
						####################
						while($query_data_servers = pg_fetch_row($sqlselect_servers))
						{
							$server_id = $query_data_servers[0];
							$server_name = $query_data_servers[1];

							##############################################
							#ADD OPTION LISTINGS TO OUR NAV VIEW DROPDOWNS
							##############################################
							$monthly_server_list .= "<option value=\"$server_id\">$server_name</option>";
							$daily_server_list .= "<option value=\"$server_id\">$server_name</option>";
							$versus_server_list .= "<option value=\"$server_id\">$server_name</option>";
							$weekly_server_list .= "<option value=\"$server_id\">$server_name</option>";
							$yearly_server_list .= "<option value=\"$server_id\">$server_name</option>";
						}

						##############
						#COMPLETE LIST
						##############
						$monthly_server_list .= "</select>";
						$daily_server_list .= "</select>";
						$versus_server_list .= "</select>";
						$weekly_server_list .= "</select>";
						$yearly_server_list .= "</select>";
					}
				}

				#####################################################
				#GET MONTH VALUS FROM PS_CORE_TBL FOR ALL SERVERS/DBS
				#####################################################
				$sqlselect_months = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(MONTH FROM recorded) AS month FROM ps_core_tbl ORDER BY month ASC");

				#############
				#MAKE CERTAIN
				#############
				if($sqlselect_months)
				{
					#####################################################
					#IF WE HAVE RESULTS, UPDATE ALL STAT VIEW MONTH LISTS
					#####################################################
					if(pg_num_rows($sqlselect_months) > 0)
					{
						################################
						#CURRENT MONTH FOR PRE-SELECTION
						################################
						$current_month = date('m');

						###############
						#START THE LIST
						###############
						$monthly_month_list  = "<select class=\"select_menu\" name=\"snap_month\" id=\"snap_month\">";
						$daily_month_list  = "<select class=\"select_menu\" name=\"daily_month\" id=\"daily_month\">";
						$versus_month_list_a  = "<select class=\"select_menu\" name=\"versus_month_a\" id=\"versus_month_a\">";
						$versus_month_list_b  = "<select class=\"select_menu\" name=\"versus_month_b\" id=\"versus_month_b\">";
						$weekly_month_list  = "<select class=\"select_menu\" name=\"weekly_month\" id=\"weekly_month\">";

						###################################################
						#WEEKLY TRENDING ALL-MONTHS OPTION - USE BY DEFAULT
						###################################################
						$weekly_month_list .= "<option value=\"0\" selected=\"selected\">All Months</option>";

						####################
						#START OUR ITERATION
						####################
						while($query_data_months = pg_fetch_row($sqlselect_months))
						{
							################################################################
							#EXTRACT MONTH - HANDLE LEADING ZEROS - AND GET FRIENDLY VERSION
							################################################################
							$month = $query_data_months[0];
							if(strlen($month) == 1) $month = "0$month";
							$month_friendly = date_get_friendly_month($month);
							if($month == $current_month) { $selected = "selected=\"selected\""; } else { $selected = ""; }

							##############################################
							#ADD OPTION LISTINGS TO OUR NAV VIEW DROPDOWNS
							##############################################
							$monthly_month_list .= "<option value=\"$month\" $selected>$month_friendly</option>";
							$daily_month_list .= "<option value=\"$month\" $selected>$month_friendly</option>";
							$versus_month_list_a .= "<option value=\"$month\" $selected>$month_friendly</option>";
							$versus_month_list_b .= "<option value=\"$month\" $selected>$month_friendly</option>";
							$weekly_month_list .= "<option value=\"$month\">$month_friendly</option>";
						}

						##############
						#COMPLETE LIST
						##############
						$monthly_month_list .= "</select>";
						$daily_month_list .= "</select>";
						$versus_month_list_a .= "</select>";
						$versus_month_list_b .= "</select>";
						$weekly_month_list .= "</select>";
					}
				}

				##############################
				#CURRENT DAY FOR PRE-SELECTION
				##############################
				$current_day = date('d');

				#############################
				#CREATE THE DAY DROPDOWN LIST
				#############################
				$daily_day_list  = "<select class=\"select_menu\" name=\"daily_day\" id=\"daily_day\">";

				for($i=1; $i<32; $i++)
				{
					if(strlen($i) == 1) { $i= "0$i"; }
					if($i == $current_day) { $selected = "selected=\"selected\""; } else { $selected = ""; }
					$daily_day_list .= "<option value=\"$i\" $selected>$i</option>";
				}

				##############
				#COMPLETE LIST
				##############
				$daily_day_list .= "</select>";

				####################################################
				#GET YEAR VALUS FROM PS_CORE_TBL FOR ALL SERVERS/DBS
				####################################################
				$sqlselect_years = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(YEAR FROM recorded) AS year FROM ps_core_tbl ORDER BY year DESC");
				
				#############
				#MAKE CERTAIN
				#############
				if($sqlselect_years)
				{
					####################################################
					#IF WE HAVE RESULTS, UPDATE ALL STAT VIEW YEAR LISTS
					####################################################
					if(pg_num_rows($sqlselect_years) > 0)
					{
						###############################
						#CURRENT YEAR FOR PRE-SELECTION
						###############################
						$current_year = date('Y');

						###############
						#START THE LIST
						###############
						$monthly_year_list  = "<select class=\"select_menu\" name=\"snap_year\" id=\"snap_year\">";
						$daily_year_list  = "<select class=\"select_menu\" name=\"daily_year\" id=\"daily_year\">";
						$versus_year_list_a  = "<select class=\"select_menu\" name=\"versus_year_a\" id=\"versus_year_a\">";
						$versus_year_list_b  = "<select class=\"select_menu\" name=\"versus_year_b\" id=\"versus_year_b\">";
						$weekly_year_list  = "<select class=\"select_menu\" name=\"weekly_year\" id=\"weekly_year\">";
						$yearly_year_list  = "<select class=\"select_menu\" name=\"yearly_year\" id=\"yearly_year\">";

						####################
						#START OUR ITERATION
						####################
						while($query_data_years = pg_fetch_row($sqlselect_years))
						{
							$year = $query_data_years[0];
							if($year == $current_year) { $selected = "selected=\"selected\""; } else { $selected = ""; }

							##############################################
							#ADD OPTION LISTINGS TO OUR NAV VIEW DROPDOWNS
							##############################################
							$monthly_year_list .= "<option value=\"$year\" $selected>$year</option>";
							$daily_year_list .= "<option value=\"$year\" $selected>$year</option>";
							$versus_year_list_a .= "<option value=\"$year\" $selected>$year</option>";
							$versus_year_list_b .= "<option value=\"$year\" $selected>$year</option>";
							$weekly_year_list .= "<option value=\"$year\" $selected>$year</option>";
							$yearly_year_list .= "<option value=\"$year\" $selected>$year</option>";
						}

						##############
						#COMPLETE LIST
						##############
						$monthly_year_list .= "</select>";
						$daily_year_list .= "</select>";
						$versus_year_list_a .= "</select>";
						$versus_year_list_b .= "</select>";
						$weekly_year_list .= "</select>";
						$yearly_year_list .= "</select>";
					}
				}

				###########################
				#CHARTTING LIST FOR MONTHLY
				###########################
				$snap_chartting_list  = "<select class=\"select_menu\" name=\"snap_chartting\" id=\"snap_chartting\">";
				$snap_chartting_list .= "<option value=\"0\">Chart Shows</option>";
				$snap_chartting_list .= "<option value=\"commits\">Commits</option>";
				$snap_chartting_list .= "<option value=\"rollbacks\">Rollbacks</option>";
				$snap_chartting_list .= "<option value=\"block_reads\">Block Reads</option>";
				$snap_chartting_list .= "<option value=\"buffer_hits\">Buffer Hits</option>";
				$snap_chartting_list .= "<option value=\"inserts\">User Inserts</option>";
				$snap_chartting_list .= "<option value=\"updates\">User Updates</option>";
				$snap_chartting_list .= "<option value=\"deletes\">User Deletes</option>";
				$snap_chartting_list .= "<option value=\"seq_scans\">Sequence Scans</option>";
				$snap_chartting_list .= "<option value=\"idx_scans\">Index Scans</option>";
				$snap_chartting_list .= "</select>";

				#########################
				#CHARTTING LIST FOR DAILY
				#########################
				$daily_chartting_list  = "<select class=\"select_menu\" name=\"daily_chartting\" id=\"daily_chartting\">";
				$daily_chartting_list .= "<option value=\"0\">Chart Shows</option>";
				$daily_chartting_list .= "<option value=\"commits\">Commits</option>";
				$daily_chartting_list .= "<option value=\"rollbacks\">Rollbacks</option>";
				$daily_chartting_list .= "<option value=\"block_reads\">Block Reads</option>";
				$daily_chartting_list .= "<option value=\"buffer_hits\">Buffer Hits</option>";
				$daily_chartting_list .= "<option value=\"inserts\">User Inserts</option>";
				$daily_chartting_list .= "<option value=\"updates\">User Updates</option>";
				$daily_chartting_list .= "<option value=\"deletes\">User Deletes</option>";
				$daily_chartting_list .= "<option value=\"seq_scans\">Sequence Scans</option>";
				$daily_chartting_list .= "<option value=\"idx_scans\">Index Scans</option>";
				$daily_chartting_list .= "</select>";

				##########################
				#CHARTTING LIST FOR VERSUS
				##########################
				$versus_chartting_list  = "<select class=\"select_menu\" name=\"versus_chartting\" id=\"versus_chartting\">";
				$versus_chartting_list .= "<option value=\"0\">Chart Shows</option>";
				$versus_chartting_list .= "<option value=\"commits\">Commits</option>";
				$versus_chartting_list .= "<option value=\"rollbacks\">Rollbacks</option>";
				$versus_chartting_list .= "<option value=\"block_reads\">Block Reads</option>";
				$versus_chartting_list .= "<option value=\"buffer_hits\">Buffer Hits</option>";
				$versus_chartting_list .= "<option value=\"inserts\">User Inserts</option>";
				$versus_chartting_list .= "<option value=\"updates\">User Updates</option>";
				$versus_chartting_list .= "<option value=\"deletes\">User Deletes</option>";
				$versus_chartting_list .= "<option value=\"seq_scans\">Sequence Scans</option>";
				$versus_chartting_list .= "<option value=\"idx_scans\">Index Scans</option>";
				$versus_chartting_list .= "</select>";

				##########################
				#CHARTTING LIST FOR WEEKLY
				##########################
				$weekly_chartting_list  = "<select class=\"select_menu\" name=\"weekly_chartting\" id=\"weekly_chartting\">";
				$weekly_chartting_list .= "<option value=\"0\">Chart Shows</option>";
				$weekly_chartting_list .= "<option value=\"commits\">Commits</option>";
				$weekly_chartting_list .= "<option value=\"rollbacks\">Rollbacks</option>";
				$weekly_chartting_list .= "<option value=\"block_reads\">Block Reads</option>";
				$weekly_chartting_list .= "<option value=\"buffer_hits\">Buffer Hits</option>";
				$weekly_chartting_list .= "<option value=\"inserts\">User Inserts</option>";
				$weekly_chartting_list .= "<option value=\"updates\">User Updates</option>";
				$weekly_chartting_list .= "<option value=\"deletes\">User Deletes</option>";
				$weekly_chartting_list .= "<option value=\"seq_scans\">Sequence Scans</option>";
				$weekly_chartting_list .= "<option value=\"idx_scans\">Index Scans</option>";
				$weekly_chartting_list .= "</select>";

				##########################
				#CHARTTING LIST FOR YEARLY
				##########################
				$yearly_chartting_list  = "<select class=\"select_menu\" name=\"yearly_chartting\" id=\"yearly_chartting\">";
				$yearly_chartting_list .= "<option value=\"0\">Chart Shows</option>";
				$yearly_chartting_list .= "<option value=\"commits\">Commits</option>";
				$yearly_chartting_list .= "<option value=\"rollbacks\">Rollbacks</option>";
				$yearly_chartting_list .= "<option value=\"block_reads\">Block Reads</option>";
				$yearly_chartting_list .= "<option value=\"buffer_hits\">Buffer Hits</option>";
				$yearly_chartting_list .= "<option value=\"inserts\">User Inserts</option>";
				$yearly_chartting_list .= "<option value=\"updates\">User Updates</option>";
				$yearly_chartting_list .= "<option value=\"deletes\">User Deletes</option>";
				$yearly_chartting_list .= "<option value=\"seq_scans\">Sequence Scans</option>";
				$yearly_chartting_list .= "<option value=\"idx_scans\">Index Scans</option>";
				$yearly_chartting_list .= "</select>";

				########################
				#REP MODE LIST FOR DAILY
				########################
				$daily_rep_mode_list  = "<select class=\"select_menu\" name=\"daily_rep_mode\" id=\"daily_rep_mode\" onChange=\"daily_select_rep_mode()\">";
				$daily_rep_mode_list .= "<option value=\"0\">Replication Mode</option>";
				$daily_rep_mode_list .= "<option value=\"split\">Split DBs</option>";
				$daily_rep_mode_list .= "<option value=\"combine\">Combine DBs</option>";
				$daily_rep_mode_list .= "</select>";

				#######################################
				#COMPLETED NAVIGATION: MONTHLY SNAPSHOT
				#######################################
				$nav_monthly  = "<form action=\"javascript:monthly_snap_retrieve()\" method=\"post\">";
				$nav_monthly .= "<div style=\"float:left;\">$monthly_server_list</div>";
				$nav_monthly .= "<div id=\"snap_nav_db_list\" style=\"float:left; margin-left:10px; display:none;\"></div>";
				$nav_monthly .= "<div id=\"snap_nav_month_list\" style=\"float:left; margin-left:10px;\">$monthly_month_list</div>";
				$nav_monthly .= "<div id=\"snap_nav_year_list\" style=\"float:left; margin-left:10px;\">$monthly_year_list</div>";
				$nav_monthly .= "<div id=\"snap_nav_chartting_list\" style=\"float:left; margin-left:10px;\">$snap_chartting_list</div>";
				$nav_monthly .= "<div style=\"float:left; margin-left:10px;\"><input class=\"button_orange\" type=\"submit\" value=\"Go!\"></div>";
				$nav_monthly .= "<div style=\"clear:both;\"></div>";
				$nav_monthly .= "</form>";

				############################
				#COMPLETED NAVIGATION: DAILY
				############################
				$nav_daily  = "<form action=\"javascript:daily_retrieve()\" method=\"post\">";
				$nav_daily .= "<div style=\"float:left;\">$daily_server_list</div>";
				$nav_daily .= "<div id=\"daily_nav_month_list\" style=\"float:left; margin-left:10px;\">$daily_month_list</div>";
				$nav_daily .= "<div id=\"daily_nav_day_list\" style=\"float:left; margin-left:10px;\">$daily_day_list</div>";
				$nav_daily .= "<div id=\"daily_nav_year_list\" style=\"float:left; margin-left:10px;\">$daily_year_list</div>";
				$nav_daily .= "<div id=\"daily_nav_chartting_list\" style=\"float:left; margin-left:10px;\">$daily_chartting_list</div>";
				$nav_daily .= "<div id=\"daily_nav_rep_mode_list\" style=\"float:left; margin-left:10px;\">$daily_rep_mode_list</div>";
				$nav_daily .= "<div style=\"float:left; margin-left:10px;\"><input class=\"button_orange\" type=\"submit\" value=\"Go!\"></div>";
				$nav_daily .= "<div style=\"clear:both;\"></div>";
				$nav_daily .= "</form>";

				#############################
				#COMPLETED NAVIGATION: VERSUS
				#############################
				$nav_versus  = "<form action=\"javascript:versus_retrieve()\" method=\"post\">";
				$nav_versus .= "<div style=\"float:left;\">$versus_server_list</div>";
				$nav_versus .= "<div id=\"versus_nav_db_list\" style=\"float:left; margin-left:10px; display:none;\"></div>";
				$nav_versus .= "<div style=\"float:left; margin:5px 0 0 10px; height:15px; width:15px; background-color:#333333; border:1px solid #666666;\"></div>";
				$nav_versus .= "<div id=\"versus_nav_month_list_a\" style=\"float:left; margin-left:10px;\">$versus_month_list_a</div>";
				$nav_versus .= "<div id=\"versus_nav_year_list_a\" style=\"float:left; margin-left:10px;\">$versus_year_list_a</div>";
				$nav_versus .= "<div style=\"float:left; margin-left:10px; padding-top:4px;\">VS</div>";
				$nav_versus .= "<div style=\"float:left; margin:5px 0 0 10px; height:15px; width:15px; background-color:#999999; border:1px solid #666666;\"></div>";
				$nav_versus .= "<div id=\"versus_nav_month_list_b\" style=\"float:left; margin-left:10px;\">$versus_month_list_b</div>";
				$nav_versus .= "<div id=\"versus_nav_year_list_b\" style=\"float:left; margin-left:10px;\">$versus_year_list_b</div>";
				$nav_versus .= "<div id=\"versus_nav_chartting_list\" style=\"float:left; margin-left:10px;\">$versus_chartting_list</div>";
				$nav_versus .= "<div style=\"float:left; margin-left:10px;\"><input class=\"button_orange\" type=\"submit\" value=\"Go!\"></div>";
				$nav_versus .= "<div style=\"clear:both;\"></div>";
				$nav_versus .= "</form>";

				######################################
				#COMPLETED NAVIGATION: WEEKLY TRENDING
				######################################
				$nav_weekly  = "<form action=\"javascript:weekly_retrieve()\" method=\"post\">";
				$nav_weekly .= "<div style=\"float:left;\">$weekly_server_list</div>";
				$nav_weekly .= "<div id=\"weekly_nav_db_list\" style=\"float:left; margin-left:10px; display:none;\"></div>";
				$nav_weekly .= "<div id=\"weekly_nav_month_list\" style=\"float:left; margin-left:10px;\">$weekly_month_list</div>";
				$nav_weekly .= "<div id=\"weekly_nav_year_list\" style=\"float:left; margin-left:10px;\">$weekly_year_list</div>";
				$nav_weekly .= "<div id=\"weekly_nav_chartting_list\" style=\"float:left; margin-left:10px;\">$weekly_chartting_list</div>";
				$nav_weekly .= "<div style=\"float:left; margin-left:10px;\"><input class=\"button_orange\" type=\"submit\" value=\"Go!\"></div>";
				$nav_weekly .= "<div style=\"clear:both;\"></div>";
				$nav_weekly .= "</form>";

				######################################
				#COMPLETED NAVIGATION: YEARLY SNAPSHOT
				######################################
				$nav_yearly  = "<form action=\"javascript:yearly_retrieve()\" method=\"post\">";
				$nav_yearly .= "<div style=\"float:left;\">$yearly_server_list</div>";
				$nav_yearly .= "<div id=\"yearly_nav_db_list\" style=\"float:left; margin-left:10px; display:none;\"></div>";
				$nav_yearly .= "<div id=\"yearly_nav_year_list\" style=\"float:left; margin-left:10px;\">$yearly_year_list</div>";
				$nav_yearly .= "<div id=\"yearly_nav_chartting_list\" style=\"float:left; margin-left:10px;\">$yearly_chartting_list</div>";
				$nav_yearly .= "<div style=\"float:left; margin-left:10px;\"><input class=\"button_orange\" type=\"submit\" value=\"Go!\"></div>";
				$nav_yearly .= "<div style=\"clear:both;\"></div>";
				$nav_yearly .= "</form>";
			}

			#####################################################
			#POSTGRESTATS DB EXISTS - ENABLE THE ADMIN NAVIGATION
			##################################################### 
			$ps_nav_admin  = "<div style=\"float:left;\"><a href=\"javascript:stat_view(2)\">Admin Account</a></div>";
			$ps_nav_admin .= "<div style=\"float:left; margin:0 5px 0 5px;\"> | </div>";
			$ps_nav_admin .= "<div style=\"float:left;\"><a href=\"javascript:stat_view(3)\">Servers and Databases</a></div>";
			$ps_nav_admin .= "<div style=\"float:left; margin:0 5px 0 5px;\"> | </div>";
			$ps_nav_admin .= "<div style=\"float:left;\"><a href=\"javascript:stat_view(1)\">PostgreStats Set-up</a></div>";
			$ps_nav_admin .= "<div style=\"clear:both;\"></div>";
		}
	}
}

#####################################
#LASTLY, ATTEMPT TO GET AN SSL STATUS
#####################################
if(isset($_SERVER['HTTPS']))
{
	if($_SERVER['HTTPS'] == "on") { $ssl_status = "Enabled"; $ssl_status_img = "icon_ssl_locked.png"; }
	else { $ssl_status = "Disabled"; $ssl_status_img = "icon_ssl_unlocked.png"; }
}
else
{
	$ssl_status = "Disabled"; $ssl_status_img = "icon_ssl_unlocked.png";
}
?>