<?php
/*
################################
#POSTGRESTATS ENTERPRISE LICENSE
################################
Copyright 2013 NWLYNX <http://www.nwlynx.com/>.

This file is part of PostgreStats Enterprise <http://www.postgrestats.com/>.

PostgreStats Enterprise is free software: you can redistribute it and/or modify it under the terms of the GNU General Public 
License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

PostgreStats Enterprise is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
*/

####################
#REQUIRE PS_CONF.PHP
####################
require("ps_conf.php");

#######################################################################################
#PARSE THE INCOMING REQUEST, GATHER DEPENDENT VARS AND PASS TO THE APPROPRIATE FUNCTION
#######################################################################################

#####################################################################
#MAKE SURE OUR STAT FUNCTION VARIABLE WAS PASSED FROM OUR AJAX SCRIPT
#####################################################################
if(isset($_POST["stat_function"]))
{
	########
	#GRAB IT
	########
	$stat_function = $_POST["stat_function"];
}
else
{
	##########
	#STOP HERE
	##########
	exit;
}

#########
#FOR SAFE
#########
if(empty($stat_function))
{
	$stat_msg = "Error no Stat Function passed.";
	echo $stat_msg;
	exit;
}

#####################
#GEN_PS_CREATE_SCRIPT
#####################
if($stat_function == "gen_ps_create_script")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$ps_user = $_POST["ps_user"];

	##################
	#CALL THE FUNCTION
	##################
	gen_ps_create_script($ps_user);
}

#####################
#ADMIN_RESET_PASSWORD
#####################
if($stat_function == "admin_reset_password")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$ps_admin_old_pass = $_POST["ps_admin_old_pass"];
	$ps_admin_new_pass_1 = $_POST["ps_admin_new_pass_1"];
	$ps_admin_new_pass_2 = $_POST["ps_admin_new_pass_2"];

	##################
	#CALL THE FUNCTION
	##################
	admin_reset_password($ps_admin_old_pass,$ps_admin_new_pass_1,$ps_admin_new_pass_2,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

#####################
#ADMIN_RESET_USERNAME
#####################
if($stat_function == "admin_reset_username")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$ps_admin_new_user = $_POST["ps_admin_new_user"];
	$ps_admin_pass = $_POST["ps_admin_pass"];

	##################
	#CALL THE FUNCTION
	##################
	admin_reset_username($ps_admin_new_user,$ps_admin_pass,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

##############
#SERVER_INSERT
##############
if($stat_function == "server_insert")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$ps_add_server_name = $_POST["ps_add_server_name"];
	$ps_add_server_host = $_POST["ps_add_server_host"];
	$ps_add_server_port = $_POST["ps_add_server_port"];

	##################
	#CALL THE FUNCTION
	##################
	server_insert($ps_add_server_name,$ps_add_server_host,$ps_add_server_port,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

##############
#SERVER_DELETE
##############
if($stat_function == "server_delete")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$server_id = $_POST["server_id"];

	##################
	#CALL THE FUNCTION
	##################
	server_delete($server_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

##############
#SERVER_UPDATE
##############
if($stat_function == "server_update")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$server_id = $_POST["server_id"];
	$ps_update_server_name = $_POST["ps_update_server_name"];
	$ps_update_server_host = $_POST["ps_update_server_host"];
	$ps_update_server_port = $_POST["ps_update_server_port"];
	$ps_update_server_pause = $_POST["ps_update_server_pause"];

	##################
	#CALL THE FUNCTION
	##################
	server_update($server_id,$ps_update_server_name,$ps_update_server_host,$ps_update_server_port,$ps_update_server_pause,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

####################
#SERVER_LIST_REFRESH
####################
if($stat_function == "server_list_refresh")
{
	##################
	#CALL THE FUNCTION
	##################
	server_list_refresh($postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

###################
#SERVER_OPEN_UPDATE
###################
if($stat_function == "server_open_update")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$server_id = $_POST["server_id"];

	##################
	#CALL THE FUNCTION
	##################
	server_open_update($server_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

###############
#DB_OPEN_INSERT
###############
if($stat_function == "db_open_insert")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$server_id = $_POST["server_id"];

	##################
	#CALL THE FUNCTION
	##################
	db_open_insert($server_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

##########
#DB_INSERT
##########
if($stat_function == "db_insert")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$server_id = $_POST["server_id"];
	$ps_insert_db_name = $_POST["ps_insert_db_name"];
	$ps_insert_db_user = $_POST["ps_insert_db_user"];
	$ps_insert_db_pass = $_POST["ps_insert_db_pass"];
	$ps_insert_db_ap = $_POST["ps_insert_db_ap"];

	##################
	#CALL THE FUNCTION
	##################
	db_insert($server_id,$ps_insert_db_name,$ps_insert_db_user,$ps_insert_db_pass,$ps_insert_db_ap,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

##########
#DB_UPDATE
##########
if($stat_function == "db_update")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$server_id = $_POST["server_id"];
	$db_id = $_POST["db_id"];
	$ps_update_db_name = $_POST["ps_update_db_name"];
	$ps_update_db_user = $_POST["ps_update_db_user"];
	$ps_update_db_pass = $_POST["ps_update_db_pass"];
	$ps_update_db_pause = $_POST["ps_update_db_pause"];

	##################
	#CALL THE FUNCTION
	##################
	db_update($server_id,$db_id,$ps_update_db_name,$ps_update_db_user,$ps_update_db_pass,$ps_update_db_pause,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

#############
#DB_OPEN_LIST
#############
if($stat_function == "db_open_list")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$server_id = $_POST["server_id"];

	##################
	#CALL THE FUNCTION
	##################
	db_open_list($server_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

##########
#DB_DELETE
##########
if($stat_function == "db_delete")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$server_id = $_POST["server_id"];
	$db_id = $_POST["db_id"];

	##################
	#CALL THE FUNCTION
	##################
	db_delete($server_id,$db_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

############
#DB_VALIDATE
############
if($stat_function == "db_validate")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$server_id = $_POST["server_id"];
	$db_id = $_POST["db_id"];

	##################
	#CALL THE FUNCTION
	##################
	db_validate($server_id,$db_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

###############
#DB_OPEN_UPDATE
###############
if($stat_function == "db_open_update")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$server_id = $_POST["server_id"];
	$db_id = $_POST["db_id"];

	##################
	#CALL THE FUNCTION
	##################
	db_open_update($server_id,$db_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

##############################
#MONTHLY_SNAP_RETRIEVE_NAV_DBS
##############################
if($stat_function == "monthly_snap_retrieve_nav_dbs")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$server_id = $_POST["server_id"];

	##################
	#CALL THE FUNCTION
	##################
	monthly_snap_retrieve_nav_dbs($server_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

###########################
#MONTHLY_SNAP_SELECT_NAV_DB
###########################
if($stat_function == "monthly_snap_select_nav_db")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$server_id = $_POST["server_id"];
	$db_id = $_POST["db_id"];

	##################
	#CALL THE FUNCTION
	##################
	monthly_snap_select_nav_db($server_id,$db_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

######################
#MONTHLY_SNAP_RETRIEVE
######################
if($stat_function == "monthly_snap_retrieve")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$servers = $_POST["servers"];
	$dbs = $_POST["dbs"];
	$month = $_POST["month"];
	$year = $_POST["year"];
	$snap_chartting = $_POST["snap_chartting"];

	##################
	#CALL THE FUNCTION
	##################
	monthly_snap_retrieve($servers,$dbs,$month,$year,$snap_chartting,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

#########################
#DAILY_SELECT_NAV_SERVERS
#########################
if($stat_function == "daily_select_nav_servers")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$server_id = $_POST["server_id"];

	##################
	#CALL THE FUNCTION
	##################
	daily_select_nav_servers($server_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

###############
#DAILY_RETRIEVE
###############
if($stat_function == "daily_retrieve")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$servers = $_POST["servers"];
	$day = $_POST["day"];
	$month = $_POST["month"];
	$year = $_POST["year"];
	$daily_chartting = $_POST["daily_chartting"];
	$daily_rep_mode = $_POST["daily_rep_mode"];

	##################
	#CALL THE FUNCTION
	##################
	daily_retrieve($servers,$day,$month,$year,$daily_chartting,$daily_rep_mode,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

########################
#VERSUS_RETRIEVE_NAV_DBS
########################
if($stat_function == "versus_retrieve_nav_dbs")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$server_id = $_POST["server_id"];

	##################
	#CALL THE FUNCTION
	##################
	versus_retrieve_nav_dbs($server_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

#####################
#VERSUS_SELECT_NAV_DB
#####################
if($stat_function == "versus_select_nav_db")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$server_id = $_POST["server_id"];
	$db_id = $_POST["db_id"];

	##################
	#CALL THE FUNCTION
	##################
	versus_select_nav_db($server_id,$db_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

################
#VERSUS_RETRIEVE
################
if($stat_function == "versus_retrieve")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$servers = $_POST["servers"];
	$dbs = $_POST["dbs"];
	$month_a = $_POST["month_a"];
	$year_a = $_POST["year_a"];
	$month_b = $_POST["month_b"];
	$year_b = $_POST["year_b"];
	$versus_chartting = $_POST["versus_chartting"];

	##################
	#CALL THE FUNCTION
	##################
	versus_retrieve($servers,$dbs,$month_a,$year_a,$month_b,$year_b,$versus_chartting,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

########################
#WEEKLY_RETRIEVE_NAV_DBS
########################
if($stat_function == "weekly_retrieve_nav_dbs")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$server_id = $_POST["server_id"];

	##################
	#CALL THE FUNCTION
	##################
	weekly_retrieve_nav_dbs($server_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

#####################
#WEEKLY_SELECT_NAV_DB
#####################
if($stat_function == "weekly_select_nav_db")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$server_id = $_POST["server_id"];
	$db_id = $_POST["db_id"];

	##################
	#CALL THE FUNCTION
	##################
	weekly_select_nav_db($server_id,$db_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

################
#WEEKLY_RETRIEVE
################
if($stat_function == "weekly_retrieve")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$servers = $_POST["servers"];
	$dbs = $_POST["dbs"];
	$month = $_POST["month"];
	$year = $_POST["year"];
	$weekly_chartting = $_POST["weekly_chartting"];

	##################
	#CALL THE FUNCTION
	##################
	weekly_retrieve($servers,$dbs,$month,$year,$weekly_chartting,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

########################
#YEARLY_RETRIEVE_NAV_DBS
########################
if($stat_function == "yearly_retrieve_nav_dbs")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$server_id = $_POST["server_id"];

	##################
	#CALL THE FUNCTION
	##################
	yearly_retrieve_nav_dbs($server_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

#####################
#YEARLY_SELECT_NAV_DB
#####################
if($stat_function == "yearly_select_nav_db")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$server_id = $_POST["server_id"];
	$db_id = $_POST["db_id"];

	##################
	#CALL THE FUNCTION
	##################
	yearly_select_nav_db($server_id,$db_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

################
#YEARLY_RETRIEVE
################
if($stat_function == "yearly_retrieve")
{
	###########################
	#RETRIEVE OUR INCOMING VARS
	###########################
	$servers = $_POST["servers"];
	$dbs = $_POST["dbs"];
	$year = $_POST["year"];
	$yearly_chartting = $_POST["yearly_chartting"];

	##################
	#CALL THE FUNCTION
	##################
	yearly_retrieve($servers,$dbs,$year,$yearly_chartting,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port);
}

##########################################################################################################
##########################################################################################################
#FUNCTION: GEN_PS_CREATE_SCRIPT
##########################################################################################################
##########################################################################################################
function gen_ps_create_script($ps_user)
{
	##############
	#PREP INCOMING
	##############
	$ps_user = trim($ps_user);

	###################
	#DO SOME VALIDATION
	###################
	if(empty($ps_user))
	{
		$ajax_return = "<div style=\"margin:15px 0 0 20px;\">Your PostgreSQL user is required.</div>";
		echo $ajax_return;
		exit;
	}

	###################################
	#CREATE 10 DIGIT RANDOM SALT FOR DB
	###################################	
	$db_user = $ps_user;
	$db_password = "password";
	$length = 10;
	$validCharacters = "0123456789abcdefghijklmnopqrstuxyvwzABCDEFGHIJKLMNOPQRSTUXYVWZ`~!@#$%^&*()-=_+";
	$validCharNumber = strlen($validCharacters);
	$salt = "";

	#######################
	#RUN THE LOOP AND DO IT
	#######################
	for($i = 0; $i < $length; $i++)
	{
		$index = mt_rand(0, $validCharNumber - 1);
		$salt .= $validCharacters[$index];
	}

	##############################
	#HASH THE PASS AND ESCAPE VARS
	##############################
	$hashed_password = hash('sha256',$salt.$db_password);
	$db_password = pg_escape_string($hashed_password);
	$db_salt = pg_escape_string($salt);

##############
#CREATE SYNTAX
##############
$sc = <<<AJR
createdb postgrestats;
psql postgrestats;
CREATE TABLE ps_user_tbl(user_id serial primary key, salt varchar(30), ps_user varchar(100), ps_pass varchar(200), account_type integer, created_date timestamp);
GRANT INSERT, SELECT, UPDATE, DELETE ON TABLE ps_user_tbl TO $db_user;
GRANT SELECT, UPDATE ON TABLE ps_user_tbl_user_id_seq TO $db_user;
CREATE TABLE ps_server_tbl(server_id serial primary key, server_name varchar(100), server_host varchar(50), port integer, pause integer, created_date timestamp);
GRANT INSERT, SELECT, UPDATE, DELETE ON TABLE ps_server_tbl TO $db_user;
GRANT SELECT, UPDATE ON TABLE ps_server_tbl_server_id_seq TO $db_user;
CREATE TABLE ps_db_tbl(db_id serial primary key, server_id integer NOT NULL,FOREIGN KEY(server_id) references ps_server_tbl, db_last_reset timestamp, db_name varchar(200), db_auth_1 varchar(100), db_auth_2 varchar(200), db_auth_3 varchar(100), db_auth_4 varchar(200), pause integer, created_date timestamp);
GRANT INSERT, SELECT, UPDATE, DELETE ON TABLE ps_db_tbl TO $db_user;
GRANT SELECT, UPDATE ON TABLE ps_db_tbl_db_id_seq TO $db_user;
CREATE TABLE ps_core_tbl(ps_core_id serial primary key, db_id integer NOT NULL,FOREIGN KEY(db_id) references ps_db_tbl, server_id integer NOT NULL,FOREIGN KEY(server_id) references ps_server_tbl, recorded timestamp, datid integer, datname varchar(200), core_commits bigint, core_rollbacks bigint, core_block_reads bigint, core_buffer_hits bigint, user_inserts bigint, user_updates bigint, user_deletes bigint, user_seq_scans bigint, user_idx_scans bigint, user_seq_rows bigint, user_idx_rows bigint);
GRANT INSERT, SELECT, UPDATE, DELETE ON TABLE ps_core_tbl TO $db_user;
GRANT SELECT, UPDATE ON TABLE ps_core_tbl_ps_core_id_seq TO $db_user;
INSERT INTO ps_user_tbl(salt,ps_user,ps_pass,account_type,created_date) VALUES('$db_salt','postgrestats','$db_password',1,CURRENT_TIMESTAMP);
\d
\q
AJR;

############################
#PERMISSION GRANTS STATEMENT
############################
$ajax_return = <<<AJR
<div style="margin:20px 0 20px 0;"><textarea class="script_gen_text_area" name="db_create_syntax" id="db_create_syntax">$sc</textarea></div>
<div><span style="font-weight:bold;">IMPORTANT:</span> The above syntax already includes the permission grant statements necessary for your PostgreSQL user. On your server, SU to postgres and simply paste this script into the command line.</div>
AJR;

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: ADMIN_RESET_PASSWORD
##########################################################################################################
##########################################################################################################
function admin_reset_password($ps_admin_old_pass,$ps_admin_new_pass_1,$ps_admin_new_pass_2,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	##############
	#PREP INCOMING
	##############
	$ps_admin_old_pass = trim($ps_admin_old_pass);
	$ps_admin_new_pass_1 = trim($ps_admin_new_pass_1);
	$ps_admin_new_pass_2 = trim($ps_admin_new_pass_2);

	###################
	#DO SOME VALIDATION
	###################
	if(empty($ps_admin_old_pass) || empty($ps_admin_new_pass_1) || empty($ps_admin_new_pass_2))
	{
		$ajax_return = "Both old and new passwords are required.";
		echo $ajax_return;
		exit;
	}
	elseif($ps_admin_new_pass_1 != $ps_admin_new_pass_2)
	{
		$ajax_return = "Your new passwords do not match.";
		echo $ajax_return;
		exit;
	}
	elseif($ps_admin_old_pass == $ps_admin_new_pass_1)
	{
		$ajax_return = "The new password and old password fields must be different.";
		echo $ajax_return;
		exit;
	}
	elseif(strlen($ps_admin_new_pass_1) < 8)
	{
		$ajax_return = "Your new password must be at least 8 characters.";
		echo $ajax_return;
		exit;
	}

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");
	if(!$pg_conn) { echo "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials."; exit; }

	################
	#QUERY USER DATA
	################
	$sqlselect_ps_admin = @pg_query($pg_conn, "SELECT * FROM ps_user_tbl WHERE account_type = 1");
	if(!$sqlselect_ps_admin) { echo "Error executing PostgreStats query."; exit; }

	##############################
	#MAKE CERTAIN WE HAVE AN ADMIN
	##############################
	if(pg_num_rows($sqlselect_ps_admin) == 0) { echo "No PostgreStats admin account was found."; exit; }

	##############
	#GRAB OUR DATA
	##############
	$query_data_ps_admin = pg_fetch_row($sqlselect_ps_admin);
	$user_id = $query_data_ps_admin[0];
	$salt = $query_data_ps_admin[1];
	$ps_user = $query_data_ps_admin[2];
	$ps_pass = $query_data_ps_admin[3];

	##############################
	#RE-HASH INCOMING OLD PASSWORD
	##############################
	$ps_admin_old_pass = hash("sha256", $salt.$ps_admin_old_pass);

	######################
	#COMPARE OLD PASSWORDS
	######################
	if($ps_admin_old_pass != $ps_pass)
	{
		$ajax_return = "The old admin password you have entered is incorrect.";
		echo $ajax_return;
		exit;
	}

	##############################
	#HASH THE PASS AND ESCAPE VARS
	##############################
	$hashed_password = hash('sha256',$salt.$ps_admin_new_pass_1);
	$db_password = pg_escape_string($hashed_password);
	$db_salt = pg_escape_string($salt);
	$db_user = pg_escape_string($ps_user);
	$db_password_old = pg_escape_string($ps_pass);

	###############
	#RUN THE UPDATE
	###############
	$sqlupdate_admin_pass = @pg_query($pg_conn, "UPDATE ps_user_tbl SET ps_pass='$db_password' WHERE account_type = 1 AND ps_pass='$db_password_old' AND ps_user = '$db_user' AND salt='$db_salt'");
	if(!$sqlupdate_admin_pass) { echo "Error executing PostgreStats query."; exit; }

	############
	#SUCCESS MSG
	############
	$ajax_return = "Your PostgreStats admin password has been reset. You'll be prompted to re-login on page refresh.";

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: ADMIN_RESET_USERNAME
##########################################################################################################
##########################################################################################################
function admin_reset_username($ps_admin_new_user,$ps_admin_pass,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	##############
	#PREP INCOMING
	##############
	$ps_admin_new_user = trim($ps_admin_new_user);
	$ps_admin_pass = trim($ps_admin_pass);

	###################
	#DO SOME VALIDATION
	###################
	if(empty($ps_admin_new_user) || empty($ps_admin_pass))
	{
		$ajax_return = "Both new username and password required.";
		echo $ajax_return;
		exit;
	}
	elseif($ps_admin_new_user == $ps_admin_pass)
	{
		$ajax_return = "Your username and password cannot be the same.";
		echo $ajax_return;
		exit;
	}
	elseif(strlen($ps_admin_new_user) < 8)
	{
		$ajax_return = "Your new username must be at least 8 characters.";
		echo $ajax_return;
		exit;
	}

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");
	if(!$pg_conn) { echo "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials."; exit; }

	################
	#QUERY USER DATA
	################
	$sqlselect_ps_admin = @pg_query($pg_conn, "SELECT * FROM ps_user_tbl WHERE account_type = 1");
	if(!$sqlselect_ps_admin) { echo "Error executing PostgreStats query."; exit; }

	##############################
	#MAKE CERTAIN WE HAVE AN ADMIN
	##############################
	if(pg_num_rows($sqlselect_ps_admin) == 0) { echo "No PostgreStats admin account was found."; exit; }

	##############
	#GRAB OUR DATA
	##############
	$query_data_ps_admin = pg_fetch_row($sqlselect_ps_admin);
	$user_id = $query_data_ps_admin[0];
	$salt = $query_data_ps_admin[1];
	$ps_user = $query_data_ps_admin[2];
	$ps_pass = $query_data_ps_admin[3];

	##################
	#COMPARE USERNAMES
	##################
	if($ps_admin_new_user == $ps_user)
	{
		$ajax_return = "This new username is the same as the old username.";
		echo $ajax_return;
		exit;
	}

	##############################
	#RE-HASH INCOMING OLD PASSWORD
	##############################
	$ps_admin_pass = hash("sha256", $salt.$ps_admin_pass);

	##################
	#COMPARE PASSWORDS
	##################
	if($ps_admin_pass != $ps_pass)
	{
		$ajax_return = "The admin password you have entered is incorrect.";
		echo $ajax_return;
		exit;
	}

	#################
	#PREP VARS FOR DB
	#################
	$ps_admin_new_user = pg_escape_string($ps_admin_new_user);
	$ps_user = pg_escape_string($ps_user);
	$salt = pg_escape_string($salt);

	###############
	#RUN THE UPDATE
	###############
	$sqlupdate_admin_user = @pg_query($pg_conn, "UPDATE ps_user_tbl SET ps_user='$ps_admin_new_user' WHERE account_type = 1 AND ps_pass='$ps_pass' AND ps_user='$ps_user' AND salt='$salt'");
	if(!$sqlupdate_admin_user) { echo "Error executing PostgreStats query."; exit; }

	############
	#SUCCESS MSG
	############
	$ajax_return = "Your PostgreStats admin username has been reset. You'll be prompted to re-login on page refresh.";

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: SERVER_INSERT
##########################################################################################################
##########################################################################################################
function server_insert($ps_add_server_name,$ps_add_server_host,$ps_add_server_port,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	####################################
	#CREATE RETURN ARRAY FOR JSON VALUES
	####################################
	$ajax_return = array();

	################################
	#DEFAULT SUCCESS VALUE AS FAILED
	################################
	$ajax_return[] = 2;

	##############
	#PREP INCOMING
	##############
	$ps_add_server_name = trim(preg_replace("/ +/", " ", $ps_add_server_name));
	$ps_add_server_name = preg_replace('/[^0-9a-zA-Z_-\s]/',"",$ps_add_server_name);
	$ps_add_server_host = strtolower(trim($ps_add_server_host));
	$ps_add_server_port = trim($ps_add_server_port);

	###################
	#DO SOME VALIDATION
	###################
	if(empty($ps_add_server_name) || empty($ps_add_server_host) || empty($ps_add_server_port))
	{
		$ajax_return[] = "Server name, host and port are required.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}
	elseif(strlen($ps_add_server_name) < 5)
	{
		$ajax_return[] = "Server name must be at least 5 characters.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}
	elseif(!is_numeric($ps_add_server_port))
	{
		$ajax_return[] = "Server port must be numeric.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}
	elseif($ps_add_server_host != "localhost")
	{
		if(!filter_var($ps_add_server_host, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4) && !filter_var($ps_add_server_host, FILTER_VALIDATE_IP, FILTER_FLAG_IPV6))
		{
			$ajax_return[] = "Server host can be 'localhost' or a valid IPV4/IPV6 IP address only.";
			$ajax_return = json_encode($ajax_return);
			echo $ajax_return;
			exit;
		}
	}

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");

	#############
	#MAKE CERTAIN
	#############
	if(!$pg_conn)
	{
		$ajax_return[] = "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	##########
	#PREP VARS
	##########
	$ps_add_server_name = pg_escape_string($ps_add_server_name);
	$ps_add_server_host = pg_escape_string($ps_add_server_host);

	#####################
	#CHECK FOR DUPLICATES
	#####################
	$sqlselect_dup_servers = @pg_query($pg_conn, "SELECT server_id FROM ps_server_tbl WHERE (server_name = '$ps_add_server_name') OR (server_host = '$ps_add_server_host' AND port = $ps_add_server_port)");

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlselect_dup_servers)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	##############
	#GRAB OUR DATA
	##############
	if(pg_num_rows($sqlselect_dup_servers) > 0)
	{
		$ajax_return[] = "Either this server name or this host/port combination already exist.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	###############
	#RUN THE INSERT
	###############
	$sqlinsert_server = @pg_query($pg_conn, "INSERT INTO ps_server_tbl(server_name,server_host,port,pause,created_date) VALUES('$ps_add_server_name','$ps_add_server_host',$ps_add_server_port,1,CURRENT_TIMESTAMP)");

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlinsert_server)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	############
	#SUCCESS MSG
	############
	$ajax_return[0] = 1;
	$ajax_return[] = "Server installed. Add databases to this server below.";
	$ajax_return = json_encode($ajax_return);

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: SERVER_DELETE
##########################################################################################################
##########################################################################################################
function server_delete($server_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	###################
	#DO SOME VALIDATION
	###################
	if(empty($server_id) || !is_numeric($server_id))
	{
		$ajax_return = "Invalid server ID passed.";
		echo $ajax_return;
		exit;
	}

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");
	if(!$pg_conn) { echo "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials."; exit; }

	#########################
	#RETRIEVE OUR SERVER DATA
	#########################
	$sqlselect_server = @pg_query($pg_conn, "SELECT server_id FROM ps_server_tbl WHERE server_id = $server_id");
	if(!$sqlselect_server) { echo "Error executing PostgreStats query."; exit; }

	############################
	#IF THERE ARE NO SERVERS YET
	############################
	if(pg_num_rows($sqlselect_server) == 0)
	{
		$ajax_return = "There are no servers by this ID.";
		echo $ajax_return;
		exit;
	}

	########################
	#DELETE FROM PS_CORE_TBL
	########################
	$sqldelete = @pg_query($pg_conn, "DELETE FROM ps_core_tbl WHERE server_id = $server_id");
	if(!$sqldelete) { echo "Error executing PostgreStats query."; exit; }

	######################
	#DELETE FROM PS_DB_TBL
	######################
	$sqldelete = @pg_query($pg_conn, "DELETE FROM ps_db_tbl WHERE server_id = $server_id");
	if(!$sqldelete) { echo "Error executing PostgreStats query."; exit; }

	##########################
	#DELETE FROM PS_SERVER_TBL
	##########################
	$sqldelete = @pg_query($pg_conn, "DELETE FROM ps_server_tbl WHERE server_id = $server_id");
	if(!$sqldelete) { echo "Error executing PostgreStats query."; exit; }

	################
	#PREP RETURN VAR
	################
	$ajax_return = "Server deleted successfully.";

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: SERVER_UPDATE
##########################################################################################################
##########################################################################################################
function server_update($server_id,$ps_update_server_name,$ps_update_server_host,$ps_update_server_port,$ps_update_server_pause,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	####################################
	#CREATE RETURN ARRAY FOR JSON VALUES
	####################################
	$ajax_return = array();

	################################
	#DEFAULT SUCCESS VALUE AS FAILED
	################################
	$ajax_return[] = 2;

	##############
	#PREP INCOMING
	##############
	$ps_update_server_name = trim(preg_replace("/ +/", " ", $ps_update_server_name));
	$ps_update_server_name = preg_replace('/[^0-9a-zA-Z_-\s]/',"",$ps_update_server_name);
	$ps_update_server_host = strtolower(trim($ps_update_server_host));
	$ps_update_server_port = trim($ps_update_server_port);

	###################
	#DO SOME VALIDATION
	###################
	if(empty($ps_update_server_name) || empty($ps_update_server_host) || empty($ps_update_server_port))
	{
		$ajax_return[] = "Server name, host and port are required.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}
	elseif(strlen($ps_update_server_name) < 5)
	{
		$ajax_return[] = "Server name must be at least 5 characters.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}
	elseif(!is_numeric($ps_update_server_port))
	{
		$ajax_return[] = "Server port must be numeric.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}
	elseif($ps_update_server_host != "localhost")
	{
		if(!filter_var($ps_update_server_host, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4) && !filter_var($ps_update_server_host, FILTER_VALIDATE_IP, FILTER_FLAG_IPV6))
		{
			$ajax_return[] = "Server host can be 'localhost' or a valid IPV4/IPV6 IP address only.";
			$ajax_return = json_encode($ajax_return);
			echo $ajax_return;
			exit;
		}
	}
	elseif(empty($server_id) || !is_numeric($server_id))
	{
		$ajax_return[] = "Invalid server ID passed.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	###########################
	#HANDLE SERVER PAUSE STATUS
	###########################
	if($ps_update_server_pause != 1 && $ps_update_server_pause != 2) $ps_update_server_pause = 1;

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");

	#############
	#MAKE CERTAIN
	#############
	if(!$pg_conn)
	{
		$ajax_return[] = "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	##########
	#PREP VARS
	##########
	$ps_update_server_name = pg_escape_string($ps_update_server_name);
	$ps_update_server_host = pg_escape_string($ps_update_server_host);

	#############################
	#MAKE SURE THIS SERVER EXISTS
	#############################
	$sqlselect_server = @pg_query($pg_conn, "SELECT server_id FROM ps_server_tbl WHERE server_id = $server_id");

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlselect_server)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	##########
	#MAKE SURE
	##########
	if(pg_num_rows($sqlselect_server) == 0)
	{
		$ajax_return[] = "There are no servers by this ID.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	#####################
	#CHECK FOR DUPLICATES
	#####################
	$sqlselect_dup_servers = @pg_query($pg_conn, "SELECT server_id FROM ps_server_tbl WHERE server_id != $server_id AND ((server_name = '$ps_update_server_name') OR (server_host = '$ps_update_server_host' AND port = $ps_update_server_port))");

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlselect_dup_servers)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	##############
	#GRAB OUR DATA
	##############
	if(pg_num_rows($sqlselect_dup_servers) > 0)
	{
		$ajax_return[] = "Either this server name or this host/port combination already exist.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	###############
	#RUN THE UPDATE
	###############
	$sqlupdate_server = @pg_query($pg_conn, "UPDATE ps_server_tbl SET server_name = '$ps_update_server_name', server_host = '$ps_update_server_host', port = $ps_update_server_port, pause = $ps_update_server_pause WHERE server_id = $server_id");
	
	#############
	#MAKE CERTAIN
	#############
	if(!$sqlupdate_server)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	############
	#SUCCESS MSG
	############
	$ajax_return[0] = 1;
	$ajax_return[] = "Server updated successfully.";
	$ajax_return = json_encode($ajax_return);

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: SERVER_LIST_REFRESH
##########################################################################################################
##########################################################################################################
function server_list_refresh($postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");
	if(!$pg_conn) { echo "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials."; exit; }

	#########################
	#RETRIEVE OUR SERVER DATA
	#########################
	$sqlselect_servers = @pg_query($pg_conn, "SELECT server_id,server_name,server_host FROM ps_server_tbl ORDER BY server_name ASC");
	if(!$sqlselect_servers) { echo "Error executing PostgreStats query."; exit; }

	############################
	#IF THERE ARE NO SERVERS YET
	############################
	if(pg_num_rows($sqlselect_servers) == 0)
	{
		$ajax_return = "There are no servers installed yet in your PostgreStats implementation.";
		echo $ajax_return;
		exit;
	}

	##############
	#PREP TOOLTIPS
	##############
	$tt_edit = "onMouseOver=\"tooltip.show('Edit&nbsp;server')\" onMouseOut='tooltip.hide()'";
	$tt_db_list = "onMouseOver=\"tooltip.show('List&nbsp;databases')\" onMouseOut='tooltip.hide()'";
	$tt_db_add = "onMouseOver=\"tooltip.show('Add&nbsp;database')\" onMouseOut='tooltip.hide()'";
	$tt_delete = "onMouseOver=\"tooltip.show('Remove&nbsp;server')\" onMouseOut='tooltip.hide()'";

############################
#PUT TOGETHER INITIAL RETURN
############################
$ajax_return = <<<AJR
<div class="black_12" style="float:left; height:25px; padding-top:4px;">Servers:</div>
<div style="float:left; height:25px; margin:0 10px 0 5px;">
<select class="select_menu" name="server_list_dropdown" id="server_list_dropdown" onchange="close_server_db_windows()">
AJR;

	################################
	#ADD EACH SERVER TO THE DROPDOWN
	################################
	while($query_data_servers = pg_fetch_row($sqlselect_servers))
	{
		$server_id = $query_data_servers[0];
		$server_name = $query_data_servers[1];
		$server_host = $query_data_servers[2];
		$ajax_return .= "<option value=\"$server_id\">$server_name ($server_host)</option>";
	}

#########################
#COMPLETE THE RETURN HTML
#########################
$ajax_return .= <<<AJR
</select>
</div>
<div style="float:left; height:25px;"><a href="javascript:server_open_update()" $tt_edit><img src="images/icon_edit.png" width="25" height="25" style="margin-right:5px;"/></a><a href="javascript:db_open_list()" $tt_db_list><img src="images/icon_dbs.png" width="25" height="25" style="margin-right:5px;"/></a><a href="javascript:db_open_insert()" $tt_db_add><img src="images/icon_db_add.png" width="25" height="25" style="margin-right:5px;"/></a><a href="javascript:server_delete()" onclick="return confirm('Delete server & all associated data?')" $tt_delete><img src="images/icon_delete.png" width="25" height="25" style="margin-right:5px;"/></a></div>
<div style="clear:both;"></div>
AJR;

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: SERVER_OPEN_UPDATE
##########################################################################################################
##########################################################################################################
function server_open_update($server_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	###################
	#DO SOME VALIDATION
	###################
	if(empty($server_id) || !is_numeric($server_id))
	{
		$ajax_return = "Invalid server ID passed.";
		echo $ajax_return;
		exit;
	}

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");
	if(!$pg_conn) { echo "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials."; exit; }

	#########################
	#RETRIEVE OUR SERVER DATA
	#########################
	$sqlselect_server = @pg_query($pg_conn, "SELECT * FROM ps_server_tbl WHERE server_id = $server_id");
	if(!$sqlselect_server) { echo "Error executing PostgreStats query."; exit; }

	############################
	#IF THERE ARE NO SERVERS YET
	############################
	if(pg_num_rows($sqlselect_server) == 0)
	{
		$ajax_return = "There are no servers by this ID.";
		echo $ajax_return;
		exit;
	}

	#############
	#GRAB RESULTS
	#############
	$query_data_server = pg_fetch_row($sqlselect_server);
	$server_id = $query_data_server[0];
	$server_name = $query_data_server[1];
	$server_host = $query_data_server[2];
	$port = $query_data_server[3];
	$pause = $query_data_server[4];

	#HANDLE PAUSE STATUS
	if($pause == 2) $pause = " checked=\"checked\"";

######################
#PUT TOGETHER OUR HTML
######################
$ajax_return = <<<AJR
<form action="javascript:server_update($server_id)" method="post">

<!-- SERVER NAME -->
<div style="margin:25px 0 0 0px; font-weight:bold;">
<div class="black_12" style="float:left; margin:4px 10px 0 0; text-align:right; width:100px;">Server&nbsp;Name:</div>
<div style="float:left;"><input name="ps_update_server_name" value="$server_name" type="text" class="text_box_grey" id="ps_update_server_name" maxlength="25"></div>
<div class="grey_12" style="float:left; margin:4px 0 0 10px; font-weight:normal;">(Friendly name you'll use to identify this server)</div>
<div style="clear:both;"></div>
</div>

<!-- SERVER HOST -->
<div style="margin:15px 0 0 0px; font-weight:bold;">
<div class="black_12" style="float:left; margin:4px 10px 0 0; text-align:right; width:100px;">Server&nbsp;Host:</div>
<div style="float:left;"><input name="ps_update_server_host" value="$server_host" type="text" class="text_box_grey" id="ps_update_server_host" maxlength="50"></div>
<div class="grey_12" style="float:left; margin:4px 0 0 10px; font-weight:normal;">(Either 'localhost' or valid IPV4 / IPV6 IP)</div>
<div style="clear:both;"></div>
</div>

<!-- SERVER PORT -->
<div style="margin:15px 0 0 0px; font-weight:bold;">
<div class="black_12" style="float:left; margin:4px 10px 0 0; text-align:right; width:100px;">Server&nbsp;Port:</div>
<div style="float:left;"><input name="ps_update_server_port" value="$port" type="text" class="text_box_grey" id="ps_update_server_port" maxlength="10"></div>
<div class="grey_12" style="float:left; margin:4px 0 0 10px; font-weight:normal;">(Default PostgreSQL port is 5432)</div>
<div style="clear:both;"></div>
</div>

<!-- SERVER PAUSE -->
<div style="margin:15px 0 0 0px; font-weight:bold;">
<div class="black_12" style="float:left; margin:0 7px 0 0; text-align:right; width:100px;">Pause:</div>
<div class="black_12" style="float:left; font-weight:normal;"><input name="ps_update_server_pause" type="checkbox" id="ps_update_server_pause" $pause/> Pause all database statistics</div>
<div style="clear:both;"></div>
</div>

<!-- DO IT -->
<div class="orange_13" style="margin:15px 0 0 110px; font-weight:bold;"><input class="button_orange" type="submit" value="Update this Server"></div>

<!-- SERVER UPDATE RESULT - IN THE EVENT OF AN ERROR -->
<div id="server_update_result" style="margin:15px 0 0 110px; font-weight:normal; display:none;"></div>
</form>
AJR;

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: DB_OPEN_INSERT
##########################################################################################################
##########################################################################################################
function db_open_insert($server_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	###################
	#DO SOME VALIDATION
	###################
	if(empty($server_id) || !is_numeric($server_id))
	{
		$ajax_return = "Invalid server ID passed.";
		echo $ajax_return;
		exit;
	}

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");
	if(!$pg_conn) { echo "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials."; exit; }

	#########################
	#RETRIEVE OUR SERVER DATA
	#########################
	$sqlselect_server = @pg_query($pg_conn, "SELECT * FROM ps_server_tbl WHERE server_id = $server_id");
	if(!$sqlselect_server) { echo "Error executing PostgreStats query."; exit; }

	############################
	#IF THERE ARE NO SERVERS YET
	############################
	if(pg_num_rows($sqlselect_server) == 0)
	{
		$ajax_return = "There are no servers by this ID.";
		echo $ajax_return;
		exit;
	}

	#############
	#GRAB RESULTS
	#############
	$query_data_server = pg_fetch_row($sqlselect_server);
	$server_id = $query_data_server[0];
	$server_name = $query_data_server[1];
	$server_host = $query_data_server[2];
	$port = $query_data_server[3];
	$pause = $query_data_server[4];

######################
#PUT TOGETHER OUR HTML
######################
$ajax_return = <<<AJR
<form action="javascript:db_insert($server_id)" method="post">

<!-- SERVER INFORMAITON -->
<div style="margin:25px 0 0 0px; font-weight:bold;">
<div class="black_12" style="margin:4px 0 0 0; width:auto;">Server: <span style="font-weight:normal;">$server_name</span><span class="grey_12" style="font-weight:normal;"> | </span>Host: <span style="font-weight:normal;">$server_host</span><span class="grey_12" style="font-weight:normal;"> | </span>Port: <span style="font-weight:normal;">$port</span></div>
</div>

<!-- DATABASE NAME -->
<div style="margin:25px 0 0 0px; font-weight:bold;">
<div class="black_12" style="float:left; margin:4px 10px 0 0; text-align:right; width:100px;">Database&nbsp;Name:</div>
<div style="float:left;"><input name="ps_insert_db_name" type="text" class="text_box_grey" id="ps_insert_db_name" maxlength="25"></div>
<div class="grey_12" style="float:left; margin:4px 0 0 10px; font-weight:normal;">(The actual database name)</div>
<div style="clear:both;"></div>
</div>

<!-- USER NAME -->
<div style="margin:15px 0 0 0px; font-weight:bold;">
<div class="black_12" style="float:left; margin:4px 10px 0 0; text-align:right; width:100px;">Connect&nbsp;as&nbsp;User:</div>
<div style="float:left;"><input name="ps_insert_db_user" type="text" class="text_box_grey" id="ps_insert_db_user" maxlength="50"></div>
<div class="grey_12" style="float:left; margin:4px 0 0 10px; font-weight:normal;"></div>
<div style="clear:both;"></div>
</div>

<!-- PASSWORD -->
<div id="db_insert_pass_required_link" style="margin:15px 0 0 110px; font-weight:bold;"><a href="javascript:db_insert_show_pass_div()">This connection requires a password</a></div>
<div id="db_insert_pass_required_div" style="display:none; margin:15px 0 0 0px; font-weight:bold;">
<div class="black_12" style="float:left; margin:4px 10px 0 0; text-align:right; width:100px;">Password:</div>
<div style="float:left;"><input name="ps_insert_db_pass" type="password" class="text_box_grey" id="ps_insert_db_pass" maxlength="10"></div>
<div class="grey_12" style="float:left; margin:4px 0 0 10px; font-weight:normal;">[<a href="javascript:db_insert_hide_pass_div()" style="font-weight:bold;">X</a>]</div>
<div style="clear:both;"></div>
</div>

<!-- AUTO POPULATE -->
<div style="margin:15px 0 0 0px; font-weight:bold;">
<div class="black_12" style="float:left; margin:0 7px 0 0; text-align:right; width:100px;">Auto-Populate:</div>
<div class="black_12" style="float:left; font-weight:normal;"><input name="ps_insert_db_ap" type="checkbox" id="ps_insert_db_ap"/> Add all DBs this user can connect to</div>
<div style="clear:both;"></div>
</div>

<!-- DO IT -->
<div class="orange_13" style="margin:15px 0 0 110px; font-weight:bold;"><input class="button_orange" type="submit" value="Verify &amp; Add Database"></div>

<!-- DATABASE INSERT RESULT - IN THE EVENT OF AN ERROR -->
<div id="db_insert_result" style="margin:15px 0 0 110px; font-weight:normal; display:none;"></div>
</form>
AJR;

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: DB_INSERT
##########################################################################################################
##########################################################################################################
function db_insert($server_id,$ps_insert_db_name,$ps_insert_db_user,$ps_insert_db_pass,$ps_insert_db_ap,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	####################################
	#CREATE RETURN ARRAY FOR JSON VALUES
	####################################
	$ajax_return = array();

	################################
	#DEFAULT SUCCESS VALUE AS FAILED
	################################
	$ajax_return[] = 2;

	##############
	#PREP INCOMING
	##############
	$ps_insert_db_name = trim($ps_insert_db_name);
	$ps_insert_db_user = trim($ps_insert_db_user);
	$ps_insert_db_pass = trim($ps_insert_db_pass);

	###################
	#DO SOME VALIDATION
	###################
	if(empty($ps_insert_db_name) || empty($ps_insert_db_user))
	{
		$ajax_return[] = "Database name and user are required.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}
	elseif(empty($server_id) || !is_numeric($server_id))
	{
		$ajax_return[] = "Invalid server ID passed.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	################################
	#CHECK ON AUTO-POPULATE FOR SAFE
	################################
	if(empty($ps_insert_db_ap) || ($ps_insert_db_ap != 1 && $ps_insert_db_ap != 2)) $ps_insert_db_ap = 2;

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");

	#############
	#MAKE CERTAIN
	#############
	if(!$pg_conn)
	{
		$ajax_return[] = "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	#############################
	#MAKE SURE THIS SERVER EXISTS
	#############################
	$sqlselect_server = @pg_query($pg_conn, "SELECT * FROM ps_server_tbl WHERE server_id = $server_id");

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlselect_server)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	##########
	#MAKE SURE
	##########
	if(pg_num_rows($sqlselect_server) == 0)
	{
		$ajax_return[] = "There are no servers by this ID.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	#####################
	#GRAB OUR SERVER DATA
	#####################
	$query_data_server = pg_fetch_row($sqlselect_server);
	$server_id = $query_data_server[0];
	$server_name = $query_data_server[1];
	$server_host = $query_data_server[2];
	$server_port = $query_data_server[3];
	$server_pause = $query_data_server[4];
	$server_created_date = $query_data_server[5];

	###############
	#ESCAPE DB NAME
	###############
	$ps_insert_db_name = pg_escape_string($ps_insert_db_name);

	##########################################
	#CHECK FOR DUPLICATE DB - THIS SERVER ONLY
	##########################################
	$sqlselect_dup_db = @pg_query($pg_conn, "SELECT db_id FROM ps_db_tbl WHERE server_id = $server_id AND db_name = '$ps_insert_db_name'");

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlselect_dup_db)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	##########
	#MAKE SURE
	##########
	if(pg_num_rows($sqlselect_dup_db) > 0)
	{
		$ajax_return[] = "PostgreStats is already collecting statistics for this database.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	#######################################
	#ATTEMPT TO CONNECT TO THE NEW DATABASE
	#######################################
	$pg_conn_verify_db = @pg_connect("dbname=$ps_insert_db_name user=$ps_insert_db_user password=$ps_insert_db_pass host=$server_host port=$server_port",PGSQL_CONNECT_FORCE_NEW);

	#############
	#MAKE CERTAIN
	#############
	if(!$pg_conn_verify_db)
	{
		$ajax_return[] = "Error connecting to database. Please verify it exists and that this user has priveleges.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	#########################################
	#DEFAULT DB PAUSE STATUS TO 1 (UN-PAUSED)
	#########################################
	$pause = 1;

	##################################
	#IF NOT IN AUTO-DB-POPULATION MODE
	##################################
	if($ps_insert_db_ap != 1)
	{
		################################################
		#FINISHED WITH VERFICATION CONNECTION - CLOSE IT
		################################################
		pg_close($pg_conn_verify_db);

		#####################################################################################
		#SOME OBFUSCATION & ENCODING JUST SO DB CREDENTIALS ARE NOT HUMAN READABLE IN THE DB
		#WHY ARE THESE NOT 1-WAY ENCRYPTED LIKE YOUR POSTGRESTATS PASSWORD?
		#BECAUSE OBTAINING CREDENTIALS ON-THE-FLY IS NECESSARY FOR AUTOMATED STAT RETRIEVAL
		#IF YOUR WEB-SERVER IS 'TRUSTED' VIA YOUR pg_hba.conf FILE AND DOES NOT REQUIRE A
		#PASSWORD TO CONNECT, WE RECOMMEND NOT STORING ANY DB PASSWORDS WHEN INSERTING DBS
		#####################################################################################

		#######################
		#HANDLE USER REGARDLESS
		#######################
		$db_user = strrev($ps_insert_db_user); $sl = strlen($db_user); $rcu = ""; $chars = "0123456789abcdefghijklmnopqrstuxyvwzABCDEFGHIJKLMNOPQRSTUXYVWZ`~!@#$%^&*()-=_+";
		while(strlen($rcu) < $sl) { $random_char = $chars[rand(0,strlen($chars)-1)]; $pos_1 = strpos($db_user, $random_char); $pos_2 = strpos($rcu, $random_char); if($pos_1 === false && $pos_2 === false) $rcu .= $random_char; }
		for($ir = 0; $ir < strlen($rcu); $ir++) { $random_position = rand(0,strlen($db_user)-1); $char = substr($rcu,$ir,1); $db_user = substr($db_user,0,$random_position).$char.substr($db_user,$random_position); }
		$db_auth_1 = pg_escape_string(str_shuffle($rcu)); $db_auth_2 = pg_escape_string(base64_encode($db_user));

		#####################
		#IF PASSWORD REQUIRED
		#####################
		if(!empty($ps_insert_db_pass))
		{
			$db_pass = strrev($ps_insert_db_pass); $sl = strlen($db_pass); $rcp = ""; $chars = "0123456789abcdefghijklmnopqrstuxyvwzABCDEFGHIJKLMNOPQRSTUXYVWZ`~!@#$%^&*()-=_+";
			while(strlen($rcp) < $sl) { $random_char = $chars[rand(0,strlen($chars)-1)]; $pos_1 = strpos($db_pass, $random_char); $pos_2 = strpos($rcp, $random_char); if($pos_1 === false && $pos_2 === false) $rcp .= $random_char; }
			for($ir = 0; $ir < strlen($rcp); $ir++) { $random_position = rand(0,strlen($db_pass)-1); $char = substr($rcp,$ir,1); $db_pass = substr($db_pass,0,$random_position).$char.substr($db_pass,$random_position); }
			$db_auth_3 = '\'' . pg_escape_string(str_shuffle($rcp)) . '\''; $db_auth_4 = '\'' . pg_escape_string(base64_encode($db_pass)) . '\'';
		}
		else
		{
			$db_auth_3 = 'NULL';
			$db_auth_4 = 'NULL';
		}

		###############
		#RUN THE INSERT
		###############
		$sqlinsert_db = @pg_query($pg_conn, "INSERT INTO ps_db_tbl(server_id,db_name,db_auth_1,db_auth_2,db_auth_3,db_auth_4,pause,created_date) VALUES($server_id,'$ps_insert_db_name','$db_auth_1','$db_auth_2',$db_auth_3,$db_auth_4,$pause,CURRENT_TIMESTAMP)");

		#############
		#MAKE CERTAIN
		#############
		if(!$sqlinsert_db)
		{
			$ajax_return[] = "Error executing PostgreStats query.";
			$ajax_return = json_encode($ajax_return);
			echo $ajax_return;
			exit;
		}

		############
		#SUCCESS MSG
		############
		$ajax_return[0] = 1;
		$ajax_return[] = "Database inserted successfully.";
		$ajax_return = json_encode($ajax_return);

		#######################################
		#RETURN IT ALL TO THE AJAX RESPONSE VAR
		#######################################
		echo $ajax_return;
		exit;	
	}
	else
	{
		##########################################################
		#IN AUTO-DB POPULATE MODE - FIRST ATTEMPT TO QUERY DB LIST
		##########################################################
		$sqlselect_auto_dbs = @pg_query($pg_conn_verify_db, "SELECT datname FROM pg_database WHERE datallowconn = true");

		#############
		#MAKE CERTAIN
		#############
		if(!$sqlselect_auto_dbs)
		{
			$ajax_return[] = "Error executing PostgreStats query.";
			$ajax_return = json_encode($ajax_return);
			echo $ajax_return;
			exit;
		}

		#################
		#GRAB OUR DB DATA
		#################
		$idb = 0;
		while($query_data_auto_dbs = pg_fetch_row($sqlselect_auto_dbs))
		{
			########################
			#GET THE NAME AND ESCAPE
			########################
			$db_auto_name = pg_escape_string($query_data_auto_dbs[0]);

			####################################################################
			#FOR EACH DB, WE'LL ATTEMPT A QUICK CONNECT WITH OUR NEW USER / PASS
			####################################################################
			$pg_conn_indi_con = @pg_connect("dbname=$db_auto_name user=$ps_insert_db_user password=$ps_insert_db_pass host=$server_host port=$server_port",PGSQL_CONNECT_FORCE_NEW);

			########################################################################
			#IF WE CONNECT, ADD THE DB TO POSTGRESTATS USING OUR ORIGINAL CONNECTION
			########################################################################
			if($pg_conn_indi_con)
			{
				###################################################
				#FIRST MAKE SURE THIS DB ISN'T ALREADY IN PS_DB_TBL
				###################################################
				$sqlselect_dup_indi = @pg_query($pg_conn, "SELECT db_id FROM ps_db_tbl WHERE server_id = $server_id AND db_name = '$db_auto_name'");

				#############
				#MAKE CERTAIN
				#############
				if(!$sqlselect_dup_indi)
				{
					$ajax_return[] = "Error executing PostgreStats query.";
					$ajax_return = json_encode($ajax_return);
					echo $ajax_return;
					exit;
				}

				###########################################
				#IF WE ARE IN THE CLEAR - INSERT THE NEW DB
				###########################################
				if(pg_num_rows($sqlselect_dup_indi) == 0)
				{
					#####################################################################################
					#SOME OBFUSCATION & ENCODING JUST SO DB CREDENTIALS ARE NOT HUMAN READABLE IN THE DB
					#WHY ARE THESE NOT 1-WAY ENCRYPTED LIKE YOUR POSTGRESTATS PASSWORD?
					#BECAUSE OBTAINING CREDENTIALS ON-THE-FLY IS NECESSARY FOR AUTOMATED STAT RETRIEVAL
					#IF YOUR WEB-SERVER IS 'TRUSTED' VIA YOUR pg_hba.conf FILE AND DOES NOT REQUIRE A
					#PASSWORD TO CONNECT, WE RECOMMEND NOT STORING ANY DB PASSWORDS WHEN INSERTING DBS
					#####################################################################################

					#######################
					#HANDLE USER REGARDLESS
					#######################
					$db_user = strrev($ps_insert_db_user); $sl = strlen($db_user); $rcu = ""; $chars = "0123456789abcdefghijklmnopqrstuxyvwzABCDEFGHIJKLMNOPQRSTUXYVWZ`~!@#$%^&*()-=_+";
					while(strlen($rcu) < $sl) { $random_char = $chars[rand(0,strlen($chars)-1)]; $pos_1 = strpos($db_user, $random_char); $pos_2 = strpos($rcu, $random_char); if($pos_1 === false && $pos_2 === false) $rcu .= $random_char; }
					for($ir = 0; $ir < strlen($rcu); $ir++) { $random_position = rand(0,strlen($db_user)-1); $char = substr($rcu,$ir,1); $db_user = substr($db_user,0,$random_position).$char.substr($db_user,$random_position); }
					$db_auth_1 = pg_escape_string(str_shuffle($rcu)); $db_auth_2 = pg_escape_string(base64_encode($db_user));

					#####################
					#IF PASSWORD REQUIRED
					#####################
					if(!empty($ps_insert_db_pass))
					{
						$db_pass = strrev($ps_insert_db_pass); $sl = strlen($db_pass); $rcp = ""; $chars = "0123456789abcdefghijklmnopqrstuxyvwzABCDEFGHIJKLMNOPQRSTUXYVWZ`~!@#$%^&*()-=_+";
						while(strlen($rcp) < $sl) { $random_char = $chars[rand(0,strlen($chars)-1)]; $pos_1 = strpos($db_pass, $random_char); $pos_2 = strpos($rcp, $random_char); if($pos_1 === false && $pos_2 === false) $rcp .= $random_char; }
						for($ir = 0; $ir < strlen($rcp); $ir++) { $random_position = rand(0,strlen($db_pass)-1); $char = substr($rcp,$ir,1); $db_pass = substr($db_pass,0,$random_position).$char.substr($db_pass,$random_position); }
						$db_auth_3 = '\'' . pg_escape_string(str_shuffle($rcp)) . '\''; $db_auth_4 = '\'' . pg_escape_string(base64_encode($db_pass)) . '\'';
					}
					else
					{
						$db_auth_3 = 'NULL';
						$db_auth_4 = 'NULL';
					}

					###############
					#RUN THE INSERT
					###############
					$sqlinsert_db = @pg_query($pg_conn, "INSERT INTO ps_db_tbl(server_id,db_name,db_auth_1,db_auth_2,db_auth_3,db_auth_4,pause,created_date) VALUES($server_id,'$db_auto_name','$db_auth_1','$db_auth_2',$db_auth_3,$db_auth_4,$pause,CURRENT_TIMESTAMP)");

					#############
					#MAKE CERTAIN
					#############
					if(!$sqlinsert_db)
					{
						$ajax_return[] = "Error executing PostgreStats query.";
						$ajax_return = json_encode($ajax_return);
						echo $ajax_return;
						exit;
					}

					########
					#PUSH UP
					########
					$idb++;
				}

				#####################################
				#CLOSE THE INDI CONNECTION REGARDLESS
				#####################################
				pg_close($pg_conn_indi_con);
			}
		}

		############
		#SUCCESS MSG
		############
		$ajax_return[0] = 1;
		$ajax_return[] = "$idb new database(s) inserted successfully.";
		$ajax_return = json_encode($ajax_return);

		#######################################
		#RETURN IT ALL TO THE AJAX RESPONSE VAR
		#######################################
		echo $ajax_return;
		exit;
	}
}

##########################################################################################################
##########################################################################################################
#FUNCTION: DB_OPEN_LIST
##########################################################################################################
##########################################################################################################
function db_open_list($server_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	###################
	#DO SOME VALIDATION
	###################
	if(empty($server_id) || !is_numeric($server_id))
	{
		$ajax_return = "Invalid server ID passed.";
		echo $ajax_return;
		exit;
	}

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");
	if(!$pg_conn) { echo "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials."; exit; }

	#########################
	#RETRIEVE OUR SERVER DATA
	#########################
	$sqlselect_server = @pg_query($pg_conn, "SELECT * FROM ps_server_tbl WHERE server_id = $server_id");
	if(!$sqlselect_server) { echo "Error executing PostgreStats query."; exit; }

	#####################
	#MAKE SURE WE HAVE IT
	#####################
	if(pg_num_rows($sqlselect_server) == 0)
	{
		$ajax_return = "There are no servers by this ID.";
		echo $ajax_return;
		exit;
	}

	#############
	#GRAB RESULTS
	#############
	$query_data_server = pg_fetch_row($sqlselect_server);
	$server_id = $query_data_server[0];
	$server_name = $query_data_server[1];
	$server_host = $query_data_server[2];
	$port = $query_data_server[3];
	$pause = $query_data_server[4];

	####################################
	#QUERY DATABASES TIED TO THIS SERVER
	####################################
	$sqlselect_dbs = @pg_query($pg_conn, "SELECT db_id,db_name FROM ps_db_tbl WHERE server_id = $server_id ORDER BY db_name ASC");
	if(!$sqlselect_dbs) { echo "Error executing PostgreStats query."; exit; }

	########################
	#IF THERE ARE NO DBS YET
	########################
	if(pg_num_rows($sqlselect_dbs) == 0)
	{
		$ajax_return = "<span class=\"black_12\">There are no databases collecting statistics for this server.</span>";
		echo $ajax_return;
		exit;
	}

	##############
	#PREP TOOLTIPS
	##############
	$tt_edit = "onMouseOver=\"tooltip.show('Edit&nbsp;database')\" onMouseOut='tooltip.hide()'";
	$tt_verify = "onMouseOver=\"tooltip.show('Verify&nbsp;connection')\" onMouseOut='tooltip.hide()'";
	$tt_delete = "onMouseOver=\"tooltip.show('Remove&nbsp;database')\" onMouseOut='tooltip.hide()'";

######################
#PUT TOGETHER OUR HTML
######################
$ajax_return = <<<AJR
<div class="black_12" style="float:left; height:25px; padding-top:4px;">Databases:</div>
<div style="float:left; height:25px; margin:0 10px 0 5px;">
<select class="select_menu" name="db_list_dropdown" id="db_list_dropdown" onchange="db_close_update()">
AJR;

	##############################
	#ITERATE THROUGH OUR DATABASES
	##############################
	while($query_data_dbs = pg_fetch_row($sqlselect_dbs))
	{
		##################################
		#GRAB DB DATA AND ADD TO DROP-DOWN
		##################################
		$db_id = $query_data_dbs[0];
		$db_name = $query_data_dbs[1];
		$ajax_return .= "<option value=\"$db_id\">$db_name</option>";
	}

#################################
#ADD LIST AND ICONS TO RETURN VAR
#################################
$ajax_return .= <<<AJR
</select>
</div>
<div style="float:left; height:25px;"><a href="javascript:db_open_update()" $tt_edit><img src="images/icon_edit.png" width="25" height="25" style="margin-right:5px;"/></a><a href="javascript:db_validate()" $tt_verify><img src="images/icon_verify.png" width="25" height="25" style="margin-right:5px;"/></a><a href="javascript:db_delete($server_id)" onclick="return confirm('Remove database from PostgreStats?')" $tt_delete><img src="images/icon_delete.png" width="25" height="25" style="margin-right:5px;"/></a></div>
<div style="clear:both;"></div>
AJR;

###################
#ADD DB UPDATE VIEW
###################
$ajax_return .= <<<AJR
<div id="view_db_update" class="setup_div" style="margin:25px 0 0 0; display:none;">
<div class="orange_15" style="padding-bottom:5px; font-weight:bold;">Update Database</div>
<div style="font-weight:normal;">Update database settings below. Changes here will auto-update existing core statistics for this DB.</div>
<div id="db_update_data" style="margin:25px 0 0 0px; font-weight:bold; display:none;"></div>
<div style="clear:both;"></div>
</div>
AJR;

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: DB_DELETE
##########################################################################################################
##########################################################################################################
function db_delete($server_id,$db_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	###################
	#DO SOME VALIDATION
	###################
	if(empty($server_id) || !is_numeric($server_id))
	{
		$ajax_return = "Invalid server ID passed.";
		echo $ajax_return;
		exit;
	}
	elseif(empty($db_id) || !is_numeric($db_id))
	{
		$ajax_return = "Invalid database ID passed.";
		echo $ajax_return;
		exit;
	}

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");
	if(!$pg_conn) { echo "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials."; exit; }

	#############################
	#QUERY THIS SERVER / DB COMBO
	#############################
	$sqlselect_db = @pg_query($pg_conn, "SELECT db_id FROM ps_db_tbl WHERE db_id = $db_id AND server_id = $server_id");
	if(!$sqlselect_db) { echo "Error executing PostgreStats query."; exit; }

	####################
	#MAKE SURE IT EXISTS
	####################
	if(pg_num_rows($sqlselect_db) == 0)
	{
		$ajax_return = "Either this server or database does not exist.";
		echo $ajax_return;
		exit;
	}

	########################
	#DELETE FROM PS_CORE_TBL
	########################
	$sqldelete = @pg_query($pg_conn, "DELETE FROM ps_core_tbl WHERE db_id = $db_id AND server_id = $server_id");
	if(!$sqldelete) { echo "Error executing PostgreStats query."; exit; }

	######################
	#DELETE FROM PS_DB_TBL
	######################
	$sqldelete = @pg_query($pg_conn, "DELETE FROM ps_db_tbl WHERE db_id = $db_id AND server_id = $server_id");
	if(!$sqldelete) { echo "Error executing PostgreStats query."; exit; }

	################
	#PREP RETURN VAR
	################
	$ajax_return = "Database deleted successfully.";

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: DB_VALIDATE
##########################################################################################################
##########################################################################################################
function db_validate($server_id,$db_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	###################
	#DO SOME VALIDATION
	###################
	if(empty($server_id) || !is_numeric($server_id))
	{
		$ajax_return = "Invalid server ID passed.";
		echo $ajax_return;
		exit;
	}
	elseif(empty($db_id) || !is_numeric($db_id))
	{
		$ajax_return = "Invalid DB ID passed.";
		echo $ajax_return;
		exit;
	}

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");
	if(!$pg_conn) { echo "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials."; exit; }

	#########################
	#RETRIEVE OUR SERVER DATA
	#########################
	$sqlselect_server = @pg_query($pg_conn, "SELECT * FROM ps_server_tbl WHERE server_id = $server_id");
	if(!$sqlselect_server) { echo "Error executing PostgreStats query."; exit; }

	############################
	#IF THERE ARE NO SERVERS YET
	############################
	if(pg_num_rows($sqlselect_server) == 0)
	{
		$ajax_return = "There are no servers by this ID.";
		echo $ajax_return;
		exit;
	}

	#############
	#GRAB RESULTS
	#############
	$query_data_server = pg_fetch_row($sqlselect_server);
	$server_id = $query_data_server[0];
	$server_name = $query_data_server[1];
	$server_host = $query_data_server[2];
	$port = $query_data_server[3];
	$pause = $query_data_server[4];

	#####################
	#RETRIEVE OUR DB DATA
	#####################
	$sqlselect_db = @pg_query($pg_conn, "SELECT * FROM ps_db_tbl WHERE server_id = $server_id AND db_id = $db_id");
	if(!$sqlselect_db) { echo "Error executing PostgreStats query."; exit; }

	########################
	#IF NO RESULTS ARE FOUND
	########################
	if(pg_num_rows($sqlselect_db) == 0)
	{
		$ajax_return = "There are no DBs found by this ID.";
		echo $ajax_return;
		exit;
	}

	#############
	#GRAB RESULTS
	#############
	$query_data_db = pg_fetch_row($sqlselect_db);
	$db_id = $query_data_db[0];
	$server_id = $query_data_db[1];
	$db_last_reset = $query_data_db[2];
	$db_name = $query_data_db[3];
	$db_auth_1 = $query_data_db[4];
	$db_auth_2 = $query_data_db[5];
	$db_auth_3 = $query_data_db[6];
	$db_auth_4 = $query_data_db[7];
	$pause = $query_data_db[8];
	$created_date = $query_data_db[9];

	############
	#DECODE USER
	############
	$db_auth_2 = base64_decode($db_auth_2);
	$db_auth_remove = str_split($db_auth_1);
	$db_user = strrev(str_replace($db_auth_remove,'',$db_auth_2));

	##########################
	#DECODE PASS IF IT'S THERE
	##########################
	if(!empty($db_auth_3) && !empty($db_auth_4))
	{
		$db_auth_4 = base64_decode($db_auth_4);
		$db_auth_remove = str_split($db_auth_3);
		$db_pass = strrev(str_replace($db_auth_remove,'',$db_auth_4));
	}
	else
	{
		###################################
		#FOR SAFE - IN CASE ONE HAS A VALUE
		###################################
		$db_pass = "";	
	}

	#######################################
	#ATTEMPT CONNECT - FORCE NEW CONNECTION
	#######################################
	$pg_conn_indi_con = @pg_connect("dbname=$db_name user=$db_user password=$db_pass host=$server_host port=$port",PGSQL_CONNECT_FORCE_NEW);

	##################
	#VERIFY CONNECTION
	##################
	if($pg_conn_indi_con)
	{
		$ajax_return = "Connected to database successfully.";

		##########################
		#CLOSE THE INDI CONNECTION
		##########################
		pg_close($pg_conn_indi_con);
	}
	else
	{
		$ajax_return = "DB connect failed. Please verify server & DB credentials.";
	}

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: DB_OPEN_UPDATE
##########################################################################################################
##########################################################################################################
function db_open_update($server_id,$db_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	###################
	#DO SOME VALIDATION
	###################
	if(empty($server_id) || !is_numeric($server_id))
	{
		$ajax_return = "Invalid server ID passed.";
		echo $ajax_return;
		exit;
	}
	elseif(empty($db_id) || !is_numeric($db_id))
	{
		$ajax_return = "Invalid DB ID passed.";
		echo $ajax_return;
		exit;
	}

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");
	if(!$pg_conn) { echo "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials."; exit; }

	#########################
	#MAKE SURE THIS DB EXISTS
	#########################
	$sqlselect_db = @pg_query($pg_conn, "SELECT * FROM ps_db_tbl WHERE server_id = $server_id AND db_id = $db_id");
	if(!$sqlselect_db) { echo "Error executing PostgreStats query."; exit; }

	########################
	#IF NO RESULTS ARE FOUND
	########################
	if(pg_num_rows($sqlselect_db) == 0)
	{
		$ajax_return = "There are no DBs found by this ID on this server.";
		echo $ajax_return;
		exit;
	}

	######################################################
	#GRAB SOME DB DATA - DO NOT ECHO PASSWORD FOR SECURITY
	######################################################
	$query_data_db = pg_fetch_row($sqlselect_db);
	$db_id = $query_data_db[0];
	$server_id = $query_data_db[1];
	$db_last_reset = $query_data_db[2];
	$db_name = $query_data_db[3];
	$db_auth_1 = $query_data_db[4];
	$db_auth_2 = $query_data_db[5];
	$db_auth_3 = $query_data_db[6];
	$db_auth_4 = $query_data_db[7];
	$pause = $query_data_db[8];
	$created_date = $query_data_db[9];

	############
	#DECODE USER
	############
	$db_auth_2 = base64_decode($db_auth_2);
	$db_auth_remove = str_split($db_auth_1);
	$db_user = strrev(str_replace($db_auth_remove,'',$db_auth_2));

	#HANDLE PAUSE STATUS
	if($pause == 2) $pause = " checked=\"checked\"";

######################
#PUT TOGETHER OUR HTML
######################
$ajax_return = <<<AJR
<form action="javascript:db_update($server_id,$db_id)" method="post">

<!-- DATABASE NAME -->
<div style="margin:25px 0 0 0px; font-weight:bold;">
<div class="black_12" style="float:left; margin:4px 10px 0 0; text-align:right; width:100px;">Database&nbsp;Name:</div>
<div style="float:left;"><input name="ps_update_db_name" type="text" class="text_box" value="$db_name" id="ps_update_db_name" maxlength="25"></div>
<div class="grey_12" style="float:left; margin:4px 0 0 10px; font-weight:normal;">(The actual database name)</div>
<div style="clear:both;"></div>
</div>

<!-- USER NAME -->
<div style="margin:15px 0 0 0px; font-weight:bold;">
<div class="black_12" style="float:left; margin:4px 10px 0 0; text-align:right; width:100px;">Connect&nbsp;as&nbsp;User:</div>
<div style="float:left;"><input name="ps_update_db_user" type="text" class="text_box" value="$db_user" id="ps_update_db_user" maxlength="50"></div>
<div class="grey_12" style="float:left; margin:4px 0 0 10px; font-weight:normal;"></div>
<div style="clear:both;"></div>
</div>

<!-- PASSWORD -->
<div id="db_update_pass_required_link" style="margin:15px 0 0 110px; font-weight:bold;"><a href="javascript:db_update_show_pass_div()">If connection requires password, re-enter it here</a></div>
<div id="db_update_pass_required_div" style="display:none; margin:15px 0 0 0px; font-weight:bold;">
<div class="black_12" style="float:left; margin:4px 10px 0 0; text-align:right; width:100px;">Password:</div>
<div style="float:left;"><input name="ps_update_db_pass" type="password" class="text_box" id="ps_update_db_pass" maxlength="10"></div>
<div class="grey_12" style="float:left; margin:4px 0 0 10px; font-weight:normal;">[<a href="javascript:db_update_hide_pass_div()" style="font-weight:bold;">X</a>]</div>
<div style="clear:both;"></div>
</div>

<!-- DB PAUSE -->
<div style="margin:15px 0 0 0px; font-weight:bold;">
<div class="black_12" style="float:left; margin:0 7px 0 0; text-align:right; width:100px;">Pause:</div>
<div class="black_12" style="float:left; font-weight:normal;"><input name="ps_update_db_pause" type="checkbox" id="ps_update_db_pause" $pause/> Pause statistics (overridden if server is paused)</div>
<div style="clear:both;"></div>
</div>

<!-- DO IT -->
<div class="orange_13" style="margin:15px 0 0 110px; font-weight:bold;"><input class="button_orange" type="submit" value="Verify &amp; Update Database"></div>

<!-- DATABASE UPDATE RESULT - IN THE EVENT OF AN ERROR -->
<div id="db_update_result" style="margin:15px 0 0 110px; font-weight:normal; display:none;"></div>
</form>
AJR;

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: DB_UPDATE
##########################################################################################################
##########################################################################################################
function db_update($server_id,$db_id,$ps_update_db_name,$ps_update_db_user,$ps_update_db_pass,$ps_update_db_pause,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	####################################
	#CREATE RETURN ARRAY FOR JSON VALUES
	####################################
	$ajax_return = array();

	################################
	#DEFAULT SUCCESS VALUE AS FAILED
	################################
	$ajax_return[] = 2;

	##############
	#PREP INCOMING
	##############
	$ps_update_db_name = trim($ps_update_db_name);
	$ps_update_db_user = trim($ps_update_db_user);
	$ps_update_db_pass = trim($ps_update_db_pass);

	###################
	#DO SOME VALIDATION
	###################
	if(empty($ps_update_db_name) || empty($ps_update_db_user))
	{
		$ajax_return[] = "Database name and user are required.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}
	elseif(empty($server_id) || !is_numeric($server_id))
	{
		$ajax_return[] = "Invalid server ID passed.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}
	elseif(empty($db_id) || !is_numeric($db_id))
	{
		$ajax_return[] = "Invalid DB ID passed.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	############################
	#CHECK ON PAUSE VAR FOR SAFE
	############################
	if(empty($ps_update_db_pause) || ($ps_update_db_pause != 1 && $ps_update_db_pause != 2)) $ps_update_db_pause = 1;

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");

	#############
	#MAKE CERTAIN
	#############
	if(!$pg_conn)
	{
		$ajax_return[] = "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	#####################################
	#MAKE SURE THIS SERVER DB COMBO EXIST
	#####################################
	$sqlselect_db = @pg_query($pg_conn, "SELECT db_id,db_name FROM ps_db_tbl WHERE server_id = $server_id AND db_id = $db_id");

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlselect_db)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	##########
	#MAKE SURE
	##########
	if(pg_num_rows($sqlselect_db) == 0)
	{
		$ajax_return[] = "There are no DBs by this ID on this server.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	#################
	#GRAB OUR DB DATA
	#################
	$query_data_db = pg_fetch_row($sqlselect_db);
	$db_id = $query_data_db[0];
	$db_name = $query_data_db[1];

	###############
	#ESCAPE DB NAME
	###############
	$ps_update_db_name = pg_escape_string($ps_update_db_name);

	##########################################
	#CHECK FOR DUPLICATE DB - THIS SERVER ONLY
	##########################################
	$sqlselect_dup_db = @pg_query($pg_conn, "SELECT db_id FROM ps_db_tbl WHERE server_id = $server_id AND db_name = '$ps_update_db_name' AND db_id != $db_id");

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlselect_dup_db)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	##########
	#MAKE SURE
	##########
	if(pg_num_rows($sqlselect_dup_db) > 0)
	{
		$ajax_return[] = "PostgreStats is already collecting statistics for this database.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	#########################
	#RETRIEVE OUR SERVER DATA
	#########################
	$sqlselect_server = @pg_query($pg_conn, "SELECT * FROM ps_server_tbl WHERE server_id = $server_id");
	if(!$sqlselect_server) { echo "Error executing PostgreStats query."; exit; }

	############################
	#IF THERE ARE NO SERVERS YET
	############################
	if(pg_num_rows($sqlselect_server) == 0)
	{
		$ajax_return = "There are no servers by this ID.";
		echo $ajax_return;
		exit;
	}

	#############
	#GRAB RESULTS
	#############
	$query_data_server = pg_fetch_row($sqlselect_server);
	$server_id = $query_data_server[0];
	$server_name = $query_data_server[1];
	$server_host = $query_data_server[2];
	$port = $query_data_server[3];
	$pause = $query_data_server[4];

	#####################################
	#ATTEMPT TO CONNECT TO THE UPDATED DB
	#####################################
	$pg_conn_verify_db = @pg_connect("dbname=$ps_update_db_name user=$ps_update_db_user password=$ps_update_db_pass host=$server_host port=$server_port",PGSQL_CONNECT_FORCE_NEW);

	#############
	#MAKE CERTAIN
	#############
	if(!$pg_conn_verify_db)
	{
		$ajax_return[] = "Error connecting to database. Please verify it exists and that this user has priveleges.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	################################################
	#FINISHED WITH VERFICATION CONNECTION - CLOSE IT
	################################################
	pg_close($pg_conn_verify_db);

	#####################################################################################
	#SOME OBFUSCATION & ENCODING JUST SO DB CREDENTIALS ARE NOT HUMAN READABLE IN THE DB
	#WHY ARE THESE NOT 1-WAY ENCRYPTED LIKE YOUR POSTGRESTATS PASSWORD?
	#BECAUSE OBTAINING CREDENTIALS ON-THE-FLY IS NECESSARY FOR AUTOMATED STAT RETRIEVAL
	#IF YOUR WEB-SERVER IS 'TRUSTED' VIA YOUR pg_hba.conf FILE AND DOES NOT REQUIRE A
	#A PASSWORD TO CONNECT, WE RECOMMEND NOT STORING ANY DB PASSWORDS WHEN INSERTING DBS
	#####################################################################################

	#######################
	#HANDLE USER REGARDLESS
	#######################
	$db_user = strrev($ps_update_db_user); $sl = strlen($db_user); $rcu = ""; $chars = "0123456789abcdefghijklmnopqrstuxyvwzABCDEFGHIJKLMNOPQRSTUXYVWZ`~!@#$%^&*()-=_+";
	while(strlen($rcu) < $sl) { $random_char = $chars[rand(0,strlen($chars)-1)]; $pos_1 = strpos($db_user, $random_char); $pos_2 = strpos($rcu, $random_char); if($pos_1 === false && $pos_2 === false) $rcu .= $random_char; }
	for($ir = 0; $ir < strlen($rcu); $ir++) { $random_position = rand(0,strlen($db_user)-1); $char = substr($rcu,$ir,1); $db_user = substr($db_user,0,$random_position).$char.substr($db_user,$random_position); }
	$db_auth_1 = pg_escape_string(str_shuffle($rcu)); $db_auth_2 = pg_escape_string(base64_encode($db_user));

	#####################
	#IF PASSWORD REQUIRED
	#####################
	if(!empty($ps_update_db_pass))
	{
		$db_pass = strrev($ps_update_db_pass); $sl = strlen($db_pass); $rcp = ""; $chars = "0123456789abcdefghijklmnopqrstuxyvwzABCDEFGHIJKLMNOPQRSTUXYVWZ`~!@#$%^&*()-=_+";
		while(strlen($rcp) < $sl) { $random_char = $chars[rand(0,strlen($chars)-1)]; $pos_1 = strpos($db_pass, $random_char); $pos_2 = strpos($rcp, $random_char); if($pos_1 === false && $pos_2 === false) $rcp .= $random_char; }
		for($ir = 0; $ir < strlen($rcp); $ir++) { $random_position = rand(0,strlen($db_pass)-1); $char = substr($rcp,$ir,1); $db_pass = substr($db_pass,0,$random_position).$char.substr($db_pass,$random_position); }
		$db_auth_3 = '\'' . pg_escape_string(str_shuffle($rcp)) . '\''; $db_auth_4 = '\'' . pg_escape_string(base64_encode($db_pass)) . '\'';
	}
	else
	{
		$db_auth_3 = 'NULL';
		$db_auth_4 = 'NULL';
	}

	###############
	#RUN THE UPDATE
	###############
	$sqlupdate_db = @pg_query($pg_conn, "UPDATE ps_db_tbl SET db_name = '$ps_update_db_name', db_auth_1 = '$db_auth_1',  db_auth_2 = '$db_auth_2',  db_auth_3 = $db_auth_3,  db_auth_4 = $db_auth_4, pause = $ps_update_db_pause WHERE server_id = $server_id AND db_id = $db_id");

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlupdate_db)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	############
	#SUCCESS MSG
	############
	$ajax_return[0] = 1;
	$ajax_return[] = "Database updated successfully.";
	$ajax_return = json_encode($ajax_return);

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: DATE_GET_FRIENDLY_MONTH
##########################################################################################################
##########################################################################################################
function date_get_friendly_month($month)
{
	#########################################
	#GET INCOMING AND CREATE FRIENDLY VERSION
	#########################################
	switch($month)
	{
		case '01': $month_friendly = "Jan"; break;
		case '02': $month_friendly = "Feb"; break;
		case '03': $month_friendly = "Mar"; break;
		case '04': $month_friendly = "Apr"; break;
		case '05': $month_friendly = "May"; break;
		case '06': $month_friendly = "Jun"; break;
		case '07': $month_friendly = "Jul"; break;
		case '08': $month_friendly = "Aug"; break;
		case '09': $month_friendly = "Sep"; break;
		case '10': $month_friendly = "Oct"; break;
		case '11': $month_friendly = "Nov"; break;
		case '12': $month_friendly = "Dec";
	}

	##########
	#RETURN IT
	##########
	return $month_friendly;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: DATE_GET_FRIENDLY_MONTH_EXT
##########################################################################################################
##########################################################################################################
function date_get_friendly_month_ext($month)
{
	#########################################
	#GET INCOMING AND CREATE FRIENDLY VERSION
	#########################################
	switch($month)
	{
		case '01': $month_friendly = "January"; break;
		case '02': $month_friendly = "February"; break;
		case '03': $month_friendly = "March"; break;
		case '04': $month_friendly = "April"; break;
		case '05': $month_friendly = "May"; break;
		case '06': $month_friendly = "June"; break;
		case '07': $month_friendly = "July"; break;
		case '08': $month_friendly = "August"; break;
		case '09': $month_friendly = "September"; break;
		case '10': $month_friendly = "October"; break;
		case '11': $month_friendly = "November"; break;
		case '12': $month_friendly = "December";
	}

	##########
	#RETURN IT
	##########
	return $month_friendly;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: NUMBER_ABBR
##########################################################################################################
##########################################################################################################
function number_abbr($num,$round_max)
{
	################################
	#FORMAT ONLY THOUSANDS AND ABOVE
	################################
	if(strlen($num) < 4) return $num;

	################################
	#VALIDATE ROUND_MAX VAR FOR SAFE
	################################
	if(empty($round_max) || !is_numeric($round_max) || $round_max < 0) $round_max = 2;

	############################################
	#DECIPHER STRING LENGTH & FORMAT ACCORDINGLY
	############################################
	if(strlen($num) > 3 && strlen($num) < 7)
	{
		$num = $num / 1000;
		$num = number_format($num, $round_max, '.', ',') . "k";
	}
	elseif(strlen($num) > 6 && strlen($num) < 10)
	{
		$num = $num / 1000000;
		$num = number_format($num, $round_max, '.', ',') . "m";
	}
	elseif(strlen($num) > 9 && strlen($num) < 13)
	{
		$num = $num / 1000000000;
		$num = number_format($num, $round_max, '.', ',') . "b";
	}
	elseif(strlen($num) > 12 && strlen($num) < 16)
	{
		$num = $num / 1000000000000;
		$num = number_format($num, $round_max, '.', ',') . "t";
	}
	elseif(strlen($num) > 15)
	{
		$num = $num / 1000000000000000;
		$num = number_format($num, $round_max, '.', ',') . "q";
	}

	##########
	#RETURN IT
	##########
	return $num;
}
##########################################################################################################
##########################################################################################################
#FUNCTION: MONTHLY_SNAP_RETRIEVE_NAV_DBS
##########################################################################################################
##########################################################################################################
function monthly_snap_retrieve_nav_dbs($server_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	####################################
	#CREATE RETURN ARRAY FOR JSON VALUES
	####################################
	$ajax_return = array();

	################################
	#DEFAULT SUCCESS VALUE AS FAILED
	################################
	$ajax_return[] = 2;

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");

	#############
	#MAKE CERTAIN
	#############
	if(!$pg_conn)
	{
		$ajax_return[] = "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	##########################################################################
	#RETRIEVE OUR DB LIST - IF SERVER_ID IS EMPTY, GET ALL DBS FOR ALL SERVERS
	##########################################################################
	if($server_id == 0 || empty($server_id) or $server_id == "0" || !is_numeric($server_id))
	{
		#########
		#DB QUERY
		#########
		$sqlselect_dbs = @pg_query($pg_conn, "SELECT db_id,db_name FROM ps_db_tbl WHERE (SELECT COUNT(db_id) FROM ps_core_tbl WHERE ps_db_tbl.db_id = ps_core_tbl.db_id) > 0 ORDER BY db_name ASC");

		############
		#MONTH QUERY
		############
		$sqlselect_months = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(MONTH FROM recorded) AS month FROM ps_core_tbl ORDER BY month ASC");
		
		###########
		#YEAR QUERY
		###########
		$sqlselect_years = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(YEAR FROM recorded) AS year FROM ps_core_tbl ORDER BY year DESC");
	}
	else
	{
		#############################
		#GRAB DBS FOR SELECTED SERVER
		#############################
		$sqlselect_dbs = @pg_query($pg_conn, "SELECT db_id,db_name FROM ps_db_tbl WHERE server_id = $server_id AND (SELECT COUNT(db_id) FROM ps_core_tbl WHERE ps_db_tbl.db_id = ps_core_tbl.db_id AND server_id = $server_id) > 0 ORDER BY db_name ASC");

		################################
		#MONTH QUERY FOR SELECTED SERVER
		################################
		$sqlselect_months = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(MONTH FROM recorded) AS month FROM ps_core_tbl WHERE server_id = $server_id ORDER BY month ASC");

		###############################
		#YEAR QUERY FOR SELECTED SERVER
		###############################
		$sqlselect_years = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(YEAR FROM recorded) AS year FROM ps_core_tbl WHERE server_id = $server_id ORDER BY year DESC");
	}

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlselect_dbs || !$sqlselect_months || !$sqlselect_years)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	############################
	#CREATE OUR DB LIST DROPDOWN
	############################
	$db_list  = "<select class=\"select_menu\" name=\"snap_dbs\" id=\"snap_dbs\" onChange=\"monthly_snap_select_nav_db()\">";
	$db_list .= "<option value=\"0\">All Databases</option>";

	#######################
	#ITERATE THROUGH VALUES
	#######################
	while($query_data_dbs = pg_fetch_row($sqlselect_dbs))
	{
		$db_id = $query_data_dbs[0];
		$db_name = $query_data_dbs[1];
		$db_list .= "<option value=\"$db_id\">$db_name</option>";
	}
	$db_list .= "</select>";

	################################
	#CURRENT MONTH FOR PRE-SELECTION
	################################
	$current_month = date('m');

	#####################
	#START THE MONTH LIST
	#####################
	$month_list = "<select class=\"select_menu\" name=\"snap_month\" id=\"snap_month\">";
	while($query_data_months = pg_fetch_row($sqlselect_months))
	{
		################################################################
		#EXTRACT MONTH - HANDLE LEADING ZEROS - AND GET FRIENDLY VERSION
		################################################################
		$month = $query_data_months[0];
		if(strlen($month) == 1) $month = "0$month";
		$month_friendly = date_get_friendly_month($month);
		if($month == $current_month) { $selected = "selected=\"selected\""; } else { $selected = ""; }
		$month_list .= "<option value=\"$month\" $selected>$month_friendly</option>";
	}
	$month_list .= "</select>";

	###############################
	#CURRENT YEAR FOR PRE-SELECTION
	###############################
	$current_year = date('Y');

	####################
	#START THE YEAR LIST
	####################
	$year_list = "<select class=\"select_menu\" name=\"snap_year\" id=\"snap_year\">";
	while($query_data_years = pg_fetch_row($sqlselect_years))
	{
		$year = $query_data_years[0];
		if($year == $current_year) { $selected = "selected=\"selected\""; } else { $selected = ""; }
		$year_list .= "<option value=\"$year\" $selected>$year</option>";
	}
	$year_list .= "</select>";

	######################
	#PREP ARRAY FOR RETURN
	######################
	$ajax_return[0] = 1;
	$ajax_return[] = $db_list;
	$ajax_return[] = $month_list;
	$ajax_return[] = $year_list;
	$ajax_return = json_encode($ajax_return);

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: MONTHLY_SNAP_SELECT_NAV_DB
##########################################################################################################
##########################################################################################################
function monthly_snap_select_nav_db($server_id,$db_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	####################################
	#CREATE RETURN ARRAY FOR JSON VALUES
	####################################
	$ajax_return = array();

	################################
	#DEFAULT SUCCESS VALUE AS FAILED
	################################
	$ajax_return[] = 2;

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");

	#############
	#MAKE CERTAIN
	#############
	if(!$pg_conn)
	{
		$ajax_return[] = "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	############################################################
	#IF NO DB_ID WAS PASSED, GET MONTH / YEAR VALUES FOR ALL DBS
	############################################################
	if($db_id == 0 || empty($db_id) or $db_id == "0" || !is_numeric($db_id))
	{
		################
		#THE MONTH QUERY
		################
		$sqlselect_months = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(MONTH FROM recorded) AS month FROM ps_core_tbl WHERE server_id = $server_id ORDER BY month ASC");

		###############
		#THE YEAR QUERY
		###############
		$sqlselect_years = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(YEAR FROM recorded) AS year FROM ps_core_tbl WHERE server_id = $server_id ORDER BY year DESC");
	}
	else
	{
		################
		#THE MONTH QUERY
		################
		$sqlselect_months = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(MONTH FROM recorded) AS month FROM ps_core_tbl WHERE server_id = $server_id AND db_id = $db_id ORDER BY month ASC");

		###############
		#THE YEAR QUERY
		###############
		$sqlselect_years = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(YEAR FROM recorded) AS year FROM ps_core_tbl WHERE server_id = $server_id AND db_id = $db_id ORDER BY year DESC");
	}

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlselect_months || !$sqlselect_years)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	################################
	#CURRENT MONTH FOR PRE-SELECTION
	################################
	$current_month = date('m');

	#####################
	#START THE MONTH LIST
	#####################
	$month_list  = "<select class=\"select_menu\" name=\"snap_month\" id=\"snap_month\">";
	while($query_data_months = pg_fetch_row($sqlselect_months))
	{
		################################################################
		#EXTRACT MONTH - HANDLE LEADING ZEROS - AND GET FRIENDLY VERSION
		################################################################
		$month = $query_data_months[0];
		if(strlen($month) == 1) $month = "0$month";
		$month_friendly = date_get_friendly_month($month);
		if($month == $current_month) { $selected = "selected=\"selected\""; } else { $selected = ""; }
		$month_list .= "<option value=\"$month\" $selected>$month_friendly</option>";
	}
	$month_list .= "</select>";

	###############################
	#CURRENT YEAR FOR PRE-SELECTION
	###############################
	$current_year = date('Y');

	####################
	#START THE YEAR LIST
	####################
	$year_list  = "<select class=\"select_menu\" name=\"snap_year\" id=\"snap_year\">";
	while($query_data_years = pg_fetch_row($sqlselect_years))
	{
		$year = $query_data_years[0];
		if($year == $current_year) { $selected = "selected=\"selected\""; } else { $selected = ""; }
		$year_list .= "<option value=\"$year\" $selected>$year</option>";
	}
	$year_list .= "</select>";

	######################
	#PREP ARRAY FOR RETURN
	######################
	$ajax_return[0] = 1;
	$ajax_return[] = $month_list;
	$ajax_return[] = $year_list;
	$ajax_return = json_encode($ajax_return);

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: MONTHLY_SNAP_RETRIEVE
##########################################################################################################
##########################################################################################################
function monthly_snap_retrieve($servers,$dbs,$month,$year,$snap_chartting,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	####################################
	#CREATE RETURN ARRAY FOR JSON VALUES
	####################################
	$ajax_return = array();

	################################
	#DEFAULT SUCCESS VALUE AS FAILED
	################################
	$ajax_return[] = 2;

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");

	#############
	#MAKE CERTAIN
	#############
	if(!$pg_conn)
	{
		$ajax_return[] = "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	#######################
	#VALIDATE CHARTTING VAR
	#######################
	if($snap_chartting != "commits" && $snap_chartting != "rollbacks" && $snap_chartting != "block_reads" && $snap_chartting != "buffer_hits" && $snap_chartting != "inserts" && $snap_chartting != "updates" && $snap_chartting != "deletes" && $snap_chartting != "seq_scans" && $snap_chartting != "idx_scans")
	{
		###########################################
		#DEFAULT THE CHART TO SHOWING COMMIT VALUES
		###########################################
		$snap_chartting = "commits";
	}

	###########################
	#INITIATE SOME GENERAL VARS
	###########################
	$bar_height_vert = 150;
	$bar_width = 20;
	$total_days_tracked = 0;
	
	####################################
	#VARS WHICH WILL HOUSE CURRENT STATS
	####################################
	$total_commits = 0;
	$total_rollbacks = 0;
	$total_block_reads = 0;
	$total_buffer_hits = 0;
	$total_inserts = 0;
	$total_updates = 0;
	$total_deletes = 0;
	$total_seq_scans = 0;
	$total_idx_scans = 0;
	$total_seq_rows = 0;
	$total_idx_rows = 0;

	################################################
	#VARS WHICH WILL HOUSE OUR ITERATION STAT VALUES
	################################################
	$commits = 0;
	$rollbacks = 0;
	$block_reads = 0;
	$buffer_hits = 0;
	$user_table_inserts = 0;
	$user_table_updates = 0;
	$user_table_deletes = 0;
	$seq_scans = 0;
	$idx_scans = 0;
	$seq_rows = 0;
	$idx_rows = 0;
	
	#####################################
	#VARS WHICH WILL HOUSE PREVIOUS STATS
	#####################################
	$total_commits_prev = 0;
	$total_rollbacks_prev = 0;
	$total_block_reads_prev = 0;
	$total_buffer_hits_prev = 0;
	$total_inserts_prev = 0;
	$total_updates_prev = 0;
	$total_deletes_prev = 0;
	$total_seq_scans_prev = 0;
	$total_idx_scans_prev = 0;
	$total_seq_rows_prev = 0;
	$total_idx_rows_prev = 0;

	################################################
	#VARS WHICH WILL HOUSE STAT COMPARISON & CHANGES
	################################################
	$commits_change = "";
	$rollbacks_change = "";
	$block_reads_change = "";
	$buffer_hits_change = "";
	$inserts_change = "";
	$updates_change = "";
	$deletes_change = "";
	$seq_scans_change = "";
	$idx_scans_change = "";
	$iud_inserts_change = "";
	$iud_updates_change = "";
	$iud_deletes_change = "";
	
	#####################
	#BAR CHART COLOR VARS
	#####################
	$bar_vert_alt_color = "#FFFFFF";
	$bar_vert_peak_color = "#FF6633";
	$bar_vert_color = "#7B7B7B";
	$bar_border_color = "#C9C9C9";

	##############
	#GRAPHICS VARS
	##############
	$stat_a1_src = "images/stat_arrow_up.png";
	$stat_a2_src = "images/stat_arrow_down.png";
	$stat_a3_src = "images/stat_arrow_equal.png";
	$stat_a4_src = "images/stat_arrow_no_data.png";

	#########
	#IUD VARS
	#########
	$iud_insert_color = "#7B7B7B";
	$iud_update_color = "#C8C8C8";
	$iud_delete_color = "#FFFFFF";
	$iud_nodata_color = "#000000";
	$iud_bar_width = 905;
	$iud_bar_height = 20;

	#####################################################################
	#VARS WHICH WILL TRACK THE HIGHEST STAT PER TYPE AND DATE OF THE PEAK
	#####################################################################
	$highest_commits = 0;
	$highest_commits_day = "";
	$highest_commits_date = "";
	
	$highest_rollbacks = 0;
	$highest_rollbacks_day = "";
	$highest_rollbacks_date = "";
	
	$highest_block_reads = 0;
	$highest_block_reads_day = "";
	$highest_block_reads_date = "";
	
	$highest_buffer_hits = 0;
	$highest_buffer_hits_day = "";
	$highest_buffer_hits_date = "";
	
	$highest_inserts = 0;
	$highest_inserts_day = "";
	$highest_inserts_date = "";
	
	$highest_updates = 0;
	$highest_updates_day = "";
	$highest_updates_date = "";
	
	$highest_deletes = 0;
	$highest_deletes_day = "";
	$highest_deletes_date = "";
	
	$highest_seq_scans = 0;
	$highest_seq_scans_day = "";
	$highest_seq_scans_date = "";
	
	$highest_idx_scans = 0;
	$highest_idx_scans_day = "";
	$highest_idx_scans_date = "";
	
	$highest_seq_rows = 0;
	$highest_seq_rows_day = "";
	$highest_seq_rows_date = "";
	
	$highest_idx_rows = 0;
	$highest_idx_rows_day = "";
	$highest_idx_rows_date = "";

	################################
	#VALIDATE OUR SERVER AND DB VARS
	################################
	if(empty($servers) || !is_numeric($servers)) $servers = 0;
	if(empty($dbs) || !is_numeric($dbs)) $dbs = 0;

	#####################
	#CONSTRUCT STAT QUERY
	#####################
	$stat_query  = "SELECT *,EXTRACT(DAY FROM recorded) FROM ps_core_tbl ";
	$stat_query .= "WHERE EXTRACT(MONTH FROM recorded) = $month AND EXTRACT(YEAR FROM recorded) = $year ";
	if($servers != 0) { $stat_query .= "AND server_id = $servers "; }
	if($dbs != 0) { $stat_query .= "AND db_id = $dbs "; }
	$stat_query .= "ORDER BY recorded ASC";

	#######
	#RUN IT
	#######
	$sqlselect_stats = @pg_query($pg_conn, $stat_query);

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlselect_stats)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	###########################
	#IF THERE ARE NO STATISTICS
	###########################
	if(pg_num_rows($sqlselect_stats) == 0)
	{
		$ajax_return[0] = 1;
		$ajax_return[] = "There are no statistics recorded for the above selections.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;	
	}

	############################
	#STORE THE PREVIOUS DAY FLAG
	############################
	$prev_day_flag = "";

	####################
	#START OUR ITERATION
	####################
	while($query_data_stats = pg_fetch_row($sqlselect_stats))
	{
		###############
		#GRAB CORE DATA
		###############
		$ps_core_id = $query_data_stats[0];
		$db_id = $query_data_stats[1];
		$server_id = $query_data_stats[2];
		$recorded = $query_data_stats[3];
		$datid = $query_data_stats[4];
		$datname = $query_data_stats[5];
		$core_commits = $query_data_stats[6];
		$core_rollbacks = $query_data_stats[7];
		$core_block_reads = $query_data_stats[8];
		$core_buffer_hits = $query_data_stats[9];
		$user_inserts = $query_data_stats[10];
		$user_updates = $query_data_stats[11];
		$user_deletes = $query_data_stats[12];
		$user_seq_scans = $query_data_stats[13];
		$user_idx_scans = $query_data_stats[14];
		$user_seq_rows = $query_data_stats[15];
		$user_idx_rows = $query_data_stats[16];
		$day_flag = $query_data_stats[17];

		####################
		#HANDLE LEADING ZERO
		####################
		if(strlen($day_flag) == 1) $day_flag = "0$day_flag";

		#####################
		#TALL UP TRACKED DAYS
		#####################
		if($day_flag != $prev_day_flag)
		{
			$total_days_tracked++;
		}

		#####################
		#UPDATE PREV DAY FLAG
		#####################
		$prev_day_flag = $day_flag;

		###################
		#PROCESS STATISTICS
		###################
		if(isset(${'db_commits_' . $day_flag})) ${'db_commits_' . $day_flag} += $core_commits;
		else ${'db_commits_' . $day_flag} = $core_commits;

		if(isset(${'db_rollbacks_' . $day_flag})) ${'db_rollbacks_' . $day_flag} += $core_rollbacks;
		else ${'db_rollbacks_' . $day_flag} = $core_rollbacks;

		if(isset(${'db_block_reads_' . $day_flag})) ${'db_block_reads_' . $day_flag} += $core_block_reads;
		else ${'db_block_reads_' . $day_flag} = $core_block_reads;
		
		if(isset(${'db_buffer_hits_' . $day_flag})) ${'db_buffer_hits_' . $day_flag} += $core_buffer_hits;
		else ${'db_buffer_hits_' . $day_flag} = $core_buffer_hits;
		
		if(isset(${'db_inserts_' . $day_flag})) ${'db_inserts_' . $day_flag} += $user_inserts;
		else ${'db_inserts_' . $day_flag} = $user_inserts;
		
		if(isset(${'db_updates_' . $day_flag})) ${'db_updates_' . $day_flag} += $user_updates;
		else ${'db_updates_' . $day_flag} = $user_updates;
		
		if(isset(${'db_deletes_' . $day_flag})) ${'db_deletes_' . $day_flag} += $user_deletes;
		else ${'db_deletes_' . $day_flag} = $user_deletes;
		
		if(isset(${'db_seq_scans_' . $day_flag})) ${'db_seq_scans_' . $day_flag} += $user_seq_scans;
		else ${'db_seq_scans_' . $day_flag} = $user_seq_scans;
		
		if(isset(${'db_idx_scans_' . $day_flag})) ${'db_idx_scans_' . $day_flag} += $user_idx_scans;
		else ${'db_idx_scans_' . $day_flag} = $user_idx_scans;
		
		if(isset(${'db_seq_rows_' . $day_flag})) ${'db_seq_rows_' . $day_flag} += $user_seq_rows;
		else ${'db_seq_rows_' . $day_flag} = $user_seq_rows;
		
		if(isset(${'db_idx_rows_' . $day_flag})) ${'db_idx_rows_' . $day_flag} += $user_idx_rows;
		else ${'db_idx_rows_' . $day_flag} = $user_idx_rows;

		#########################
		#TALL UP TOTAL STATISTICS
		#########################
		$total_commits += $core_commits;
		$total_rollbacks += $core_rollbacks;
		$total_block_reads += $core_block_reads;
		$total_buffer_hits += $core_buffer_hits;
		$total_inserts += $user_inserts;
		$total_updates += $user_updates;
		$total_deletes += $user_deletes;
		$total_seq_scans += $user_seq_scans;
		$total_idx_scans += $user_idx_scans;
		$total_seq_rows += $user_seq_rows;
		$total_idx_rows += $user_idx_rows;

		############################################################################
		#TALLY UP OUR "HIGHEST" VARS SO THAT WE CAN DETERMINE BAR CHART VALUES LATER
		############################################################################
		if(${'db_commits_' . $day_flag} >= $highest_commits)
		{
			$highest_commits = ${'db_commits_' . $day_flag};
			$highest_commits_day = $day_flag;
			$highest_commits_date = "$month-$day_flag-$year";	
		}
		if(${'db_rollbacks_' . $day_flag} >= $highest_rollbacks)
		{
			$highest_rollbacks = ${'db_rollbacks_' . $day_flag};
			$highest_rollbacks_day = $day_flag;
			$highest_rollbacks_date = "$month-$day_flag-$year";
		}
		if(${'db_block_reads_' . $day_flag} >= $highest_block_reads)
		{
			$highest_block_reads = ${'db_block_reads_' . $day_flag};
			$highest_block_reads_day = $day_flag;
			$highest_block_reads_date = "$month-$day_flag-$year";
		}
		if(${'db_buffer_hits_' . $day_flag} >= $highest_buffer_hits)
		{
			$highest_buffer_hits = ${'db_buffer_hits_' . $day_flag};
			$highest_buffer_hits_day = $day_flag;
			$highest_buffer_hits_date = "$month-$day_flag-$year";
		}
		if(${'db_inserts_' . $day_flag} >= $highest_inserts)
		{
			$highest_inserts = ${'db_inserts_' . $day_flag};
			$highest_inserts_day = $day_flag;
			$highest_inserts_date = "$month-$day_flag-$year";
		}
		if(${'db_updates_' . $day_flag} >= $highest_updates)
		{
			$highest_updates = ${'db_updates_' . $day_flag};
			$highest_updates_day = $day_flag;
			$highest_updates_date = "$month-$day_flag-$year";
		}
		if(${'db_deletes_' . $day_flag} >= $highest_deletes)
		{
			$highest_deletes = ${'db_deletes_' . $day_flag};
			$highest_deletes_day = $day_flag;
			$highest_deletes_date = "$month-$day_flag-$year";
		}
		if(${'db_seq_scans_' . $day_flag} >= $highest_seq_scans)
		{
			$highest_seq_scans = ${'db_seq_scans_' . $day_flag};
			$highest_seq_scans_day = $day_flag;
			$highest_seq_scans_date = "$month-$day_flag-$year";
		}
		if(${'db_idx_scans_' . $day_flag} >= $highest_idx_scans)
		{
			$highest_idx_scans = ${'db_idx_scans_' . $day_flag};
			$highest_idx_scans_day = $day_flag;
			$highest_idx_scans_date = "$month-$day_flag-$year";
		}
		if(${'db_seq_rows_' . $day_flag} >= $highest_seq_rows)
		{
			$highest_seq_rows = ${'db_seq_rows_' . $day_flag};
			$highest_seq_rows_day = $day_flag;
			$highest_seq_rows_date = "$month-$day_flag-$year";
		}
		if(${'db_idx_rows_' . $day_flag} >= $highest_idx_rows)
		{
			$highest_idx_rows = ${'db_idx_rows_' . $day_flag};
			$highest_idx_rows_day = $day_flag;
			$highest_idx_rows_date = "$month-$day_flag-$year";
		}
	}

	##############################################################
	#CHECK AND SEE IF STATS ARE AVAILABLE FOR THE PREVIOUS CYCLE
	##############################################################

	#####################
	#CONSTRUCT STAT QUERY
	#####################
	$date_prev = "$year-$month-01";
	$month_prev = date("m",strtotime("$date_prev -1 month"));
	$year_prev = date("Y",strtotime("$date_prev -1 month"));

	##########################
	#CONSTRUCT PREV STAT QUERY
	##########################
	$stat_query_prev  = "SELECT *,EXTRACT(DAY FROM recorded) FROM ps_core_tbl ";
	$stat_query_prev .= "WHERE EXTRACT(MONTH FROM recorded) = $month_prev AND EXTRACT(YEAR FROM recorded) = $year_prev ";
	if($servers != 0) { $stat_query_prev .= "AND server_id = $servers "; }
	if($dbs != 0) { $stat_query_prev .= "AND db_id = $dbs "; }
	$stat_query_prev .= "ORDER BY recorded ASC";

	#######
	#RUN IT
	#######
	$sqlselect_stats_prev = @pg_query($pg_conn, $stat_query_prev);

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlselect_stats_prev)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	##########################################
	#IF THERE ARE STATS FOR THE PREVIOUS CYCLE
	##########################################
	if(pg_num_rows($sqlselect_stats_prev) == 0)
	{
		$prev_stats_available = false;
	}
	else
	{
		$prev_stats_available = true;

		####################
		#START OUR ITERATION
		####################
		while($query_data_prev_stats = pg_fetch_row($sqlselect_stats_prev))
		{
			###############
			#GRAB CORE DATA
			###############
			$ps_core_id = $query_data_prev_stats[0];
			$db_id = $query_data_prev_stats[1];
			$server_id = $query_data_prev_stats[2];
			$recorded = $query_data_prev_stats[3];
			$datid = $query_data_prev_stats[4];
			$datname = $query_data_prev_stats[5];
			$core_commits = $query_data_prev_stats[6];
			$core_rollbacks = $query_data_prev_stats[7];
			$core_block_reads = $query_data_prev_stats[8];
			$core_buffer_hits = $query_data_prev_stats[9];
			$user_inserts = $query_data_prev_stats[10];
			$user_updates = $query_data_prev_stats[11];
			$user_deletes = $query_data_prev_stats[12];
			$user_seq_scans = $query_data_prev_stats[13];
			$user_idx_scans = $query_data_prev_stats[14];
			$user_seq_rows = $query_data_prev_stats[15];
			$user_idx_rows = $query_data_prev_stats[16];
			$day_flag = $query_data_prev_stats[17];

			####################
			#HANDLE LEADING ZERO
			####################
			if(strlen($day_flag) == 1) $day_flag = "0$day_flag";

			###################
			#PROCESS STATISTICS
			###################
			if(isset(${'db_commits_prev_' . $day_flag})) ${'db_commits_prev_' . $day_flag} += $core_commits;
			else ${'db_commits_prev_' . $day_flag} = $core_commits;
			
			if(isset(${'db_rollbacks_prev_' . $day_flag})) ${'db_rollbacks_prev_' . $day_flag} += $core_rollbacks;
			else ${'db_rollbacks_prev_' . $day_flag} = $core_rollbacks;
			
			if(isset(${'db_block_reads_prev_' . $day_flag})) ${'db_block_reads_prev_' . $day_flag} += $core_block_reads;
			else ${'db_block_reads_prev_' . $day_flag} = $core_block_reads;
			
			if(isset(${'db_buffer_hits_prev_' . $day_flag})) ${'db_buffer_hits_prev_' . $day_flag} += $core_buffer_hits;
			else ${'db_buffer_hits_prev_' . $day_flag} = $core_buffer_hits;
			
			if(isset(${'db_inserts_prev_' . $day_flag})) ${'db_inserts_prev_' . $day_flag} += $user_inserts;
			else ${'db_inserts_prev_' . $day_flag} = $user_inserts;
			
			if(isset(${'db_updates_prev_' . $day_flag})) ${'db_updates_prev_' . $day_flag} += $user_updates;
			else ${'db_updates_prev_' . $day_flag} = $user_updates;
			
			if(isset(${'db_deletes_prev_' . $day_flag})) ${'db_deletes_prev_' . $day_flag} += $user_deletes;
			else ${'db_deletes_prev_' . $day_flag} = $user_deletes;
			
			if(isset(${'db_seq_scans_prev_' . $day_flag})) ${'db_seq_scans_prev_' . $day_flag} += $user_seq_scans;
			else ${'db_seq_scans_prev_' . $day_flag} = $user_seq_scans;
			
			if(isset(${'db_idx_scans_prev_' . $day_flag})) ${'db_idx_scans_prev_' . $day_flag} += $user_idx_scans;
			else ${'db_idx_scans_prev_' . $day_flag} = $user_idx_scans;
			
			if(isset(${'db_seq_rows_prev_' . $day_flag})) ${'db_seq_rows_prev_' . $day_flag} += $user_seq_rows;
			else ${'db_seq_rows_prev_' . $day_flag} = $user_seq_rows;
			
			if(isset(${'db_idx_rows_prev_' . $day_flag})) ${'db_idx_rows_prev_' . $day_flag} += $user_idx_rows;
			else ${'db_idx_rows_prev_' . $day_flag} = $user_idx_rows;

			###################
			#TALL UP STATISTICS
			###################
			$total_commits_prev += $core_commits;
			$total_rollbacks_prev += $core_rollbacks;
			$total_block_reads_prev += $core_block_reads;
			$total_buffer_hits_prev += $core_buffer_hits;
			$total_inserts_prev += $user_inserts;
			$total_updates_prev += $user_updates;
			$total_deletes_prev += $user_deletes;
			$total_seq_scans_prev += $user_seq_scans;
			$total_idx_scans_prev += $user_idx_scans;
			$total_seq_rows_prev += $user_seq_rows;
			$total_idx_rows_prev += $user_idx_rows;
		}
	}

	################################
	#START CREATING OUR INITIAL HTML
	################################
$stats = <<<AJR
<div class="stat_div_bg">
<div class="orange_13" style="font-weight:bold; margin:0 0 10px 0;">Target Statistics:</div>
<table class="table_chart">
<tr>
AJR;
	
	#####################################################################################
	#PUT TOGETHER THE MONTH TABLEWORK - ITERATING THROUGH OUR DB VARS - CHECKING EACH DAY
	#####################################################################################
	for($i=1; $i<32; $i++)
	{
		################################
		#INITIATE/RESET VARS IN THE LOOP
		################################
		$tooltip = "";
		$bar_height_percent = 0;
		$bar_height = 0;
		$bar_height_final = 0;
		$bar_height_alt = 0;
		
		#####################
		#HANDLE LEADING ZEROS
		#####################
		if(strlen($i) == 1) $i = "0$i";
		
		###############################################################################################
		#DETERMINE WHAT TYPES OF STATS WE'LL BE BAR CHARTTING FIRST
		#CHECK FOR EACH DAY AND HANDLE DAYS WITH ZERO STATS - DEFAULT THE LIGHT GREY BAR HEIGHT TO 100%
		###############################################################################################
		$no_stat = false;
		
		################################################
		#CHECK THE STAT TYPE AND SEE IF THERE IS A VALUE
		################################################
		if(!isset(${'db_' . $snap_chartting . '_' . $i}))
		{
			$bar_height_alt = $bar_height_vert;
			$no_stat = true;
		}
		
		##################################################
		#IF WE HAVE STATS, PREPARE THE TOOLTIP, BARS, ETC.
		##################################################
		if($no_stat == false)
		{	
			##################################
			#FIRST PREP OUR COMMIT TOOLTIP VAR
			##################################
			$tt_commits = ${'db_commits_' . $i};
			if($tt_commits == 0 || empty($tt_commits)) $tt_commits = "0";
			else $tt_commits = number_format($tt_commits);
			
			###############################
			#PREP OUR ROLLBACKS TOOLTIP VAR
			###############################
			$tt_rollbacks = ${'db_rollbacks_' . $i};
			if($tt_rollbacks == 0 || empty($tt_rollbacks)) $tt_rollbacks = "0";
			else $tt_rollbacks = number_format($tt_rollbacks);
			
			#################################
			#PREP OUR BLOCK READS TOOLTIP VAR
			#################################
			$tt_block_reads = ${'db_block_reads_' . $i};
			if($tt_block_reads == 0 || empty($tt_block_reads)) $tt_block_reads = "0";
			else $tt_block_reads = number_format($tt_block_reads);
			
			#################################
			#PREP OUR BUFFER HITS TOOLTIP VAR
			#################################
			$tt_buffer_hits = ${'db_buffer_hits_' . $i};
			if($tt_buffer_hits == 0 || empty($tt_buffer_hits)) $tt_buffer_hits = "0";
			else $tt_buffer_hits = number_format($tt_buffer_hits);
			
			############################
			#PREP OUR INSERT TOOLTIP VAR
			############################
			$tt_inserts = ${'db_inserts_' . $i};
			if($tt_inserts == 0 || empty($tt_inserts)) $tt_inserts = "0";
			else $tt_inserts = number_format($tt_inserts);
			
			############################
			#PREP OUR UPDATE TOOLTIP VAR
			############################
			$tt_updates = ${'db_updates_' . $i};
			if($tt_updates == 0 || empty($tt_updates)) $tt_updates = "0";
			else $tt_updates = number_format($tt_updates);
			
			############################
			#PREP OUR DELETE TOOLTIP VAR
			############################
			$tt_deletes = ${'db_deletes_' . $i};
			if($tt_deletes == 0 || empty($tt_deletes)) $tt_deletes = "0";
			else $tt_deletes = number_format($tt_deletes);
			
			###############################
			#PREP OUR SEQ SCANS TOOLTIP VAR
			###############################
			$tt_seq_scans = ${'db_seq_scans_' . $i};
			if($tt_seq_scans == 0 || empty($tt_seq_scans)) $tt_seq_scans = "0";
			else $tt_seq_scans = number_format($tt_seq_scans);
			
			###############################
			#PREP OUR IDX SCANS TOOLTIP VAR
			###############################
			$tt_idx_scans = ${'db_idx_scans_' . $i};
			if($tt_idx_scans == 0 || empty($tt_idx_scans)) $tt_idx_scans = "0";
			else $tt_idx_scans = number_format($tt_idx_scans);
			
			#######################################################
			#CHECK TO SEE IF WE HAVE STATS FOR PREVIOUS CYCLE
			#IF SO, CALCULATE THE PERCENTAGE UP OR DOWN AND DISPLAY
			#######################################################
			if($prev_stats_available == true)
			{
				##############################
				#DEFAULT OUR CHANGE VAR VALUES
				##############################
				$change = "";
				$commits_change = "";
				$rollbacks_change = "";
				$block_reads_change = "";
				$buffer_hits_change = "";
				$inserts_change = "";
				$updates_change = "";
				$deletes_change = "";
				$seq_scans_change = "";
				$idx_scans_change = "";

				#############################################
				#CHECK STATISTICS INCREASE / DECREASE
				#SHOW PREVIOUS FIGURES IN THE TOOLTIP AS WELL
				#############################################

				###################################################################################
				#SET UP AN ARRAY OF THE STAT TYPES SO WE CAN ITERATE THROUGH THEM FOR THE NEXT STEP
				###################################################################################
				$stat_type_array = array("commits","rollbacks","block_reads","buffer_hits","inserts","updates","deletes","seq_scans","idx_scans");

				###############################
				#ITERATE THROUGH EACH STAT TYPE
				###############################
				foreach($stat_type_array as &$stat_type)
				{
					#######################
					#FORCE NUMBER TYPE CASE
					#######################
					if(isset(${'db_' . $stat_type . '_prev_' . $i})) ${'db_' . $stat_type . '_prev_' . $i} += 0;
					if(isset(${'db_' . $stat_type . '_' . $i})) ${'db_' . $stat_type . '_' . $i} += 0;

					##############################################################
					#OBTAIN CHANGE STAT ONLY IF BOTH CURRENT AND PREV STATS EXISTS
					##############################################################
					if(isset(${'db_' . $stat_type . '_' . $i}) && isset(${'db_' . $stat_type . '_prev_' . $i}))
					{
						####################
						#HANDLE THE INCREASE
						####################
						if(${'db_' . $stat_type . '_' . $i} > ${'db_' . $stat_type . '_prev_' . $i})
						{
							if(${'db_' . $stat_type . '_prev_' . $i} == 0)
							{
								$change = ${'db_' . $stat_type . '_' . $i} * 100;
							}
							else
							{
								$change = ((${'db_' . $stat_type . '_' . $i} - ${'db_' . $stat_type . '_prev_' . $i}) * 100) / ${'db_' . $stat_type . '_prev_' . $i};
							}

							$change = number_format($change, 2, '.', ',') . "%";
							${$stat_type . '_change'} = "&nbsp;(+" . $change . ")";
						}

						####################
						#HANDLE THE DECREASE
						####################
						elseif(${'db_' . $stat_type . '_prev_' . $i} > ${'db_' . $stat_type . '_' . $i})
						{
							if(${'db_' . $stat_type . '_' . $i} == 0)
							{
								$change = ${'db_' . $stat_type . '_prev_' . $i} * 100;
							}
							else
							{
								$change = ((${'db_' . $stat_type . '_prev_' . $i} - ${'db_' . $stat_type . '_' . $i}) * 100) / ${'db_' . $stat_type . '_' . $i};
							}

							$change = number_format($change, 2, '.', ',') . "%";
							${$stat_type . '_change'} = "&nbsp;(-" . $change . ")";
						}
					}
				}
			}

			################
			#PUT IT TOGETHER
			################
			$tooltip = "<div style=line-height:17px;>";

			########
			#COMMITS
			########
			if($snap_chartting == "commits") $tooltip .= "<span class=orange_12><strong>Commits:&nbsp;" . $tt_commits . $commits_change . "</strong></span><br>";
			else $tooltip .= "Commits:&nbsp;<strong>" . $tt_commits . "</strong>" . $commits_change . "<br>";

			##########
			#ROLLBACKS
			##########
			if($snap_chartting == "rollbacks") $tooltip .= "<span class=orange_12><strong>Rollbacks:&nbsp;" . $tt_rollbacks . $rollbacks_change . "</strong></span><br>";
			else $tooltip .= "Rollbacks:&nbsp;<strong>" . $tt_rollbacks . "</strong>" . $rollbacks_change . "<br>";

			############
			#BLOCK READS
			############
			if($snap_chartting == "block_reads") $tooltip .= "<span class=orange_12><strong>Block&nbsp;Reads:&nbsp;" . $tt_block_reads . $block_reads_change . "</strong></span><br>";
			else $tooltip .= "Block&nbsp;Reads:&nbsp;<strong>" . $tt_block_reads . "</strong>" . $block_reads_change . "<br>";

			############
			#BUFFER HITS
			############
			if($snap_chartting == "buffer_hits") $tooltip .= "<span class=orange_12><strong>Buffer&nbsp;Hits:&nbsp;" . $tt_buffer_hits . $buffer_hits_change . "</strong></span><br>";
			else $tooltip .= "Buffer&nbsp;Hits:&nbsp;<strong>" . $tt_buffer_hits . "</strong>" . $buffer_hits_change . "<br>";

			########
			#INSERTS
			########
			if($snap_chartting == "inserts") $tooltip .= "<span class=orange_12><strong>Inserts:&nbsp;" . $tt_inserts . $inserts_change . "</strong></span><br>";
			else $tooltip .= "Inserts:&nbsp;<strong>" . $tt_inserts . "</strong>" . $inserts_change . "<br>";

			########
			#UPDATES
			########
			if($snap_chartting == "updates") $tooltip .= "<span class=orange_12><strong>Updates:&nbsp;" . $tt_updates . $updates_change . "</strong></span><br>";
			else $tooltip .= "Updates:&nbsp;<strong>" . $tt_updates . "</strong>" . $updates_change . "<br>";

			########
			#DELETES
			########
			if($snap_chartting == "deletes") $tooltip .= "<span class=orange_12><strong>Deletes:&nbsp;" . $tt_deletes . $deletes_change . "</strong></span><br>";
			else $tooltip .= "Deletes:&nbsp;<strong>" . $tt_deletes . "</strong>" . $deletes_change . "<br>";

			##########
			#SEQ SCANS
			##########
			if($snap_chartting == "seq_scans") $tooltip .= "<span class=orange_12><strong>Sequence&nbsp;Scans:&nbsp;" . $tt_seq_scans . $seq_scans_change . "</strong></span><br>";
			else $tooltip .= "Sequence&nbsp;Scans:&nbsp;<strong>" . $tt_seq_scans . "</strong>" . $seq_scans_change . "<br>";

			##########
			#IDX SCANS
			##########
			if($snap_chartting == "idx_scans") $tooltip .= "<span class=orange_12><strong>Index&nbsp;Scans:&nbsp;" . $tt_idx_scans . $idx_scans_change . "</strong></span><br>";
			else $tooltip .= "Index&nbsp;Scans:&nbsp;<strong>" . $tt_idx_scans . "</strong>" . $idx_scans_change . "<br>";

			#########################
			#COMPLETE THE TOOLTIP DIV
			#########################
			$tooltip .= "</div>";

			###################################################################################################
			#GET THE STAT PERCENT FOR THE APPROPRIATE STAT TYPE AND DEFINE THE BAR HEIGHT FOR THE DARK GREY BAR
			###################################################################################################	
			if(!empty(${'highest_' . $snap_chartting})) { $stat_percent = ${'db_' . $snap_chartting . '_' . $i} / ${'highest_' . $snap_chartting}; $bar_height_percent = $stat_percent; } else { $bar_height_percent = 0; }

			#################################
			#COMPLETE OUR MATH FOR THE HEIGHT
			#################################
			$bar_height = $bar_height_vert * $bar_height_percent;
			$bar_height_final = number_format($bar_height, 0, '.', '');

			############################
			#CHECK THE HEIGHT - FOR SAFE
			############################
			if($bar_height_final > $bar_height_vert) $bar_height_final = $bar_height_vert;

			####################################################################################
			#CREATE THE HEIGHT FOR THE ALT LIGHT GREY BAR WHICH SITS ON TOP OF THE DARK GREY BAR
			####################################################################################
			$bar_height_alt = $bar_height_vert - $bar_height_final;

			#############################################################################
			#HANDLE THE FINAL SOURCE GRAPHIC AND CHECK FOR THE PEAK DAY - FLAGGED EARLIER
			#############################################################################
			if($i == ${'highest_' . $snap_chartting . '_day'}) $bar_vert_color_final = $bar_vert_peak_color;
			else $bar_vert_color_final = $bar_vert_color;
		}
	
		$stats .= "<td valign=\"bottom\" style=\"text-align:center;\">";

		#######################################################
		#START UP THE TABLEWORK WHICH WILL HOUSE THE BAR ITSELF
		#######################################################
		$stats .= "<table>";

		############################
		#DETERMINE BORDER STYLES NOW
		############################
		$bar_border = "border:1px solid $bar_border_color;";
		if($bar_height_final <= 0) $bar_alt_border = "border:1px solid $bar_border_color;";
		else $bar_alt_border = "border-color:$bar_border_color; border-width:1px 1px 0px 1px; border-style:solid;"; 

		#####################################################################################
		#HANDLE THE ALT COLOR - WILL EITHER BE THE ENTIRE BAR (NO DATA) OR THE TOP OF THE BAR
		#####################################################################################
		if($bar_height_alt > 0)
		{
			#############################
			#CREATE FINAL CELL DIMENSIONS
			#############################
			$bar_width_px = $bar_width . "px";
			$bar_height_alt_px = $bar_height_alt . "px";

			#############
			#DISPLAY CELL
			#############
			$stats .= "<tr><td style=\"width:$bar_width_px; height:$bar_height_alt_px; background-color:$bar_vert_alt_color; $bar_alt_border\"></td></tr>";
		}

		################################################
		#HANDLE THE BOTTOM OF THE BAR WHERE WE HAVE DATA
		################################################
		if($bar_height_final > 0)
		{
			#############################
			#CREATE FINAL CELL DIMENSIONS
			#############################
			$bar_width_px = $bar_width . "px";
			$bar_height_final_px = $bar_height_final . "px";

			#############
			#DISPLAY CELL
			#############
			$stats .= "<tr><td style=\"width:$bar_width_px; height:$bar_height_final_px; background-color:$bar_vert_color_final; $bar_border\" onMouseOver=\"tooltip.show('$tooltip')\" onMouseOut='tooltip.hide()'></td></tr>";
		}

		$stats .= "</table>";

		################################################
		#FINISHED WITH THE BAR TABLE - CONTINUE OUR HTML
		################################################
		$stats .= "</td>";
	}

$stats .= <<<AJR
</tr>
<tr>
AJR;

	##########################################################################################################
	#CREATE THE MONTH NUMBERS AND IF THERE ARE TARGET STAT VALUES FOR EACH DAY - MAKE A QUICK LINK TO THAT DAY
	##########################################################################################################
	for($i=1; $i<32; $i++)
	{
		#####################
		#HANDLE LEADING ZEROS
		#####################
		if(strlen($i) == 1) $i = "0$i";

		##############################
		#HANDLE THE TOOLTIP COMMIT MSG
		##############################
		$tooltip = "Retrieve&nbsp;Stats";
		$stats .= "<td class=\"grey_12\" style=\"text-align:center; padding-top:5px;\">";

		###################################################
		#CHECK TARGET STAT TARGET THIS DAY AND SET THE LINK
		###################################################
		if(isset(${'db_' . $snap_chartting . '_' . $i}))
		{
			if(${'db_' . $snap_chartting . '_' . $i} > 0)
			{
				$stats .= "<span onMouseOver=\"tooltip.show('$tooltip')\" onMouseOut='tooltip.hide()'><a href=javascript:daily_retrieve('$month','$i','$year')>$i</a></span>";
			}
			else
			{
				###################
				#JUST DAY - NO LINK
				###################
				$stats .= $i;
			}
		}
		else
		{
			######################
			#NO STATS FOR THIS DAY
			######################
			$stats .= $i;
		}

		$stats .= "</td>";
	}

	#############################################
	#HANDLE PREVIOUS STATS FOR THE IUD QUICK VIEW
	#############################################
	if($prev_stats_available == true)
	{
		###################################################################################
		#SET UP AN ARRAY OF THE STAT TYPES SO WE CAN ITERATE THROUGH THEM FOR THE NEXT STEP
		###################################################################################
		$stat_type_array = array("inserts","updates","deletes");

		#######################
		#START UP THE ITERATION
		#######################
		foreach($stat_type_array as &$stat_type)
		{
			##########################################
			#FOR IUD COMPARISONS - HANDLE THE INCREASE
			##########################################
			if(${'total_' . $stat_type} > ${'total_' . $stat_type . '_prev'})
			{
				if(${'total_' . $stat_type . '_prev'} == 0)
				{
					$change = ${'total_' . $stat_type} * 100;
				}
				else
				{
					$change = ((${'total_' . $stat_type} - ${'total_' . $stat_type . '_prev'}) * 100) / ${'total_' . $stat_type . '_prev'};
				}
				
				$change = number_format($change, 2, '.', ',') . "%";
				${'iud_' . $stat_type . '_change'} = "&nbsp;(+" . $change . ")";
			}
			####################
			#HANDLE THE DECREASE
			####################
			elseif(${'total_' . $stat_type . '_prev'} > ${'total_' . $stat_type})
			{
				if(${'total_' . $stat_type} == 0)
				{
					$change = ${'total_' . $stat_type . '_prev'} * 100;
				}
				else
				{
					$change = ((${'total_' . $stat_type . '_prev'} - ${'total_' . $stat_type}) * 100) / ${'total_' . $stat_type};
				}

				$change = number_format($change, 2, '.', ',') . "%";
				${'iud_' . $stat_type . '_change'} = "&nbsp;(-" . $change . ")";
			}
		}
	}

	##################################
	#PUT THE LAST OF OUR HTML TOGETHER
	##################################
$stats .= <<<AJR
</tr>
<tr>
AJR;

	###########################################################################################################
	#CALCULATE THE STAT ARROWS SHOWING VISITOR WHETHER PREVIOUS STATS ARE UP, DOWN OR EQUAL TO THE CURRENT STAT
	###########################################################################################################
	for($i=1; $i<32; $i++)
	{
		#####################
		#HANDLE LEADING ZEROS
		#####################
		if(strlen($i) == 1) $i = "0$i";

		##################
		#START-UP OUR HTML
		##################
		$stats .= "<td class=\"grey_12\" style=\"text-align:center; padding-top:5px;\">";

		#############################################################################
		#CHECK TO SEE IF WE HAVE STATS FOR PREVIOUS CYCLE
		#ALSO CHECK TO MAKE SURE WE ONLY SHOW ICONS FOR DAYS WITH STATS WHICH WE HAVE
		#SHOW 'NO-DATA' ICON FOR ALL OTHER DAYS AFTER
		#############################################################################	
		if($prev_stats_available == true && isset(${'db_' . $snap_chartting . '_' . $i}))
		{
			###########################
			#CHECK FOR NO PREVIOUS DATA
			###########################
			if(!isset(${'db_' . $snap_chartting . '_prev_' . $i})) $stats .= "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";

			###########################
			#CHECK FOR STATS INCREASING
			###########################
			elseif(${'db_' . $snap_chartting . '_' . $i} > ${'db_' . $snap_chartting . '_prev_' . $i}) $stats .= "<img src=\"$stat_a1_src\" width=\"10\" height=\"8\"/>";

			###########################
			#CHECK FOR STATS DECREASING
			###########################
			elseif(${'db_' . $snap_chartting . '_' . $i} < ${'db_' . $snap_chartting . '_prev_' . $i}) $stats .= "<img src=\"$stat_a2_src\" width=\"10\" height=\"8\"/>";

			#################################
			#CHECK FOR STATS EXACTLY THE SAME
			#################################
			elseif(${'db_' . $snap_chartting . '_' . $i} == ${'db_' . $snap_chartting . '_prev_' . $i}) $stats .= "<img src=\"$stat_a3_src\" width=\"10\" height=\"8\"/>";
		}
		else
		{
			################################
			#FORCE THE NO-DATA ICON FOR SAFE
			################################
			$stats .= "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
		}

		##########
		#FINISH UP
		##########
		$stats .= "</td>";
	}

###################################################
#PUT THE LAST OF OUR HTML TOGETHER FOR THE BAR AREA
###################################################
$stats .= <<<AJR
</tr>
</table>
</div>
AJR;

##############################################
#DETERMINE RECAP STATS FOR THIS CHARTTING TYPE
##############################################
$recap_average_day = ${'total_' . $snap_chartting} / $total_days_tracked;
$recap_average_hour = $recap_average_day / 24;
$recap_average_minute = $recap_average_hour / 60;
$recap_average_day = number_format($recap_average_day, 2, '.', ',');
$recap_average_hour = number_format($recap_average_hour, 2, '.', ',');
$recap_average_minute = number_format($recap_average_minute, 2, '.', ',');
$recap_peak = number_format(${'highest_' . $snap_chartting});
$recap_total = number_format(${'total_' . $snap_chartting});

#################################################################
#CAPS THE FIRST LETTER IN THE YEAR_CHARTTING VAR FOR A NICE TITLE
#################################################################
switch($snap_chartting)
{
	case "commits"; $stat_title = "Commits"; break;
	case "rollbacks"; $stat_title = "Roll&nbsp;Backs"; break;
	case "block_reads"; $stat_title = "Block&nbsp;Reads"; break;
	case "buffer_hits"; $stat_title = "Buffer&nbsp;Hits"; break;
	case "inserts"; $stat_title = "Inserts"; break;
	case "updates"; $stat_title = "Updates"; break;
	case "deletes"; $stat_title = "Deletes"; break;
	case "seq_scans"; $stat_title = "SEQ&nbsp;Scans"; break;
	case "idx_scans"; $stat_title = "IDX&nbsp;Scans";
}

###############################################################
#PARSE THE PEAK DATE SO WE CAN LINK IT TO THE DAIL DB STAT VIEW
###############################################################
$peak_month = substr(${'highest_' . $snap_chartting . '_date'},0,2);
$peak_day = substr(${'highest_' . $snap_chartting . '_date'},3,2);
$peak_year = $year;
$tooltip = "Retrieve Stats";

#######################################################################
#PUT TOGETHER THE STATS / TABLE WHICH WILL BE TO THE RIGHT OF THE CHART
#DISPLAYING SOME GENERAL STATS ON THE SELECTED TYPE
#######################################################################
$stats .= <<<AJR
</td>
</tr>
</table>
AJR;

#########################
#START HTML FOR RECAP DIV
#########################
$stats .= "<div class=\"stat_div_bg\" style=\"margin:20px 0 20px 0;\">";

############
#RECAP TOTAL
############
$stats .= <<<AJR
<div class="orange_13" style="font-weight:bold; margin:0 0 10px 0;">Statistics Overview:</div>
<div class="black_12" style="padding:10px; float:left; border:1px solid $bar_border_color; background-color:#FFFFFF;"><span style="font-weight:bold;">Total $stat_title:</span> $recap_total</div>
AJR;

###############
#RECAP PEAK DAY
###############
$stats .= <<<AJR
<div class="black_12" style="margin-left:5px; padding:10px; float:left; border:1px solid $bar_border_color; background-color:#FFFFFF;"><span style="font-weight:bold;">Peak Day:</span> 
AJR;

if($recap_peak > 0) $stats .= "$recap_peak";
else $stats .= "N/A";

######################################
#SHOW THE PEAK MONTH ONLY IF IT EXISTS
######################################
if(!empty($peak_month) && !empty($peak_day) && !empty($peak_year) && $recap_peak > 0)
{
	$stats .= "&nbsp;<span class=\"orange_12\" onMouseOver=\"tooltip.show('$tooltip')\" onMouseOut='tooltip.hide()'>(<a href=javascript:daily_retrieve('$peak_month','$peak_day','$peak_year')>${'highest_' . $snap_chartting . '_date'}</a>)</span>";
}
$stats .= "</div>";

####################
#RECAP AVERAGE DAILY
####################
$stats .= <<<AJR
<div class="black_12" style="margin-left:5px; padding:10px; float:left; border:1px solid $bar_border_color; background-color:#FFFFFF;"><span style="font-weight:bold;">Avg/Day:</span>   
AJR;

if($recap_average_day > 0) $stats .= "$recap_average_day";
else $stats .= "N/A";
$stats .= "</div>";

#####################
#RECAP AVERAGE HOURLY
#####################
$stats .= <<<AJR
<div class="black_12" style="margin-left:5px; padding:10px; float:left; border:1px solid $bar_border_color; background-color:#FFFFFF;"><span style="font-weight:bold;">Avg/Hr:</span> 
AJR;

if($recap_average_hour > 0) $stats .= "$recap_average_hour";
else $stats .= "N/A";
$stats .= "</div>";

#####################
#RECAP AVERAGE MINUTE
#####################
$stats .= <<<AJR
<div class="black_12" style="margin-left:5px; padding:10px; float:left; border:1px solid $bar_border_color; background-color:#FFFFFF;"><span style="font-weight:bold;">Avg/Min:</span> 
AJR;

if($recap_average_minute > 0) $stats .= "$recap_average_minute";
else $stats .= "N/A";
$stats .= "</div>";

############
#CLAR FLOATS
############
$stats .= "<div style=\"clear:both;\"></div>";

##########################
#END OF OF RECAP STATS DIV
##########################
$stats .= "</div>";

#################
#START OF IUD DIV
#################
$stats .= <<<AJR
<div class="stat_div_bg" style="margin:0 0 20px 0;">
<div class="orange_13" style="font-weight:bold; margin:0 0 10px 0;">Insert / Update / Delete Quick View:</div>
AJR;

	##############################################################
	#PUT TOGETHER OUR IUD STATS - FIRST INITIATE SOME GENERAL VARS
	##############################################################
	$total_iud = $total_inserts + $total_updates + $total_deletes;

	##############################################
	#GET THE PERCENTAGES OF EACH AGAINST THE TOTAL
	##############################################
	if(!empty($total_iud)) { $iud_ins_percent = number_format($total_inserts / $total_iud, 2, '.', ','); } else { $iud_ins_percent = 0; }
	if(!empty($total_iud)) { $iud_upd_percent = number_format($total_updates / $total_iud, 2, '.', ','); } else { $iud_upd_percent = 0; }
	if(!empty($total_iud)) { $iud_del_percent = number_format($total_deletes / $total_iud, 2, '.', ','); } else { $iud_del_percent = 0; }

	#################################################
	#PREPARE THE BAR WIDTHS AND ROUND THE NUMBERS OUT
	#################################################
	$iud_ins_bar_w = number_format($iud_bar_width * $iud_ins_percent);
	$iud_upd_bar_w = number_format($iud_bar_width * $iud_upd_percent);
	$iud_del_bar_w = number_format($iud_bar_width * $iud_del_percent);

	#######################################################################################################
	#TALLY UP THE WIDTHS AND TAKE ANY NOMINAL REMAINDER +/- IUD_BAR_WIDTH AND +/- IT FROM THE LARGEST SCORE
	#######################################################################################################
	$iud_bar_total = $iud_ins_bar_w + $iud_upd_bar_w + $iud_del_bar_w;

	if($iud_bar_total < $iud_bar_width && $iud_bar_total > 0) 
	{
		###################
		#GET THE DIFFERENCE
		###################
		$iud_remain = $iud_bar_width-$iud_bar_total;

		############################
		#ADD IT TO HIGHEST IUD SCORE
		############################
		if($total_inserts > $total_updates && $total_inserts > $total_deletes) $iud_ins_bar_w += $iud_remain;
		elseif($total_updates > $total_inserts && $total_updates > $total_deletes) $iud_upd_bar_w += $iud_remain;
		else $iud_del_bar_w += $iud_remain;
	}
	elseif($iud_bar_total > $iud_bar_width) 
	{
		###################
		#GET THE DIFFERENCE
		###################
		$iud_remain = $iud_bar_total-$iud_bar_width;

		###################################
		#SUBTRACT IT FROM HIGHEST IUD SCORE
		###################################
		if($total_inserts > $total_updates && $total_inserts > $total_deletes) $iud_ins_bar_w -= $iud_remain;
		elseif($total_updates > $total_inserts && $total_updates > $total_deletes) $iud_upd_bar_w -= $iud_remain;
		else $iud_del_bar_w -= $iud_remain;
	}

	##################################
	#PUT TOGETHER OUR IUD TOOLTIP VARS
	##################################
	$iud_tt_ins = "<div style=line-height:17px;>";
	$iud_tt_ins .= "Total Inserts:&nbsp;<strong class=orange_12>" . number_format($total_inserts) . "</strong>" . $iud_inserts_change;
	$iud_tt_ins .= "</div>";

	$iud_tt_upd = "<div style=line-height:17px;>";
	$iud_tt_upd .= "Total Updates:&nbsp;<strong class=orange_12>" . number_format($total_updates) . "</strong>" . $iud_updates_change;
	$iud_tt_upd .= "</div>";

	$iud_tt_del = "<div style=line-height:17px;>";
	$iud_tt_del .= "Total Deletes:&nbsp;<strong class=orange_12>" . number_format($total_deletes) . "</strong>" . $iud_deletes_change;
	$iud_tt_del .= "</div>";

	###########################################################################################
	#SHOW EITHER THE THREE IUD BARS TOGETHER OR THE DEFAULT NO-DATA BAR IF THERE IS NO IUD DATA
	###########################################################################################

	#####################
	#PREP CELL DIMENSIONS
	#####################
	$iud_bar_width_px = $iud_bar_width . "px";
	$iud_bar_height_px = $iud_bar_height . "px";

	################
	#BEGIN TABLEWORK
	################
	$stats .= "<table style=\"width:$iud_bar_width_px; max-width:$iud_bar_width_px;\">";
	$stats .= "<tr>";

	if($total_iud > 0)
	{
		###########
		#INSERT BAR
		###########
		if($iud_ins_bar_w > 0)
		{
			$ins_border = "border:1px solid $bar_border_color;";
			$iud_ins_bar_w_px = $iud_ins_bar_w . "px";
			$stats .= "<td style=\"width:$iud_ins_bar_w_px; height:$iud_bar_height_px; background-color:$iud_insert_color; $ins_border\" onMouseOver=\"tooltip.show('$iud_tt_ins')\" onMouseOut='tooltip.hide()'></td>";
		}

		###########
		#UPDATE BAR
		###########
		if($iud_upd_bar_w > 0)
		{
			if($iud_ins_bar_w > 0) $upd_border = "border-color:$bar_border_color; border-width:1px 1px 1px 0px; border-style:solid;";
			else $upd_border = "border:1px solid $bar_border_color;";
			$iud_upd_bar_w_px = $iud_upd_bar_w . "px";
			$stats .= "<td style=\"width:$iud_upd_bar_w_px; height:$iud_bar_height_px; background-color:$iud_update_color; $upd_border\" onMouseOver=\"tooltip.show('$iud_tt_upd')\" onMouseOut='tooltip.hide()'></td>";
		}

		###########
		#DELETE BAR
		###########
		if($iud_del_bar_w > 0) 
		{
			if($iud_upd_bar_w > 0 || $iud_ins_bar_w > 0) $del_border = "border-color:$bar_border_color; border-width:1px 1px 1px 0px; border-style:solid;";
			else $del_border = "border:1px solid $bar_border_color;";
			$iud_del_bar_w_px = $iud_del_bar_w . "px";
			$stats .= "<td style=\"width:$iud_del_bar_w_px; height:$iud_bar_height_px; background-color:$iud_delete_color; $del_border\" onMouseOver=\"tooltip.show('$iud_tt_del')\" onMouseOut='tooltip.hide()'></td>";
		}
	}
	else
	{
		##################################
		#DEFAULT THE NO-DATA BAR AND WIDTH
		##################################
		$stats .= "<td style=\"width:$iud_bar_width_px; height:$iud_bar_height_px; background-color:$iud_nodata_color; border:1px solid $bar_border_color;\" onMouseOver=\"tooltip.show('No data to report.')\" onMouseOut='tooltip.hide()'></td>";
	}

	##############################################
	#COMPLETE OUR HTML TABLE WORK FOR THE IUD AREA
	##############################################
	$stats .= "</tr>";
	$stats .= "</table>";

	##################
	#CREATE IUD LEGEND
	##################
$stats .= <<<AJR
<div class="grey_12" style="margin:15px 0 0 0;">
<div style="float:left; height:15px; width:15px; background-color:$iud_nodata_color; border:1px solid $bar_border_color; margin-right:5px;"></div>
<div style="float:left; height:15px; margin-right:10px;">No Data</div>
<div style="float:left; height:15px; width:15px; background-color:$iud_insert_color; border:1px solid $bar_border_color; margin-right:5px;"></div>
<div style="float:left; height:15px; margin-right:10px;">Inserts</div>
<div style="float:left; height:15px; width:15px; background-color:$iud_update_color; border:1px solid $bar_border_color; margin-right:5px;"></div>
<div style="float:left; height:15px; margin-right:10px;">Updates</div>
<div style="float:left; height:15px; width:15px; background-color:$iud_delete_color; border:1px solid $bar_border_color; margin-right:5px;"></div>
<div style="float:left; height:15px; margin-right:10px;">Deletes</div>
<div style="clear:both;"></div>
</div>
AJR;

##################
#COMPLETE IUD AREA
##################
$stats .= "</div>";

####################################
#START THE CORE STATISTICS DIV BELOW
####################################
$stats .= <<<AJR
<div class="stat_div_bg">
<div class="orange_13" style="font-weight:bold; margin:0 0 10px 0;">Core Statistics:</div>
AJR;

	######################################################################
	#DETERMINE THE +/- GRAPHIC SOURCES BASED ON TOTALS AND PREVIOUS TOTALS
	#WE'LL SHOW THESE BELOW THE BAR CHART IN OUR TABLE
	######################################################################
	if($prev_stats_available == true)
	{
		###################################################################################
		#SET UP AN ARRAY OF THE STAT TYPES SO WE CAN ITERATE THROUGH THEM FOR THE NEXT STEP
		###################################################################################
		$stat_type_array = array("commits","rollbacks","block_reads","buffer_hits","inserts","updates","deletes","seq_scans","idx_scans","seq_rows","idx_rows");
		
		###############################
		#ITERATE THROUGH EACH STAT TYPE
		###############################
		foreach($stat_type_array as &$stat_type)
		{
			if(${'total_' . $stat_type} > ${'total_' . $stat_type . '_prev'}) ${'total_' . $stat_type . '_change'} = "<img src=\"$stat_a1_src\" width=\"10\" height=\"8\"/>";
			elseif(${'total_' . $stat_type . '_prev'} > ${'total_' . $stat_type}) ${'total_' . $stat_type . '_change'} = "<img src=\"$stat_a2_src\" width=\"10\" height=\"8\"/>";
			elseif(${'total_' . $stat_type} == ${'total_' . $stat_type . '_prev'}) ${'total_' . $stat_type . '_change'} = "<img src=\"$stat_a3_src\" width=\"10\" height=\"8\"/>";
			else ${'total_' . $stat_type . '_change'} = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
		}
	}
	else
	{
		################################################
		#NO PREVIOUS STATS - SHOW GREY 'NO-DATA' GRAPHIC
		################################################
		$total_commits_change = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
		$total_rollbacks_change = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
		$total_block_reads_change = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
		$total_buffer_hits_change = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
		$total_inserts_change = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
		$total_updates_change = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
		$total_deletes_change = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
		$total_seq_scans_change = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
		$total_idx_scans_change = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
		$total_seq_rows_change = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
		$total_idx_rows_change = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
	}
	
	######################################
	#FORMAT GENERAL STATISTICS FOR COMMITS
	######################################
	$average_day = $total_commits / $total_days_tracked;
	$average_hour = $average_day / 24;
	$average_minute = $average_hour / 60;
	$average_second = $average_minute / 60;
	$average_day = number_format($average_day, 2, '.', ',');
	$average_hour = number_format($average_hour, 2, '.', ',');
	$average_minute = number_format($average_minute, 2, '.', ',');
	$average_second = number_format($average_second, 4, '.', ',');
	$total_commits = number_format($total_commits);
	$highest_commits = number_format($highest_commits);
	
	########################################
	#FORMAT GENERAL STATISTICS FOR ROLLBACKS
	########################################
	$average_day_rollbacks = $total_rollbacks / $total_days_tracked;
	$average_hour_rollbacks = $average_day_rollbacks / 24;
	$average_minute_rollbacks = $average_hour_rollbacks / 60;
	$average_second_rollbacks = $average_minute_rollbacks / 60;
	$average_day_rollbacks = number_format($average_day_rollbacks, 2, '.', ',');
	$average_hour_rollbacks = number_format($average_hour_rollbacks, 2, '.', ',');
	$average_minute_rollbacks = number_format($average_minute_rollbacks, 2, '.', ',');
	$average_second_rollbacks = number_format($average_second_rollbacks, 4, '.', ',');
	$total_rollbacks = number_format($total_rollbacks);
	$highest_rollbacks = number_format($highest_rollbacks);
	
	##########################################
	#FORMAT GENERAL STATISTICS FOR BLOCK READS
	##########################################
	$average_day_block_reads = $total_block_reads / $total_days_tracked;
	$average_hour_block_reads = $average_day_block_reads / 24;
	$average_minute_block_reads = $average_hour_block_reads / 60;
	$average_second_block_reads = $average_minute_block_reads / 60;
	$average_day_block_reads = number_format($average_day_block_reads, 2, '.', ',');
	$average_hour_block_reads = number_format($average_hour_block_reads, 2, '.', ',');
	$average_minute_block_reads = number_format($average_minute_block_reads, 2, '.', ',');
	$average_second_block_reads = number_format($average_second_block_reads, 4, '.', ',');
	$total_block_reads = number_format($total_block_reads);
	$highest_block_reads = number_format($highest_block_reads);
	
	##########################################
	#FORMAT GENERAL STATISTICS FOR BUFFER HITS
	##########################################
	$average_day_buffer_hits = $total_buffer_hits / $total_days_tracked;
	$average_hour_buffer_hits = $average_day_buffer_hits / 24;
	$average_minute_buffer_hits = $average_hour_buffer_hits / 60;
	$average_second_buffer_hits = $average_minute_buffer_hits / 60;
	$average_day_buffer_hits = number_format($average_day_buffer_hits, 2, '.', ',');
	$average_hour_buffer_hits = number_format($average_hour_buffer_hits, 2, '.', ',');
	$average_minute_buffer_hits = number_format($average_minute_buffer_hits, 2, '.', ',');
	$average_second_buffer_hits = number_format($average_second_buffer_hits, 4, '.', ',');
	$total_buffer_hits = number_format($total_buffer_hits);
	$highest_buffer_hits = number_format($highest_buffer_hits);
	
	######################################
	#FORMAT GENERAL STATISTICS FOR INSERTS
	######################################
	$average_day_inserts = $total_inserts / $total_days_tracked;
	$average_hour_inserts = $average_day_inserts / 24;
	$average_minute_inserts = $average_hour_inserts / 60;
	$average_second_inserts = $average_minute_inserts / 60;
	$average_day_inserts = number_format($average_day_inserts, 2, '.', ',');
	$average_hour_inserts = number_format($average_hour_inserts, 2, '.', ',');
	$average_minute_inserts = number_format($average_minute_inserts, 2, '.', ',');
	$average_second_inserts = number_format($average_second_inserts, 4, '.', ',');
	$total_inserts = number_format($total_inserts);
	$highest_inserts = number_format($highest_inserts);
	
	######################################
	#FORMAT GENERAL STATISTICS FOR UPDATES
	######################################
	$average_day_updates = $total_updates / $total_days_tracked;
	$average_hour_updates = $average_day_updates / 24;
	$average_minute_updates = $average_hour_updates / 60;
	$average_second_updates = $average_minute_updates / 60;
	$average_day_updates = number_format($average_day_updates, 2, '.', ',');
	$average_hour_updates = number_format($average_hour_updates, 2, '.', ',');
	$average_minute_updates = number_format($average_minute_updates, 2, '.', ',');
	$average_second_updates = number_format($average_second_updates, 4, '.', ',');
	$total_updates = number_format($total_updates);
	$highest_updates = number_format($highest_updates);
	
	######################################
	#FORMAT GENERAL STATISTICS FOR DELETES
	######################################
	$average_day_deletes = $total_deletes / $total_days_tracked;
	$average_hour_deletes = $average_day_deletes / 24;
	$average_minute_deletes = $average_hour_deletes / 60;
	$average_second_deletes = $average_minute_deletes / 60;
	$average_day_deletes = number_format($average_day_deletes, 2, '.', ',');
	$average_hour_deletes = number_format($average_hour_deletes, 2, '.', ',');
	$average_minute_deletes = number_format($average_minute_deletes, 2, '.', ',');
	$average_second_deletes = number_format($average_second_deletes, 4, '.', ',');
	$total_deletes = number_format($total_deletes);
	$highest_deletes = number_format($highest_deletes);
	
	#############################################
	#FORMAT GENERAL STATISTICS FOR SEQUENCE SCANS
	#############################################
	$average_day_seq_scans = $total_seq_scans / $total_days_tracked;
	$average_hour_seq_scans = $average_day_seq_scans / 24;
	$average_minute_seq_scans = $average_hour_seq_scans / 60;
	$average_second_seq_scans = $average_minute_seq_scans / 60;
	$average_day_seq_scans = number_format($average_day_seq_scans, 2, '.', ',');
	$average_hour_seq_scans = number_format($average_hour_seq_scans, 2, '.', ',');
	$average_minute_seq_scans = number_format($average_minute_seq_scans, 2, '.', ',');
	$average_second_seq_scans = number_format($average_second_seq_scans, 4, '.', ',');
	$total_seq_scans = number_format($total_seq_scans);
	$highest_seq_scans = number_format($highest_seq_scans);
	
	##########################################
	#FORMAT GENERAL STATISTICS FOR INDEX SCANS
	##########################################
	$average_day_idx_scans = $total_idx_scans / $total_days_tracked;
	$average_hour_idx_scans = $average_day_idx_scans / 24;
	$average_minute_idx_scans = $average_hour_idx_scans / 60;
	$average_second_idx_scans = $average_minute_idx_scans / 60;
	$average_day_idx_scans = number_format($average_day_idx_scans, 2, '.', ',');
	$average_hour_idx_scans = number_format($average_hour_idx_scans, 2, '.', ',');
	$average_minute_idx_scans = number_format($average_minute_idx_scans, 2, '.', ',');
	$average_second_idx_scans = number_format($average_second_idx_scans, 4, '.', ',');
	$total_idx_scans = number_format($total_idx_scans);
	$highest_idx_scans = number_format($highest_idx_scans);

	############################################
	#FORMAT GENERAL STATISTICS FOR SEQUENCE ROWS
	############################################
	$average_day_seq_rows = $total_seq_rows / $total_days_tracked;
	$average_hour_seq_rows = $average_day_seq_rows / 24;
	$average_minute_seq_rows = $average_hour_seq_rows / 60;
	$average_second_seq_rows = $average_minute_seq_rows / 60;
	$average_day_seq_rows = number_format($average_day_seq_rows, 2, '.', ',');
	$average_hour_seq_rows = number_format($average_hour_seq_rows, 2, '.', ',');
	$average_minute_seq_rows = number_format($average_minute_seq_rows, 2, '.', ',');
	$average_second_seq_rows = number_format($average_second_seq_rows, 4, '.', ',');
	$total_seq_rows = number_format($total_seq_rows);
	$highest_seq_rows = number_format($highest_seq_rows);
	
	#########################################
	#FORMAT GENERAL STATISTICS FOR INDEX ROWS
	#########################################
	$average_day_idx_rows = $total_idx_rows / $total_days_tracked;
	$average_hour_idx_rows = $average_day_idx_rows / 24;
	$average_minute_idx_rows = $average_hour_idx_rows / 60;
	$average_second_idx_rows = $average_minute_idx_rows / 60;
	$average_day_idx_rows = number_format($average_day_idx_rows, 2, '.', ',');
	$average_hour_idx_rows = number_format($average_hour_idx_rows, 2, '.', ',');
	$average_minute_idx_rows = number_format($average_minute_idx_rows, 2, '.', ',');
	$average_second_idx_rows = number_format($average_second_idx_rows, 4, '.', ',');
	$total_idx_rows = number_format($total_idx_rows);
	$highest_idx_rows = number_format($highest_idx_rows);

############################
#FINISH UP THE IUD AREA HTML
############################
$stats .= <<<AJR
</td>
</tr>
</table>
AJR;

	###################################################################
	#FIRST PARSE OUR PEAK DATES SO WE CAN LINK TO INDI DB / DAILY STATS
	###################################################################
	$peak_month_commits = substr($highest_commits_date,0,2);
	$peak_day_commits = substr($highest_commits_date,3,2);
	$peak_year_commits = substr($highest_commits_date,6,4);
	
	$peak_month_rollbacks = substr($highest_rollbacks_date,0,2);
	$peak_day_rollbacks = substr($highest_rollbacks_date,3,2);
	$peak_year_rollbacks = substr($highest_rollbacks_date,6,4);
	
	$peak_month_block_reads = substr($highest_block_reads_date,0,2);
	$peak_day_block_reads = substr($highest_block_reads_date,3,2);
	$peak_year_block_reads = substr($highest_block_reads_date,6,4);
	
	$peak_month_buffer_hits = substr($highest_buffer_hits_date,0,2);
	$peak_day_buffer_hits = substr($highest_buffer_hits_date,3,2);
	$peak_year_buffer_hits = substr($highest_buffer_hits_date,6,4);
	
	$peak_month_inserts = substr($highest_inserts_date,0,2);
	$peak_day_inserts = substr($highest_inserts_date,3,2);
	$peak_year_inserts = substr($highest_inserts_date,6,4);
	
	$peak_month_updates = substr($highest_updates_date,0,2);
	$peak_day_updates = substr($highest_updates_date,3,2);
	$peak_year_updates = substr($highest_updates_date,6,4);
	
	$peak_month_deletes = substr($highest_deletes_date,0,2);
	$peak_day_deletes = substr($highest_deletes_date,3,2);
	$peak_year_deletes = substr($highest_deletes_date,6,4);
	
	$peak_month_seq_scans = substr($highest_seq_scans_date,0,2);
	$peak_day_seq_scans = substr($highest_seq_scans_date,3,2);
	$peak_year_seq_scans = substr($highest_seq_scans_date,6,4);
	
	$peak_month_idx_scans = substr($highest_idx_scans_date,0,2);
	$peak_day_idx_scans = substr($highest_idx_scans_date,3,2);
	$peak_year_idx_scans = substr($highest_idx_scans_date,6,4);
	
	$peak_month_seq_rows = substr($highest_seq_rows_date,0,2);
	$peak_day_seq_rows = substr($highest_seq_rows_date,3,2);
	$peak_year_seq_rows = substr($highest_seq_rows_date,6,4);
	
	$peak_month_idx_rows = substr($highest_idx_rows_date,0,2);
	$peak_day_idx_rows = substr($highest_idx_rows_date,3,2);
	$peak_year_idx_rows = substr($highest_idx_rows_date,6,4);

###############################################
#START UP OUR BOTTOM AREA OF GENERAL STATISTICS
###############################################
$stats .= <<<AJR
<table style="width:100%">
<tr>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Statistic</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Change/Total</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Peak Day</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Peak Date</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Avg/Day</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Avg/Hr</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Avg/Min</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Avg/Sec</td>
</tr>
AJR;

##################
#REPORT ON COMMITS
##################
$stats .= <<<AJR
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">Commits:</td>
<td>$total_commits_change&nbsp;&nbsp;$total_commits</td>
<td>$highest_commits</td>
AJR;

	if($highest_commits > 0 && !empty($highest_commits_date)) $stats .= "<td><span onMouseOver=\"tooltip.show('Retrieve&nbsp;Stats')\" onMouseOut='tooltip.hide()'><a href=javascript:daily_retrieve('$peak_month_commits','$peak_day_commits','$peak_year_commits')>$peak_month_commits-$peak_day_commits</a></span></td>";
	else $stats .= "<td>N/A</td>";

$stats .= <<<AJR
<td>$average_day</td>
<td>$average_hour</td>
<td>$average_minute</td>
<td>$average_second</td>
</tr>
<tr>
<td colspan="8" style="height:30px;"><hr size="1"/></td>
</tr>
AJR;

####################
#REPORT ON ROLLBACKS
####################
$stats .= <<<AJR
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">Rollbacks:</td>
<td>$total_rollbacks_change&nbsp;&nbsp;$total_rollbacks</td>
<td>$highest_rollbacks</td>
AJR;

	if($highest_rollbacks > 0 && !empty($highest_rollbacks_date)) $stats .= "<td><span onMouseOver=\"tooltip.show('Retrieve&nbsp;Stats')\" onMouseOut='tooltip.hide()'><a href=javascript:daily_retrieve('$peak_month_rollbacks','$peak_day_rollbacks','$peak_year_rollbacks')>$peak_month_rollbacks-$peak_day_rollbacks</a></span></td>";
	else $stats .= "<td>N/A</td>";

$stats .= <<<AJR
<td>$average_day_rollbacks</td>
<td>$average_hour_rollbacks</td>
<td>$average_minute_rollbacks</td>
<td>$average_second_rollbacks</td>
</tr>
<tr>
<td colspan="8" style="height:30px;"><hr size="1"/></td>
</tr>
AJR;

######################
#REPORT ON BLOCK READS
######################
$stats .= <<<AJR
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">Block&nbsp;Reads:</td>
<td>$total_block_reads_change&nbsp;&nbsp;$total_block_reads</td>
<td>$highest_block_reads</td>
AJR;

	if($highest_block_reads > 0 && !empty($highest_block_reads_date)) $stats .= "<td><span onMouseOver=\"tooltip.show('Retrieve&nbsp;Stats')\" onMouseOut='tooltip.hide()'><a href=javascript:daily_retrieve('$peak_month_block_reads','$peak_day_block_reads','$peak_year_block_reads')>$peak_month_block_reads-$peak_day_block_reads</a></span></td>";
	else $stats .= "<td>N/A</td>";

$stats .= <<<AJR
<td>$average_day_block_reads</td>
<td>$average_hour_block_reads</td>
<td>$average_minute_block_reads</td>
<td>$average_second_block_reads</td>
</tr>
<tr>
<td colspan="8" style="height:30px;"><hr size="1"/></td>
</tr>
AJR;

######################
#REPORT ON BUFFER HITS
######################
$stats .= <<<AJR
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">Buffer&nbsp;Hits:</td>
<td>$total_buffer_hits_change&nbsp;&nbsp;$total_buffer_hits</td>
<td>$highest_buffer_hits</td>
AJR;

	if($highest_buffer_hits > 0 && !empty($highest_buffer_hits_date)) $stats .= "<td><span onMouseOver=\"tooltip.show('Retrieve&nbsp;Stats')\" onMouseOut='tooltip.hide()'><a href=javascript:daily_retrieve('$peak_month_buffer_hits','$peak_day_buffer_hits','$peak_year_buffer_hits')>$peak_month_buffer_hits-$peak_day_buffer_hits</a></span></td>";
	else $stats .= "<td>N/A</td>";

$stats .= <<<AJR
<td>$average_day_buffer_hits</td>
<td>$average_hour_buffer_hits</td>
<td>$average_minute_buffer_hits</td>
<td>$average_second_buffer_hits</td>
</tr>
<tr>
<td colspan="8" style="height:30px;"><hr size="1"/></td>
</tr>
AJR;

##################
#REPORT ON INSERTS
##################
$stats .= <<<AJR
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">User&nbsp;Inserts:</td>
<td>$total_inserts_change&nbsp;&nbsp;$total_inserts</td>
<td>$highest_inserts</td>
AJR;

	if($highest_inserts > 0 && !empty($highest_inserts_date)) $stats .= "<td><span onMouseOver=\"tooltip.show('Retrieve&nbsp;Stats')\" onMouseOut='tooltip.hide()'><a href=javascript:daily_retrieve('$peak_month_inserts','$peak_day_inserts','$peak_year_inserts')>$peak_month_inserts-$peak_day_inserts</a></span></td>"; 
	else $stats .= "<td>N/A</td>";

$stats .= <<<AJR
<td>$average_day_inserts</td>
<td>$average_hour_inserts</td>
<td>$average_minute_inserts</td>
<td>$average_second_inserts</td>
</tr>
<tr>
<td colspan="8" style="height:30px;"><hr size="1"/></td>
</tr>
AJR;

##################
#REPORT ON UPDATES
##################
$stats .= <<<AJR
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">User&nbsp;Updates:</td>
<td>$total_updates_change&nbsp;&nbsp;$total_updates</td>
<td>$highest_updates</td>
AJR;

	if($highest_updates > 0 && !empty($highest_updates_date)) $stats .= "<td><span onMouseOver=\"tooltip.show('Retrieve&nbsp;Stats')\" onMouseOut='tooltip.hide()'><a href=javascript:daily_retrieve('$peak_month_updates','$peak_day_updates','$peak_year_updates')>$peak_month_updates-$peak_day_updates</a></span></td>";
	else $stats .= "<td>N/A</td>";

$stats .= <<<AJR
<td>$average_day_updates</td>
<td>$average_hour_updates</td>
<td>$average_minute_updates</td>
<td>$average_second_updates</td>
</tr>
<tr>
<td colspan="8" style="height:30px;"><hr size="1"/></td>
</tr>
AJR;

##################
#REPORT ON DELETES
##################
$stats .= <<<AJR
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">User&nbsp;Deletes:</td>
<td>$total_deletes_change&nbsp;&nbsp;$total_deletes</td>
<td>$highest_deletes</td>
AJR;

	if($highest_deletes > 0 && !empty($highest_deletes_date)) $stats .= "<td><span onMouseOver=\"tooltip.show('Retrieve&nbsp;Stats')\" onMouseOut='tooltip.hide()'><a href=javascript:daily_retrieve('$peak_month_deletes','$peak_day_deletes','$peak_year_deletes')>$peak_month_deletes-$peak_day_deletes</a></span></td>";
	else $stats .= "<td>N/A</td>";

$stats .= <<<AJR
<td>$average_day_deletes</td>
<td>$average_hour_deletes</td>
<td>$average_minute_deletes</td>
<td>$average_second_deletes</td>
</tr>
<tr>
<td colspan="8" style="height:30px;"><hr size="1"/></td>
</tr>
AJR;

#########################
#REPORT ON SEQUENCE SCANS
#########################
$stats .= <<<AJR
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">SEQ&nbsp;Scans:</td>
<td>$total_seq_scans_change&nbsp;&nbsp;$total_seq_scans</td>
<td>$highest_seq_scans</td>
AJR;

	if($highest_seq_scans > 0 && !empty($highest_seq_scans_date)) $stats .= "<td><span onMouseOver=\"tooltip.show('Retrieve&nbsp;Stats')\" onMouseOut='tooltip.hide()'><a href=javascript:daily_retrieve('$peak_month_seq_scans','$peak_day_seq_scans','$peak_year_seq_scans')>$peak_month_seq_scans-$peak_day_seq_scans</a></span></td>";
	else $stats .= "<td>N/A</td>";

$stats .= <<<AJR
<td>$average_day_seq_scans</td>
<td>$average_hour_seq_scans</td>
<td>$average_minute_seq_scans</td>
<td>$average_second_seq_scans</td>
</tr>
AJR;

########################
#REPORT ON SEQUENCE ROWS
########################
$stats .= <<<AJR
<tr>
<td class="grey_12" style="padding-right:10px;">Rows&nbsp;Used:</td>
<td>$total_seq_rows_change&nbsp;&nbsp;$total_seq_rows</td>
<td>$highest_seq_rows</td>
AJR;

	if($highest_seq_rows > 0 && !empty($highest_seq_rows_date)) $stats .= "<td><span onMouseOver=\"tooltip.show('Retrieve&nbsp;Stats')\" onMouseOut='tooltip.hide()'><a href=javascript:daily_retrieve('$peak_month_seq_rows','$peak_day_seq_rows','$peak_year_seq_rows')>$peak_month_seq_rows-$peak_day_seq_rows</a></span></td>";
	else $stats .= "<td>N/A</td>";

$stats .= <<<AJR
<td>$average_day_seq_rows</td>
<td>$average_hour_seq_rows</td>
<td>$average_minute_seq_rows</td>
<td>$average_second_seq_rows</td>
</tr>
<tr>
<td colspan="8" style="height:30px;"><hr size="1"/></td>
</tr>
AJR;

######################
#REPORT ON INDEX SCANS
######################
$stats .= <<<AJR
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">IDX&nbsp;Scans:</td>
<td>$total_idx_scans_change&nbsp;&nbsp;$total_idx_scans</td>
<td>$highest_idx_scans</td>
AJR;

	if($highest_idx_scans > 0 && !empty($highest_idx_scans_date)) $stats .= "<td><span onMouseOver=\"tooltip.show('Retrieve&nbsp;Stats')\" onMouseOut='tooltip.hide()'><a href=javascript:daily_retrieve('$peak_month_idx_scans','$peak_day_idx_scans','$peak_year_idx_scans')>$peak_month_idx_scans-$peak_day_idx_scans</a></span></td>";
	else $stats .= "<td>N/A</td>";

$stats .= <<<AJR
<td>$average_day_idx_scans</td>
<td>$average_hour_idx_scans</td>
<td>$average_minute_idx_scans</td>
<td>$average_second_idx_scans</td>
</tr>
AJR;

#####################
#REPORT ON INDEX ROWS
#####################
$stats .= <<<AJR
<tr>
<td class="grey_12" style="padding-right:10px;">Rows&nbsp;Used:</td>
<td>$total_idx_rows_change&nbsp;&nbsp;$total_idx_rows</td>
<td>$highest_idx_rows</td>
AJR;

	if($highest_idx_rows > 0 && !empty($highest_idx_rows_date)) $stats .= "<td><span onMouseOver=\"tooltip.show('Retrieve&nbsp;Stats')\" onMouseOut='tooltip.hide()'><a href=javascript:daily_retrieve('$peak_month_idx_rows','$peak_day_idx_rows','$peak_year_idx_rows')>$peak_month_idx_rows-$peak_day_idx_rows</a></span></td>";
	else $stats .= "<td>N/A</td>";

$stats .= <<<AJR
<td>$average_day_idx_rows</td>
<td>$average_hour_idx_rows</td>
<td>$average_minute_idx_rows</td>
<td>$average_second_idx_rows</td>
</tr>
<tr>
</table>
AJR;

	#################################
	#COMPLETE THE CORE STATISTICS DIV
	#################################
	$stats .= "</div>";

	#############################
	#GET TOTAL SCRIPT PEAK MEMORY
	#############################
	$script_mem = number_format(((memory_get_peak_usage(true)/1024)/1024),3) . "M";

	######################
	#PREP ARRAY FOR RETURN
	######################
	$ajax_return[0] = 1;
	$ajax_return[] = $stats;
	$ajax_return[] = $script_mem;
	$ajax_return = json_encode($ajax_return);

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: DAILY_SELECT_NAV_SERVERS
##########################################################################################################
##########################################################################################################
function daily_select_nav_servers($server_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	####################################
	#CREATE RETURN ARRAY FOR JSON VALUES
	####################################
	$ajax_return = array();

	################################
	#DEFAULT SUCCESS VALUE AS FAILED
	################################
	$ajax_return[] = 2;

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");

	#############
	#MAKE CERTAIN
	#############
	if(!$pg_conn)
	{
		$ajax_return[] = "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	######################################################################
	#VALIDATE SERVER_ID VAR AND QUERY VALID MONTH YEAR VARS FOR STATISTICS
	######################################################################
	if($server_id == 0 || empty($server_id) or $server_id == "0" || !is_numeric($server_id))
	{
		############
		#MONTH QUERY
		############
		$sqlselect_months = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(MONTH FROM recorded) AS month FROM ps_core_tbl ORDER BY month ASC");
		
		###########
		#YEAR QUERY
		###########
		$sqlselect_years = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(YEAR FROM recorded) AS year FROM ps_core_tbl ORDER BY year DESC");
	}
	else
	{
		################################
		#MONTH QUERY FOR SELECTED SERVER
		################################
		$sqlselect_months = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(MONTH FROM recorded) AS month FROM ps_core_tbl WHERE server_id = $server_id ORDER BY month ASC");

		###############################
		#YEAR QUERY FOR SELECTED SERVER
		###############################
		$sqlselect_years = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(YEAR FROM recorded) AS year FROM ps_core_tbl WHERE server_id = $server_id ORDER BY year DESC");
	}

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlselect_months || !$sqlselect_years)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	################################
	#CURRENT MONTH FOR PRE-SELECTION
	################################
	$current_month = date('m');

	#####################
	#START THE MONTH LIST
	#####################
	$month_list = "<select class=\"select_menu\" name=\"daily_month\" id=\"daily_month\">";
	while($query_data_months = pg_fetch_row($sqlselect_months))
	{
		################################################################
		#EXTRACT MONTH - HANDLE LEADING ZEROS - AND GET FRIENDLY VERSION
		################################################################
		$month = $query_data_months[0];
		if(strlen($month) == 1) $month = "0$month";
		$month_friendly = date_get_friendly_month($month);
		if($month == $current_month) { $selected = "selected=\"selected\""; } else { $selected = ""; }
		$month_list .= "<option value=\"$month\" $selected>$month_friendly</option>";
	}
	$month_list .= "</select>";

	###############################
	#CURRENT YEAR FOR PRE-SELECTION
	###############################
	$current_year = date('Y');

	####################
	#START THE YEAR LIST
	####################
	$year_list = "<select class=\"select_menu\" name=\"daily_year\" id=\"daily_year\">";
	while($query_data_years = pg_fetch_row($sqlselect_years))
	{
		$year = $query_data_years[0];
		if($year == $current_year) { $selected = "selected=\"selected\""; } else { $selected = ""; }
		$year_list .= "<option value=\"$year\" $selected>$year</option>";
	}
	$year_list .= "</select>";

	######################
	#PREP ARRAY FOR RETURN
	######################
	$ajax_return[0] = 1;
	$ajax_return[] = $month_list;
	$ajax_return[] = $year_list;
	$ajax_return = json_encode($ajax_return);

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: DAILY_RETRIEVE
##########################################################################################################
##########################################################################################################
function daily_retrieve($servers,$day,$month,$year,$daily_chartting,$daily_rep_mode,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	####################################
	#CREATE RETURN ARRAY FOR JSON VALUES
	####################################
	$ajax_return = array();

	################################
	#DEFAULT SUCCESS VALUE AS FAILED
	################################
	$ajax_return[] = 2;

	########################################
	#FIRST MAKE SURE WE HAVE DATE COMPONENTS
	########################################
	if(empty($day) || empty($month) || empty($year))
	{
		$ajax_return[] = "Error retrieving day, month and year values.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	################################
	#CREATE VARS FOR VALIDATING DATE
	################################
	$val_date_day = $day;
	$val_date_month = $month;
	$val_date_year = $year;

	#################################
	#STRIP LEADING ZEROS IF NECESSARY
	#################################
	if(substr($val_date_day,0,1) == "0") $val_date_day = substr($val_date_day,1,1);
	if(substr($val_date_month,0,1) == "0") $val_date_month = substr($val_date_month,1,1);

	######
	#DO IT
	######
	if(!checkdate($val_date_month,$val_date_day,$val_date_year))
	{
		$ajax_return[0] = 1;
		$ajax_return[] = "The date you've chosen is not a valid date.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	########################################################
	#PREPARE FINAL DB DATE, FOR SAFE, CHECK ON LEADING ZEROS
	########################################################
	if(strlen($day) == 1) $day = "0$day";
	if(strlen($month) == 1) $month = "0$month";

	#########################
	#PUT OUR DB DATE TOGETHER
	#########################
	$target_date = "$year-$month-$day";

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");

	#############
	#MAKE CERTAIN
	#############
	if(!$pg_conn)
	{
		$ajax_return[] = "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	#######################
	#VALIDATE CHARTTING VAR
	#######################
	if($daily_chartting != "commits" && $daily_chartting != "rollbacks" && $daily_chartting != "block_reads" && $daily_chartting != "buffer_hits" && $daily_chartting != "inserts" && $daily_chartting != "updates" && $daily_chartting != "deletes" && $daily_chartting != "seq_scans" && $daily_chartting != "idx_scans")
	{
		###########################################
		#DEFAULT THE CHART TO SHOWING COMMIT VALUES
		###########################################
		$daily_chartting = "commits";
	}

	###########################
	#INITIATE SOME GENERAL VARS
	###########################
	$bar_length = 150;
	$bar_height = 20;
	$total_stat = 0;
	$peak_stat = 0;
	$stat_percent = 0;
	$stat_bar_percent = 0;
	$bar_alt_color = "#F1F1F1";
	$bar_border_color = "#C9C9C9";
	$stat_a1_src = "images/stat_arrow_up.png";
	$stat_a2_src = "images/stat_arrow_down.png";
	$stat_a3_src = "images/stat_arrow_equal.png";
	$stat_a4_src = "images/stat_arrow_no_data.png";

	################################################
	#HANDLE ORDER BY SYNTAX - BASED ON CHARTTING VAR
	################################################
	switch($daily_chartting)
	{
		case "commits": $target_stat = "a.core_commits"; $target_order = "core_commits"; break;
		case "rollbacks": $target_stat = "a.core_rollbacks"; $target_order = "core_rollbacks"; break;
		case "block_reads": $target_stat = "a.core_block_reads"; $target_order = "core_block_reads"; break;
		case "buffer_hits": $target_stat = "a.core_buffer_hits"; $target_order = "core_buffer_hits"; break;
		case "inserts": $target_stat = "a.user_inserts"; $target_order = "user_inserts"; break;
		case "updates": $target_stat = "a.user_updates"; $target_order = "user_updates"; break;
		case "deletes": $target_stat = "a.user_deletes"; $target_order = "user_deletes"; break;
		case "seq_scans": $target_stat = "a.user_seq_scans"; $target_order = "user_seq_scans"; break;
		case "idx_scans": $target_stat = "a.user_idx_scans"; $target_order = "user_idx_scans";
	}

	###########################################################
	#VALIDATE SERVERS VAR AND CONSTRUCT QUERY FOR SELECTED DATE
	###########################################################
	if(!isset($servers)) $servers = 0;

	##########################################################
	#IF WE ARE IN COMBINED MODE, GRAB SUM DATA FOR ALL SERVERS
	##########################################################
	if($daily_rep_mode == "combine")
	{
		$stat_query  = "SELECT SUM($target_stat), a.datname, SUM(a.core_commits), SUM(a.core_rollbacks), SUM(a.core_block_reads), SUM(a.core_buffer_hits), SUM(a.user_inserts), SUM(a.user_updates), SUM(a.user_deletes), SUM(a.user_seq_scans), SUM(a.user_idx_scans), SUM(a.user_seq_rows), SUM(a.user_idx_rows) ";
		$stat_query .= "FROM ps_core_tbl AS a WHERE DATE(a.recorded) = '$target_date' ";
		$stat_query .= "GROUP BY a.datname ";
		$stat_query .= "ORDER BY SUM($target_stat) DESC";
	}
	else
	{
		################################################################
		#IN SPLIT REP MODE - RETRIEVE STATISTICS FOR ALL OR SOME SERVERS
		################################################################
		if($servers == 0 || empty($servers) or $servers == "0" || !is_numeric($servers))
		{
			$stat_query  = "SELECT $target_stat, a.datname, a.core_commits, a.core_rollbacks, a.core_block_reads, a.core_buffer_hits, a.user_inserts, a.user_updates, a.user_deletes, a.user_seq_scans, a.user_idx_scans, a.user_seq_rows, a.user_idx_rows, b.server_name ";
			$stat_query .= "FROM ps_core_tbl AS a, ps_server_tbl AS b WHERE DATE(a.recorded) = '$target_date' AND a.server_id = b.server_id ORDER BY $target_order DESC";
		}
		else
		{
			$stat_query  = "SELECT $target_stat, a.datname, a.core_commits, a.core_rollbacks, a.core_block_reads, a.core_buffer_hits, a.user_inserts, a.user_updates, a.user_deletes, a.user_seq_scans, a.user_idx_scans, a.user_seq_rows, a.user_idx_rows, b.server_name ";
			$stat_query .= "FROM ps_core_tbl AS a, ps_server_tbl AS b WHERE DATE(a.recorded) = '$target_date' AND a.server_id = b.server_id AND a.server_id = $servers ORDER BY $target_order DESC";
		}
	}

	#######
	#RUN IT
	#######
	$sqlselect_stats = @pg_query($pg_conn, $stat_query);

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlselect_stats)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	###########################
	#IF THERE ARE NO STATISTICS
	###########################
	if(pg_num_rows($sqlselect_stats) == 0)
	{
		$ajax_return[0] = 1;
		$ajax_return[] = "There are no statistics recorded for the above selections.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;	
	}

	##########################################################################
	#CREATE ARRAY WHICH WILL STORE DB STATISTICS - EACH FIELD WILL BE AN ARRAY
	##########################################################################
	$db_array = array();

	####################
	#START OUR ITERATION
	####################
	while($query_data_stats = pg_fetch_row($sqlselect_stats))
	{
		###############
		#GRAB CORE DATA
		###############
		$i_target_stat = $query_data_stats[0];
		$i_datname = $query_data_stats[1];
		$i_core_commits = $query_data_stats[2];
		$i_core_rollbacks = $query_data_stats[3];
		$i_core_block_reads = $query_data_stats[4];
		$i_core_buffer_hits = $query_data_stats[5];
		$i_user_inserts = $query_data_stats[6];
		$i_user_updates = $query_data_stats[7];
		$i_user_deletes = $query_data_stats[8];
		$i_user_seq_scans = $query_data_stats[9];
		$i_user_idx_scans = $query_data_stats[10];
		$i_user_seq_rows = $query_data_stats[11];
		$i_user_idx_rows = $query_data_stats[12];
		if($daily_rep_mode != "combine") $i_server_name = $query_data_stats[13];

		##############################################################################
		#CREATE AN ARRAY WITH THIS DBS STATS - IT WILL BE STORED IN THE DB_ARRAY ARRAY
		##############################################################################
		$db_solo_array = array();
		$db_solo_array[] = $i_target_stat;
		$db_solo_array[] = $i_datname;
		$db_solo_array[] = $i_core_commits;
		$db_solo_array[] = $i_core_rollbacks;
		$db_solo_array[] = $i_core_block_reads;
		$db_solo_array[] = $i_core_buffer_hits;
		$db_solo_array[] = $i_user_inserts;
		$db_solo_array[] = $i_user_updates;
		$db_solo_array[] = $i_user_deletes;
		$db_solo_array[] = $i_user_seq_scans;
		$db_solo_array[] = $i_user_idx_scans;
		$db_solo_array[] = $i_user_seq_rows;
		$db_solo_array[] = $i_user_idx_rows;
		if($daily_rep_mode != "combine") $db_solo_array[] = $i_server_name;

		################################
		#TALLY UP PEAK STAT IF NECESSARY
		################################
		if($i_target_stat > $peak_stat) $peak_stat = $i_target_stat;

		########################
		#TALLY UP TOTAL STAT VAR
		########################
		$total_stat += $i_target_stat;

		###########################################
		#PUSH THIS NEW SOLO ARRAY INTO THE DB_ARRAY
		###########################################
		$db_array[] = $db_solo_array;
	}

	############################################################
	#CHECK AND SEE IF STATS ARE AVAILABLE FOR THE PREVIOUS CYCLE
	############################################################

	#####################
	#CONSTRUCT STAT QUERY
	#####################
	$target_date_prev = date("Y-m-d",strtotime("$target_date -1 day"));

	###########################################################
	#VALIDATE SERVERS VAR AND CONSTRUCT QUERY FOR SELECTED DATE
	###########################################################
	if($daily_rep_mode == "combine")
	{
		$stat_prev_query  = "SELECT SUM($target_stat), a.datname, SUM(a.core_commits), SUM(a.core_rollbacks), SUM(a.core_block_reads), SUM(a.core_buffer_hits), SUM(a.user_inserts), SUM(a.user_updates), SUM(a.user_deletes), SUM(a.user_seq_scans), SUM(a.user_idx_scans), SUM(a.user_seq_rows), SUM(a.user_idx_rows) ";
		$stat_prev_query .= "FROM ps_core_tbl AS a WHERE DATE(a.recorded) = '$target_date_prev' ";
		$stat_prev_query .= "GROUP BY a.datname ";
		$stat_prev_query .= "ORDER BY SUM($target_stat) DESC";
	}
	else
	{
		if($servers == 0 || empty($servers) or $servers == "0" || !is_numeric($servers))
		{
			$stat_prev_query  = "SELECT $target_stat, a.datname, a.core_commits, a.core_rollbacks, a.core_block_reads, a.core_buffer_hits, a.user_inserts, a.user_updates, a.user_deletes, a.user_seq_scans, a.user_idx_scans, a.user_seq_rows, a.user_idx_rows, b.server_name ";
			$stat_prev_query .= "FROM ps_core_tbl AS a, ps_server_tbl AS b WHERE DATE(a.recorded) = '$target_date_prev' AND a.server_id = b.server_id ORDER BY $target_order DESC";
		}
		else
		{
			$stat_prev_query  = "SELECT $target_stat, a.datname, a.core_commits, a.core_rollbacks, a.core_block_reads, a.core_buffer_hits, a.user_inserts, a.user_updates, a.user_deletes, a.user_seq_scans, a.user_idx_scans, a.user_seq_rows, a.user_idx_rows, b.server_name ";
			$stat_prev_query .= "FROM ps_core_tbl AS a, ps_server_tbl AS b WHERE DATE(a.recorded) = '$target_date_prev' AND a.server_id = b.server_id AND a.server_id = $servers ORDER BY $target_order DESC";
		}
	}

	#######
	#RUN IT
	#######
	$sqlselect_prev_stats = @pg_query($pg_conn, $stat_prev_query);

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlselect_prev_stats)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	###################################################
	#VAR TO HOUSE WHETHER THERE ARE PREVIOUS STATISTICS
	###################################################
	$prev_stats_available = false;

	########################
	#IF THERE ARE PREV STATS
	########################
	if(pg_num_rows($sqlselect_prev_stats) > 0)
	{
		$prev_stats_available = true;

		##########################################################################
		#CREATE ARRAY WHICH WILL STORE DB STATISTICS - EACH FIELD WILL BE AN ARRAY
		##########################################################################
		$prev_db_array = array();

		####################
		#START OUR ITERATION
		####################
		while($query_data_prev_stats = pg_fetch_row($sqlselect_prev_stats))
		{
			###############
			#GRAB CORE DATA
			###############
			$i_target_stat = $query_data_prev_stats[0];
			$i_datname = $query_data_prev_stats[1];
			$i_core_commits = $query_data_prev_stats[2];
			$i_core_rollbacks = $query_data_prev_stats[3];
			$i_core_block_reads = $query_data_prev_stats[4];
			$i_core_buffer_hits = $query_data_prev_stats[5];
			$i_user_inserts = $query_data_prev_stats[6];
			$i_user_updates = $query_data_prev_stats[7];
			$i_user_deletes = $query_data_prev_stats[8];
			$i_user_seq_scans = $query_data_prev_stats[9];
			$i_user_idx_scans = $query_data_prev_stats[10];
			$i_user_seq_rows = $query_data_prev_stats[11];
			$i_user_idx_rows = $query_data_prev_stats[12];
			if($daily_rep_mode != "combine") $i_server_name = $query_data_prev_stats[13];

			##############################################################################
			#CREATE AN ARRAY WITH THIS DBS STATS - IT WILL BE STORED IN THE DB_ARRAY ARRAY
			##############################################################################
			$prev_db_solo_array = array();
			$prev_db_solo_array[] = $i_target_stat;
			$prev_db_solo_array[] = $i_datname;
			$prev_db_solo_array[] = $i_core_commits;
			$prev_db_solo_array[] = $i_core_rollbacks;
			$prev_db_solo_array[] = $i_core_block_reads;
			$prev_db_solo_array[] = $i_core_buffer_hits;
			$prev_db_solo_array[] = $i_user_inserts;
			$prev_db_solo_array[] = $i_user_updates;
			$prev_db_solo_array[] = $i_user_deletes;
			$prev_db_solo_array[] = $i_user_seq_scans;
			$prev_db_solo_array[] = $i_user_idx_scans;
			$prev_db_solo_array[] = $i_user_seq_rows;
			$prev_db_solo_array[] = $i_user_idx_rows;
			if($daily_rep_mode != "combine") $prev_db_solo_array[] = $i_server_name;

			###########################################
			#PUSH THIS NEW SOLO ARRAY INTO THE DB_ARRAY
			###########################################
			$prev_db_array[] = $prev_db_solo_array;
		}
	}

	###############
	#GET A DB COUNT
	###############
	$db_count = count($db_array);

	#####################
	#START THE TABLE WORK
	#####################
	$stats  = "<div class=\"stat_div_bg\">";
	$stats .= "<table class=\"table_chart\">";
	$stats .= "<tr>";
	$stats .= "<td style=\" padding-bottom:5px;\"><span class=\"black_13\" style=\"font-weight:bold;\">Database:</span></td>";
	$stats .= "<td style=\" padding-bottom:5px;\"><span class=\"black_13\" style=\"font-weight:bold;\">Server:</span></td>";
	$stats .= "<td style=\" padding-bottom:5px;\"><span class=\"black_13\" style=\"font-weight:bold;\">Total:</span></td>";
	$stats .= "<td style=\" padding-bottom:5px;\"><span class=\"black_13\" style=\"font-weight:bold;\">Change:</span></td>";
	$stats .= "<td style=\" padding-bottom:5px;\"><span class=\"black_13\" style=\"font-weight:bold;\"></span></td>";
	$stats .= "</tr>";

	############################################
	#FOR EACH DB, CREATE THE ROW / COLUMNS & BAR
	############################################
	for($i=0; $i<$db_count; $i++)
	{
		############
		#OBTAIN DATA
		############
		$i_target_stat = $db_array[$i][0];
		$i_datname = $db_array[$i][1];
		$i_core_commits = $db_array[$i][2];
		$i_core_rollbacks = $db_array[$i][3];
		$i_core_block_reads = $db_array[$i][4];
		$i_core_buffer_hits = $db_array[$i][5];
		$i_user_inserts = $db_array[$i][6];
		$i_user_updates = $db_array[$i][7];
		$i_user_deletes = $db_array[$i][8];
		$i_user_seq_scans = $db_array[$i][9];
		$i_user_idx_scans = $db_array[$i][10];
		$i_user_seq_rows = $db_array[$i][11];
		$i_user_idx_rows = $db_array[$i][12];
		if($daily_rep_mode != "combine") $i_server_name = $db_array[$i][13];

		##########################################################################
		#HANDLE THE PEAK ORANGE GRAPHIC AND SHOW IT OR THE STANDARD COLOR DATA BAR
		##########################################################################
		if($i_target_stat == $peak_stat) $bar_color = "#FF6633";
		else $bar_color = "#7B7B7B";

		####################################################
		#GET THE STAT PERCENT VARS AND CREATE THE BAR VALUES
		####################################################
		if($total_stat > 0) { $stat_percent = ($i_target_stat / $total_stat); } else { $stat_percent = 0; }
		$stat_percent = (number_format($stat_percent, 4, '.', '') * 100);
		if($peak_stat > 0) { $stat_bar_percent = ($i_target_stat / $peak_stat); } else { $stat_bar_percent = 0; }
		$bar_length_percent = $stat_bar_percent;
		$bar_length_final = $bar_length * $bar_length_percent;
		$bar_length_final = number_format($bar_length_final, 0, '.', '');

		############################
		#FORCE BAR LENGTH - FOR SAFE
		############################
		if($bar_length_final > $bar_length) $bar_length_final = $bar_length;

		#####################################
		#GET THE ALT (LIGHT GREY) IMAGE WIDTH
		#####################################
		$bar_length_final_alt = $bar_length - $bar_length_final;

		#############
		#FORMAT TOTAL
		#############
		$i_target_stat_display = number_format($i_target_stat);

		#############
		#PREP TOOLTIP
		#############
		$tooltip = "Show&nbsp;All&nbsp;Stats";

		###################################################
		#IF IN REP STAT COMBINE MODE, DEFAULT SERVER TO N/A
		###################################################
		if($daily_rep_mode == "combine") $i_server_name = "Combined";

		###############
		#CREATE OUR ROW
		###############
		$stats .= "<tr>";
		$stats .= "<td style=\"padding:5px 0 5px 0; font-weight:bold;\"><span onMouseOver=\"tooltip.show('$tooltip')\" onMouseOut='tooltip.hide()'><a href=\"javascript:daily_extended($i)\">$i_datname</a></span></td>";
		$stats .= "<td>$i_server_name</td>";
		$stats .= "<td class=\"orange_12\" style=\"font-weight:bold;\">$i_target_stat_display</td>";
		$stats .= "<td>";

		if($prev_stats_available == true)
		{
			######################
			#DEFAULT CHANGE STATUS
			######################
			$target_change = "&nbsp;N/A";
			$commits_change = "&nbsp;N/A";
			$rollbacks_change = "&nbsp;N/A";
			$block_reads_change = "&nbsp;N/A";
			$buffer_hits_change = "&nbsp;N/A";
			$inserts_change = "&nbsp;N/A";
			$updates_change = "&nbsp;N/A";
			$deletes_change = "&nbsp;N/A";
			$seq_scans_change = "&nbsp;N/A";
			$seq_rows_change = "&nbsp;N/A";
			$idx_scans_change = "&nbsp;N/A";
			$idx_rows_change = "&nbsp;N/A";

			######################
			#DEFAULT CHANGE IMAGES
			######################
			$target_compare_img = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
			$commits_compare_img = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
			$rollbacks_compare_img = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
			$block_reads_compare_img = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
			$buffer_hits_compare_img = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
			$inserts_compare_img = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
			$updates_compare_img = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
			$deletes_compare_img = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
			$seq_scans_compare_img = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
			$seq_rows_compare_img = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
			$idx_scans_compare_img = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
			$idx_rows_compare_img = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";

			##########################################################
			#LOOP THROUGH THE PREV ARRAYS AND FIND THIS DBS PREV STATS
			##########################################################
			for($ip=0; $ip<count($prev_db_array); $ip++)
			{
				########################
				#CHECK FOR DB NAME MATCH
				########################
				if($i_datname == $prev_db_array[$ip][1])
				{
					##############
					#TARGET CHANGE
					##############
					$prev_target_stat = $prev_db_array[$ip][0];
					if($i_target_stat > $prev_target_stat) { if($prev_target_stat == 0) { $target_change = $i_target_stat * 100; } else { $target_change = (($i_target_stat - $prev_target_stat) * 100) / $prev_target_stat; } $target_compare_img = "<img src=\"$stat_a1_src\" width=\"10\" height=\"8\"/>"; $target_change = "&nbsp;" . number_format($target_change, 2, '.', ',') . "%"; }
					elseif($prev_target_stat > $i_target_stat) { if($i_target_stat == 0) { $target_change = $prev_target_stat * 100; } else { $target_change = (($prev_target_stat - $i_target_stat) * 100) / $i_target_stat; } $target_compare_img = "<img src=\"$stat_a2_src\" width=\"10\" height=\"8\"/>"; $target_change = "&nbsp;" . number_format($target_change, 2, '.', ',') . "%"; }
					elseif($prev_target_stat == $i_target_stat) { $target_compare_img = "<img src=\"$stat_a3_src\" width=\"10\" height=\"8\"/>"; $target_change = ""; }

					###############
					#COMMITS CHANGE
					###############
					$prev_commits_stat = $prev_db_array[$ip][2];
					if($i_core_commits > $prev_commits_stat) { if($prev_commits_stat == 0) { $commits_change = $i_core_commits * 100; } else { $commits_change = (($i_core_commits - $prev_commits_stat) * 100) / $prev_commits_stat; } $commits_compare_img = "<img src=\"$stat_a1_src\" width=\"10\" height=\"8\"/>"; $commits_change = "&nbsp;" . number_format($commits_change, 2, '.', ',') . "%"; }
					elseif($prev_commits_stat > $i_core_commits) { if($i_core_commits == 0) { $commits_change = $prev_commits_stat * 100; } else { $commits_change = (($prev_commits_stat - $i_core_commits) * 100) / $i_core_commits; } $commits_compare_img = "<img src=\"$stat_a2_src\" width=\"10\" height=\"8\"/>"; $commits_change = "&nbsp;" . number_format($commits_change, 2, '.', ',') . "%"; }
					elseif($prev_commits_stat == $i_core_commits) { $commits_compare_img = "<img src=\"$stat_a3_src\" width=\"10\" height=\"8\"/>"; $commits_change = ""; }

					#################
					#ROLLBACKS CHANGE
					#################
					$prev_rollbacks_stat = $prev_db_array[$ip][3];
					if($i_core_rollbacks > $prev_rollbacks_stat) { if($prev_rollbacks_stat == 0) { $rollbacks_change = $i_core_rollbacks * 100; } else { $rollbacks_change = (($i_core_rollbacks - $prev_rollbacks_stat) * 100) / $prev_rollbacks_stat; } $rollbacks_compare_img = "<img src=\"$stat_a1_src\" width=\"10\" height=\"8\"/>"; $rollbacks_change = "&nbsp;" . number_format($rollbacks_change, 2, '.', ',') . "%"; }
					elseif($prev_rollbacks_stat > $i_core_rollbacks) { if($i_core_rollbacks == 0) { $rollbacks_change = $prev_rollbacks_stat * 100; } else { $rollbacks_change = (($prev_rollbacks_stat - $i_core_rollbacks) * 100) / $i_core_rollbacks; } $rollbacks_compare_img = "<img src=\"$stat_a2_src\" width=\"10\" height=\"8\"/>"; $rollbacks_change = "&nbsp;" . number_format($rollbacks_change, 2, '.', ',') . "%"; }
					elseif($prev_rollbacks_stat == $i_core_rollbacks) { $rollbacks_compare_img = "<img src=\"$stat_a3_src\" width=\"10\" height=\"8\"/>"; $rollbacks_change = ""; }

					###################
					#BLOCK READS CHANGE
					###################
					$prev_block_reads_stat = $prev_db_array[$ip][4];
					if($i_core_block_reads > $prev_block_reads_stat) { if($prev_block_reads_stat == 0) { $block_reads_change = $i_core_block_reads * 100; } else { $block_reads_change = (($i_core_block_reads - $prev_block_reads_stat) * 100) / $prev_block_reads_stat; } $block_reads_compare_img = "<img src=\"$stat_a1_src\" width=\"10\" height=\"8\"/>"; $block_reads_change = "&nbsp;" . number_format($block_reads_change, 2, '.', ',') . "%"; }
					elseif($prev_block_reads_stat > $i_core_block_reads) { if($i_core_block_reads == 0) { $block_reads_change = $prev_block_reads_stat * 100; } else { $block_reads_change = (($prev_block_reads_stat - $i_core_block_reads) * 100) / $i_core_block_reads; } $block_reads_compare_img = "<img src=\"$stat_a2_src\" width=\"10\" height=\"8\"/>"; $block_reads_change = "&nbsp;" . number_format($block_reads_change, 2, '.', ',') . "%"; }
					elseif($prev_block_reads_stat == $i_core_block_reads) { $block_reads_compare_img = "<img src=\"$stat_a3_src\" width=\"10\" height=\"8\"/>"; $block_reads_change = ""; }

					###################
					#BUFFER HITS CHANGE
					###################
					$prev_buffer_hits_stat = $prev_db_array[$ip][5];
					if($i_core_buffer_hits > $prev_buffer_hits_stat) { if($prev_buffer_hits_stat == 0) { $buffer_hits_change = $i_core_buffer_hits * 100; } else { $buffer_hits_change = (($i_core_buffer_hits - $prev_buffer_hits_stat) * 100) / $prev_buffer_hits_stat; } $buffer_hits_compare_img = "<img src=\"$stat_a1_src\" width=\"10\" height=\"8\"/>"; $buffer_hits_change = "&nbsp;" . number_format($buffer_hits_change, 2, '.', ',') . "%"; }
					elseif($prev_buffer_hits_stat > $i_core_buffer_hits) { if($i_core_buffer_hits == 0) { $buffer_hits_change = $prev_buffer_hits_stat * 100; } else { $buffer_hits_change = (($prev_buffer_hits_stat - $i_core_buffer_hits) * 100) / $i_core_buffer_hits; } $buffer_hits_compare_img = "<img src=\"$stat_a2_src\" width=\"10\" height=\"8\"/>"; $buffer_hits_change = "&nbsp;" . number_format($buffer_hits_change, 2, '.', ',') . "%"; }
					elseif($prev_buffer_hits_stat == $i_core_buffer_hits) { $buffer_hits_compare_img = "<img src=\"$stat_a3_src\" width=\"10\" height=\"8\"/>"; $buffer_hits_change = ""; }

					###############
					#INSERTS CHANGE
					###############
					$prev_inserts_stat = $prev_db_array[$ip][6];
					if($i_user_inserts > $prev_inserts_stat) { if($prev_inserts_stat == 0) { $inserts_change = $i_user_inserts * 100; } else { $inserts_change = (($i_user_inserts - $prev_inserts_stat) * 100) / $prev_inserts_stat; } $inserts_compare_img = "<img src=\"$stat_a1_src\" width=\"10\" height=\"8\"/>"; $inserts_change = "&nbsp;" . number_format($inserts_change, 2, '.', ',') . "%"; }
					elseif($prev_inserts_stat > $i_user_inserts) { if($i_user_inserts == 0) { $inserts_change = $prev_inserts_stat * 100; } else { $inserts_change = (($prev_inserts_stat - $i_user_inserts) * 100) / $i_user_inserts; } $inserts_compare_img = "<img src=\"$stat_a2_src\" width=\"10\" height=\"8\"/>"; $inserts_change = "&nbsp;" . number_format($inserts_change, 2, '.', ',') . "%"; }
					elseif($prev_inserts_stat == $i_user_inserts) { $inserts_compare_img = "<img src=\"$stat_a3_src\" width=\"10\" height=\"8\"/>"; $inserts_change = ""; }

					###############
					#UPDATES CHANGE
					###############
					$prev_updates_stat = $prev_db_array[$ip][7];
					if($i_user_updates > $prev_updates_stat) { if($prev_updates_stat == 0) { $updates_change = $i_user_updates * 100; } else { $updates_change = (($i_user_updates - $prev_updates_stat) * 100) / $prev_updates_stat; } $updates_compare_img = "<img src=\"$stat_a1_src\" width=\"10\" height=\"8\"/>"; $updates_change = "&nbsp;" . number_format($updates_change, 2, '.', ',') . "%"; }
					elseif($prev_updates_stat > $i_user_updates) { if($i_user_updates == 0) { $updates_change = $prev_updates_stat * 100; } else { $updates_change = (($prev_updates_stat - $i_user_updates) * 100) / $i_user_updates; } $updates_compare_img = "<img src=\"$stat_a2_src\" width=\"10\" height=\"8\"/>"; $updates_change = "&nbsp;" . number_format($updates_change, 2, '.', ',') . "%"; }
					elseif($prev_updates_stat == $i_user_updates) { $updates_compare_img = "<img src=\"$stat_a3_src\" width=\"10\" height=\"8\"/>"; $updates_change = ""; }

					###############
					#DELETES CHANGE
					###############
					$prev_deletes_stat = $prev_db_array[$ip][8];
					if($i_user_deletes > $prev_deletes_stat) { if($prev_deletes_stat == 0) { $deletes_change = $i_user_deletes * 100; } else { $deletes_change = (($i_user_deletes - $prev_deletes_stat) * 100) / $prev_deletes_stat; } $deletes_compare_img = "<img src=\"$stat_a1_src\" width=\"10\" height=\"8\"/>"; $deletes_change = "&nbsp;" . number_format($deletes_change, 2, '.', ',') . "%"; }
					elseif($prev_deletes_stat > $i_user_deletes) { if($i_user_deletes == 0) { $deletes_change = $prev_deletes_stat * 100; } else { $deletes_change = (($prev_deletes_stat - $i_user_deletes) * 100) / $i_user_deletes; } $deletes_compare_img = "<img src=\"$stat_a2_src\" width=\"10\" height=\"8\"/>"; $deletes_change = "&nbsp;" . number_format($deletes_change, 2, '.', ',') . "%"; }
					elseif($prev_deletes_stat == $i_user_deletes) { $deletes_compare_img = "<img src=\"$stat_a3_src\" width=\"10\" height=\"8\"/>"; $deletes_change = ""; }

					#################
					#SEQ SCANS CHANGE
					#################
					$prev_seq_scans_stat = $prev_db_array[$ip][9];
					if($i_user_seq_scans > $prev_seq_scans_stat) { if($prev_seq_scans_stat == 0) { $seq_scans_change = $i_user_seq_scans * 100; } else { $seq_scans_change = (($i_user_seq_scans - $prev_seq_scans_stat) * 100) / $prev_seq_scans_stat; } $seq_scans_compare_img = "<img src=\"$stat_a1_src\" width=\"10\" height=\"8\"/>"; $seq_scans_change = "&nbsp;" . number_format($seq_scans_change, 2, '.', ',') . "%"; }
					elseif($prev_seq_scans_stat > $i_user_seq_scans) { if($i_user_seq_scans == 0) { $seq_scans_change = $prev_seq_scans_stat * 100; } else { $seq_scans_change = (($prev_seq_scans_stat - $i_user_seq_scans) * 100) / $i_user_seq_scans; } $seq_scans_compare_img = "<img src=\"$stat_a2_src\" width=\"10\" height=\"8\"/>"; $seq_scans_change = "&nbsp;" . number_format($seq_scans_change, 2, '.', ',') . "%"; }
					elseif($prev_seq_scans_stat == $i_user_seq_scans) { $seq_scans_compare_img = "<img src=\"$stat_a3_src\" width=\"10\" height=\"8\"/>"; $seq_scans_change = ""; }

					#################
					#IDX SCANS CHANGE
					#################
					$prev_idx_scans_stat = $prev_db_array[$ip][10];
					if($i_user_idx_scans > $prev_idx_scans_stat) { if($prev_idx_scans_stat == 0) { $idx_scans_change = $i_user_idx_scans * 100; } else { $idx_scans_change = (($i_user_idx_scans - $prev_idx_scans_stat) * 100) / $prev_idx_scans_stat; } $idx_scans_compare_img = "<img src=\"$stat_a1_src\" width=\"10\" height=\"8\"/>"; $idx_scans_change = "&nbsp;" . number_format($idx_scans_change, 2, '.', ',') . "%"; }
					elseif($prev_idx_scans_stat > $i_user_idx_scans) { if($i_user_idx_scans == 0) { $idx_scans_change = $prev_idx_scans_stat * 100; } else { $idx_scans_change = (($prev_idx_scans_stat - $i_user_idx_scans) * 100) / $i_user_idx_scans; } $idx_scans_compare_img = "<img src=\"$stat_a2_src\" width=\"10\" height=\"8\"/>"; $idx_scans_change = "&nbsp;" . number_format($idx_scans_change, 2, '.', ',') . "%"; }
					elseif($prev_idx_scans_stat == $i_user_idx_scans) { $idx_scans_compare_img = "<img src=\"$stat_a3_src\" width=\"10\" height=\"8\"/>"; $idx_scans_change = ""; }

					################
					#SEQ ROWS CHANGE
					################
					$prev_seq_rows_stat = $prev_db_array[$ip][11];
					if($i_user_seq_rows > $prev_seq_rows_stat) { if($prev_seq_rows_stat == 0) { $seq_rows_change = $i_user_seq_rows * 100; } else { $seq_rows_change = (($i_user_seq_rows - $prev_seq_rows_stat) * 100) / $prev_seq_rows_stat; } $seq_rows_compare_img = "<img src=\"$stat_a1_src\" width=\"10\" height=\"8\"/>"; $seq_rows_change = "&nbsp;" . number_format($seq_rows_change, 2, '.', ',') . "%"; }
					elseif($prev_seq_rows_stat > $i_user_seq_rows) { if($i_user_seq_rows == 0) { $seq_rows_change = $prev_seq_rows_stat * 100; } else { $seq_rows_change = (($prev_seq_rows_stat - $i_user_seq_rows) * 100) / $i_user_seq_rows; } $seq_rows_compare_img = "<img src=\"$stat_a2_src\" width=\"10\" height=\"8\"/>"; $seq_rows_change = "&nbsp;" . number_format($seq_rows_change, 2, '.', ',') . "%"; }
					elseif($prev_seq_rows_stat == $i_user_seq_rows) { $seq_rows_compare_img = "<img src=\"$stat_a3_src\" width=\"10\" height=\"8\"/>"; $seq_rows_change = ""; }

					################
					#IDX ROWS CHANGE
					################
					$prev_idx_rows_stat = $prev_db_array[$ip][12];
					if($i_user_idx_rows > $prev_idx_rows_stat) { if($prev_idx_rows_stat == 0) { $idx_rows_change = $i_user_idx_rows * 100; } else { $idx_rows_change = (($i_user_idx_rows - $prev_idx_rows_stat) * 100) / $prev_idx_rows_stat; } $idx_rows_compare_img = "<img src=\"$stat_a1_src\" width=\"10\" height=\"8\"/>"; $idx_rows_change = "&nbsp;" . number_format($idx_rows_change, 2, '.', ',') . "%"; }
					elseif($prev_idx_rows_stat > $i_user_idx_rows) { if($i_user_idx_rows == 0) { $idx_rows_change = $prev_idx_rows_stat * 100; } else { $idx_rows_change = (($prev_idx_rows_stat - $i_user_idx_rows) * 100) / $i_user_idx_rows; } $idx_rows_compare_img = "<img src=\"$stat_a2_src\" width=\"10\" height=\"8\"/>"; $idx_rows_change = "&nbsp;" . number_format($idx_rows_change, 2, '.', ',') . "%"; }
					elseif($prev_idx_rows_stat == $i_user_idx_rows) { $idx_rows_compare_img = "<img src=\"$stat_a3_src\" width=\"10\" height=\"8\"/>"; $idx_rows_change = ""; }
				}
			}
		}
		else
		{
			######################
			#DEFAULT CHANGE STATUS
			######################
			$target_change = "&nbsp;N/A";
			$commits_change = "&nbsp;N/A";
			$rollbacks_change = "&nbsp;N/A";
			$block_reads_change = "&nbsp;N/A";
			$buffer_hits_change = "&nbsp;N/A";
			$inserts_change = "&nbsp;N/A";
			$updates_change = "&nbsp;N/A";
			$deletes_change = "&nbsp;N/A";
			$seq_scans_change = "&nbsp;N/A";
			$seq_rows_change = "&nbsp;N/A";
			$idx_scans_change = "&nbsp;N/A";
			$idx_rows_change = "&nbsp;N/A";

			######################
			#DEFAULT CHANGE IMAGES
			######################
			$target_compare_img = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
			$commits_compare_img = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
			$rollbacks_compare_img = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
			$block_reads_compare_img = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
			$buffer_hits_compare_img = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
			$inserts_compare_img = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
			$updates_compare_img = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
			$deletes_compare_img = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
			$seq_scans_compare_img = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
			$seq_rows_compare_img = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
			$idx_scans_compare_img = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
			$idx_rows_compare_img = "<img src=\"$stat_a4_src\" width=\"10\" height=\"8\"/>";
		}

		###################
		#CONTINUE TABLEWORK
		###################
		$stats .= $target_compare_img . $target_change;
		$stats .= "</td>";
		$stats .= "<td>";

		#######################################################
		#CHECK THE LENGTH VALUES AND PUT THE BARS TOGETHER
		#START UP THE TABLEWORK WHICH WILL HOUSE THE BAR ITSELF
		#######################################################
		$bar_length_px = $bar_length . "px";
		$stats .= "<table style=\"length:$bar_length_px;\"><tr>";

		############################
		#DETERMINE BORDER STYLES NOW
		############################
		$bar_border = "border:1px solid $bar_border_color;";

		#########################
		#HANDLE THE BORDER STYLES
		#########################
		if($bar_length_final <= 0) $bar_alt_border = "border:1px solid $bar_border_color;";
		else $bar_alt_border = "border-color: $bar_border_color; border-width: 1px 1px 1px 0px; border-style: solid;";

		#####################################################################################
		#HANDLE THE ALT COLOR - WILL EITHER BE THE ENTIRE BAR (NO DATA) OR THE TOP OF THE BAR
		#####################################################################################
		if($bar_length_final > 0)
		{
			#################
			#PREP TOOLTIP VAR
			#################
			$tooltip = "$stat_percent%";

			###########################
			#PREP FINAL CELL DIMENSIONS
			###########################
			$bar_length_final_px = $bar_length_final . "px";
			$bar_height_px = $bar_height . "px";

			#############
			#DISPLAY CELL
			#############
			$stats .= "<td style=\"$bar_border background-color:$bar_color; width:$bar_length_final_px; height:$bar_height_px;\" onMouseOver=\"tooltip.show('$tooltip')\" onMouseOut='tooltip.hide()'></td>";
		}

		################################################
		#HANDLE THE BOTTOM OF THE BAR WHERE WE HAVE DATA
		################################################
		if($bar_length_final_alt > 0)
		{
			###########################
			#PREP FINAL CELL DIMENSIONS
			###########################
			$bar_length_final_alt_px = $bar_length_final_alt . "px";
			$bar_height_px = $bar_height . "px";

			#############
			#DISPLAY CELL
			#############
			$stats .= "<td style=\"$bar_alt_border background-color:$bar_alt_color; width:$bar_length_final_alt_px; height:$bar_height_px;\"></td>";
		}

		###################
		#COMPLETE TABLEWORK
		###################
		$stats .= "</tr>";
		$stats .= "</table>";
		$stats .= "</td>";
		$stats .= "</tr>";

		###########################
		#HANDLE EXTENDED STATISTICS
		###########################
		$extended_stats  = "<table class=\"table_chart_sub\"><tr>";
		$extended_stats .= "<td class=\"black_12\" style=\"font-weight:bold; padding-bottom:10px;\">Statistic</td>";
		$extended_stats .= "<td class=\"black_12\" style=\"font-weight:bold; padding-bottom:10px;\">Total</td>";
		$extended_stats .= "<td class=\"black_12\" style=\"font-weight:bold; padding-bottom:10px;\">Change</td>";
		$extended_stats .= "<td class=\"black_12\" style=\"font-weight:bold; padding-bottom:10px;\">Avg/Hr</td>";
		$extended_stats .= "<td class=\"black_12\" style=\"font-weight:bold; padding-bottom:10px;\">Avg/Min</td>";
		$extended_stats .= "<td class=\"black_12\" style=\"font-weight:bold; padding-bottom:10px;\">Avg/Sec</td>";
		$extended_stats .= "</tr>";

		########
		#COMMITS
		########
		$i_core_commits_hour = $i_core_commits / 24;
		$i_core_commits_min = $i_core_commits_hour / 60;
		$i_core_commits_sec = $i_core_commits_min / 60;
		$i_core_commits_hour = number_format($i_core_commits_hour, 2, '.', ',');
		$i_core_commits_min = number_format($i_core_commits_min, 2, '.', ',');
		$i_core_commits_sec = number_format($i_core_commits_sec, 4, '.', ',');
		$i_core_commits = number_format($i_core_commits);

		$extended_stats .= "<tr>";
		$extended_stats .= "<td class=\"orange_12\" style=\"font-weight:bold;\">Commits:</td>";
		$extended_stats .= "<td>$i_core_commits</td>";
		$extended_stats .= "<td>$commits_compare_img$commits_change</td>";
		$extended_stats .= "<td>$i_core_commits_hour</td>";
		$extended_stats .= "<td>$i_core_commits_min</td>";
		$extended_stats .= "<td>$i_core_commits_sec</td>";
		$extended_stats .= "</tr>";
		$extended_stats .= "<tr><td colspan=\"6\" style=\"height:30px;\"><hr class=\"hr_light_grey\"/></td></tr>";

		##########
		#ROLLBACKS
		##########
		$i_core_rollbacks_hour = $i_core_rollbacks / 24;
		$i_core_rollbacks_min = $i_core_rollbacks_hour / 60;
		$i_core_rollbacks_sec = $i_core_rollbacks_min / 60;
		$i_core_rollbacks_hour = number_format($i_core_rollbacks_hour, 2, '.', ',');
		$i_core_rollbacks_min = number_format($i_core_rollbacks_min, 2, '.', ',');
		$i_core_rollbacks_sec = number_format($i_core_rollbacks_sec, 4, '.', ',');
		$i_core_rollbacks = number_format($i_core_rollbacks);

		$extended_stats .= "<tr>";
		$extended_stats .= "<td class=\"orange_12\" style=\"font-weight:bold;\">Rolbacks:</td>";
		$extended_stats .= "<td>$i_core_rollbacks</td>";
		$extended_stats .= "<td>$rollbacks_compare_img$rollbacks_change</td>";
		$extended_stats .= "<td>$i_core_rollbacks_hour</td>";
		$extended_stats .= "<td>$i_core_rollbacks_min</td>";
		$extended_stats .= "<td>$i_core_rollbacks_sec</td>";
		$extended_stats .= "</tr>";
		$extended_stats .= "<tr><td colspan=\"6\" style=\"height:30px;\"><hr class=\"hr_light_grey\"/></td></tr>";

		############
		#BLOCK_READS
		############
		$i_core_block_reads_hour = $i_core_block_reads / 24;
		$i_core_block_reads_min = $i_core_block_reads_hour / 60;
		$i_core_block_reads_sec = $i_core_block_reads_min / 60;
		$i_core_block_reads_hour = number_format($i_core_block_reads_hour, 2, '.', ',');
		$i_core_block_reads_min = number_format($i_core_block_reads_min, 2, '.', ',');
		$i_core_block_reads_sec = number_format($i_core_block_reads_sec, 4, '.', ',');
		$i_core_block_reads = number_format($i_core_block_reads);

		$extended_stats .= "<tr>";
		$extended_stats .= "<td class=\"orange_12\" style=\"font-weight:bold;\">Block&nbsp;Reads:</td>";
		$extended_stats .= "<td>$i_core_block_reads</td>";
		$extended_stats .= "<td>$block_reads_compare_img$block_reads_change</td>";
		$extended_stats .= "<td>$i_core_block_reads_hour</td>";
		$extended_stats .= "<td>$i_core_block_reads_min</td>";
		$extended_stats .= "<td>$i_core_block_reads_sec</td>";
		$extended_stats .= "</tr>";
		$extended_stats .= "<tr><td colspan=\"6\" style=\"height:30px;\"><hr class=\"hr_light_grey\"/></td></tr>";

		############
		#BUFFER_HITS
		############
		$i_core_buffer_hits_hour = $i_core_buffer_hits / 24;
		$i_core_buffer_hits_min = $i_core_buffer_hits_hour / 60;
		$i_core_buffer_hits_sec = $i_core_buffer_hits_min / 60;
		$i_core_buffer_hits_hour = number_format($i_core_buffer_hits_hour, 2, '.', ',');
		$i_core_buffer_hits_min = number_format($i_core_buffer_hits_min, 2, '.', ',');
		$i_core_buffer_hits_sec = number_format($i_core_buffer_hits_sec, 4, '.', ',');
		$i_core_buffer_hits = number_format($i_core_buffer_hits);

		$extended_stats .= "<tr>";
		$extended_stats .= "<td class=\"orange_12\" style=\"font-weight:bold;\">Buffer&nbsp;Hits:</td>";
		$extended_stats .= "<td>$i_core_buffer_hits</td>";
		$extended_stats .= "<td>$buffer_hits_compare_img$buffer_hits_change</td>";
		$extended_stats .= "<td>$i_core_buffer_hits_hour</td>";
		$extended_stats .= "<td>$i_core_buffer_hits_min</td>";
		$extended_stats .= "<td>$i_core_buffer_hits_sec</td>";
		$extended_stats .= "</tr>";
		$extended_stats .= "<tr><td colspan=\"6\" style=\"height:30px;\"><hr class=\"hr_light_grey\"/></td></tr>";

		#############
		#USER_INSERTS
		#############
		$i_user_inserts_hour = $i_user_inserts / 24;
		$i_user_inserts_min = $i_user_inserts_hour / 60;
		$i_user_inserts_sec = $i_user_inserts_min / 60;
		$i_user_inserts_hour = number_format($i_user_inserts_hour, 2, '.', ',');
		$i_user_inserts_min = number_format($i_user_inserts_min, 2, '.', ',');
		$i_user_inserts_sec = number_format($i_user_inserts_sec, 4, '.', ',');
		$i_user_inserts = number_format($i_user_inserts);

		$extended_stats .= "<tr>";
		$extended_stats .= "<td class=\"orange_12\" style=\"font-weight:bold;\">User&nbsp;Inserts:</td>";
		$extended_stats .= "<td>$i_user_inserts</td>";
		$extended_stats .= "<td>$inserts_compare_img$inserts_change</td>";
		$extended_stats .= "<td>$i_user_inserts_hour</td>";
		$extended_stats .= "<td>$i_user_inserts_min</td>";
		$extended_stats .= "<td>$i_user_inserts_sec</td>";
		$extended_stats .= "</tr>";
		$extended_stats .= "<tr><td colspan=\"6\" style=\"height:30px;\"><hr class=\"hr_light_grey\"/></td></tr>";

		#############
		#USER_UPDATES
		#############
		$i_user_updates_hour = $i_user_updates / 24;
		$i_user_updates_min = $i_user_updates_hour / 60;
		$i_user_updates_sec = $i_user_updates_min / 60;
		$i_user_updates_hour = number_format($i_user_updates_hour, 2, '.', ',');
		$i_user_updates_min = number_format($i_user_updates_min, 2, '.', ',');
		$i_user_updates_sec = number_format($i_user_updates_sec, 4, '.', ',');
		$i_user_updates = number_format($i_user_updates);

		$extended_stats .= "<tr>";
		$extended_stats .= "<td class=\"orange_12\" style=\"font-weight:bold;\">User&nbsp;Updates:</td>";
		$extended_stats .= "<td>$i_user_updates</td>";
		$extended_stats .= "<td>$updates_compare_img$updates_change</td>";
		$extended_stats .= "<td>$i_user_updates_hour</td>";
		$extended_stats .= "<td>$i_user_updates_min</td>";
		$extended_stats .= "<td>$i_user_updates_sec</td>";
		$extended_stats .= "</tr>";
		$extended_stats .= "<tr><td colspan=\"6\" style=\"height:30px;\"><hr class=\"hr_light_grey\"/></td></tr>";

		#############
		#USER_DELETES
		#############
		$i_user_deletes_hour = $i_user_deletes / 24;
		$i_user_deletes_min = $i_user_deletes_hour / 60;
		$i_user_deletes_sec = $i_user_deletes_min / 60;
		$i_user_deletes_hour = number_format($i_user_deletes_hour, 2, '.', ',');
		$i_user_deletes_min = number_format($i_user_deletes_min, 2, '.', ',');
		$i_user_deletes_sec = number_format($i_user_deletes_sec, 4, '.', ',');
		$i_user_deletes = number_format($i_user_deletes);

		$extended_stats .= "<tr>";
		$extended_stats .= "<td class=\"orange_12\" style=\"font-weight:bold;\">User&nbsp;Deletes:</td>";
		$extended_stats .= "<td>$i_user_deletes</td>";
		$extended_stats .= "<td>$deletes_compare_img$deletes_change</td>";
		$extended_stats .= "<td>$i_user_deletes_hour</td>";
		$extended_stats .= "<td>$i_user_deletes_min</td>";
		$extended_stats .= "<td>$i_user_deletes_sec</td>";
		$extended_stats .= "</tr>";
		$extended_stats .= "<tr><td colspan=\"6\" style=\"height:30px;\"><hr class=\"hr_light_grey\"/></td></tr>";

		##########
		#SEQ_SCANS
		##########
		$i_user_seq_scans_hour = $i_user_seq_scans / 24;
		$i_user_seq_scans_min = $i_user_seq_scans_hour / 60;
		$i_user_seq_scans_sec = $i_user_seq_scans_min / 60;
		$i_user_seq_scans_hour = number_format($i_user_seq_scans_hour, 2, '.', ',');
		$i_user_seq_scans_min = number_format($i_user_seq_scans_min, 2, '.', ',');
		$i_user_seq_scans_sec = number_format($i_user_seq_scans_sec, 4, '.', ',');
		$i_user_seq_scans = number_format($i_user_seq_scans);

		$extended_stats .= "<tr>";
		$extended_stats .= "<td class=\"orange_12\" style=\"font-weight:bold;\">SEQ&nbsp;Scans:</td>";
		$extended_stats .= "<td>$i_user_seq_scans</td>";
		$extended_stats .= "<td>$seq_scans_compare_img$seq_scans_change</td>";
		$extended_stats .= "<td>$i_user_seq_scans_hour</td>";
		$extended_stats .= "<td>$i_user_seq_scans_min</td>";
		$extended_stats .= "<td>$i_user_seq_scans_sec</td>";
		$extended_stats .= "</tr>";

		#########
		#SEQ_ROWS
		#########
		$i_user_seq_rows_hour = $i_user_seq_rows / 24;
		$i_user_seq_rows_min = $i_user_seq_rows_hour / 60;
		$i_user_seq_rows_sec = $i_user_seq_rows_min / 60;
		$i_user_seq_rows_hour = number_format($i_user_seq_rows_hour, 2, '.', ',');
		$i_user_seq_rows_min = number_format($i_user_seq_rows_min, 2, '.', ',');
		$i_user_seq_rows_sec = number_format($i_user_seq_rows_sec, 4, '.', ',');
		$i_user_seq_rows = number_format($i_user_seq_rows);

		$extended_stats .= "<tr>";
		$extended_stats .= "<td>Rows&nbsp;Used:</td>";
		$extended_stats .= "<td>$i_user_seq_rows</td>";
		$extended_stats .= "<td>$seq_rows_compare_img$seq_rows_change</td>";
		$extended_stats .= "<td>$i_user_seq_rows_hour</td>";
		$extended_stats .= "<td>$i_user_seq_rows_min</td>";
		$extended_stats .= "<td>$i_user_seq_rows_sec</td>";
		$extended_stats .= "</tr>";
		$extended_stats .= "<tr><td colspan=\"6\" style=\"height:30px;\"><hr class=\"hr_light_grey\"/></td></tr>";

		##########
		#IDX_SCANS
		##########
		$i_user_idx_scans_hour = $i_user_idx_scans / 24;
		$i_user_idx_scans_min = $i_user_idx_scans_hour / 60;
		$i_user_idx_scans_sec = $i_user_idx_scans_min / 60;
		$i_user_idx_scans_hour = number_format($i_user_idx_scans_hour, 2, '.', ',');
		$i_user_idx_scans_min = number_format($i_user_idx_scans_min, 2, '.', ',');
		$i_user_idx_scans_sec = number_format($i_user_idx_scans_sec, 4, '.', ',');
		$i_user_idx_scans = number_format($i_user_idx_scans);

		$extended_stats .= "<tr>";
		$extended_stats .= "<td class=\"orange_12\" style=\"font-weight:bold;\">IDX&nbsp;Scans:</td>";
		$extended_stats .= "<td>$i_user_idx_scans</td>";
		$extended_stats .= "<td>$idx_scans_compare_img$idx_scans_change</td>";
		$extended_stats .= "<td>$i_user_idx_scans_hour</td>";
		$extended_stats .= "<td>$i_user_idx_scans_min</td>";
		$extended_stats .= "<td>$i_user_idx_scans_sec</td>";
		$extended_stats .= "</tr>";

		#########
		#IDX_ROWS
		#########
		$i_user_idx_rows_hour = $i_user_idx_rows / 24;
		$i_user_idx_rows_min = $i_user_idx_rows_hour / 60;
		$i_user_idx_rows_sec = $i_user_idx_rows_min / 60;
		$i_user_idx_rows_hour = number_format($i_user_idx_rows_hour, 2, '.', ',');
		$i_user_idx_rows_min = number_format($i_user_idx_rows_min, 2, '.', ',');
		$i_user_idx_rows_sec = number_format($i_user_idx_rows_sec, 4, '.', ',');
		$i_user_idx_rows = number_format($i_user_idx_rows);

		$extended_stats .= "<tr>";
		$extended_stats .= "<td>Rows&nbsp;Used:</td>";
		$extended_stats .= "<td>$i_user_idx_rows</td>";
		$extended_stats .= "<td>$idx_rows_compare_img$idx_rows_change</td>";
		$extended_stats .= "<td>$i_user_idx_rows_hour</td>";
		$extended_stats .= "<td>$i_user_idx_rows_min</td>";
		$extended_stats .= "<td>$i_user_idx_rows_sec</td>";
		$extended_stats .= "</tr>";

		###################
		#COMPLETE TABLEWORK
		###################
		$extended_stats .= "</table>";

		########################################
		#ADD DYNAMIC TR FOR EXTENDED DAILY STATS
		########################################
		if(substr($day,0,1) == "0") { $extended_date_day = substr($day,1,1); } else { $extended_date_day = $day; }
		$extended_date_month = date_get_friendly_month($month);
		$extended_date = "$extended_date_month $extended_date_day, $year";

		####################
		#PUT IT ALL TOGETHER
		####################
		$stats .= "<tr id=\"daily_extended_$i\" style=\"display:none;\"><td colspan=\"6\"><div class=\"stat_sub_div_bg\" style=\"margin:20px 0 20px 0;\">";
		$stats .= "<div class=\"black_12\" style=\"float:left; font-weight:bold;\">Daily Statistics<span class=\"grey_12\" style=\"font-weight:normal;\"> | </span><span class=\"orange_12\">$i_datname</span><span class=\"grey_12\" style=\"font-weight:normal;\"> | $extended_date</span></div>";
		$stats .= "<div class=\"grey_12\" style=\"float:right;\">[<a href=\"javascript:daily_extended($i)\"><span style=\"font-weight:bold;\">X</span></a>]</div>";
		$stats .= "<div style=\"clear:both;\"></div>";
		$stats .= "<div style=\"margin:10px 0 20px 0;\"><hr></div>";
		$stats .= "<div>$extended_stats</div>";
		$stats .= "</div></td><tr>";
	}

	##################
	#FORMAT TOTAL STAT
	##################
	$total_stat = number_format($total_stat);

	###############
	#COMPLETE TABLE
	###############
	$stats .= "<tr><td class=\"black_13\" style=\"padding-top:10px; font-weight:bold;\">Target Stat Total:</td><td></td><td class=\"black_13\" style=\"padding-top:10px; font-weight:bold;\">$total_stat</td><td></td><td></td></tr>";
	$stats .= "</table>";
	$stats .= "</div>";

	#############################
	#GET TOTAL SCRIPT PEAK MEMORY
	#############################
	$script_mem = number_format(((memory_get_peak_usage(true)/1024)/1024),3) . "M";

	#########################
	//TEMPORARILY STOP SCRIPT
	#########################
	$ajax_return[0] = 1;
	$ajax_return[] = $stats;
	$ajax_return[] = $script_mem;
	$ajax_return = json_encode($ajax_return);
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: VERSUS_RETRIEVE_NAV_DBS
##########################################################################################################
##########################################################################################################
function versus_retrieve_nav_dbs($server_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	####################################
	#CREATE RETURN ARRAY FOR JSON VALUES
	####################################
	$ajax_return = array();

	################################
	#DEFAULT SUCCESS VALUE AS FAILED
	################################
	$ajax_return[] = 2;

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");

	#############
	#MAKE CERTAIN
	#############
	if(!$pg_conn)
	{
		$ajax_return[] = "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	##########################################################################
	#RETRIEVE OUR DB LIST - IF SERVER_ID IS EMPTY, GET ALL DBS FOR ALL SERVERS
	##########################################################################
	if($server_id == 0 || empty($server_id) or $server_id == "0" || !is_numeric($server_id))
	{
		#########
		#DB QUERY
		#########
		$sqlselect_dbs = @pg_query($pg_conn, "SELECT db_id,db_name FROM ps_db_tbl WHERE (SELECT COUNT(db_id) FROM ps_core_tbl WHERE ps_db_tbl.db_id = ps_core_tbl.db_id) > 0 ORDER BY db_name ASC");

		############
		#MONTH QUERY
		############
		$sqlselect_months = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(MONTH FROM recorded) AS month FROM ps_core_tbl ORDER BY month ASC");
		
		###########
		#YEAR QUERY
		###########
		$sqlselect_years = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(YEAR FROM recorded) AS year FROM ps_core_tbl ORDER BY year DESC");
	}
	else
	{
		#############################
		#GRAB DBS FOR SELECTED SERVER
		#############################
		$sqlselect_dbs = @pg_query($pg_conn, "SELECT db_id,db_name FROM ps_db_tbl WHERE server_id = $server_id AND (SELECT COUNT(db_id) FROM ps_core_tbl WHERE ps_db_tbl.db_id = ps_core_tbl.db_id AND server_id = $server_id) > 0 ORDER BY db_name ASC");

		################################
		#MONTH QUERY FOR SELECTED SERVER
		################################
		$sqlselect_months = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(MONTH FROM recorded) AS month FROM ps_core_tbl WHERE server_id = $server_id ORDER BY month ASC");

		###############################
		#YEAR QUERY FOR SELECTED SERVER
		###############################
		$sqlselect_years = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(YEAR FROM recorded) AS year FROM ps_core_tbl WHERE server_id = $server_id ORDER BY year DESC");
	}

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlselect_dbs || !$sqlselect_months || !$sqlselect_years)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	############################
	#CREATE OUR DB LIST DROPDOWN
	############################
	$db_list  = "<select class=\"select_menu\" name=\"versus_dbs\" id=\"versus_dbs\" onChange=\"versus_select_nav_db()\">";
	$db_list .= "<option value=\"0\">All Databases</option>";

	#######################
	#ITERATE THROUGH VALUES
	#######################
	while($query_data_dbs = pg_fetch_row($sqlselect_dbs))
	{
		$db_id = $query_data_dbs[0];
		$db_name = $query_data_dbs[1];
		$db_list .= "<option value=\"$db_id\">$db_name</option>";
	}
	$db_list .= "</select>";

	################################
	#CURRENT MONTH FOR PRE-SELECTION
	################################
	$current_month = date('m');

	#####################
	#START THE MONTH LIST
	#####################
	$month_list_a = "<select class=\"select_menu\" name=\"versus_month_a\" id=\"versus_month_a\">";
	$month_list_b = "<select class=\"select_menu\" name=\"versus_month_b\" id=\"versus_month_b\">";
	while($query_data_months = pg_fetch_row($sqlselect_months))
	{
		################################################################
		#EXTRACT MONTH - HANDLE LEADING ZEROS - AND GET FRIENDLY VERSION
		################################################################
		$month = $query_data_months[0];
		if(strlen($month) == 1) $month = "0$month";
		$month_friendly = date_get_friendly_month($month);
		if($month == $current_month) { $selected = "selected=\"selected\""; } else { $selected = ""; }
		$month_list_a .= "<option value=\"$month\" $selected>$month_friendly</option>";
		$month_list_b .= "<option value=\"$month\" $selected>$month_friendly</option>";
	}
	$month_list_a .= "</select>";
	$month_list_b .= "</select>";

	###############################
	#CURRENT YEAR FOR PRE-SELECTION
	###############################
	$current_year = date('Y');

	####################
	#START THE YEAR LIST
	####################
	$year_list_a = "<select class=\"select_menu\" name=\"versus_year_a\" id=\"versus_year_a\">";
	$year_list_b = "<select class=\"select_menu\" name=\"versus_year_b\" id=\"versus_year_b\">";
	while($query_data_years = pg_fetch_row($sqlselect_years))
	{
		$year = $query_data_years[0];
		if($year == $current_year) { $selected = "selected=\"selected\""; } else { $selected = ""; }
		$year_list_a .= "<option value=\"$year\" $selected>$year</option>";
		$year_list_b .= "<option value=\"$year\" $selected>$year</option>";
	}
	$year_list_a .= "</select>";
	$year_list_b .= "</select>";

	######################
	#PREP ARRAY FOR RETURN
	######################
	$ajax_return[0] = 1;
	$ajax_return[] = $db_list;
	$ajax_return[] = $month_list_a;
	$ajax_return[] = $year_list_a;
	$ajax_return[] = $month_list_b;
	$ajax_return[] = $year_list_b;
	$ajax_return = json_encode($ajax_return);

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: VERSUS_SELECT_NAV_DB
##########################################################################################################
##########################################################################################################
function versus_select_nav_db($server_id,$db_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	####################################
	#CREATE RETURN ARRAY FOR JSON VALUES
	####################################
	$ajax_return = array();

	################################
	#DEFAULT SUCCESS VALUE AS FAILED
	################################
	$ajax_return[] = 2;

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");

	#############
	#MAKE CERTAIN
	#############
	if(!$pg_conn)
	{
		$ajax_return[] = "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	############################################################
	#IF NO DB_ID WAS PASSED, GET MONTH / YEAR VALUES FOR ALL DBS
	############################################################
	if($db_id == 0 || empty($db_id) or $db_id == "0" || !is_numeric($db_id))
	{
		################
		#THE MONTH QUERY
		################
		$sqlselect_months = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(MONTH FROM recorded) AS month FROM ps_core_tbl WHERE server_id = $server_id ORDER BY month ASC");

		###############
		#THE YEAR QUERY
		###############
		$sqlselect_years = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(YEAR FROM recorded) AS year FROM ps_core_tbl WHERE server_id = $server_id ORDER BY year DESC");
	}
	else
	{
		################
		#THE MONTH QUERY
		################
		$sqlselect_months = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(MONTH FROM recorded) AS month FROM ps_core_tbl WHERE server_id = $server_id AND db_id = $db_id ORDER BY month ASC");

		###############
		#THE YEAR QUERY
		###############
		$sqlselect_years = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(YEAR FROM recorded) AS year FROM ps_core_tbl WHERE server_id = $server_id AND db_id = $db_id ORDER BY year DESC");
	}

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlselect_months || !$sqlselect_years)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	################################
	#CURRENT MONTH FOR PRE-SELECTION
	################################
	$current_month = date('m');

	#####################
	#START THE MONTH LIST
	#####################
	$month_list_a  = "<select class=\"select_menu\" name=\"versus_month_a\" id=\"versus_month_a\">";
	$month_list_b  = "<select class=\"select_menu\" name=\"versus_month_b\" id=\"versus_month_b\">";
	while($query_data_months = pg_fetch_row($sqlselect_months))
	{
		################################################################
		#EXTRACT MONTH - HANDLE LEADING ZEROS - AND GET FRIENDLY VERSION
		################################################################
		$month = $query_data_months[0];
		if(strlen($month) == 1) $month = "0$month";
		$month_friendly = date_get_friendly_month($month);
		if($month == $current_month) { $selected = "selected=\"selected\""; } else { $selected = ""; }
		$month_list_a .= "<option value=\"$month\" $selected>$month_friendly</option>";
		$month_list_b .= "<option value=\"$month\" $selected>$month_friendly</option>";
	}
	$month_list_a .= "</select>";
	$month_list_b .= "</select>";

	###############################
	#CURRENT YEAR FOR PRE-SELECTION
	###############################
	$current_year = date('Y');

	####################
	#START THE YEAR LIST
	####################
	$year_list_a  = "<select class=\"select_menu\" name=\"versus_year_a\" id=\"versus_year_a\">";
	$year_list_b  = "<select class=\"select_menu\" name=\"versus_year_b\" id=\"versus_year_b\">";
	while($query_data_years = pg_fetch_row($sqlselect_years))
	{
		$year = $query_data_years[0];
		if($year == $current_year) { $selected = "selected=\"selected\""; } else { $selected = ""; }
		$year_list_a .= "<option value=\"$year\" $selected>$year</option>";
		$year_list_b .= "<option value=\"$year\" $selected>$year</option>";
	}
	$year_list_a .= "</select>";
	$year_list_b .= "</select>";

	######################
	#PREP ARRAY FOR RETURN
	######################
	$ajax_return[0] = 1;
	$ajax_return[] = $month_list_a;
	$ajax_return[] = $year_list_a;
	$ajax_return[] = $month_list_b;
	$ajax_return[] = $year_list_b;
	$ajax_return = json_encode($ajax_return);

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: VERSUS_RETRIEVE
##########################################################################################################
##########################################################################################################
function versus_retrieve($servers,$dbs,$month_a,$year_a,$month_b,$year_b,$versus_chartting,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	####################################
	#CREATE RETURN ARRAY FOR JSON VALUES
	####################################
	$ajax_return = array();

	################################
	#DEFAULT SUCCESS VALUE AS FAILED
	################################
	$ajax_return[] = 2;

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");

	#############
	#MAKE CERTAIN
	#############
	if(!$pg_conn)
	{
		$ajax_return[] = "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	#######################
	#VALIDATE CHARTTING VAR
	#######################
	if($versus_chartting != "commits" && $versus_chartting != "rollbacks" && $versus_chartting != "block_reads" && $versus_chartting != "buffer_hits" && $versus_chartting != "inserts" && $versus_chartting != "updates" && $versus_chartting != "deletes" && $versus_chartting != "seq_scans" && $versus_chartting != "idx_scans")
	{
		###########################################
		#DEFAULT THE CHART TO SHOWING COMMIT VALUES
		###########################################
		$versus_chartting = "commits";
	}

	################################
	#VALIDATE OUR SERVER AND DB VARS
	################################
	if(empty($servers) || !is_numeric($servers)) $servers = 0;
	if(empty($dbs) || !is_numeric($dbs)) $dbs = 0;

	#####################################################
	#MAKE SURE TARGET MONTH & YEARS FOR A/B ARE DIFFERENT
	#####################################################
	if($month_a == $month_b && $year_a == $year_b)
	{
		$ajax_return[0] = 1;
		$ajax_return[] = "Please select two different target months.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	##############################
	#GET FRIENDLY MONTHS FOR LATER
	##############################
	$month_a_str = date_get_friendly_month($month_a);
	$month_b_str = date_get_friendly_month($month_b);
	$month_a_str_ext = date_get_friendly_month_ext($month_a);
	$month_b_str_ext = date_get_friendly_month_ext($month_b);

	#################################
	#CONSTRUCT STAT QUERY FOR MONTH A
	#################################
	$stat_query  = "SELECT *,EXTRACT(DAY FROM recorded) FROM ps_core_tbl ";
	$stat_query .= "WHERE EXTRACT(MONTH FROM recorded) = $month_a AND EXTRACT(YEAR FROM recorded) = $year_a ";
	if($servers != 0) { $stat_query .= "AND server_id = $servers "; }
	if($dbs != 0) { $stat_query .= "AND db_id = $dbs "; }
	$stat_query .= "ORDER BY recorded ASC";

	#######
	#RUN IT
	#######
	$sqlselect_stats_a = @pg_query($pg_conn, $stat_query);

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlselect_stats_a)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	###################################
	#IF THERE ARE NO MONTH A STATISTICS
	###################################
	if(pg_num_rows($sqlselect_stats_a) == 0)
	{
		$ajax_return[0] = 1;
		$ajax_return[] = "There are no statistics recorded for the first month.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	#################################
	#CONSTRUCT STAT QUERY FOR MONTH B
	#################################
	$stat_query  = "SELECT *,EXTRACT(DAY FROM recorded) FROM ps_core_tbl ";
	$stat_query .= "WHERE EXTRACT(MONTH FROM recorded) = $month_b AND EXTRACT(YEAR FROM recorded) = $year_b ";
	if($servers != 0) { $stat_query .= "AND server_id = $servers "; }
	if($dbs != 0) { $stat_query .= "AND db_id = $dbs "; }
	$stat_query .= "ORDER BY recorded ASC";

	#######
	#RUN IT
	#######
	$sqlselect_stats_b = @pg_query($pg_conn, $stat_query);

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlselect_stats_b)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	###################################
	#IF THERE ARE NO MONTH B STATISTICS
	###################################
	if(pg_num_rows($sqlselect_stats_b) == 0)
	{
		$ajax_return[0] = 1;
		$ajax_return[] = "There are no statistics recorded for the second month.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	#####################################
	#VARS FOR TRACKING TOTAL DAYS STATTED
	#####################################
	$total_days_tracked_month_a = 0;
	$total_days_tracked_month_b = 0;

	###############################################
	#VARS FOR TRACKING THE PEAK LEVEL FOR EACH STAT
	###############################################
	$highest_commits_month_a = 0;
	$highest_commits_month_b = 0;
	$highest_rollbacks_month_a = 0;
	$highest_rollbacks_month_b = 0;
	$highest_block_reads_month_a = 0;
	$highest_block_reads_month_b = 0;
	$highest_buffer_hits_month_a = 0;
	$highest_buffer_hits_month_b = 0;
	$highest_inserts_month_a = 0;
	$highest_inserts_month_b = 0;
	$highest_updates_month_a = 0;
	$highest_updates_month_b = 0;
	$highest_deletes_month_a = 0;
	$highest_deletes_month_b = 0;
	$highest_seq_scans_month_a = 0;
	$highest_seq_scans_month_b = 0;
	$highest_seq_rows_month_a = 0;
	$highest_seq_rows_month_b = 0;
	$highest_idx_scans_month_a = 0;
	$highest_idx_scans_month_b = 0;
	$highest_idx_rows_month_a = 0;
	$highest_idx_rows_month_b = 0;
	
	#####################
	#VARS FOR TOTAL STATS
	#####################
	$total_commits_month_a = 0;
	$total_commits_month_b = 0;
	$total_rollbacks_month_a = 0;
	$total_rollbacks_month_b = 0;
	$total_block_reads_month_a = 0;
	$total_block_reads_month_b = 0;
	$total_buffer_hits_month_a = 0;
	$total_buffer_hits_month_b = 0;
	$total_inserts_month_a = 0;
	$total_inserts_month_b = 0;
	$total_updates_month_a = 0;
	$total_updates_month_b = 0;
	$total_deletes_month_a = 0;
	$total_deletes_month_b = 0;
	$total_seq_scans_month_a = 0;
	$total_seq_scans_month_b = 0;
	$total_seq_rows_month_a = 0;
	$total_seq_rows_month_b = 0;
	$total_idx_scans_month_a = 0;
	$total_idx_scans_month_b = 0;
	$total_idx_rows_month_a = 0;
	$total_idx_rows_month_b = 0;

	#############################
	#VARS TO HOUSE TOOLTIP VALUES
	#############################
	$tt_commits_a = 0;
	$tt_rollbacks_a = 0;
	$tt_block_reads_a = 0;
	$tt_buffer_hits_a = 0;
	$tt_inserts_a = 0;
	$tt_updates_a = 0;
	$tt_deletes_a = 0;
	$tt_seq_scans_a = 0;
	$tt_idx_scans_a = 0;
	$tt_commits_b = 0;
	$tt_rollbacks_b = 0;
	$tt_block_reads_b = 0;
	$tt_buffer_hits_b = 0;
	$tt_inserts_b = 0;
	$tt_updates_b = 0;
	$tt_deletes_b = 0;
	$tt_seq_scans_b = 0;
	$tt_idx_scans_b = 0;

	###################
	#BAR AND TABLE VARS
	###################
	$bar_height_vert = 150;
	$bar_width = 12;
	$table_width = $bar_width * 2;

	################################################
	#RESET BAR WIDTH NOW ACCOUNTING FOR BORDER STYLE
	################################################
	$bar_width = $bar_width -2;

	#####################
	#BAR CHART COLOR VARS
	#####################
	$bar_vert_alt_color = "#FFFFFF";
	$bar_vert_color_a = "#333333";
	$bar_vert_color_b = "#999999";
	$bar_border_color = "#C9C9C9";

	############################
	#STORE THE PREVIOUS DAY FLAG
	############################
	$prev_day_flag = "";

	##############################
	#START OUR ITERATION - MONTH A
	##############################
	while($query_data_stats_a = pg_fetch_row($sqlselect_stats_a))
	{
		###############
		#GRAB CORE DATA
		###############
		$ps_core_id = $query_data_stats_a[0];
		$db_id = $query_data_stats_a[1];
		$server_id = $query_data_stats_a[2];
		$recorded = $query_data_stats_a[3];
		$datid = $query_data_stats_a[4];
		$datname = $query_data_stats_a[5];
		$core_commits = $query_data_stats_a[6];
		$core_rollbacks = $query_data_stats_a[7];
		$core_block_reads = $query_data_stats_a[8];
		$core_buffer_hits = $query_data_stats_a[9];
		$user_inserts = $query_data_stats_a[10];
		$user_updates = $query_data_stats_a[11];
		$user_deletes = $query_data_stats_a[12];
		$user_seq_scans = $query_data_stats_a[13];
		$user_idx_scans = $query_data_stats_a[14];
		$user_seq_rows = $query_data_stats_a[15];
		$user_idx_rows = $query_data_stats_a[16];
		$day_flag = $query_data_stats_a[17];

		####################
		#HANDLE LEADING ZERO
		####################
		if(strlen($day_flag) == 1) $day_flag = "0$day_flag";

		#####################
		#TALL UP TRACKED DAYS
		#####################
		if($day_flag != $prev_day_flag)
		{
			$total_days_tracked_month_a++;
		}

		#####################
		#UPDATE PREV DAY FLAG
		#####################
		$prev_day_flag = $day_flag;

		###################
		#PROCESS STATISTICS
		###################
		if(isset(${'db_commits_a_' . $day_flag})) ${'db_commits_a_' . $day_flag} += $core_commits;
		else ${'db_commits_a_' . $day_flag} = $core_commits;

		if(isset(${'db_rollbacks_a_' . $day_flag})) ${'db_rollbacks_a_' . $day_flag} += $core_rollbacks;
		else ${'db_rollbacks_a_' . $day_flag} = $core_rollbacks;

		if(isset(${'db_block_reads_a_' . $day_flag})) ${'db_block_reads_a_' . $day_flag} += $core_block_reads;
		else ${'db_block_reads_a_' . $day_flag} = $core_block_reads;
		
		if(isset(${'db_buffer_hits_a_' . $day_flag})) ${'db_buffer_hits_a_' . $day_flag} += $core_buffer_hits;
		else ${'db_buffer_hits_a_' . $day_flag} = $core_buffer_hits;
		
		if(isset(${'db_inserts_a_' . $day_flag})) ${'db_inserts_a_' . $day_flag} += $user_inserts;
		else ${'db_inserts_a_' . $day_flag} = $user_inserts;
		
		if(isset(${'db_updates_a_' . $day_flag})) ${'db_updates_a_' . $day_flag} += $user_updates;
		else ${'db_updates_a_' . $day_flag} = $user_updates;
		
		if(isset(${'db_deletes_a_' . $day_flag})) ${'db_deletes_a_' . $day_flag} += $user_deletes;
		else ${'db_deletes_a_' . $day_flag} = $user_deletes;
		
		if(isset(${'db_seq_scans_a_' . $day_flag})) ${'db_seq_scans_a_' . $day_flag} += $user_seq_scans;
		else ${'db_seq_scans_a_' . $day_flag} = $user_seq_scans;
		
		if(isset(${'db_idx_scans_a_' . $day_flag})) ${'db_idx_scans_a_' . $day_flag} += $user_idx_scans;
		else ${'db_idx_scans_a_' . $day_flag} = $user_idx_scans;
		
		if(isset(${'db_seq_rows_a_' . $day_flag})) ${'db_seq_rows_a_' . $day_flag} += $user_seq_rows;
		else ${'db_seq_rows_a_' . $day_flag} = $user_seq_rows;
		
		if(isset(${'db_idx_rows_a_' . $day_flag})) ${'db_idx_rows_a_' . $day_flag} += $user_idx_rows;
		else ${'db_idx_rows_a_' . $day_flag} = $user_idx_rows;

		#########################
		#TALL UP TOTAL STATISTICS
		#########################
		$total_commits_month_a += $core_commits;
		$total_rollbacks_month_a += $core_rollbacks;
		$total_block_reads_month_a += $core_block_reads;
		$total_buffer_hits_month_a += $core_buffer_hits;
		$total_inserts_month_a += $user_inserts;
		$total_updates_month_a += $user_updates;
		$total_deletes_month_a += $user_deletes;
		$total_seq_scans_month_a += $user_seq_scans;
		$total_idx_scans_month_a += $user_idx_scans;
		$total_seq_rows_month_a += $user_seq_rows;
		$total_idx_rows_month_a += $user_idx_rows;

		############################################################################
		#TALLY UP OUR "HIGHEST" VARS SO THAT WE CAN DETERMINE BAR CHART VALUES LATER
		############################################################################
		if(${'db_commits_a_' . $day_flag} >= $highest_commits_month_a)
		{
			$highest_commits_month_a = ${'db_commits_a_' . $day_flag};
			$highest_commits_day_month_a = $day_flag;
			$highest_commits_date_month_a = "$month_a-$day_flag-$year_a";	
		}
		if(${'db_rollbacks_a_' . $day_flag} >= $highest_rollbacks_month_a)
		{
			$highest_rollbacks_month_a = ${'db_rollbacks_a_' . $day_flag};
			$highest_rollbacks_day_month_a = $day_flag;
			$highest_rollbacks_date_month_a = "$month_a-$day_flag-$year_a";
		}
		if(${'db_block_reads_a_' . $day_flag} >= $highest_block_reads_month_a)
		{
			$highest_block_reads_month_a = ${'db_block_reads_a_' . $day_flag};
			$highest_block_reads_day_month_a = $day_flag;
			$highest_block_reads_date_month_a = "$month_a-$day_flag-$year_a";
		}
		if(${'db_buffer_hits_a_' . $day_flag} >= $highest_buffer_hits_month_a)
		{
			$highest_buffer_hits_month_a = ${'db_buffer_hits_a_' . $day_flag};
			$highest_buffer_hits_day_month_a = $day_flag;
			$highest_buffer_hits_date_month_a = "$month_a-$day_flag-$year_a";
		}
		if(${'db_inserts_a_' . $day_flag} >= $highest_inserts_month_a)
		{
			$highest_inserts_month_a = ${'db_inserts_a_' . $day_flag};
			$highest_inserts_day_month_a = $day_flag;
			$highest_inserts_date_month_a = "$month_a-$day_flag-$year_a";
		}
		if(${'db_updates_a_' . $day_flag} >= $highest_updates_month_a)
		{
			$highest_updates_month_a = ${'db_updates_a_' . $day_flag};
			$highest_updates_day_month_a = $day_flag;
			$highest_updates_date_month_a = "$month_a-$day_flag-$year_a";
		}
		if(${'db_deletes_a_' . $day_flag} >= $highest_deletes_month_a)
		{
			$highest_deletes_month_a = ${'db_deletes_a_' . $day_flag};
			$highest_deletes_day_month_a = $day_flag;
			$highest_deletes_date_month_a = "$month_a-$day_flag-$year_a";
		}
		if(${'db_seq_scans_a_' . $day_flag} >= $highest_seq_scans_month_a)
		{
			$highest_seq_scans_month_a = ${'db_seq_scans_a_' . $day_flag};
			$highest_seq_scans_day_month_a = $day_flag;
			$highest_seq_scans_date_month_a = "$month_a-$day_flag-$year_a";
		}
		if(${'db_idx_scans_a_' . $day_flag} >= $highest_idx_scans_month_a)
		{
			$highest_idx_scans_month_a = ${'db_idx_scans_a_' . $day_flag};
			$highest_idx_scans_day_month_a = $day_flag;
			$highest_idx_scans_date_month_a = "$month_a-$day_flag-$year_a";
		}
		if(${'db_seq_rows_a_' . $day_flag} >= $highest_seq_rows_month_a)
		{
			$highest_seq_rows_month_a = ${'db_seq_rows_a_' . $day_flag};
			$highest_seq_rows_day_month_a = $day_flag;
			$highest_seq_rows_date_month_a = "$month_a-$day_flag-$year_a";
		}
		if(${'db_idx_rows_a_' . $day_flag} >= $highest_idx_rows_month_a)
		{
			$highest_idx_rows_month_a = ${'db_idx_rows_a_' . $day_flag};
			$highest_idx_rows_day_month_a = $day_flag;
			$highest_idx_rows_date_month_a = "$month_a-$day_flag-$year_a";
		}
	}

	############################
	#STORE THE PREVIOUS DAY FLAG
	############################
	$prev_day_flag = "";

	##############################
	#START OUR ITERATION - MONTH A
	##############################
	while($query_data_stats_b = pg_fetch_row($sqlselect_stats_b))
	{
		###############
		#GRAB CORE DATA
		###############
		$ps_core_id = $query_data_stats_b[0];
		$db_id = $query_data_stats_b[1];
		$server_id = $query_data_stats_b[2];
		$recorded = $query_data_stats_b[3];
		$datid = $query_data_stats_b[4];
		$datname = $query_data_stats_b[5];
		$core_commits = $query_data_stats_b[6];
		$core_rollbacks = $query_data_stats_b[7];
		$core_block_reads = $query_data_stats_b[8];
		$core_buffer_hits = $query_data_stats_b[9];
		$user_inserts = $query_data_stats_b[10];
		$user_updates = $query_data_stats_b[11];
		$user_deletes = $query_data_stats_b[12];
		$user_seq_scans = $query_data_stats_b[13];
		$user_idx_scans = $query_data_stats_b[14];
		$user_seq_rows = $query_data_stats_b[15];
		$user_idx_rows = $query_data_stats_b[16];
		$day_flag = $query_data_stats_b[17];

		####################
		#HANDLE LEADING ZERO
		####################
		if(strlen($day_flag) == 1) $day_flag = "0$day_flag";

		#####################
		#TALL UP TRACKED DAYS
		#####################
		if($day_flag != $prev_day_flag)
		{
			$total_days_tracked_month_b++;
		}

		#####################
		#UPDATE PREV DAY FLAG
		#####################
		$prev_day_flag = $day_flag;

		###################
		#PROCESS STATISTICS
		###################
		if(isset(${'db_commits_b_' . $day_flag})) ${'db_commits_b_' . $day_flag} += $core_commits;
		else ${'db_commits_b_' . $day_flag} = $core_commits;

		if(isset(${'db_rollbacks_b_' . $day_flag})) ${'db_rollbacks_b_' . $day_flag} += $core_rollbacks;
		else ${'db_rollbacks_b_' . $day_flag} = $core_rollbacks;

		if(isset(${'db_block_reads_b_' . $day_flag})) ${'db_block_reads_b_' . $day_flag} += $core_block_reads;
		else ${'db_block_reads_b_' . $day_flag} = $core_block_reads;
		
		if(isset(${'db_buffer_hits_b_' . $day_flag})) ${'db_buffer_hits_b_' . $day_flag} += $core_buffer_hits;
		else ${'db_buffer_hits_b_' . $day_flag} = $core_buffer_hits;
		
		if(isset(${'db_inserts_b_' . $day_flag})) ${'db_inserts_b_' . $day_flag} += $user_inserts;
		else ${'db_inserts_b_' . $day_flag} = $user_inserts;
		
		if(isset(${'db_updates_b_' . $day_flag})) ${'db_updates_b_' . $day_flag} += $user_updates;
		else ${'db_updates_b_' . $day_flag} = $user_updates;
		
		if(isset(${'db_deletes_b_' . $day_flag})) ${'db_deletes_b_' . $day_flag} += $user_deletes;
		else ${'db_deletes_b_' . $day_flag} = $user_deletes;
		
		if(isset(${'db_seq_scans_b_' . $day_flag})) ${'db_seq_scans_b_' . $day_flag} += $user_seq_scans;
		else ${'db_seq_scans_b_' . $day_flag} = $user_seq_scans;
		
		if(isset(${'db_idx_scans_b_' . $day_flag})) ${'db_idx_scans_b_' . $day_flag} += $user_idx_scans;
		else ${'db_idx_scans_b_' . $day_flag} = $user_idx_scans;
		
		if(isset(${'db_seq_rows_b_' . $day_flag})) ${'db_seq_rows_b_' . $day_flag} += $user_seq_rows;
		else ${'db_seq_rows_b_' . $day_flag} = $user_seq_rows;
		
		if(isset(${'db_idx_rows_b_' . $day_flag})) ${'db_idx_rows_b_' . $day_flag} += $user_idx_rows;
		else ${'db_idx_rows_b_' . $day_flag} = $user_idx_rows;

		#########################
		#TALL UP TOTAL STATISTICS
		#########################
		$total_commits_month_b += $core_commits;
		$total_rollbacks_month_b += $core_rollbacks;
		$total_block_reads_month_b += $core_block_reads;
		$total_buffer_hits_month_b += $core_buffer_hits;
		$total_inserts_month_b += $user_inserts;
		$total_updates_month_b += $user_updates;
		$total_deletes_month_b += $user_deletes;
		$total_seq_scans_month_b += $user_seq_scans;
		$total_idx_scans_month_b += $user_idx_scans;
		$total_seq_rows_month_b += $user_seq_rows;
		$total_idx_rows_month_b += $user_idx_rows;

		############################################################################
		#TALLY UP OUR "HIGHEST" VARS SO THAT WE CAN DETERMINE BAR CHART VALUES LATER
		############################################################################
		if(${'db_commits_b_' . $day_flag} >= $highest_commits_month_b)
		{
			$highest_commits_month_b = ${'db_commits_b_' . $day_flag};
			$highest_commits_day_month_b = $day_flag;
			$highest_commits_date_month_b = "$month_b-$day_flag-$year_b";	
		}
		if(${'db_rollbacks_b_' . $day_flag} >= $highest_rollbacks_month_b)
		{
			$highest_rollbacks_month_b = ${'db_rollbacks_b_' . $day_flag};
			$highest_rollbacks_day_month_b = $day_flag;
			$highest_rollbacks_date_month_b = "$month_b-$day_flag-$year_b";
		}
		if(${'db_block_reads_b_' . $day_flag} >= $highest_block_reads_month_b)
		{
			$highest_block_reads_month_b = ${'db_block_reads_b_' . $day_flag};
			$highest_block_reads_day_month_b = $day_flag;
			$highest_block_reads_date_month_b = "$month_b-$day_flag-$year_b";
		}
		if(${'db_buffer_hits_b_' . $day_flag} >= $highest_buffer_hits_month_b)
		{
			$highest_buffer_hits_month_b = ${'db_buffer_hits_b_' . $day_flag};
			$highest_buffer_hits_day_month_b = $day_flag;
			$highest_buffer_hits_date_month_b = "$month_b-$day_flag-$year_b";
		}
		if(${'db_inserts_b_' . $day_flag} >= $highest_inserts_month_b)
		{
			$highest_inserts_month_b = ${'db_inserts_b_' . $day_flag};
			$highest_inserts_day_month_b = $day_flag;
			$highest_inserts_date_month_b = "$month_b-$day_flag-$year_b";
		}
		if(${'db_updates_b_' . $day_flag} >= $highest_updates_month_b)
		{
			$highest_updates_month_b = ${'db_updates_b_' . $day_flag};
			$highest_updates_day_month_b = $day_flag;
			$highest_updates_date_month_b = "$month_b-$day_flag-$year_b";
		}
		if(${'db_deletes_b_' . $day_flag} >= $highest_deletes_month_b)
		{
			$highest_deletes_month_b = ${'db_deletes_b_' . $day_flag};
			$highest_deletes_day_month_b = $day_flag;
			$highest_deletes_date_month_b = "$month_b-$day_flag-$year_b";
		}
		if(${'db_seq_scans_b_' . $day_flag} >= $highest_seq_scans_month_b)
		{
			$highest_seq_scans_month_b = ${'db_seq_scans_b_' . $day_flag};
			$highest_seq_scans_day_month_b = $day_flag;
			$highest_seq_scans_date_month_b = "$month_b-$day_flag-$year_b";
		}
		if(${'db_idx_scans_b_' . $day_flag} >= $highest_idx_scans_month_b)
		{
			$highest_idx_scans_month_b = ${'db_idx_scans_b_' . $day_flag};
			$highest_idx_scans_day_month_b = $day_flag;
			$highest_idx_scans_date_month_b = "$month_b-$day_flag-$year_b";
		}
		if(${'db_seq_rows_b_' . $day_flag} >= $highest_seq_rows_month_b)
		{
			$highest_seq_rows_month_b = ${'db_seq_rows_b_' . $day_flag};
			$highest_seq_rows_day_month_b = $day_flag;
			$highest_seq_rows_date_month_b = "$month_b-$day_flag-$year_b";
		}
		if(${'db_idx_rows_b_' . $day_flag} >= $highest_idx_rows_month_b)
		{
			$highest_idx_rows_month_b = ${'db_idx_rows_b_' . $day_flag};
			$highest_idx_rows_day_month_b = $day_flag;
			$highest_idx_rows_date_month_b = "$month_b-$day_flag-$year_b";
		}
	}

	###############################
	#START-UP HTML RETURN TABLEWORK
	###############################
$stats = <<<AJR
<div class="stat_div_bg">
<div class="orange_13" style="font-weight:bold; margin:0 0 10px 0;">Target Statistics:</div>
<table class="table_chart">
<tr>
AJR;
	
	############################################################################
	#FIND OUT WHICH PEAK IS HIGHER - WE'LL USE THIS TO DETERMINE ALL BAR HEIGHTS
	############################################################################
	if(${'highest_' . $versus_chartting . '_month_a'} > ${'highest_' . $versus_chartting . '_month_b'}) $peak_db_day = ${'highest_' . $versus_chartting . '_month_a'};
	else $peak_db_day = ${'highest_' . $versus_chartting . '_month_b'};

	#############################################################################
	#PUT TOGETHER THE MONTH TABLEWORK - USING OUR BAR HEIGHT VARS AS GRAPH VALUES
	#############################################################################
	for($i=1; $i<32; $i++)
	{
		#####################
		#HANDLE LEADING ZEROS
		#####################
		if(strlen($i) == 1) $i = "0$i";

		##################################
		#PUT TOGETHER TOOLTIPS FOR MONTH A
		##################################
		if(!empty(${'db_commits_a_' . $i}))
		{
			$tt_commits_a = ${'db_commits_a_' . $i};
			if($tt_commits_a == 0 || empty($tt_commits_a)) $tt_commits_a = "0";
			else $tt_commits_a = number_format($tt_commits_a);
		}

		################################
		#PREP OUR ROLL BACKS TOOLTIP VAR
		################################
		if(!empty(${'db_rollbacks_a_' . $i}))
		{
			$tt_rollbacks_a = ${'db_rollbacks_a_' . $i};
			if($tt_rollbacks_a == 0 || empty($tt_rollbacks_a)) $tt_rollbacks_a = "0";
			else $tt_rollbacks_a = number_format($tt_rollbacks_a);
		}

		#################################
		#PREP OUR BLOCK READS TOOLTIP VAR
		#################################
		if(!empty(${'db_block_reads_a_' . $i}))
		{
			$tt_block_reads_a = ${'db_block_reads_a_' . $i};
			if($tt_block_reads_a == 0 || empty($tt_block_reads_a)) $tt_block_reads_a = "0";
			else $tt_block_reads_a = number_format($tt_block_reads_a);
		}

		#################################
		#PREP OUR BUFFER HITS TOOLTIP VAR
		#################################
		if(!empty(${'db_buffer_hits_a_' . $i}))
		{
			$tt_buffer_hits_a = ${'db_buffer_hits_a_' . $i};
			if($tt_buffer_hits_a == 0 || empty($tt_buffer_hits_a)) $tt_buffer_hits_a = "0";
			else $tt_buffer_hits_a = number_format($tt_buffer_hits_a);
		}

		############################
		#PREP OUR INSERT TOOLTIP VAR
		############################
		if(!empty(${'db_inserts_a_' . $i}))
		{
			$tt_inserts_a = ${'db_inserts_a_' . $i};
			if($tt_inserts_a == 0 || empty($tt_inserts_a)) $tt_inserts_a = "0";
			else $tt_inserts_a = number_format($tt_inserts_a);
		}

		############################
		#PREP OUR UPDATE TOOLTIP VAR
		############################
		if(!empty(${'db_updates_a_' . $i}))
		{		
			$tt_updates_a = ${'db_updates_a_' . $i};
			if($tt_updates_a == 0 || empty($tt_updates_a)) $tt_updates_a = "0";
			else $tt_updates_a = number_format($tt_updates_a);
		}

		############################
		#PREP OUR DELETE TOOLTIP VAR
		############################
		if(!empty(${'db_deletes_a_' . $i}))
		{
			$tt_deletes_a = ${'db_deletes_a_' . $i};
			if($tt_deletes_a == 0 || empty($tt_deletes_a)) $tt_deletes_a = "0";
			else $tt_deletes_a = number_format($tt_deletes_a);
		}

		##############################
		#PREP OUR SEQ SCAN TOOLTIP VAR
		##############################
		if(!empty(${'db_seq_scans_a_' . $i}))
		{
			$tt_seq_scans_a = ${'db_seq_scans_a_' . $i};
			if($tt_seq_scans_a == 0 || empty($tt_seq_scans_a)) $tt_seq_scans_a = "0";
			else $tt_seq_scans_a = number_format($tt_seq_scans_a);
		}

		##############################
		#PREP OUR IDX SCAN TOOLTIP VAR
		##############################
		if(!empty(${'db_idx_scans_a_' . $i}))
		{
			$tt_idx_scans_a = ${'db_idx_scans_a_' . $i};
			if($tt_idx_scans_a == 0 || empty($tt_idx_scans_a)) $tt_idx_scans_a = "0";
			else $tt_idx_scans_a = number_format($tt_idx_scans_a);
		}

		################
		#PUT IT TOGETHER
		################
		$tooltip_a = "<div style=line-height:17px;>";

		########
		#COMMITS
		########
		if($versus_chartting == "commits") $tooltip_a .= "<span class=orange_12><strong>Commits:&nbsp;" . $tt_commits_a . "</strong></span><br>";
		else $tooltip_a .= "Commits:&nbsp;<strong>" . $tt_commits_a . "</strong><br>";

		##########
		#ROLLBACKS
		##########
		if($versus_chartting == "rollbacks") $tooltip_a .= "<span class=orange_12><strong>Rollbacks:&nbsp;" . $tt_rollbacks_a . "</strong></span><br>";
		else $tooltip_a .= "Rollbacks:&nbsp;<strong>" . $tt_rollbacks_a . "</strong><br>";

		############
		#BLOCK READS
		############
		if($versus_chartting == "block_reads") $tooltip_a .= "<span class=orange_12><strong>Block&nbsp;Reads:&nbsp;" . $tt_block_reads_a . "</strong></span><br>";
		else $tooltip_a .= "Block&nbsp;Reads:&nbsp;<strong>" . $tt_block_reads_a . "</strong><br>";

		############
		#BUFFER HITS
		############
		if($versus_chartting == "buffer_hits") $tooltip_a .= "<span class=orange_12><strong>Buffer&nbsp;Hits:&nbsp;" . $tt_buffer_hits_a . "</strong></span><br>";
		else $tooltip_a .= "Buffer&nbsp;Hits:&nbsp;<strong>" . $tt_buffer_hits_a . "</strong><br>";

		########
		#INSERTS
		########
		if($versus_chartting == "inserts") $tooltip_a .= "<span class=orange_12><strong>Inserts:&nbsp;" . $tt_inserts_a . "</strong></span><br>";
		else $tooltip_a .= "Inserts:&nbsp;<strong>" . $tt_inserts_a . "</strong><br>";

		########
		#UPDATES
		########
		if($versus_chartting == "updates") $tooltip_a .= "<span class=orange_12><strong>Updates:&nbsp;" . $tt_updates_a . "</strong></span><br>";
		else $tooltip_a .= "Updates:&nbsp;<strong>" . $tt_updates_a . "</strong><br>";

		########
		#DELETES
		########
		if($versus_chartting == "deletes") $tooltip_a .= "<span class=orange_12><strong>Deletes:&nbsp;" . $tt_deletes_a . "</strong></span><br>";
		else $tooltip_a .= "Deletes:&nbsp;<strong>" . $tt_deletes_a . "</strong><br>";

		##########
		#SEQ SCANS
		##########
		if($versus_chartting == "seq_scans") $tooltip_a .= "<span class=orange_12><strong>Sequence&nbsp;Scans:&nbsp;" . $tt_seq_scans_a . "</strong></span><br>";
		else $tooltip_a .= "Sequence&nbsp;Scans:&nbsp;<strong>" . $tt_seq_scans_a . "</strong><br>";

		##########
		#IDX SCANS
		##########
		if($versus_chartting == "idx_scans") $tooltip_a .= "<span class=orange_12><strong>Index&nbsp;Scans:&nbsp;" . $tt_idx_scans_a . "</strong></span><br>";
		else $tooltip_a .= "Index&nbsp;Scans:&nbsp;<strong>" . $tt_idx_scans_a . "</strong><br>";

		#########################
		#COMPLETE THE TOOLTIP DIV
		#########################
		$tooltip_a .= "</div>";

		##################################
		#PUT TOGETHER TOOLTIPS FOR MONTH B
		##################################
		if(!empty(${'db_commits_b_' . $i}))
		{
			$tt_commits_b = ${'db_commits_b_' . $i};
			$db_stat_b = $tt_commits_b;
			if($tt_commits_b == 0 || empty($tt_commits_b)) $tt_commits_b = "0";
			else $tt_commits_b = number_format($tt_commits_b);
		}

		################################
		#PREP OUR ROLL BACKS TOOLTIP VAR
		################################
		if(!empty(${'db_rollbacks_b_' . $i}))
		{
			$tt_rollbacks_b = ${'db_rollbacks_b_' . $i};
			if($tt_rollbacks_b == 0 || empty($tt_rollbacks_b)) $tt_rollbacks_b = "0";
			else $tt_rollbacks_b = number_format($tt_rollbacks_b);
		}

		#################################
		#PREP OUR BLOCK READS TOOLTIP VAR
		#################################
		if(!empty(${'db_block_reads_b_' . $i}))
		{
			$tt_block_reads_b = ${'db_block_reads_b_' . $i};
			if($tt_block_reads_b == 0 || empty($tt_block_reads_b)) $tt_block_reads_b = "0";
			else $tt_block_reads_b = number_format($tt_block_reads_b);
		}

		#################################
		#PREP OUR BUFFER HITS TOOLTIP VAR
		#################################
		if(!empty(${'db_buffer_hits_b_' . $i}))
		{
			$tt_buffer_hits_b = ${'db_buffer_hits_b_' . $i};
			if($tt_buffer_hits_b == 0 || empty($tt_buffer_hits_b)) $tt_buffer_hits_b = "0";
			else $tt_buffer_hits_b = number_format($tt_buffer_hits_b);
		}

		############################
		#PREP OUR INSERT TOOLTIP VAR
		############################
		if(!empty(${'db_inserts_b_' . $i}))
		{
			$tt_inserts_b = ${'db_inserts_b_' . $i};
			if($tt_inserts_b == 0 || empty($tt_inserts_b)) $tt_inserts_b = "0";
			else $tt_inserts_b = number_format($tt_inserts_b);
		}

		############################
		#PREP OUR UPDATE TOOLTIP VAR
		############################
		if(!empty(${'db_updates_b_' . $i}))
		{
			$tt_updates_b = ${'db_updates_b_' . $i};
			if($tt_updates_b == 0 || empty($tt_updates_b)) $tt_updates_b = "0";
			else $tt_updates_b = number_format($tt_updates_b);
		}

		############################
		#PREP OUR DELETE TOOLTIP VAR
		############################
		if(!empty(${'db_deletes_b_' . $i}))
		{
			$tt_deletes_b = ${'db_deletes_b_' . $i};
			if($tt_deletes_b == 0 || empty($tt_deletes_b)) $tt_deletes_b = "0";
			else $tt_deletes_b = number_format($tt_deletes_b);
		}

		##############################
		#PREP OUR SEQ SCAN TOOLTIP VAR
		##############################
		if(!empty(${'db_seq_scans_b_' . $i}))
		{
			$tt_seq_scans_b = ${'db_seq_scans_b_' . $i};
			if($tt_seq_scans_b == 0 || empty($tt_seq_scans_b)) $tt_seq_scans_b = "0";
			else $tt_seq_scans_b = number_format($tt_seq_scans_b);
		}

		##############################
		#PREP OUR IDX SCAN TOOLTIP VAR
		##############################
		if(!empty(${'db_idx_scans_b_' . $i}))
		{
			$tt_idx_scans_b = ${'db_idx_scans_b_' . $i};
			if($tt_idx_scans_b == 0 || empty($tt_idx_scans_b)) $tt_idx_scans_b = "0";
			else $tt_idx_scans_b = number_format($tt_idx_scans_b);
		}

		################
		#PUT IT TOGETHER
		################
		$tooltip_b = "<div style=line-height:17px;>";

		########
		#COMMITS
		########
		if($versus_chartting == "commits") $tooltip_b .= "<span class=orange_12><strong>Commits:&nbsp;" . $tt_commits_b . "</strong></span><br>";
		else $tooltip_b .= "Commits:&nbsp;<strong>" . $tt_commits_b . "</strong><br>";

		##########
		#ROLLBACKS
		##########
		if($versus_chartting == "rollbacks") $tooltip_b .= "<span class=orange_12><strong>Rollbacks:&nbsp;" . $tt_rollbacks_b . "</strong></span><br>";
		else $tooltip_b .= "Rollbacks:&nbsp;<strong>" . $tt_rollbacks_b . "</strong><br>";

		############
		#BLOCK READS
		############
		if($versus_chartting == "block_reads") $tooltip_b .= "<span class=orange_12><strong>Block&nbsp;Reads:&nbsp;" . $tt_block_reads_b . "</strong></span><br>";
		else $tooltip_b .= "Block&nbsp;Reads:&nbsp;<strong>" . $tt_block_reads_b . "</strong><br>";

		############
		#BUFFER HITS
		############
		if($versus_chartting == "buffer_hits") $tooltip_b .= "<span class=orange_12><strong>Buffer&nbsp;Hits:&nbsp;" . $tt_buffer_hits_b . "</strong></span><br>";
		else $tooltip_b .= "Buffer&nbsp;Hits:&nbsp;<strong>" . $tt_buffer_hits_b . "</strong><br>";

		########
		#INSERTS
		########
		if($versus_chartting == "inserts") $tooltip_b .= "<span class=orange_12><strong>Inserts:&nbsp;" . $tt_inserts_b . "</strong></span><br>";
		else $tooltip_b .= "Inserts:&nbsp;<strong>" . $tt_inserts_b . "</strong><br>";

		########
		#UPDATES
		########
		if($versus_chartting == "updates") $tooltip_b .= "<span class=orange_12><strong>Updates:&nbsp;" . $tt_updates_b . "</strong></span><br>";
		else $tooltip_b .= "Updates:&nbsp;<strong>" . $tt_updates_b . "</strong><br>";

		########
		#DELETES
		########
		if($versus_chartting == "deletes") $tooltip_b .= "<span class=orange_12><strong>Deletes:&nbsp;" . $tt_deletes_b . "</strong></span><br>";
		else $tooltip_b .= "Deletes:&nbsp;<strong>" . $tt_deletes_b . "</strong><br>";

		##########
		#SEQ SCANS
		##########
		if($versus_chartting == "seq_scans") $tooltip_b .= "<span class=orange_12><strong>Sequence&nbsp;Scans:&nbsp;" . $tt_seq_scans_b . "</strong></span><br>";
		else $tooltip_b .= "Sequence&nbsp;Scans:&nbsp;<strong>" . $tt_seq_scans_b . "</strong><br>";

		##########
		#IDX SCANS
		##########
		if($versus_chartting == "idx_scans") $tooltip_b .= "<span class=orange_12><strong>Index&nbsp;Scans:&nbsp;" . $tt_idx_scans_b . "</strong></span><br>";
		else $tooltip_b .= "Index&nbsp;Scans:&nbsp;<strong>" . $tt_idx_scans_b . "</strong><br>";

		#########################
		#COMPLETE THE TOOLTIP DIV
		#########################
		$tooltip_b .= "</div>";

		#############################################################################################################
		#DETERMINE WHICH HIGHEST VAR IS HIGHER, A OR B. WE'LL USE THE HIGHEST TO DETERMINE ALL BAR HEIGHT PERCENTAGES
		#############################################################################################################
		if(${'highest_' . $versus_chartting . '_month_a'} > ${'highest_' . $versus_chartting . '_month_b'}) $peak_vs = 'a';
		else $peak_vs = 'b';
		
		####################################################
		#GET THE BAR PERCENT BASED ON WHICH STAT IS SELECTED
		####################################################
		if(!empty(${'highest_' . $versus_chartting . '_month_' . $peak_vs}) && !empty(${'db_' . $versus_chartting . '_a_' . $i})) { $stat_percent_a = ${'db_' . $versus_chartting . '_a_' . $i} / ${'highest_' . $versus_chartting . '_month_' . $peak_vs}; } else { $stat_percent_a = 0; }
		if(!empty(${'highest_' . $versus_chartting . '_month_' . $peak_vs}) && !empty(${'db_' . $versus_chartting . '_b_' . $i})) { $stat_percent_b = ${'db_' . $versus_chartting . '_b_' . $i} / ${'highest_' . $versus_chartting . '_month_' . $peak_vs}; } else { $stat_percent_b = 0; }

		$bar_height_percent_a = $stat_percent_a;
		$bar_height_percent_b = $stat_percent_b;

		$stat_percent_a = (number_format($stat_percent_a, 4, '.', '') * 100);
		$stat_percent_b = (number_format($stat_percent_b, 4, '.', '') * 100);
		
		#####################
		#CALCULATE BAR HEIGHT
		#####################
		$bar_height_final_a = $bar_height_vert * $bar_height_percent_a;
		$bar_height_final_b = $bar_height_vert * $bar_height_percent_b;

		$bar_height_a = number_format($bar_height_final_a, 0, '.', '');
		$bar_height_b = number_format($bar_height_final_b, 0, '.', '');
		
		############################
		#FORCE BAR HEIGHT - FOR SAFE
		############################
		if($bar_height_a > $bar_height_vert) $bar_height_a = $bar_height_vert;
		if($bar_height_b > $bar_height_vert) $bar_height_b = $bar_height_vert;

		#########################################################################################
		#CREATE THE ALT BAR (LIGHT GREY) WHICH WILL BE DISPLAYED ABOVE THE DARK GREY VERTICAL BAR
		#########################################################################################
		$bar_height_alt_a = $bar_height_vert - $bar_height_a;
		$bar_height_alt_b = $bar_height_vert - $bar_height_b;

		#####################################
		#PREP FINAL TABLE AND CELL WIDTH VARS
		#####################################
		$table_width_px = $table_width . "px";
		$bar_width_px = $bar_width . "px";

##################################
#PUT SOME MORE TABLE WORK TOGETHER
##################################
$stats .= <<<AJR
<td valign="bottom" style="text-align:center;">
<table style="width:$table_width_px;">
<tr>
<td>
<table align="left" style="width:$bar_width_px; border:1px solid $bar_border_color;">
AJR;

		#################################################
		#CHECK FOR THE ALT (NO DATA) TOP COLOR OF THE BAR
		#################################################
		$bar_height_alt_a_px = $bar_height_alt_a . "px";
		if($bar_height_alt_a > 0) $stats .= "<tr><td style=\"background-color:$bar_vert_alt_color; width:$bar_width_px; height:$bar_height_alt_a_px;\"></td></tr>";

		#################################
		#CHECK FOR THE BOTTOM 'A' BAR NOW
		#################################
		$bar_height_a_px = $bar_height_a . "px";
		if($bar_height_a > 0) $stats .= "<tr><td style=\"background-color:$bar_vert_color_a; width:$bar_width_px; height:$bar_height_a_px;\" onMouseOver=\"tooltip.show('$tooltip_a')\" onMouseOut='tooltip.hide()'></td></tr>";
		
		$stats .= "</table>";
		$stats .= "<table align=\"left\" style=\"width:$bar_width_px; border-color:$bar_border_color; border-width: 1px 1px 1px 0px; border-style: solid;\">";

		#################################################
		#CHECK FOR THE ALT (NO DATA) TOP COLOR OF THE BAR
		#################################################
		$bar_height_alt_b_px = $bar_height_alt_b . "px";
		if($bar_height_alt_b > 0) $stats .= "<tr><td style=\"background-color:$bar_vert_alt_color; width:$bar_width_px; height:$bar_height_alt_b_px;\"></td></tr>";

		#################################
		#CHECK FOR THE BOTTOM 'B' BAR NOW
		#################################
		$bar_height_b_px = $bar_height_b . "px";
		if($bar_height_b > 0) $stats .= "<tr><td style=\"background-color:$bar_vert_color_b; width:$bar_width_px; height:$bar_height_b_px;\" onMouseOver=\"tooltip.show('$tooltip_b')\" onMouseOut='tooltip.hide()'></td></tr>";

		$stats .= "</table>";

#####################################
#CONTINUE ON TO DAY LINK / TABLE WORK
#####################################
$stats .= <<<AJR
</td>
</tr>
<tr>
<td style="padding-top:3px;"><div class="grey_12" style="text-align:center;">
AJR;
		#############################
		#CONFIGURE DAILY STAT LINK-UP
		#############################
		$i_link = $i;

		if(isset(${'db_' . $versus_chartting . '_a_' . $i}))
		{
			if(${'db_' . $versus_chartting . '_a_' . $i} > 0)
			{
				###########################
				#MONTH A HAS VALUE - USE IT
				###########################
				$i_link = "<span onMouseOver=\"tooltip.show('Retrieve&nbsp;Stats')\" onMouseOut='tooltip.hide()'><a href=javascript:daily_retrieve('$month_a','$i','$year_a')>$i</a></span>";
			}
		}
		elseif(isset(${'db_' . $versus_chartting . '_b_' . $i}))
		{
			if(${'db_' . $versus_chartting . '_b_' . $i} > 0)
			{
				###########################
				#MONTH B HAS VALUE - USE IT
				###########################
				$i_link = "<span onMouseOver=\"tooltip.show('Retrieve&nbsp;Stats')\" onMouseOut='tooltip.hide()'><a href=javascript:daily_retrieve('$month_b','$i','$year_b')>$i</a></span>";
			}
		}
		else
		{
			######################
			#NO STATS FOR THIS DAY
			######################
			$i_link = $i;
		}

$stats .= <<<AJR
$i_link
</div></td>
</tr>
</table>
</td>
AJR;

	}

$stats .= <<<AJR
</tr>
<tr>
AJR;

	################################
	#COMPLETE OUR DYNAMIC TABLE WORK
	################################
	$stats .= "</table></div><br>";

	#################################################################
	#CAPS THE FIRST LETTER IN THE YEAR_CHARTTING VAR FOR A NICE TITLE
	#################################################################
	switch($versus_chartting)
	{
		case "commits"; $stat_title = "Commits"; break;
		case "rollbacks"; $stat_title = "Roll&nbsp;Backs"; break;
		case "block_reads"; $stat_title = "Block&nbsp;Reads"; break;
		case "buffer_hits"; $stat_title = "Buffer&nbsp;Hits"; break;
		case "inserts"; $stat_title = "Inserts"; break;
		case "updates"; $stat_title = "Updates"; break;
		case "deletes"; $stat_title = "Deletes"; break;
		case "seq_scans"; $stat_title = "SEQ&nbsp;Scans"; break;
		case "idx_scans"; $stat_title = "IDX&nbsp;Scans";
	}

	##############################################
	#DETERMINE RECAP STATS FOR THIS CHARTTING TYPE
	##############################################
	$recap_peak_a = number_format(${'highest_' . $versus_chartting . '_month_a'});
	$recap_total_a = number_format(${'total_' . $versus_chartting . '_month_a'});
	$recap_peak_b = number_format(${'highest_' . $versus_chartting . '_month_b'});
	$recap_total_b = number_format(${'total_' . $versus_chartting . '_month_b'});

	#########################
	#START HTML FOR RECAP DIV
	#########################
	$stats .= "<div class=\"stat_div_bg\" style=\"margin:0 0 20px 0;\">";

#######################
#BEGIN RECAP TABLE WORK
#######################
$stats .= <<<AJR
<div class="orange_13" style="font-weight:bold; margin:0 0 10px 0;">Versus Overview:</div>
<div class="black_12" style="padding:10px; float:left; border:1px solid $bar_border_color; background-color:#FFFFFF;"><span style="font-weight:bold;">$month_a_str&nbsp;$stat_title:</span>&nbsp;$recap_total_a</div>
AJR;

#########################
#RECAP PEAK DAY - MONTH A
#########################
$stats .= <<<AJR
<div class="black_12" style="margin-left:5px; padding:10px; float:left; border:1px solid $bar_border_color; background-color:#FFFFFF;"><span style="font-weight:bold;">Peak&nbsp;Day:</span> 
AJR;

	if($recap_peak_a > 0) $stats .= "$recap_peak_a";
	else $stats .= "N/A";

	####################################
	#SHOW THE PEAK DAY ONLY IF IT EXISTS
	####################################
	if(isset(${'highest_' . $versus_chartting . '_day_month_a'}) && isset(${'highest_' . $versus_chartting . '_date_month_a'}))
	{
		#########################
		#MAKE SURE IT HAS A VALUE
		#########################
		if(${'highest_' . $versus_chartting . '_month_a'} > 0)
		{
			$stats .= "&nbsp;<span class=\"orange_12\" onMouseOver=\"tooltip.show('Retrieve&nbsp;Stats')\" onMouseOut='tooltip.hide()'>(<a href=javascript:daily_retrieve('$month_a','${'highest_' . $versus_chartting . '_day_month_a'}','$year_a')>${'highest_' . $versus_chartting . '_date_month_a'}</a>)</span>";
		}
	}
	$stats .= "</div>";

$stats .= <<<AJR
<div class="black_12" style="margin-left:5px; padding:10px; float:left; border:1px solid $bar_border_color; background-color:#FFFFFF;"><span style="font-weight:bold;">$month_b_str&nbsp;$stat_title:</span>&nbsp;$recap_total_b</div>
AJR;

#########################
#RECAP PEAK DAY - MONTH B
#########################
$stats .= <<<AJR
<div class="black_12" style="margin-left:5px; padding:10px; float:left; border:1px solid $bar_border_color; background-color:#FFFFFF;"><span style="font-weight:bold;">Peak&nbsp;Day:</span> 
AJR;

	if($recap_peak_b > 0) $stats .= "$recap_peak_b";
	else $stats .= "N/A";

	####################################
	#SHOW THE PEAK DAY ONLY IF IT EXISTS
	####################################
	if(isset(${'highest_' . $versus_chartting . '_day_month_b'}) && isset(${'highest_' . $versus_chartting . '_date_month_b'}))
	{
		#########################
		#MAKE SURE IT HAS A VALUE
		#########################
		if(${'highest_' . $versus_chartting . '_month_b'} > 0)
		{
			$stats .= "&nbsp;<span class=\"orange_12\" onMouseOver=\"tooltip.show('Retrieve&nbsp;Stats')\" onMouseOut='tooltip.hide()'>(<a href=javascript:daily_retrieve('$month_b','${'highest_' . $versus_chartting . '_day_month_b'}','$year_b')>${'highest_' . $versus_chartting . '_date_month_b'}</a>)</span>";
		}
	}
	$stats .= "</div>";

	############
	#CLAR FLOATS
	############
	$stats .= "<div style=\"clear:both;\"></div>";

	##########################
	#END OF OF RECAP STATS DIV
	##########################
	$stats .= "</div>";

	#################################
	#CONFIGURE OUR PEAK STATS / LINKS
	#################################
	$stat_type_array = array('commits','rollbacks','block_reads','buffer_hits','inserts','updates','deletes','seq_scans','seq_rows','idx_scans','idx_rows');

	####################
	#START OUR ITERATION
	####################
	foreach($stat_type_array as &$stat)
	{
		if(${'highest_' . $stat . '_month_a'} == 0 && ${'highest_' . $stat . '_month_b'} == 0)
		{
			${'peak_' . $stat} = "N/A";
			${'peak_' . $stat . '_day'} = "N/A";
		}
		elseif(${'highest_' . $stat . '_month_a'} >= ${'highest_' . $stat . '_month_b'})
		{
			${'highest_' . $stat . '_month_a'} = number_format(${'highest_' . $stat . '_month_a'});
			${'peak_' . $stat} = ${'highest_' . $stat . '_month_a'};
			${'peak_' . $stat . '_day'} = "<span class=\"orange_12\"><span onMouseOver=\"tooltip.show('Retrieve&nbsp;Stats')\" onMouseOut='tooltip.hide()'><a href=javascript:daily_retrieve('$month_a','${'highest_' . $stat . '_day_month_a'}','$year_a')>${'highest_' . $stat . '_date_month_a'}</a></span></span>";
		}
		elseif(${'highest_' . $stat . '_month_a'} < ${'highest_' . $stat . '_month_b'})
		{
			${'highest_' . $stat . '_month_b'} = number_format(${'highest_' . $stat . '_month_b'});
			${'peak_' . $stat} = ${'highest_' . $stat . '_month_b'};
			${'peak_' . $stat . '_day'} = "<span class=\"orange_12\"><span onMouseOver=\"tooltip.show('Retrieve&nbsp;Stats')\" onMouseOut='tooltip.hide()'><a href=javascript:daily_retrieve('$month_b','${'highest_' . $stat . '_day_month_b'}','$year_b')>${'highest_' . $stat . '_date_month_b'}</a></span></span>";
		}
	}

	#######################################
	#PUT TOGETHER SOME COMBINED STATS FIRST
	#######################################	
	$combined_commits = number_format($total_commits_month_a + $total_commits_month_b);
	$combined_peaks = number_format($highest_commits_month_a + $highest_commits_month_b);
	$combined_rollbacks = number_format($total_rollbacks_month_a + $total_rollbacks_month_b);
	$combined_block_reads = number_format($total_block_reads_month_a + $total_block_reads_month_b);
	$combined_buffer_hits = number_format($total_buffer_hits_month_a + $total_buffer_hits_month_b);
	$combined_inserts = number_format($total_inserts_month_a + $total_inserts_month_b);
	$combined_updates = number_format($total_updates_month_a + $total_updates_month_b);
	$combined_deletes = number_format($total_deletes_month_a + $total_deletes_month_b);
	$combined_seq_scans = number_format($total_seq_scans_month_a + $total_seq_scans_month_b);
	$combined_seq_rows = number_format($total_seq_rows_month_a + $total_seq_rows_month_b);
	$combined_idx_scans = number_format($total_idx_scans_month_a + $total_idx_scans_month_b);
	$combined_idx_rows = number_format($total_idx_rows_month_a + $total_idx_rows_month_b);

	######################
	#FORMAT MONTH A TOTALS
	######################
	$total_commits_month_a = number_format($total_commits_month_a);
	$total_rollbacks_month_a = number_format($total_rollbacks_month_a);
	$total_block_reads_month_a = number_format($total_block_reads_month_a);
	$total_buffer_hits_month_a = number_format($total_buffer_hits_month_a);
	$total_inserts_month_a = number_format($total_inserts_month_a);
	$total_updates_month_a = number_format($total_updates_month_a);
	$total_deletes_month_a = number_format($total_deletes_month_a);
	$total_seq_scans_month_a = number_format($total_seq_scans_month_a);
	$total_seq_rows_month_a = number_format($total_seq_rows_month_a);
	$total_idx_scans_month_a = number_format($total_idx_scans_month_a);
	$total_idx_rows_month_a = number_format($total_idx_rows_month_a);

	######################
	#FORMAT MONTH B TOTALS
	######################
	$total_commits_month_b = number_format($total_commits_month_b);
	$total_rollbacks_month_b = number_format($total_rollbacks_month_b);
	$total_block_reads_month_b = number_format($total_block_reads_month_b);
	$total_buffer_hits_month_b = number_format($total_buffer_hits_month_b);
	$total_inserts_month_b = number_format($total_inserts_month_b);
	$total_updates_month_b = number_format($total_updates_month_b);
	$total_deletes_month_b = number_format($total_deletes_month_b);
	$total_seq_scans_month_b = number_format($total_seq_scans_month_b);
	$total_seq_rows_month_b = number_format($total_seq_rows_month_b);
	$total_idx_scans_month_b = number_format($total_idx_scans_month_b);
	$total_idx_rows_month_b = number_format($total_idx_rows_month_b);

	#########################################
	#START UP THE BOTTOM HALF OF OUR VS STATS
	#########################################

$stats .= <<<AJR
<div class="stat_div_bg">
<div class="orange_13" style="font-weight:bold; margin:0 0 10px 0;">Core Statistics:</div>
<table style="width:100%">
<tr>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Statistic</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">$month_a_str_ext</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">$month_b_str_ext</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Combined</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Peak&nbsp;Stat</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Peak&nbsp;Day</td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">Commits:</td>
<td>$total_commits_month_a</td>
<td>$total_commits_month_b</td>
<td>$combined_commits</td>
<td>$peak_commits</td>
<td>$peak_commits_day</td>
</tr>
<tr>
<td colspan="6" style="height:30px;"><hr size="1"/></td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">Rollbacks:</td>
<td>$total_rollbacks_month_a</td>
<td>$total_rollbacks_month_b</td>
<td>$combined_rollbacks</td>
<td>$peak_rollbacks</td>
<td>$peak_rollbacks_day</td>
</tr>
<tr>
<td colspan="6" style="height:30px;"><hr size="1"/></td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">Block&nbsp;Reads:</td>
<td>$total_block_reads_month_a</td>
<td>$total_block_reads_month_b</td>
<td>$combined_block_reads</td>
<td>$peak_block_reads</td>
<td>$peak_block_reads_day</td>
</tr>
<tr>
<td colspan="6" style="height:30px;"><hr size="1"/></td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">Buffer&nbsp;Hits:</td>
<td>$total_buffer_hits_month_a</td>
<td>$total_buffer_hits_month_b</td>
<td>$combined_buffer_hits</td>
<td>$peak_buffer_hits</td>
<td>$peak_buffer_hits_day</td>
</tr>
<tr>
<td colspan="6" style="height:30px;"><hr size="1"/></td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">User&nbsp;Inserts:</td>
<td>$total_inserts_month_a</td>
<td>$total_inserts_month_b</td>
<td>$combined_inserts</td>
<td>$peak_inserts</td>
<td>$peak_inserts_day</td>
</tr>
<tr>
<td colspan="6" style="height:30px;"><hr size="1"/></td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">User&nbsp;Updates:</td>
<td>$total_updates_month_a</td>
<td>$total_updates_month_b</td>
<td>$combined_updates</td>
<td>$peak_updates</td>
<td>$peak_updates_day</td>
</tr>
<tr>
<td colspan="6" style="height:30px;"><hr size="1"/></td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">User&nbsp;Deletes:</td>
<td>$total_deletes_month_a</td>
<td>$total_deletes_month_b</td>
<td>$combined_deletes</td>
<td>$peak_deletes</td>
<td>$peak_deletes_day</td>
</tr>
<tr>
<td colspan="6" style="height:30px;"><hr size="1"/></td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">SEQ&nbsp;Scans:</td>
<td>$total_seq_scans_month_a</td>
<td>$total_seq_scans_month_b</td>
<td>$combined_seq_scans</td>
<td>$peak_seq_scans</td>
<td>$peak_seq_scans_day</td>
</tr>
<tr>
<td class="grey_12" style="padding-right:10px;">Rows&nbsp;Used:</td>
<td>$total_seq_rows_month_a</td>
<td>$total_seq_rows_month_b</td>
<td>$combined_seq_rows</td>
<td>$peak_seq_rows</td>
<td>$peak_seq_rows_day</td>
</tr>
<tr>
<td colspan="6" style="height:30px;"><hr size="1"/></td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">IDX&nbsp;Scans:</td>
<td>$total_idx_scans_month_a</td>
<td>$total_idx_scans_month_b</td>
<td>$combined_idx_scans</td>
<td>$peak_idx_scans</td>
<td>$peak_idx_scans_day</td>
</tr>
<tr>
<td class="grey_12" style="padding-right:10px;">Rows&nbsp;Used:</td>
<td>$total_idx_rows_month_a</td>
<td>$total_idx_rows_month_b</td>
<td>$combined_idx_rows</td>
<td>$peak_idx_rows</td>
<td>$peak_idx_rows_day</td>
</tr>
</table>
</div>
AJR;

	#############################
	#GET TOTAL SCRIPT PEAK MEMORY
	#############################
	$script_mem = number_format(((memory_get_peak_usage(true)/1024)/1024),3) . "M";

	######################
	#PREP ARRAY FOR RETURN
	######################
	$ajax_return[0] = 1;
	$ajax_return[] = $stats;
	$ajax_return[] = $script_mem;
	$ajax_return = json_encode($ajax_return);

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: WEEKLY_RETRIEVE_NAV_DBS
##########################################################################################################
##########################################################################################################
function weekly_retrieve_nav_dbs($server_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	####################################
	#CREATE RETURN ARRAY FOR JSON VALUES
	####################################
	$ajax_return = array();

	################################
	#DEFAULT SUCCESS VALUE AS FAILED
	################################
	$ajax_return[] = 2;

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");

	#############
	#MAKE CERTAIN
	#############
	if(!$pg_conn)
	{
		$ajax_return[] = "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	##########################################################################
	#RETRIEVE OUR DB LIST - IF SERVER_ID IS EMPTY, GET ALL DBS FOR ALL SERVERS
	##########################################################################
	if($server_id == 0 || empty($server_id) or $server_id == "0" || !is_numeric($server_id))
	{
		#########
		#DB QUERY
		#########
		$sqlselect_dbs = @pg_query($pg_conn, "SELECT db_id,db_name FROM ps_db_tbl WHERE (SELECT COUNT(db_id) FROM ps_core_tbl WHERE ps_db_tbl.db_id = ps_core_tbl.db_id) > 0 ORDER BY db_name ASC");

		############
		#MONTH QUERY
		############
		$sqlselect_months = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(MONTH FROM recorded) AS month FROM ps_core_tbl ORDER BY month ASC");
		
		###########
		#YEAR QUERY
		###########
		$sqlselect_years = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(YEAR FROM recorded) AS year FROM ps_core_tbl ORDER BY year DESC");
	}
	else
	{
		#############################
		#GRAB DBS FOR SELECTED SERVER
		#############################
		$sqlselect_dbs = @pg_query($pg_conn, "SELECT db_id,db_name FROM ps_db_tbl WHERE server_id = $server_id AND (SELECT COUNT(db_id) FROM ps_core_tbl WHERE ps_db_tbl.db_id = ps_core_tbl.db_id AND server_id = $server_id) > 0 ORDER BY db_name ASC");

		################################
		#MONTH QUERY FOR SELECTED SERVER
		################################
		$sqlselect_months = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(MONTH FROM recorded) AS month FROM ps_core_tbl WHERE server_id = $server_id ORDER BY month ASC");

		###############################
		#YEAR QUERY FOR SELECTED SERVER
		###############################
		$sqlselect_years = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(YEAR FROM recorded) AS year FROM ps_core_tbl WHERE server_id = $server_id ORDER BY year DESC");
	}

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlselect_dbs || !$sqlselect_months || !$sqlselect_years)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	############################
	#CREATE OUR DB LIST DROPDOWN
	############################
	$db_list  = "<select class=\"select_menu\" name=\"weekly_dbs\" id=\"weekly_dbs\" onChange=\"weekly_select_nav_db()\">";
	$db_list .= "<option value=\"0\">All Databases</option>";

	#######################
	#ITERATE THROUGH VALUES
	#######################
	while($query_data_dbs = pg_fetch_row($sqlselect_dbs))
	{
		$db_id = $query_data_dbs[0];
		$db_name = $query_data_dbs[1];
		$db_list .= "<option value=\"$db_id\">$db_name</option>";
	}
	$db_list .= "</select>";

	#####################
	#START THE MONTH LIST
	#####################
	$month_list = "<select class=\"select_menu\" name=\"weekly_month\" id=\"weekly_month\">";

	######################################
	#ADD ALL-MONTHS OPTION FOR WEEKLY VIEW
	######################################
	$month_list .= "<option value=\"0\" selected=\"selected\">All Months</option>";

	####################
	#START OUR ITERATION
	####################
	while($query_data_months = pg_fetch_row($sqlselect_months))
	{
		################################################################
		#EXTRACT MONTH - HANDLE LEADING ZEROS - AND GET FRIENDLY VERSION
		################################################################
		$month = $query_data_months[0];
		if(strlen($month) == 1) $month = "0$month";
		$month_friendly = date_get_friendly_month($month);
		$month_list .= "<option value=\"$month\">$month_friendly</option>";
	}
	$month_list .= "</select>";

	###############################
	#CURRENT YEAR FOR PRE-SELECTION
	###############################
	$current_year = date('Y');

	####################
	#START THE YEAR LIST
	####################
	$year_list = "<select class=\"select_menu\" name=\"weekly_year\" id=\"weekly_year\">";
	while($query_data_years = pg_fetch_row($sqlselect_years))
	{
		$year = $query_data_years[0];
		if($year == $current_year) { $selected = "selected=\"selected\""; } else { $selected = ""; }
		$year_list .= "<option value=\"$year\" $selected>$year</option>";
	}
	$year_list .= "</select>";

	######################
	#PREP ARRAY FOR RETURN
	######################
	$ajax_return[0] = 1;
	$ajax_return[] = $db_list;
	$ajax_return[] = $month_list;
	$ajax_return[] = $year_list;
	$ajax_return = json_encode($ajax_return);

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: WEEKLY_SELECT_NAV_DB
##########################################################################################################
##########################################################################################################
function weekly_select_nav_db($server_id,$db_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	####################################
	#CREATE RETURN ARRAY FOR JSON VALUES
	####################################
	$ajax_return = array();

	################################
	#DEFAULT SUCCESS VALUE AS FAILED
	################################
	$ajax_return[] = 2;

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");

	#############
	#MAKE CERTAIN
	#############
	if(!$pg_conn)
	{
		$ajax_return[] = "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	############################################################
	#IF NO DB_ID WAS PASSED, GET MONTH / YEAR VALUES FOR ALL DBS
	############################################################
	if($db_id == 0 || empty($db_id) or $db_id == "0" || !is_numeric($db_id))
	{
		################
		#THE MONTH QUERY
		################
		$sqlselect_months = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(MONTH FROM recorded) AS month FROM ps_core_tbl WHERE server_id = $server_id ORDER BY month ASC");

		###############
		#THE YEAR QUERY
		###############
		$sqlselect_years = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(YEAR FROM recorded) AS year FROM ps_core_tbl WHERE server_id = $server_id ORDER BY year DESC");
	}
	else
	{
		################
		#THE MONTH QUERY
		################
		$sqlselect_months = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(MONTH FROM recorded) AS month FROM ps_core_tbl WHERE server_id = $server_id AND db_id = $db_id ORDER BY month ASC");

		###############
		#THE YEAR QUERY
		###############
		$sqlselect_years = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(YEAR FROM recorded) AS year FROM ps_core_tbl WHERE server_id = $server_id AND db_id = $db_id ORDER BY year DESC");
	}

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlselect_months || !$sqlselect_years)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	#####################
	#START THE MONTH LIST
	#####################
	$month_list  = "<select class=\"select_menu\" name=\"weekly_month\" id=\"weekly_month\">";

	######################################
	#ADD ALL-MONTHS OPTION FOR WEEKLY VIEW
	######################################
	$month_list .= "<option value=\"0\" selected=\"selected\">All Months</option>";

	####################
	#START OUR ITERATION
	####################
	while($query_data_months = pg_fetch_row($sqlselect_months))
	{
		################################################################
		#EXTRACT MONTH - HANDLE LEADING ZEROS - AND GET FRIENDLY VERSION
		################################################################
		$month = $query_data_months[0];
		if(strlen($month) == 1) $month = "0$month";
		$month_friendly = date_get_friendly_month($month);
		$month_list .= "<option value=\"$month\">$month_friendly</option>";
	}
	$month_list .= "</select>";

	###############################
	#CURRENT YEAR FOR PRE-SELECTION
	###############################
	$current_year = date('Y');

	####################
	#START THE YEAR LIST
	####################
	$year_list  = "<select class=\"select_menu\" name=\"weekly_year\" id=\"weekly_year\">";
	while($query_data_years = pg_fetch_row($sqlselect_years))
	{
		$year = $query_data_years[0];
		if($year == $current_year) { $selected = "selected=\"selected\""; } else { $selected = ""; }
		$year_list .= "<option value=\"$year\" $selected>$year</option>";
	}
	$year_list .= "</select>";

	######################
	#PREP ARRAY FOR RETURN
	######################
	$ajax_return[0] = 1;
	$ajax_return[] = $month_list;
	$ajax_return[] = $year_list;
	$ajax_return = json_encode($ajax_return);

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: WEEKLY_RETRIEVE
##########################################################################################################
##########################################################################################################
function weekly_retrieve($servers,$dbs,$month,$year,$weekly_chartting,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	####################################
	#CREATE RETURN ARRAY FOR JSON VALUES
	####################################
	$ajax_return = array();

	################################
	#DEFAULT SUCCESS VALUE AS FAILED
	################################
	$ajax_return[] = 2;

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");

	#############
	#MAKE CERTAIN
	#############
	if(!$pg_conn)
	{
		$ajax_return[] = "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	#######################
	#VALIDATE CHARTTING VAR
	#######################
	if($weekly_chartting != "commits" && $weekly_chartting != "rollbacks" && $weekly_chartting != "block_reads" && $weekly_chartting != "buffer_hits" && $weekly_chartting != "inserts" && $weekly_chartting != "updates" && $weekly_chartting != "deletes" && $weekly_chartting != "seq_scans" && $weekly_chartting != "idx_scans")
	{
		###########################################
		#DEFAULT THE CHART TO SHOWING COMMIT VALUES
		###########################################
		$weekly_chartting = "commits";
	}

	###########################
	#INITIATE SOME GENERAL VARS
	###########################
	$bar_height_vert = 150;
	$bar_width = 25;
	$prev_day_flag = "";
	$peak_stat = 0;
	$peak_day = "";

	##########################
	#FOR TRACKING DAYS STATTED
	##########################
	$total_days_tracked = 0;
	$total_days_tracked_sun = 0;
	$total_days_tracked_mon = 0;
	$total_days_tracked_tue = 0;
	$total_days_tracked_wed = 0;
	$total_days_tracked_thu = 0;
	$total_days_tracked_fri = 0;
	$total_days_tracked_sat = 0;

	###########################################
	#VARS WHICH WILL HOUSE TOTALS FOR ALL STATS
	###########################################
	$total_commits = 0;
	$total_rollbacks = 0;
	$total_block_reads = 0;
	$total_buffer_hits = 0;
	$total_inserts = 0;
	$total_updates = 0;
	$total_deletes = 0;
	$total_seq_scans = 0;
	$total_idx_scans = 0;
	$total_seq_rows = 0;
	$total_idx_rows = 0;

	################################################
	#VARS WHICH WILL TRACK THE HIGHEST STAT PER TYPE
	################################################
	$highest_commits = 0;
	$highest_rollbacks = 0;
	$highest_block_reads = 0;
	$highest_buffer_hits = 0;
	$highest_inserts = 0;
	$highest_updates = 0;
	$highest_deletes = 0;
	$highest_seq_scans = 0;
	$highest_idx_scans = 0;
	$highest_seq_rows = 0;
	$highest_idx_rows = 0;

	######################################################################
	#VARS WHICH WILL HOUSE THE TOTAL AND HIGHEST STATS PER DAY OF THE WEEK
	######################################################################
	$day_array = array("sun","mon","tue","wed","thu","fri","sat");

	#####################
	#GET THROUGH THEM NOW
	#####################
	foreach($day_array as &$day)
	{
		${'total_commits_' . $day} = 0;
		${'total_rollbacks_' . $day} = 0;
		${'total_block_reads_' . $day} = 0;
		${'total_buffer_hits_' . $day} = 0;
		${'total_inserts_' . $day} = 0;
		${'total_updates_' . $day} = 0;
		${'total_deletes_' . $day} = 0;
		${'total_seq_scans_' . $day} = 0;
		${'total_seq_rows_' . $day} = 0;
		${'total_idx_scans_' . $day} = 0;
		${'total_idx_rows_' . $day} = 0;
		${'highest_commits_' . $day} = 0;
		${'highest_rollbacks_' . $day} = 0;
		${'highest_block_reads_' . $day} = 0;
		${'highest_buffer_hits_' . $day} = 0;
		${'highest_inserts_' . $day} = 0;
		${'highest_updates_' . $day} = 0;
		${'highest_deletes_' . $day} = 0;
		${'highest_seq_scans_' . $day} = 0;
		${'highest_seq_rows_' . $day} = 0;
		${'highest_idx_scans_' . $day} = 0;
		${'highest_idx_rows_' . $day} = 0;
	}

	#####################
	#BAR CHART COLOR VARS
	#####################
	$bar_vert_alt_color = "#FFFFFF";
	$bar_vert_peak_color = "#FF6633";
	$bar_vert_color = "#7B7B7B";
	$bar_border_color = "#C9C9C9";

	#########
	#IUD VARS
	#########
	$iud_insert_color = "#7B7B7B";
	$iud_update_color = "#C8C8C8";
	$iud_delete_color = "#FFFFFF";
	$iud_nodata_color = "#000000";
	$iud_bar_width = 905;
	$iud_bar_height = 20;

	################################
	#VALIDATE OUR SERVER AND DB VARS
	################################
	if(empty($servers) || !is_numeric($servers)) $servers = 0;
	if(empty($dbs) || !is_numeric($dbs)) $dbs = 0;

	##############################################
	#HANDLE THE ALL-MONTHS LIST OPTION ACCORDINGLY
	##############################################
	if(empty($month) || !is_numeric($month))
	{
		###################################
		#CONSTRUCT THE QUERY FOR ALL MONTHS
		###################################
		$stat_query  = "SELECT *,EXTRACT(dow FROM recorded) FROM ps_core_tbl ";
		$stat_query .= "WHERE EXTRACT(YEAR FROM recorded) = $year ";
		if($servers != 0) { $stat_query .= "AND server_id = $servers "; }
		if($dbs != 0) { $stat_query .= "AND db_id = $dbs "; }
		$stat_query .= "ORDER BY recorded ASC";	
	}
	else
	{
		#######################################
		#CONSTRUCT THE QUERY FOR SELECTED MONTH
		#######################################
		$stat_query  = "SELECT *,EXTRACT(dow FROM recorded) FROM ps_core_tbl ";
		$stat_query .= "WHERE EXTRACT(MONTH FROM recorded) = $month AND EXTRACT(YEAR FROM recorded) = $year ";
		if($servers != 0) { $stat_query .= "AND server_id = $servers "; }
		if($dbs != 0) { $stat_query .= "AND db_id = $dbs "; }
		$stat_query .= "ORDER BY recorded ASC";
	}

	#######
	#RUN IT
	#######
	$sqlselect_stats = @pg_query($pg_conn, $stat_query);

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlselect_stats)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	###########################
	#IF THERE ARE NO STATISTICS
	###########################
	if(pg_num_rows($sqlselect_stats) == 0)
	{
		$ajax_return[0] = 1;
		$ajax_return[] = "There are no statistics recorded for the above selections.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;	
	}

	####################
	#START OUR ITERATION
	####################
	while($query_data_stats = pg_fetch_row($sqlselect_stats))
	{
		###############
		#GRAB CORE DATA
		###############
		$ps_core_id = $query_data_stats[0];
		$db_id = $query_data_stats[1];
		$server_id = $query_data_stats[2];
		$recorded = $query_data_stats[3];
		$datid = $query_data_stats[4];
		$datname = $query_data_stats[5];
		$core_commits = $query_data_stats[6];
		$core_rollbacks = $query_data_stats[7];
		$core_block_reads = $query_data_stats[8];
		$core_buffer_hits = $query_data_stats[9];
		$user_inserts = $query_data_stats[10];
		$user_updates = $query_data_stats[11];
		$user_deletes = $query_data_stats[12];
		$user_seq_scans = $query_data_stats[13];
		$user_idx_scans = $query_data_stats[14];
		$user_seq_rows = $query_data_stats[15];
		$user_idx_rows = $query_data_stats[16];
		$day_flag = $query_data_stats[17];

		#####################
		#TALL UP TRACKED DAYS
		#####################
		if($day_flag != $prev_day_flag)
		{
			$total_days_tracked++;

			switch($day_flag)
			{
				case "0": #Sun
				$total_days_tracked_sun++;
				break;

				case "1": #Mon
				$total_days_tracked_mon++;
				break;

				case "2": #Tue
				$total_days_tracked_tue++;
				break;

				case "3": #Wed
				$total_days_tracked_wed++;
				break;

				case "4": #Thu
				$total_days_tracked_thu++;
				break;

				case "5": #Fri
				$total_days_tracked_fri++;
				break;

				case "6": #Sat
				$total_days_tracked_sat++;
			}
		}

		#####################
		#UPDATE PREV DAY FLAG
		#####################
		$prev_day_flag = $day_flag;

		################
		#TALLY UP TOTALS
		################
		$total_commits += $core_commits;
		$total_rollbacks += $core_rollbacks;
		$total_block_reads += $core_block_reads;
		$total_buffer_hits += $core_buffer_hits;
		$total_inserts += $user_inserts;
		$total_updates += $user_updates;
		$total_deletes += $user_deletes;
		$total_seq_scans += $user_seq_scans;
		$total_idx_scans += $user_idx_scans;
		$total_seq_rows += $user_seq_rows;
		$total_idx_rows += $user_idx_rows;

		#############################################################################
		#TALL UP THE DAYS TRACKED, TOTAL COMMIT, INSERTS, UPDATES AND DELETES PER DAY
		#############################################################################
		switch($day_flag)
		{
			case "0": #Sun
			$total_commits_sun += $core_commits;
			$total_rollbacks_sun += $core_rollbacks;
			$total_block_reads_sun += $core_block_reads;
			$total_buffer_hits_sun += $core_buffer_hits;
			$total_inserts_sun += $user_inserts;
			$total_updates_sun += $user_updates;
			$total_deletes_sun += $user_deletes;
			$total_seq_scans_sun += $user_seq_scans;
			$total_idx_scans_sun += $user_idx_scans;
			$total_seq_rows_sun += $user_seq_rows;
			$total_idx_rows_sun += $user_idx_rows;
			break;

			case "1": #Mon
			$total_commits_mon += $core_commits;
			$total_rollbacks_mon += $core_rollbacks;
			$total_block_reads_mon += $core_block_reads;
			$total_buffer_hits_mon += $core_buffer_hits;
			$total_inserts_mon += $user_inserts;
			$total_updates_mon += $user_updates;
			$total_deletes_mon += $user_deletes;
			$total_seq_scans_mon += $user_seq_scans;
			$total_idx_scans_mon += $user_idx_scans;
			$total_seq_rows_mon += $user_seq_rows;
			$total_idx_rows_mon += $user_idx_rows;
			break;

			case "2": #Tue
			$total_commits_tue += $core_commits;
			$total_rollbacks_tue += $core_rollbacks;
			$total_block_reads_tue += $core_block_reads;
			$total_buffer_hits_tue += $core_buffer_hits;
			$total_inserts_tue += $user_inserts;
			$total_updates_tue += $user_updates;
			$total_deletes_tue += $user_deletes;
			$total_seq_scans_tue += $user_seq_scans;
			$total_idx_scans_tue += $user_idx_scans;
			$total_seq_rows_tue += $user_seq_rows;
			$total_idx_rows_tue += $user_idx_rows;
			break;

			case "3": #Wed
			$total_commits_wed += $core_commits;
			$total_rollbacks_wed += $core_rollbacks;
			$total_block_reads_wed += $core_block_reads;
			$total_buffer_hits_wed += $core_buffer_hits;
			$total_inserts_wed += $user_inserts;
			$total_updates_wed += $user_updates;
			$total_deletes_wed += $user_deletes;
			$total_seq_scans_wed += $user_seq_scans;
			$total_idx_scans_wed += $user_idx_scans;
			$total_seq_rows_wed += $user_seq_rows;
			$total_idx_rows_wed += $user_idx_rows;
			break;

			case "4": #Thu
			$total_commits_thu += $core_commits;
			$total_rollbacks_thu += $core_rollbacks;
			$total_block_reads_thu += $core_block_reads;
			$total_buffer_hits_thu += $core_buffer_hits;
			$total_inserts_thu += $user_inserts;
			$total_updates_thu += $user_updates;
			$total_deletes_thu += $user_deletes;
			$total_seq_scans_thu += $user_seq_scans;
			$total_idx_scans_thu += $user_idx_scans;
			$total_seq_rows_thu += $user_seq_rows;
			$total_idx_rows_thu += $user_idx_rows;
			break;

			case "5": #Fri
			$total_commits_fri += $core_commits;
			$total_rollbacks_fri += $core_rollbacks;
			$total_block_reads_fri += $core_block_reads;
			$total_buffer_hits_fri += $core_buffer_hits;
			$total_inserts_fri += $user_inserts;
			$total_updates_fri += $user_updates;
			$total_deletes_fri += $user_deletes;
			$total_seq_scans_fri += $user_seq_scans;
			$total_idx_scans_fri += $user_idx_scans;
			$total_seq_rows_fri += $user_seq_rows;
			$total_idx_rows_fri += $user_idx_rows;
			break;

			case "6": #Sat
			$total_commits_sat += $core_commits;
			$total_rollbacks_sat += $core_rollbacks;
			$total_block_reads_sat += $core_block_reads;
			$total_buffer_hits_sat += $core_buffer_hits;
			$total_inserts_sat += $user_inserts;
			$total_updates_sat += $user_updates;
			$total_deletes_sat += $user_deletes;
			$total_seq_scans_sat += $user_seq_scans;
			$total_idx_scans_sat += $user_idx_scans;
			$total_seq_rows_sat += $user_seq_rows;
			$total_idx_rows_sat += $user_idx_rows;
		}

		##########################
		#TALLY UP OUR HIGHEST VARS
		##########################
		if($core_commits > $highest_commits) $highest_commits = $core_commits;
		if($core_rollbacks > $highest_rollbacks) $highest_rollbacks = $core_rollbacks;
		if($core_block_reads > $highest_block_reads) $highest_block_reads = $core_block_reads;
		if($core_buffer_hits > $highest_buffer_hits) $highest_buffer_hits = $core_buffer_hits;
		if($user_inserts > $highest_inserts) $highest_inserts = $user_inserts;
		if($user_updates > $highest_updates) $highest_updates = $user_updates;
		if($user_deletes > $highest_deletes) $highest_deletes = $user_deletes;
		if($user_seq_scans > $highest_seq_scans) $highest_seq_scans = $user_seq_scans;
		if($user_idx_scans > $highest_idx_scans) $highest_idx_scans = $user_idx_scans;
		if($user_seq_rows > $highest_seq_rows) $highest_seq_rows = $user_seq_rows;
		if($user_idx_rows > $highest_idx_rows) $idx_rows = $user_idx_rows;

		#####################################################################################
		#TALLY UP OUR "HIGHEST" VARS PER STAT SO THAT WE CAN DETERMINE BAR CHART VALUES LATER
		#####################################################################################
		switch($day_flag)
		{
			case "0": #Sun
			#####################
			#HANDLE HIGHEST STATS
			#####################
			if($core_commits > $highest_commits_sun) $highest_commits_sun = $core_commits;
			if($core_rollbacks > $highest_rollbacks_sun) $highest_rollbacks_sun = $core_rollbacks;
			if($core_block_reads > $highest_block_reads_sun) $highest_block_reads_sun = $core_block_reads;
			if($core_buffer_hits > $highest_buffer_hits_sun) $highest_buffer_hits_sun = $core_buffer_hits;
			if($user_inserts > $highest_inserts_sun) $highest_inserts_sun = $user_inserts;
			if($user_updates > $highest_updates_sun) $highest_updates_sun = $user_updates;
			if($user_deletes > $highest_deletes_sun) $highest_deletes_sun = $user_deletes;
			if($user_seq_scans > $highest_seq_scans_sun) $highest_seq_scans_sun = $user_seq_scans;
			if($user_idx_scans > $highest_idx_scans_sun) $highest_idx_scans_sun = $user_idx_scans;
			if($user_seq_rows > $highest_seq_rows_sun) $highest_seq_rows_sun = $user_seq_rows;
			if($user_idx_rows > $highest_idx_rows_sun) $highest_idx_rows_sun = $user_idx_rows;
			break;

			case "1": #Mon
			#####################
			#HANDLE HIGHEST STATS
			#####################
			if($core_commits > $highest_commits_mon) $highest_commits_mon = $core_commits;
			if($core_rollbacks > $highest_rollbacks_mon) $highest_rollbacks_mon = $core_rollbacks;
			if($core_block_reads > $highest_block_reads_mon) $highest_block_reads_mon = $core_block_reads;
			if($core_buffer_hits > $highest_buffer_hits_mon) $highest_buffer_hits_mon = $core_buffer_hits;
			if($user_inserts > $highest_inserts_mon) $highest_inserts_mon = $user_inserts;
			if($user_updates > $highest_updates_mon) $highest_updates_mon = $user_updates;
			if($user_deletes > $highest_deletes_mon) $highest_deletes_mon = $user_deletes;
			if($user_seq_scans > $highest_seq_scans_mon) $highest_seq_scans_mon = $user_seq_scans;
			if($user_idx_scans > $highest_idx_scans_mon) $highest_idx_scans_mon = $user_idx_scans;
			if($user_seq_rows > $highest_seq_rows_mon) $highest_seq_rows_mon = $user_seq_rows;
			if($user_idx_rows > $highest_idx_rows_mon) $highest_idx_rows_mon = $user_idx_rows;
			break;

			case "2": #Tue
			#####################
			#HANDLE HIGHEST STATS
			#####################
			if($core_commits > $highest_commits_tue) $highest_commits_tue = $core_commits;
			if($core_rollbacks > $highest_rollbacks_tue) $highest_rollbacks_tue = $core_rollbacks;
			if($core_block_reads > $highest_block_reads_tue) $highest_block_reads_tue = $core_block_reads;
			if($core_buffer_hits > $highest_buffer_hits_tue) $highest_buffer_hits_tue = $core_buffer_hits;
			if($user_inserts > $highest_inserts_tue) $highest_inserts_tue = $user_inserts;
			if($user_updates > $highest_updates_tue) $highest_updates_tue = $user_updates;
			if($user_deletes > $highest_deletes_tue) $highest_deletes_tue = $user_deletes;
			if($user_seq_scans > $highest_seq_scans_tue) $highest_seq_scans_tue = $user_seq_scans;
			if($user_idx_scans > $highest_idx_scans_tue) $highest_idx_scans_tue = $user_idx_scans;
			if($user_seq_rows > $highest_seq_rows_tue) $highest_seq_rows_tue = $user_seq_rows;
			if($user_idx_rows > $highest_idx_rows_tue) $highest_idx_rows_tue = $user_idx_rows;
			break;

			case "3": #Wed
			#####################
			#HANDLE HIGHEST STATS
			#####################
			if($core_commits > $highest_commits_wed) $highest_commits_wed = $core_commits;
			if($core_rollbacks > $highest_rollbacks_wed) $highest_rollbacks_wed = $core_rollbacks;
			if($core_block_reads > $highest_block_reads_wed) $highest_block_reads_wed = $core_block_reads;
			if($core_buffer_hits > $highest_buffer_hits_wed) $highest_buffer_hits_wed = $core_buffer_hits;
			if($user_inserts > $highest_inserts_wed) $highest_inserts_wed = $user_inserts;
			if($user_updates > $highest_updates_wed) $highest_updates_wed = $user_updates;
			if($user_deletes > $highest_deletes_wed) $highest_deletes_wed = $user_deletes;
			if($user_seq_scans > $highest_seq_scans_wed) $highest_seq_scans_wed = $user_seq_scans;
			if($user_idx_scans > $highest_idx_scans_wed) $highest_idx_scans_wed = $user_idx_scans;
			if($user_seq_rows > $highest_seq_rows_wed) $highest_seq_rows_wed = $user_seq_rows;
			if($user_idx_rows > $highest_idx_rows_wed) $highest_idx_rows_wed = $user_idx_rows;
			break;

			case "4": #Thu
			#####################
			#HANDLE HIGHEST STATS
			#####################
			if($core_commits > $highest_commits_thu) $highest_commits_thu = $core_commits;
			if($core_rollbacks > $highest_rollbacks_thu) $highest_rollbacks_thu = $core_rollbacks;
			if($core_block_reads > $highest_block_reads_thu) $highest_block_reads_thu = $core_block_reads;
			if($core_buffer_hits > $highest_buffer_hits_thu) $highest_buffer_hits_thu = $core_buffer_hits;
			if($user_inserts > $highest_inserts_thu) $highest_inserts_thu = $user_inserts;
			if($user_updates > $highest_updates_thu) $highest_updates_thu = $user_updates;
			if($user_deletes > $highest_deletes_thu) $highest_deletes_thu = $user_deletes;
			if($user_seq_scans > $highest_seq_scans_thu) $highest_seq_scans_thu = $user_seq_scans;
			if($user_idx_scans > $highest_idx_scans_thu) $highest_idx_scans_thu = $user_idx_scans;
			if($user_seq_rows > $highest_seq_rows_thu) $highest_seq_rows_thu = $user_seq_rows;
			if($user_idx_rows > $highest_idx_rows_thu) $highest_idx_rows_thu = $user_idx_rows;
			break;

			case "5": #Fri
			#####################
			#HANDLE HIGHEST STATS
			#####################
			if($core_commits > $highest_commits_fri) $highest_commits_fri = $core_commits;
			if($core_rollbacks > $highest_rollbacks_fri) $highest_rollbacks_fri = $core_rollbacks;
			if($core_block_reads > $highest_block_reads_fri) $highest_block_reads_fri = $core_block_reads;
			if($core_buffer_hits > $highest_buffer_hits_fri) $highest_buffer_hits_fri = $core_buffer_hits;
			if($user_inserts > $highest_inserts_fri) $highest_inserts_fri = $user_inserts;
			if($user_updates > $highest_updates_fri) $highest_updates_fri = $user_updates;
			if($user_deletes > $highest_deletes_fri) $highest_deletes_fri = $user_deletes;
			if($user_seq_scans > $highest_seq_scans_fri) $highest_seq_scans_fri = $user_seq_scans;
			if($user_idx_scans > $highest_idx_scans_fri) $highest_idx_scans_fri = $user_idx_scans;
			if($user_seq_rows > $highest_seq_rows_fri) $highest_seq_rows_fri = $user_seq_rows;
			if($user_idx_rows > $highest_idx_rows_fri) $highest_idx_rows_fri = $user_idx_rows;
			break;

			case "6": #Sat
			#####################
			#HANDLE HIGHEST STATS
			#####################
			if($core_commits > $highest_commits_sat) $highest_commits_sat = $core_commits;
			if($core_rollbacks > $highest_rollbacks_sat) $highest_rollbacks_sat = $core_rollbacks;
			if($core_block_reads > $highest_block_reads_sat) $highest_block_reads_sat = $core_block_reads;
			if($core_buffer_hits > $highest_buffer_hits_sat) $highest_buffer_hits_sat = $core_buffer_hits;
			if($user_inserts > $highest_inserts_sat) $highest_inserts_sat = $user_inserts;
			if($user_updates > $highest_updates_sat) $highest_updates_sat = $user_updates;
			if($user_deletes > $highest_deletes_sat) $highest_deletes_sat = $user_deletes;
			if($user_seq_scans > $highest_seq_scans_sat) $highest_seq_scans_sat = $user_seq_scans;
			if($user_idx_scans > $highest_idx_scans_sat) $highest_idx_scans_sat = $user_idx_scans;
			if($user_seq_rows > $highest_seq_rows_sat) $highest_seq_rows_sat = $user_seq_rows;
			if($user_idx_rows > $highest_idx_rows_sat) $highest_idx_rows_sat = $user_idx_rows;
		}
	}

################################
#START CREATING OUR INITIAL HTML
################################
$stats = <<<AJR
<div class="stat_div_bg">
<div class="orange_13" style="font-weight:bold; margin:0 0 10px 0;">Target Statistics:</div>
<table class="table_chart" style="width:auto;">
<tr>
AJR;

	######################################################
	#IDENTIFY OUR PEAK STAT DAY FOR CALCULATING BARS LATER
	######################################################
	foreach($day_array as &$day)
	{
		if(${'total_' . $weekly_chartting . '_' . $day} > $peak_stat)
		{
			##############################
			#RECORD PEAK STAT AND DAY FLAG
			##############################
			$peak_stat = ${'total_' . $weekly_chartting . '_' . $day};
			$peak_day = $day;
		}
	}

	#####################
	#GET THROUGH THEM NOW
	#####################
	foreach($day_array as &$day)
	{
		################################
		#INITIATE/RESET VARS IN THE LOOP
		################################
		$tooltip = "";
		$bar_height_percent = 0;
		$bar_height = 0;
		$bar_height_final = 0;
		$bar_height_alt = 0;

		#####################
		#CHECK EACH MONTH NOW
		#####################
		if(${'total_' . $weekly_chartting . '_' . $day} <= 0)
		{
			############################
			#HANDLE DAYS WITH ZERO STATS
			############################
			$bar_height_alt = $bar_height_vert;
		}
		else
		{
			##################################
			#FIRST PREP OUR COMMIT TOOLTIP VAR
			##################################
			$tt_commits = ${'total_commits_' . $day};
			if($tt_commits == 0 || empty($tt_commits)) $tt_commits = "0";
			else $tt_commits = number_format($tt_commits);

			###############################
			#PREP OUR ROLLBACKS TOOLTIP VAR
			###############################
			$tt_rollbacks = ${'total_rollbacks_' . $day};
			if($tt_rollbacks == 0 || empty($tt_rollbacks)) $tt_rollbacks = "0";
			else $tt_rollbacks = number_format($tt_rollbacks);

			#################################
			#PREP OUR BLOCK READS TOOLTIP VAR
			#################################
			$tt_block_reads = ${'total_block_reads_' . $day};
			if($tt_block_reads == 0 || empty($tt_block_reads)) $tt_block_reads = "0";
			else $tt_block_reads = number_format($tt_block_reads);

			#################################
			#PREP OUR BUFFER HITS TOOLTIP VAR
			#################################
			$tt_buffer_hits = ${'total_buffer_hits_' . $day};
			if($tt_buffer_hits == 0 || empty($tt_buffer_hits)) $tt_buffer_hits = "0";
			else $tt_buffer_hits = number_format($tt_buffer_hits);

			############################
			#PREP OUR INSERT TOOLTIP VAR
			############################
			$tt_inserts = ${'total_inserts_' . $day};
			if($tt_inserts == 0 || empty($tt_inserts)) $tt_inserts = "0";
			else $tt_inserts = number_format($tt_inserts);

			############################
			#PREP OUR UPDATE TOOLTIP VAR
			############################
			$tt_updates = ${'total_updates_' . $day};
			if($tt_updates == 0 || empty($tt_updates)) $tt_updates = "0";
			else $tt_updates = number_format($tt_updates);

			############################
			#PREP OUR DELETE TOOLTIP VAR
			############################
			$tt_deletes = ${'total_deletes_' . $day};
			if($tt_deletes == 0 || empty($tt_deletes)) $tt_deletes = "0";
			else $tt_deletes = number_format($tt_deletes);

			####################################
			#PREP OUR SEQUENCE SCANS TOOLTIP VAR
			####################################
			$tt_seq_scans = ${'total_seq_scans_' . $day};
			if($tt_seq_scans == 0 || empty($tt_seq_scans)) $tt_seq_scans = "0";
			else $tt_seq_scans = number_format($tt_seq_scans);

			#################################
			#PREP OUR INDEX SCANS TOOLTIP VAR
			#################################
			$tt_idx_scans = ${'total_idx_scans_' . $day};
			if($tt_idx_scans == 0 || empty($tt_idx_scans)) $tt_idx_scans = "0";
			else $tt_idx_scans = number_format($tt_idx_scans);

			################
			#PUT IT TOGETHER
			################
			$tooltip = "<div style=line-height:17px;>";

			########
			#COMMITS
			########
			if($weekly_chartting == "commits") $tooltip .= "<span class=orange_12><strong>Commits:&nbsp;" . $tt_commits . "</strong></span><br>";
			else $tooltip .= "Commits:&nbsp;<strong>" . $tt_commits . "</strong>" . "<br>";

			##########
			#ROLLBACKS
			##########
			if($weekly_chartting == "rollbacks") $tooltip .= "<span class=orange_12><strong>Rollbacks:&nbsp;" . $tt_rollbacks . "</strong></span><br>";
			else $tooltip .= "Rollbacks:&nbsp;<strong>" . $tt_rollbacks . "</strong>" . "<br>";

			############
			#BLOCK READS
			############
			if($weekly_chartting == "block_reads") $tooltip .= "<span class=orange_12><strong>Block&nbsp;Reads:&nbsp;" . $tt_block_reads . "</strong></span><br>";
			else $tooltip .= "Block&nbsp;Reads:&nbsp;<strong>" . $tt_block_reads . "</strong>" . "<br>";

			############
			#BUFFER HITS
			############
			if($weekly_chartting == "buffer_hits") $tooltip .= "<span class=orange_12><strong>Buffer&nbsp;Hits:&nbsp;" . $tt_buffer_hits . "</strong></span><br>";
			else $tooltip .= "Buffer&nbsp;Hits:&nbsp;<strong>" . $tt_buffer_hits . "</strong>" . "<br>";

			########
			#INSERTS
			########
			if($weekly_chartting == "inserts") $tooltip .= "<span class=orange_12><strong>Inserts:&nbsp;" . $tt_inserts . "</strong></span><br>";
			else $tooltip .= "Inserts:&nbsp;<strong>" . $tt_inserts . "</strong>" . "<br>";

			########
			#UPDATES
			########
			if($weekly_chartting == "updates") $tooltip .= "<span class=orange_12><strong>Updates:&nbsp;" . $tt_updates . "</strong></span><br>";
			else $tooltip .= "Updates:&nbsp;<strong>" . $tt_updates . "</strong>" . "<br>";

			########
			#DELETES
			########
			if($weekly_chartting == "deletes") $tooltip .= "<span class=orange_12><strong>Deletes:&nbsp;" . $tt_deletes . "</strong></span><br>";
			else $tooltip .= "Deletes:&nbsp;<strong>" . $tt_deletes . "</strong>" . "<br>";

			##########
			#SEQ SCANS
			##########
			if($weekly_chartting == "seq_scans") $tooltip .= "<span class=orange_12><strong>Sequence&nbsp;Scans:&nbsp;" . $tt_seq_scans . "</strong></span><br>";
			else $tooltip .= "Sequence&nbsp;Scans:&nbsp;<strong>" . $tt_seq_scans . "</strong>" . "<br>";

			##########
			#IDX SCANS
			##########
			if($weekly_chartting == "idx_scans") $tooltip .= "<span class=orange_12><strong>Index&nbsp;Scans:&nbsp;" . $tt_idx_scans . "</strong></span><br>";
			else $tooltip .= "Index&nbsp;Scans:&nbsp;<strong>" . $tt_idx_scans . "</strong>" . "<br>";

			#########################
			#COMPLETE THE TOOLTIP DIV
			#########################
			$tooltip .= "</div>";

			#############################################################
			#GET THE PERCENTAGE NOW SO WE CAN PUT OUR BAR / DATA TOGETHER
			#############################################################
			if(!empty($peak_stat))
			{
				$stat_percent = ${'total_' . $weekly_chartting . '_' . $day} / $peak_stat;
				$bar_height_percent = $stat_percent;
			}
			else
			{
				$bar_height_percent = 0;
			}

			#################################
			#COMPLETE OUR MATH FOR THE HEIGHT
			#################################
			$bar_height = $bar_height_vert * $bar_height_percent;
			$bar_height_final = number_format($bar_height, 0, '.', '');

			############################
			#CHECK THE HEIGHT - FOR SAFE
			############################
			if($bar_height_final > $bar_height_vert) $bar_height_final = $bar_height_vert;

			####################################################################################
			#CREATE THE HEIGHT FOR THE ALT LIGHT GREY BAR WHICH SITS ON TOP OF THE DARK GREY BAR
			####################################################################################
			$bar_height_alt = $bar_height_vert - $bar_height_final;

			###########################################################
			#HANDLE THE FINAL SOURCE GRAPHIC AND CHECK FOR THE PEAK DAY
			###########################################################
			if($peak_stat == ${'total_' . $weekly_chartting . '_' . $day}) $bar_vert_color_final = $bar_vert_peak_color;
			else $bar_vert_color_final = $bar_vert_color;
		}

		#####################
		#COMPLETE THE TD CELL
		#####################
		$stats .= "<td valign=\"bottom\" style=\"text-align:center;\">";

		#######################################################
		#START UP THE TABLEWORK WHICH WILL HOUSE THE BAR ITSELF
		#######################################################
		$stats .= "<table>";

		############################
		#DETERMINE BORDER STYLES NOW
		############################
		$bar_border = "border:1px solid $bar_border_color;";
		if($bar_height_final <= 0) $bar_alt_border = "border:1px solid $bar_border_color;";
		else $bar_alt_border = "border-color:$bar_border_color; border-width:1px 1px 0px 1px; border-style:solid;"; 

		#####################################################################################
		#HANDLE THE ALT COLOR - WILL EITHER BE THE ENTIRE BAR (NO DATA) OR THE TOP OF THE BAR
		#####################################################################################
		if($bar_height_alt > 0)
		{
			#############################
			#CREATE FINAL CELL DIMENSIONS
			#############################
			$bar_width_px = $bar_width . "px";
			$bar_height_alt_px = $bar_height_alt . "px";

			#############
			#DISPLAY CELL
			#############
			$stats .= "<tr><td style=\"width:$bar_width_px; height:$bar_height_alt_px; background-color:$bar_vert_alt_color; $bar_alt_border\"></td></tr>";
		}

		################################################
		#HANDLE THE BOTTOM OF THE BAR WHERE WE HAVE DATA
		################################################
		if($bar_height_final > 0)
		{
			#############################
			#CREATE FINAL CELL DIMENSIONS
			#############################
			$bar_width_px = $bar_width . "px";
			$bar_height_final_px = $bar_height_final . "px";

			#############
			#DISPLAY CELL
			#############
			$stats .= "<tr><td style=\"width:$bar_width_px; height:$bar_height_final_px; background-color:$bar_vert_color_final; $bar_border\" onMouseOver=\"tooltip.show('$tooltip')\" onMouseOut='tooltip.hide()'></td></tr>";
		}

		$stats .= "</table>";

		################################################
		#FINISHED WITH THE BAR TABLE - CONTINUE OUR HTML
		################################################
		$stats .= "</td>";
	}

$stats .= <<<AJR
</tr>
<tr>
AJR;

	#########################
	#START OF LABEL ITERATION
	#########################
	foreach($day_array as &$day)
	{
		##################
		#START THE TD CELL
		##################
		$stats .= "<td class=\"grey_12\" style=\"text-align:center; padding-top:5px;\">";

		###########################
		#RETRIEVE FRIENDLY DAY NAME
		###########################
		switch($day)
		{
			case "sun": $day_label = "Sun"; break;
			case "mon": $day_label = "Mon"; break;
			case "tue": $day_label = "Tue"; break;
			case "wed": $day_label = "Wed"; break;
			case "thu": $day_label = "Thu"; break;
			case "fri": $day_label = "Fri"; break;
			case "sat": $day_label = "Sat";
		}

		################################
		#ADD LABEL AND CLOSE THE TD CELL
		################################
		$stats .= $day_label;
		$stats .= "</td>";
	}

##################################
#PUT THE LAST OF OUR HTML TOGETHER
##################################
$stats .= <<<AJR
</tr>
AJR;

######################################
#CHART TABLEWORK COMPLETED - MOVING ON
######################################
$stats .= <<<AJR
</table>
</div>
AJR;

	#########################
	#START HTML FOR RECAP DIV
	#########################
	$stats .= "<div class=\"stat_div_bg\" style=\"margin:20px 0 20px 0;\">";

	###############################################################################################
	#DETERMINE THE TOTAL STATS FOR THIS TYPE - THIS WILL BE DISPLAYED TO THE RIGHT OF THE BAR CHART
	###############################################################################################
	if(!empty(${'total_' . $weekly_chartting . '_' . $peak_day})) { $recap_peak = ${'total_' . $weekly_chartting . '_' . $peak_day}; } else { $recap_peak = 0; }
	if(!empty($recap_peak) && !empty(${'total_days_tracked_' . $peak_day})) { $recap_avg_on_peak = $recap_peak / ${'total_days_tracked_' . $peak_day}; } else { $recap_avg_on_peak = 0; }

	################
	#FORMAT THE VARS
	################
	$recap_peak = number_format($recap_peak);
	$recap_total = number_format(${'total_' . $weekly_chartting});
	$recap_avg_on_peak = number_format($recap_avg_on_peak, 2, '.', ',');

	#########################################
	#CREATE A FRIENDLY TITLE FOR THE PEAK DAY
	#########################################
	$recap_peak_day = "";
	switch($peak_day)
	{
		case "sun": $recap_peak_day = "Sunday"; break;
		case "mon": $recap_peak_day = "Monday"; break;
		case "tue": $recap_peak_day = "Tuesday"; break;
		case "wed": $recap_peak_day = "Wednesday"; break;
		case "thu": $recap_peak_day = "Thursday"; break;
		case "fri": $recap_peak_day = "Friday"; break;
		case "sat": $recap_peak_day = "Saturday";
	}

	#################################################
	#CREATE A FRIENDLY TITLE FOR THE TARGET STATISTIC
	#################################################
	switch($weekly_chartting)
	{
		case "commits"; $stat_title = "Commits"; break;
		case "rollbacks"; $stat_title = "Roll&nbsp;Backs"; break;
		case "block_reads"; $stat_title = "Block&nbsp;Reads"; break;
		case "buffer_hits"; $stat_title = "Buffer&nbsp;Hits"; break;
		case "inserts"; $stat_title = "Inserts"; break;
		case "updates"; $stat_title = "Updates"; break;
		case "deletes"; $stat_title = "Deletes"; break;
		case "seq_scans"; $stat_title = "SEQ&nbsp;Scans"; break;
		case "idx_scans"; $stat_title = "IDX&nbsp;Scans";
	}

############
#RECAP TOTAL
############
$stats .= <<<AJR
<div class="orange_13" style="font-weight:bold; margin:0 0 10px 0;">Statistics Overview:</div>
<div class="black_12" style="padding:10px; float:left; border:1px solid $bar_border_color; background-color:#FFFFFF;"><span style="font-weight:bold;">Total $stat_title:</span> $recap_total</div>
AJR;

###############
#RECAP PEAK DAY
###############
$stats .= <<<AJR
<div class="black_12" style="margin-left:5px; padding:10px; float:left; border:1px solid $bar_border_color; background-color:#FFFFFF;"><span style="font-weight:bold;">Peak Day / Sum:</span> 
AJR;

	if($recap_peak > 0) $stats .= "$recap_peak_day&nbsp;/&nbsp;$recap_peak";
	else $stats .= "N/A";
	$stats .= "</div>";

########################
#SHOW PEAK AVERAGE / DAY
########################
$stats .= <<<AJR
<div class="black_12" style="margin-left:5px; padding:10px; float:left; border:1px solid $bar_border_color; background-color:#FFFFFF;">
AJR;

	if($recap_peak > 0) $stats .= "<span style=\"font-weight:bold;\">Average / $recap_peak_day:</span> $recap_avg_on_peak";
	else $stats .= "<span style=\"font-weight:bold;\">Average:</span> N/A";
	$stats .= "</div>";

	############
	#CLAR FLOATS
	############
	$stats .= "<div style=\"clear:both;\"></div>";

	##########################
	#END OF OF RECAP STATS DIV
	##########################
	$stats .= "</div>";

#################
#START OF IUD DIV
#################
$stats .= <<<AJR
<div class="stat_div_bg" style="margin:0 0 20px 0;">
<div class="orange_13" style="font-weight:bold; margin:0 0 10px 0;">Insert / Update / Delete Quick View:</div>
AJR;

	##############################################################
	#PUT TOGETHER OUR IUD STATS - FIRST INITIATE SOME GENERAL VARS
	##############################################################
	$total_iud = $total_inserts + $total_updates + $total_deletes;

	##############################################
	#GET THE PERCENTAGES OF EACH AGAINST THE TOTAL
	##############################################
	if(!empty($total_iud)) { $iud_ins_percent = number_format($total_inserts / $total_iud, 2, '.', ','); } else { $iud_ins_percent = 0; }
	if(!empty($total_iud)) { $iud_upd_percent = number_format($total_updates / $total_iud, 2, '.', ','); } else { $iud_upd_percent = 0; }
	if(!empty($total_iud)) { $iud_del_percent = number_format($total_deletes / $total_iud, 2, '.', ','); } else { $iud_del_percent = 0; }

	#################################################
	#PREPARE THE BAR WIDTHS AND ROUND THE NUMBERS OUT
	#################################################
	$iud_ins_bar_w = number_format($iud_bar_width * $iud_ins_percent);
	$iud_upd_bar_w = number_format($iud_bar_width * $iud_upd_percent);
	$iud_del_bar_w = number_format($iud_bar_width * $iud_del_percent);

	#######################################################################################################
	#TALLY UP THE WIDTHS AND TAKE ANY NOMINAL REMAINDER +/- IUD_BAR_WIDTH AND +/- IT FROM THE LARGEST SCORE
	#######################################################################################################
	$iud_bar_total = $iud_ins_bar_w + $iud_upd_bar_w + $iud_del_bar_w;

	if($iud_bar_total < $iud_bar_width && $iud_bar_total > 0) 
	{
		###################
		#GET THE DIFFERENCE
		###################
		$iud_remain = $iud_bar_width-$iud_bar_total;

		############################
		#ADD IT TO HIGHEST IUD SCORE
		############################
		if($total_inserts > $total_updates && $total_inserts > $total_deletes) $iud_ins_bar_w += $iud_remain;
		elseif($total_updates > $total_inserts && $total_updates > $total_deletes) $iud_upd_bar_w += $iud_remain;
		else $iud_del_bar_w += $iud_remain;
	}
	elseif($iud_bar_total > $iud_bar_width) 
	{
		###################
		#GET THE DIFFERENCE
		###################
		$iud_remain = $iud_bar_total-$iud_bar_width;

		###################################
		#SUBTRACT IT FROM HIGHEST IUD SCORE
		###################################
		if($total_inserts > $total_updates && $total_inserts > $total_deletes) $iud_ins_bar_w -= $iud_remain;
		elseif($total_updates > $total_inserts && $total_updates > $total_deletes) $iud_upd_bar_w -= $iud_remain;
		else $iud_del_bar_w -= $iud_remain;
	}

	##################################
	#PUT TOGETHER OUR IUD TOOLTIP VARS
	##################################
	$iud_tt_ins = "<div style=line-height:17px;>";
	$iud_tt_ins .= "Total Inserts:&nbsp;<strong class=orange_12>" . number_format($total_inserts) . "</strong>";
	$iud_tt_ins .= "</div>";

	$iud_tt_upd = "<div style=line-height:17px;>";
	$iud_tt_upd .= "Total Updates:&nbsp;<strong class=orange_12>" . number_format($total_updates) . "</strong>";
	$iud_tt_upd .= "</div>";

	$iud_tt_del = "<div style=line-height:17px;>";
	$iud_tt_del .= "Total Deletes:&nbsp;<strong class=orange_12>" . number_format($total_deletes) . "</strong>";
	$iud_tt_del .= "</div>";

	###########################################################################################
	#SHOW EITHER THE THREE IUD BARS TOGETHER OR THE DEFAULT NO-DATA BAR IF THERE IS NO IUD DATA
	###########################################################################################

	#####################
	#PREP CELL DIMENSIONS
	#####################
	$iud_bar_width_px = $iud_bar_width . "px";
	$iud_bar_height_px = $iud_bar_height . "px";

	################
	#BEGIN TABLEWORK
	################
	$stats .= "<table style=\"width:$iud_bar_width_px; max-width:$iud_bar_width_px;\">";
	$stats .= "<tr>";

	if($total_iud > 0)
	{
		###########
		#INSERT BAR
		###########
		if($iud_ins_bar_w > 0)
		{
			$ins_border = "border:1px solid $bar_border_color;";
			$iud_ins_bar_w_px = $iud_ins_bar_w . "px";
			$stats .= "<td style=\"width:$iud_ins_bar_w_px; height:$iud_bar_height_px; background-color:$iud_insert_color; $ins_border\" onMouseOver=\"tooltip.show('$iud_tt_ins')\" onMouseOut='tooltip.hide()'></td>";
		}

		###########
		#UPDATE BAR
		###########
		if($iud_upd_bar_w > 0)
		{
			if($iud_ins_bar_w > 0) $upd_border = "border-color:$bar_border_color; border-width:1px 1px 1px 0px; border-style:solid;";
			else $upd_border = "border:1px solid $bar_border_color;";
			$iud_upd_bar_w_px = $iud_upd_bar_w . "px";
			$stats .= "<td style=\"width:$iud_upd_bar_w_px; height:$iud_bar_height_px; background-color:$iud_update_color; $upd_border\" onMouseOver=\"tooltip.show('$iud_tt_upd')\" onMouseOut='tooltip.hide()'></td>";
		}

		###########
		#DELETE BAR
		###########
		if($iud_del_bar_w > 0) 
		{
			if($iud_upd_bar_w > 0 || $iud_ins_bar_w > 0) $del_border = "border-color:$bar_border_color; border-width:1px 1px 1px 0px; border-style:solid;";
			else $del_border = "border:1px solid $bar_border_color;";
			$iud_del_bar_w_px = $iud_del_bar_w . "px";
			$stats .= "<td style=\"width:$iud_del_bar_w_px; height:$iud_bar_height_px; background-color:$iud_delete_color; $del_border\" onMouseOver=\"tooltip.show('$iud_tt_del')\" onMouseOut='tooltip.hide()'></td>";
		}
	}
	else
	{
		##################################
		#DEFAULT THE NO-DATA BAR AND WIDTH
		##################################
		$stats .= "<td style=\"width:$iud_bar_width_px; height:$iud_bar_height_px; background-color:$iud_nodata_color; border:1px solid $bar_border_color;\" onMouseOver=\"tooltip.show('No data to report.')\" onMouseOut='tooltip.hide()'></td>";
	}

	##############################################
	#COMPLETE OUR HTML TABLE WORK FOR THE IUD AREA
	##############################################
	$stats .= "</tr>";
	$stats .= "</table>";

	##################
	#CREATE IUD LEGEND
	##################
$stats .= <<<AJR
<div class="grey_12" style="margin:15px 0 0 0;">
<div style="float:left; height:15px; width:15px; background-color:$iud_nodata_color; border:1px solid $bar_border_color; margin-right:5px;"></div>
<div style="float:left; height:15px; margin-right:10px;">No Data</div>
<div style="float:left; height:15px; width:15px; background-color:$iud_insert_color; border:1px solid $bar_border_color; margin-right:5px;"></div>
<div style="float:left; height:15px; margin-right:10px;">Inserts</div>
<div style="float:left; height:15px; width:15px; background-color:$iud_update_color; border:1px solid $bar_border_color; margin-right:5px;"></div>
<div style="float:left; height:15px; margin-right:10px;">Updates</div>
<div style="float:left; height:15px; width:15px; background-color:$iud_delete_color; border:1px solid $bar_border_color; margin-right:5px;"></div>
<div style="float:left; height:15px; margin-right:10px;">Deletes</div>
<div style="clear:both;"></div>
</div>
AJR;

##################
#COMPLETE IUD AREA
##################
$stats .= "</div>";

####################################
#START THE CORE STATISTICS DIV BELOW
####################################
$stats .= <<<AJR
<div class="stat_div_bg">
<div class="orange_13" style="font-weight:bold; margin:0 0 10px 0;">Core Statistics:</div>
AJR;

###########################################################
#GET THE BOTTOM TABLE OF STATS TOGETHER - START UP THE HTML
#GET OUR HIGHEST SUM STATS PRIOR TO FORMATTING BELOW
###########################################################
$highest_sum_commits = $highest_commits_sun + $highest_commits_mon + $highest_commits_tue + $highest_commits_wed + $highest_commits_thu + $highest_commits_fri + $highest_commits_sat;
$highest_sum_rollbacks = $highest_rollbacks_sun + $highest_rollbacks_mon + $highest_rollbacks_tue + $highest_rollbacks_wed + $highest_rollbacks_thu + $highest_rollbacks_fri + $highest_rollbacks_sat;
$highest_sum_block_reads = $highest_block_reads_sun + $highest_block_reads_mon + $highest_block_reads_tue + $highest_block_reads_wed + $highest_block_reads_thu + $highest_block_reads_fri + $highest_block_reads_sat;
$highest_sum_buffer_hits = $highest_buffer_hits_sun + $highest_buffer_hits_mon + $highest_buffer_hits_tue + $highest_buffer_hits_wed + $highest_buffer_hits_thu + $highest_buffer_hits_fri + $highest_buffer_hits_sat;
$highest_sum_inserts = $highest_inserts_sun + $highest_inserts_mon + $highest_inserts_tue + $highest_inserts_wed + $highest_inserts_thu + $highest_inserts_fri + $highest_inserts_sat;
$highest_sum_updates = $highest_updates_sun + $highest_updates_mon + $highest_updates_tue + $highest_updates_wed + $highest_updates_thu + $highest_updates_fri + $highest_updates_sat;
$highest_sum_deletes = $highest_deletes_sun + $highest_deletes_mon + $highest_deletes_tue + $highest_deletes_wed + $highest_deletes_thu + $highest_deletes_fri + $highest_deletes_sat;
$highest_sum_seq_scans = $highest_seq_scans_sun + $highest_seq_scans_mon + $highest_seq_scans_tue + $highest_seq_scans_wed + $highest_seq_scans_thu + $highest_seq_scans_fri + $highest_seq_scans_sat;
$highest_sum_idx_scans = $highest_idx_scans_sun + $highest_idx_scans_mon + $highest_idx_scans_tue + $highest_idx_scans_wed + $highest_idx_scans_thu + $highest_idx_scans_fri + $highest_idx_scans_sat;
$highest_sum_seq_rows = $highest_seq_rows_sun + $highest_seq_rows_mon + $highest_seq_rows_tue + $highest_seq_rows_wed + $highest_seq_rows_thu + $highest_seq_rows_fri + $highest_seq_rows_sat;
$highest_sum_idx_rows = $highest_idx_rows_sun + $highest_idx_rows_mon + $highest_idx_rows_tue + $highest_idx_rows_wed + $highest_idx_rows_thu + $highest_idx_rows_fri + $highest_idx_rows_sat;

###########################################################
#FORMAT OUR TOTAL AND HIGHEST STAT VARS FOR THE TABLE BELOW
#CREATE AN ARRAY OF THE DAYS FIRST SO WE CAN ITERATE
###########################################################
$day_array = array("sun","mon","tue","wed","thu","fri","sat");

#####################
#GET THROUGH THEM NOW
#####################
foreach($day_array as &$day)
{
	${'total_commits_' . $day} = number_format(${'total_commits_' . $day});
	${'total_rollbacks_' . $day} = number_format(${'total_rollbacks_' . $day});
	${'total_block_reads_' . $day} = number_format(${'total_block_reads_' . $day});
	${'total_buffer_hits_' . $day} = number_format(${'total_buffer_hits_' . $day});
	${'total_inserts_' . $day} = number_format(${'total_inserts_' . $day});
	${'total_updates_' . $day} = number_format(${'total_updates_' . $day});
	${'total_deletes_' . $day} = number_format(${'total_deletes_' . $day});
	${'total_seq_scans_' . $day} = number_format(${'total_seq_scans_' . $day});
	${'total_idx_scans_' . $day} = number_format(${'total_idx_scans_' . $day});
	${'total_seq_rows_' . $day} = number_format(${'total_seq_rows_' . $day});
	${'total_idx_rows_' . $day} = number_format(${'total_idx_rows_' . $day});
	
	${'highest_commits_' . $day} = number_format(${'highest_commits_' . $day});
	${'highest_rollbacks_' . $day} = number_format(${'highest_rollbacks_' . $day});
	${'highest_block_reads_' . $day} = number_format(${'highest_block_reads_' . $day});
	${'highest_buffer_hits_' . $day} = number_format(${'highest_buffer_hits_' . $day});
	${'highest_inserts_' . $day} = number_format(${'highest_inserts_' . $day});
	${'highest_updates_' . $day} = number_format(${'highest_updates_' . $day});
	${'highest_deletes_' . $day} = number_format(${'highest_deletes_' . $day});
	${'highest_seq_scans_' . $day} = number_format(${'highest_seq_scans_' . $day});
	${'highest_idx_scans_' . $day} = number_format(${'highest_idx_scans_' . $day});
	${'highest_seq_rows_' . $day} = number_format(${'highest_seq_rows_' . $day});
	${'highest_idx_rows_' . $day} = number_format(${'highest_idx_rows_' . $day});
}

#######################################
#FORMAT TOTAL VARS AND HIGHEST SUM VARS
#######################################
$total_commits = number_format($total_commits);
$total_rollbacks = number_format($total_rollbacks);
$total_block_reads = number_format($total_block_reads);
$total_buffer_hits = number_format($total_buffer_hits);
$total_inserts = number_format($total_inserts);
$total_updates = number_format($total_updates);
$total_deletes = number_format($total_deletes);
$total_seq_scans = number_format($total_seq_scans);
$total_idx_scans = number_format($total_idx_scans);
$total_seq_rows = number_format($total_seq_rows);
$total_idx_rows = number_format($total_idx_rows);

$highest_sum_commits = number_format($highest_sum_commits);
$highest_sum_rollbacks = number_format($highest_sum_rollbacks);
$highest_sum_block_reads = number_format($highest_sum_block_reads);
$highest_sum_buffer_hits = number_format($highest_sum_buffer_hits);
$highest_sum_inserts = number_format($highest_sum_inserts);
$highest_sum_updates = number_format($highest_sum_updates);
$highest_sum_deletes = number_format($highest_sum_deletes);
$highest_sum_seq_scans = number_format($highest_sum_seq_scans);
$highest_sum_idx_scans = number_format($highest_sum_idx_scans);
$highest_sum_seq_rows = number_format($highest_sum_seq_rows);
$highest_sum_idx_rows = number_format($highest_sum_idx_rows);

###############################################
#START UP OUR BOTTOM AREA OF GENERAL STATISTICS
###############################################
$stats .= <<<AJR
<table style="width:100%">
<tr>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Statistic</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Sunday</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Monday</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Tuesday</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Wednesday</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Thursday</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Friday</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Saturday</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Combined</td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">Commits:</td>
<td>$total_commits_sun</td>
<td>$total_commits_mon</td>
<td>$total_commits_tue</td>
<td>$total_commits_wed</td>
<td>$total_commits_thu</td>
<td>$total_commits_fri</td>
<td>$total_commits_sat</td>
<td class="orange_12" style="font-weight:bold;">$total_commits</td>
</tr>
<tr>
<td class="grey_12" style="padding-right:10px;">Peak&nbsp;Day:</td>
<td class="grey_lt_12">$highest_commits_sun</td>
<td class="grey_lt_12">$highest_commits_mon</td>
<td class="grey_lt_12">$highest_commits_tue</td>
<td class="grey_lt_12">$highest_commits_wed</td>
<td class="grey_lt_12">$highest_commits_thu</td>
<td class="grey_lt_12">$highest_commits_fri</td>
<td class="grey_lt_12">$highest_commits_sat</td>
<td class="grey_lt_12">$highest_sum_commits</td>
</tr>
<tr>
<td colspan="9" style="height:30px;"><hr size="1"/></td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">Rollbacks:</td>
<td>$total_rollbacks_sun</td>
<td>$total_rollbacks_mon</td>
<td>$total_rollbacks_tue</td>
<td>$total_rollbacks_wed</td>
<td>$total_rollbacks_thu</td>
<td>$total_rollbacks_fri</td>
<td>$total_rollbacks_sat</td>
<td class="orange_12" style="font-weight:bold;">$total_rollbacks</td>
</tr>
<tr>
<td class="grey_12" style="padding-right:10px;">Peak&nbsp;Day:</td>
<td class="grey_lt_12">$highest_rollbacks_sun</td>
<td class="grey_lt_12">$highest_rollbacks_mon</td>
<td class="grey_lt_12">$highest_rollbacks_tue</td>
<td class="grey_lt_12">$highest_rollbacks_wed</td>
<td class="grey_lt_12">$highest_rollbacks_thu</td>
<td class="grey_lt_12">$highest_rollbacks_fri</td>
<td class="grey_lt_12">$highest_rollbacks_sat</td>
<td class="grey_lt_12">$highest_sum_rollbacks</td>
</tr>
<tr>
<td colspan="9" style="height:30px;"><hr size="1"/></td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">Block&nbsp;Reads:</td>
<td>$total_block_reads_sun</td>
<td>$total_block_reads_mon</td>
<td>$total_block_reads_tue</td>
<td>$total_block_reads_wed</td>
<td>$total_block_reads_thu</td>
<td>$total_block_reads_fri</td>
<td>$total_block_reads_sat</td>
<td class="orange_12" style="font-weight:bold;">$total_block_reads</td>
</tr>
<tr>
<td class="grey_12" style="padding-right:10px;">Peak&nbsp;Day:</td>
<td class="grey_lt_12">$highest_block_reads_sun</td>
<td class="grey_lt_12">$highest_block_reads_mon</td>
<td class="grey_lt_12">$highest_block_reads_tue</td>
<td class="grey_lt_12">$highest_block_reads_wed</td>
<td class="grey_lt_12">$highest_block_reads_thu</td>
<td class="grey_lt_12">$highest_block_reads_fri</td>
<td class="grey_lt_12">$highest_block_reads_sat</td>
<td class="grey_lt_12">$highest_sum_block_reads</td>
</tr>
<tr>
<td colspan="9" style="height:30px;"><hr size="1"/></td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">Buffer&nbsp;Hits:</td>
<td>$total_buffer_hits_sun</td>
<td>$total_buffer_hits_mon</td>
<td>$total_buffer_hits_tue</td>
<td>$total_buffer_hits_wed</td>
<td>$total_buffer_hits_thu</td>
<td>$total_buffer_hits_fri</td>
<td>$total_buffer_hits_sat</td>
<td class="orange_12" style="font-weight:bold;">$total_buffer_hits</td>
</tr>
<tr>
<td class="grey_12" style="padding-right:10px;">Peak&nbsp;Day:</td>
<td class="grey_lt_12">$highest_buffer_hits_sun</td>
<td class="grey_lt_12">$highest_buffer_hits_mon</td>
<td class="grey_lt_12">$highest_buffer_hits_tue</td>
<td class="grey_lt_12">$highest_buffer_hits_wed</td>
<td class="grey_lt_12">$highest_buffer_hits_thu</td>
<td class="grey_lt_12">$highest_buffer_hits_fri</td>
<td class="grey_lt_12">$highest_buffer_hits_sat</td>
<td class="grey_lt_12">$highest_sum_buffer_hits</td>
</tr>
<tr>
<td colspan="9" style="height:30px;"><hr size="1"/></td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">User&nbsp;Inserts:</td>
<td>$total_inserts_sun</td>
<td>$total_inserts_mon</td>
<td>$total_inserts_tue</td>
<td>$total_inserts_wed</td>
<td>$total_inserts_thu</td>
<td>$total_inserts_fri</td>
<td>$total_inserts_sat</td>
<td class="orange_12" style="font-weight:bold;">$total_inserts</td>
</tr>
<tr>
<td class="grey_12" style="padding-right:10px;">Peak&nbsp;Day:</td>
<td class="grey_lt_12">$highest_inserts_sun</td>
<td class="grey_lt_12">$highest_inserts_mon</td>
<td class="grey_lt_12">$highest_inserts_tue</td>
<td class="grey_lt_12">$highest_inserts_wed</td>
<td class="grey_lt_12">$highest_inserts_thu</td>
<td class="grey_lt_12">$highest_inserts_fri</td>
<td class="grey_lt_12">$highest_inserts_sat</td>
<td class="grey_lt_12">$highest_sum_inserts</td>
</tr>
<tr>
<td colspan="9" style="height:30px;"><hr size="1"/></td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">User&nbsp;Updates:</td>
<td>$total_updates_sun</td>
<td>$total_updates_mon</td>
<td>$total_updates_tue</td>
<td>$total_updates_wed</td>
<td>$total_updates_thu</td>
<td>$total_updates_fri</td>
<td>$total_updates_sat</td>
<td class="orange_12" style="font-weight:bold;">$total_updates</td>
</tr>
<tr>
<td class="grey_12" style="padding-right:10px;">Peak&nbsp;Day:</td>
<td class="grey_lt_12">$highest_updates_sun</td>
<td class="grey_lt_12">$highest_updates_mon</td>
<td class="grey_lt_12">$highest_updates_tue</td>
<td class="grey_lt_12">$highest_updates_wed</td>
<td class="grey_lt_12">$highest_updates_thu</td>
<td class="grey_lt_12">$highest_updates_fri</td>
<td class="grey_lt_12">$highest_updates_sat</td>
<td class="grey_lt_12">$highest_sum_updates</td>
</tr>
<tr>
<td colspan="9" style="height:30px;"><hr size="1"/></td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">User&nbsp;Deletes:</td>
<td>$total_deletes_sun</td>
<td>$total_deletes_mon</td>
<td>$total_deletes_tue</td>
<td>$total_deletes_wed</td>
<td>$total_deletes_thu</td>
<td>$total_deletes_fri</td>
<td>$total_deletes_sat</td>
<td class="orange_12" style="font-weight:bold;">$total_deletes</td>
</tr>
<tr>
<td class="grey_12" style="padding-right:10px;">Peak&nbsp;Day:</td>
<td class="grey_lt_12">$highest_deletes_sun</td>
<td class="grey_lt_12">$highest_deletes_mon</td>
<td class="grey_lt_12">$highest_deletes_tue</td>
<td class="grey_lt_12">$highest_deletes_wed</td>
<td class="grey_lt_12">$highest_deletes_thu</td>
<td class="grey_lt_12">$highest_deletes_fri</td>
<td class="grey_lt_12">$highest_deletes_sat</td>
<td class="grey_lt_12">$highest_sum_deletes</td>
</tr>
<tr>
<td colspan="9" style="height:30px;"><hr size="1"/></td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">SEQ&nbsp;Scans:</td>
<td>$total_seq_scans_sun</td>
<td>$total_seq_scans_mon</td>
<td>$total_seq_scans_tue</td>
<td>$total_seq_scans_wed</td>
<td>$total_seq_scans_thu</td>
<td>$total_seq_scans_fri</td>
<td>$total_seq_scans_sat</td>
<td class="orange_12" style="font-weight:bold;">$total_seq_scans</td>
</tr>
<tr>
<td class="grey_12" style="padding-right:10px;">Peak&nbsp;Day:</td>
<td class="grey_lt_12">$highest_seq_scans_sun</td>
<td class="grey_lt_12">$highest_seq_scans_mon</td>
<td class="grey_lt_12">$highest_seq_scans_tue</td>
<td class="grey_lt_12">$highest_seq_scans_wed</td>
<td class="grey_lt_12">$highest_seq_scans_thu</td>
<td class="grey_lt_12">$highest_seq_scans_fri</td>
<td class="grey_lt_12">$highest_seq_scans_sat</td>
<td class="grey_lt_12">$highest_sum_seq_scans</td>
</tr>
<tr>
<td class="orange_12" style="padding:10px 10pt 0 0; font-weight:bold;">Rows&nbsp;Used:</td>
<td style="padding-top:10px;">$total_seq_rows_sun</td>
<td style="padding-top:10px;">$total_seq_rows_mon</td>
<td style="padding-top:10px;">$total_seq_rows_tue</td>
<td style="padding-top:10px;">$total_seq_rows_wed</td>
<td style="padding-top:10px;">$total_seq_rows_thu</td>
<td style="padding-top:10px;">$total_seq_rows_fri</td>
<td style="padding-top:10px;">$total_seq_rows_sat</td>
<td class="orange_12" style="padding-top:10px; font-weight:bold;">$total_seq_rows</td>
</tr>
<tr>
<td class="grey_12" style="padding-right:10px;">Peak&nbsp;Day:</td>
<td class="grey_lt_12">$highest_seq_rows_sun</td>
<td class="grey_lt_12">$highest_seq_rows_mon</td>
<td class="grey_lt_12">$highest_seq_rows_tue</td>
<td class="grey_lt_12">$highest_seq_rows_wed</td>
<td class="grey_lt_12">$highest_seq_rows_thu</td>
<td class="grey_lt_12">$highest_seq_rows_fri</td>
<td class="grey_lt_12">$highest_seq_rows_sat</td>
<td class="grey_lt_12">$highest_sum_seq_rows</td>
</tr>
<tr>
<td colspan="9" style="height:30px;"><hr size="1"/></td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">IDX&nbsp;Scans:</td>
<td>$total_idx_scans_sun</td>
<td>$total_idx_scans_mon</td>
<td>$total_idx_scans_tue</td>
<td>$total_idx_scans_wed</td>
<td>$total_idx_scans_thu</td>
<td>$total_idx_scans_fri</td>
<td>$total_idx_scans_sat</td>
<td class="orange_12" style="font-weight:bold;">$total_idx_scans</td>
</tr>
<tr>
<td class="grey_12" style="padding-right:10px;">Peak&nbsp;Day:</td>
<td class="grey_lt_12">$highest_idx_scans_sun</td>
<td class="grey_lt_12">$highest_idx_scans_mon</td>
<td class="grey_lt_12">$highest_idx_scans_tue</td>
<td class="grey_lt_12">$highest_idx_scans_wed</td>
<td class="grey_lt_12">$highest_idx_scans_thu</td>
<td class="grey_lt_12">$highest_idx_scans_fri</td>
<td class="grey_lt_12">$highest_idx_scans_sat</td>
<td class="grey_lt_12">$highest_sum_idx_scans</td>
</tr>
<tr>
<td class="orange_12" style="padding:10px 10pt 0 0; font-weight:bold;">Rows&nbsp;Used:</td>
<td style="padding-top:10px;">$total_idx_rows_sun</td>
<td style="padding-top:10px;">$total_idx_rows_mon</td>
<td style="padding-top:10px;">$total_idx_rows_tue</td>
<td style="padding-top:10px;">$total_idx_rows_wed</td>
<td style="padding-top:10px;">$total_idx_rows_thu</td>
<td style="padding-top:10px;">$total_idx_rows_fri</td>
<td style="padding-top:10px;">$total_idx_rows_sat</td>
<td class="orange_12" style="padding-top:10px; font-weight:bold;">$total_idx_rows</td>
</tr>
<tr>
<td class="grey_12" style="padding-right:10px;">Peak&nbsp;Day:</td>
<td class="grey_lt_12">$highest_idx_rows_sun</td>
<td class="grey_lt_12">$highest_idx_rows_mon</td>
<td class="grey_lt_12">$highest_idx_rows_tue</td>
<td class="grey_lt_12">$highest_idx_rows_wed</td>
<td class="grey_lt_12">$highest_idx_rows_thu</td>
<td class="grey_lt_12">$highest_idx_rows_fri</td>
<td class="grey_lt_12">$highest_idx_rows_sat</td>
<td class="grey_lt_12">$highest_sum_idx_rows</td>
</tr>
</table>
AJR;

	#################################
	#COMPLETE THE CORE STATISTICS DIV
	#################################
	$stats .= "</div>";

	#############################
	#GET TOTAL SCRIPT PEAK MEMORY
	#############################
	$script_mem = number_format(((memory_get_peak_usage(true)/1024)/1024),3) . "M";

	######################
	#PREP ARRAY FOR RETURN
	######################
	$ajax_return[0] = 1;
	$ajax_return[] = $stats;
	$ajax_return[] = $script_mem;
	$ajax_return = json_encode($ajax_return);

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: YEARLY_RETRIEVE_NAV_DBS
##########################################################################################################
##########################################################################################################
function yearly_retrieve_nav_dbs($server_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	####################################
	#CREATE RETURN ARRAY FOR JSON VALUES
	####################################
	$ajax_return = array();

	################################
	#DEFAULT SUCCESS VALUE AS FAILED
	################################
	$ajax_return[] = 2;

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");

	#############
	#MAKE CERTAIN
	#############
	if(!$pg_conn)
	{
		$ajax_return[] = "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	##########################################################################
	#RETRIEVE OUR DB LIST - IF SERVER_ID IS EMPTY, GET ALL DBS FOR ALL SERVERS
	##########################################################################
	if($server_id == 0 || empty($server_id) or $server_id == "0" || !is_numeric($server_id))
	{
		#########
		#DB QUERY
		#########
		$sqlselect_dbs = @pg_query($pg_conn, "SELECT db_id,db_name FROM ps_db_tbl WHERE (SELECT COUNT(db_id) FROM ps_core_tbl WHERE ps_db_tbl.db_id = ps_core_tbl.db_id) > 0 ORDER BY db_name ASC");

		###########
		#YEAR QUERY
		###########
		$sqlselect_years = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(YEAR FROM recorded) AS year FROM ps_core_tbl ORDER BY year DESC");
	}
	else
	{
		#############################
		#GRAB DBS FOR SELECTED SERVER
		#############################
		$sqlselect_dbs = @pg_query($pg_conn, "SELECT db_id,db_name FROM ps_db_tbl WHERE server_id = $server_id AND (SELECT COUNT(db_id) FROM ps_core_tbl WHERE ps_db_tbl.db_id = ps_core_tbl.db_id AND server_id = $server_id) > 0 ORDER BY db_name ASC");

		###############################
		#YEAR QUERY FOR SELECTED SERVER
		###############################
		$sqlselect_years = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(YEAR FROM recorded) AS year FROM ps_core_tbl WHERE server_id = $server_id ORDER BY year DESC");
	}

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlselect_dbs || !$sqlselect_years)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	############################
	#CREATE OUR DB LIST DROPDOWN
	############################
	$db_list  = "<select class=\"select_menu\" name=\"yearly_dbs\" id=\"yearly_dbs\" onChange=\"yearly_select_nav_db()\">";
	$db_list .= "<option value=\"0\">All Databases</option>";

	#######################
	#ITERATE THROUGH VALUES
	#######################
	while($query_data_dbs = pg_fetch_row($sqlselect_dbs))
	{
		$db_id = $query_data_dbs[0];
		$db_name = $query_data_dbs[1];
		$db_list .= "<option value=\"$db_id\">$db_name</option>";
	}
	$db_list .= "</select>";

	###############################
	#CURRENT YEAR FOR PRE-SELECTION
	###############################
	$current_year = date('Y');

	####################
	#START THE YEAR LIST
	####################
	$year_list = "<select class=\"select_menu\" name=\"yearly_year\" id=\"yearly_year\">";
	while($query_data_years = pg_fetch_row($sqlselect_years))
	{
		$year = $query_data_years[0];
		if($year == $current_year) { $selected = "selected=\"selected\""; } else { $selected = ""; }
		$year_list .= "<option value=\"$year\" $selected>$year</option>";
	}
	$year_list .= "</select>";

	######################
	#PREP ARRAY FOR RETURN
	######################
	$ajax_return[0] = 1;
	$ajax_return[] = $db_list;
	$ajax_return[] = $year_list;
	$ajax_return = json_encode($ajax_return);

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: YEARLY_SELECT_NAV_DB
##########################################################################################################
##########################################################################################################
function yearly_select_nav_db($server_id,$db_id,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	####################################
	#CREATE RETURN ARRAY FOR JSON VALUES
	####################################
	$ajax_return = array();

	################################
	#DEFAULT SUCCESS VALUE AS FAILED
	################################
	$ajax_return[] = 2;

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");

	#############
	#MAKE CERTAIN
	#############
	if(!$pg_conn)
	{
		$ajax_return[] = "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	####################################################
	#IF NO DB_ID WAS PASSED, GET YEAR VALUES FOR ALL DBS
	####################################################
	if($db_id == 0 || empty($db_id) or $db_id == "0" || !is_numeric($db_id))
	{
		###############
		#THE YEAR QUERY
		###############
		$sqlselect_years = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(YEAR FROM recorded) AS year FROM ps_core_tbl WHERE server_id = $server_id ORDER BY year DESC");
	}
	else
	{
		###############
		#THE YEAR QUERY
		###############
		$sqlselect_years = @pg_query($pg_conn, "SELECT DISTINCT EXTRACT(YEAR FROM recorded) AS year FROM ps_core_tbl WHERE server_id = $server_id AND db_id = $db_id ORDER BY year DESC");
	}

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlselect_years)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	###############################
	#CURRENT YEAR FOR PRE-SELECTION
	###############################
	$current_year = date('Y');

	####################
	#START THE YEAR LIST
	####################
	$year_list  = "<select class=\"select_menu\" name=\"yearly_year\" id=\"yearly_year\">";
	while($query_data_years = pg_fetch_row($sqlselect_years))
	{
		$year = $query_data_years[0];
		if($year == $current_year) { $selected = "selected=\"selected\""; } else { $selected = ""; }
		$year_list .= "<option value=\"$year\" $selected>$year</option>";
	}
	$year_list .= "</select>";

	######################
	#PREP ARRAY FOR RETURN
	######################
	$ajax_return[0] = 1;
	$ajax_return[] = $year_list;
	$ajax_return = json_encode($ajax_return);

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}

##########################################################################################################
##########################################################################################################
#FUNCTION: YEARLY_RETRIEVE
##########################################################################################################
##########################################################################################################
function yearly_retrieve($servers,$dbs,$year,$yearly_chartting,$postgrestats_db_name,$postgrestats_db_user,$postgrestats_db_pass,$postgrestats_db_host,$postgrestats_db_port)
{
	####################################
	#CREATE RETURN ARRAY FOR JSON VALUES
	####################################
	$ajax_return = array();

	################################
	#DEFAULT SUCCESS VALUE AS FAILED
	################################
	$ajax_return[] = 2;

	################
	#CONNECT ATTEMPT
	################
	$pg_conn = @pg_connect("dbname=$postgrestats_db_name user=$postgrestats_db_user password=$postgrestats_db_pass host=$postgrestats_db_host port=$postgrestats_db_port");

	#############
	#MAKE CERTAIN
	#############
	if(!$pg_conn)
	{
		$ajax_return[] = "Error connecting to the PostgreStats database. Please verify your ps_conf.php credentials.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	#######################
	#VALIDATE CHARTTING VAR
	#######################
	if($yearly_chartting != "commits" && $yearly_chartting != "rollbacks" && $yearly_chartting != "block_reads" && $yearly_chartting != "buffer_hits" && $yearly_chartting != "inserts" && $yearly_chartting != "updates" && $yearly_chartting != "deletes" && $yearly_chartting != "seq_scans" && $yearly_chartting != "idx_scans")
	{
		###########################################
		#DEFAULT THE CHART TO SHOWING COMMIT VALUES
		###########################################
		$yearly_chartting = "commits";
	}

	################################
	#VALIDATE OUR SERVER AND DB VARS
	################################
	if(empty($servers) || !is_numeric($servers)) $servers = 0;
	if(empty($dbs) || !is_numeric($dbs)) $dbs = 0;

	##################################
	#CONSTRUCT THE QUERY FOR THIS YEAR
	##################################
	$stat_query  = "SELECT *,EXTRACT(DAY FROM recorded),EXTRACT(MONTH FROM recorded) FROM ps_core_tbl ";
	$stat_query .= "WHERE EXTRACT(YEAR FROM recorded) = $year ";
	if($servers != 0) { $stat_query .= "AND server_id = $servers "; }
	if($dbs != 0) { $stat_query .= "AND db_id = $dbs "; }
	$stat_query .= "ORDER BY recorded ASC";

	#######
	#RUN IT
	#######
	$sqlselect_stats = @pg_query($pg_conn, $stat_query);

	#############
	#MAKE CERTAIN
	#############
	if(!$sqlselect_stats)
	{
		$ajax_return[] = "Error executing PostgreStats query.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;
	}

	###########################
	#IF THERE ARE NO STATISTICS
	###########################
	if(pg_num_rows($sqlselect_stats) == 0)
	{
		$ajax_return[0] = 1;
		$ajax_return[] = "There are no statistics recorded for the above selections.";
		$ajax_return = json_encode($ajax_return);
		echo $ajax_return;
		exit;	
	}

	###############################################################################
	#SET UP SOME DEFAULT VARS AND PREPARE TO START OUT ITERATION THROUGH THE MONTHS
	###############################################################################
	$total_months_tracked = 0;
	$month_flag = "";
	$prev_month_flag = "";
	$day_flag = "";
	$prev_day_flag = "";
	$bar_height_vert = 150;
	$bar_width = 25;
	$peak_stat = 0;
	$peak_month = "";

	#####################
	#BAR CHART COLOR VARS
	#####################
	$bar_vert_alt_color = "#FFFFFF";
	$bar_vert_peak_color = "#FF6633";
	$bar_vert_color = "#7B7B7B";
	$bar_border_color = "#C9C9C9";

	#########
	#IUD VARS
	#########
	$iud_insert_color = "#7B7B7B";
	$iud_update_color = "#C8C8C8";
	$iud_delete_color = "#FFFFFF";
	$iud_nodata_color = "#000000";
	$iud_bar_width = 905;
	$iud_bar_height = 20;

	#####################
	#VARS FOR TOTAL STATS
	#####################
	$total_commits = 0;
	$total_rollbacks = 0;
	$total_block_reads = 0;
	$total_buffer_hits = 0;
	$total_inserts = 0;
	$total_updates = 0;
	$total_deletes = 0;
	$total_seq_scans = 0;
	$total_idx_scans = 0;
	$total_seq_rows = 0;
	$total_idx_rows = 0;

	############################################################
	#VARS WHICH WILL HOUSE THE TOTAL AND HIGHEST STATS PER MONTH
	############################################################
	for($i=1; $i<13; $i++)
	{
		${'total_commits_' . $i} = 0;
		${'total_rollbacks_' . $i} = 0;
		${'total_block_reads_' . $i} = 0;
		${'total_buffer_hits_' . $i} = 0;
		${'total_inserts_' . $i} = 0;
		${'total_updates_' . $i} = 0;
		${'total_deletes_' . $i} = 0;
		${'total_seq_scans_' . $i} = 0;
		${'total_seq_rows_' . $i} = 0;
		${'total_idx_scans_' . $i} = 0;
		${'total_idx_rows_' . $i} = 0;
	}

	#####################################
	#VARS TO HOUSE TRACKED DAYS PER MONTH
	#####################################
	for($i=1; $i<13; $i++)
	{
		${'total_days_tracked_' . $i} = 0;
	}

	####################
	#START OUR ITERATION
	####################
	while($query_data_stats = pg_fetch_row($sqlselect_stats))
	{
		###############
		#GRAB CORE DATA
		###############
		$ps_core_id = $query_data_stats[0];
		$db_id = $query_data_stats[1];
		$server_id = $query_data_stats[2];
		$recorded = $query_data_stats[3];
		$datid = $query_data_stats[4];
		$datname = $query_data_stats[5];
		$core_commits = $query_data_stats[6];
		$core_rollbacks = $query_data_stats[7];
		$core_block_reads = $query_data_stats[8];
		$core_buffer_hits = $query_data_stats[9];
		$user_inserts = $query_data_stats[10];
		$user_updates = $query_data_stats[11];
		$user_deletes = $query_data_stats[12];
		$user_seq_scans = $query_data_stats[13];
		$user_idx_scans = $query_data_stats[14];
		$user_seq_rows = $query_data_stats[15];
		$user_idx_rows = $query_data_stats[16];
		$day_flag = $query_data_stats[17];
		$month_flag = $query_data_stats[18];

		##########################################
		#TALL UP TRACKED MONTHS & UPDATE PREV FLAG
		##########################################
		if($month_flag != $prev_month_flag) $total_months_tracked++;
		if($day_flag != $prev_day_flag) ${'total_days_tracked_' . $month_flag} ++;
		$prev_month_flag = $month_flag;
		$prev_day_flag = $day_flag;

		################
		#TALLY UP TOTALS
		################
		$total_commits += $core_commits;
		$total_rollbacks += $core_rollbacks;
		$total_block_reads += $core_block_reads;
		$total_buffer_hits += $core_buffer_hits;
		$total_inserts += $user_inserts;
		$total_updates += $user_updates;
		$total_deletes += $user_deletes;
		$total_seq_scans += $user_seq_scans;
		$total_idx_scans += $user_idx_scans;
		$total_seq_rows += $user_seq_rows;
		$total_idx_rows += $user_idx_rows;

		###############################
		#TALLY UP OUR MONTH TOTAL STATS
		###############################
		${'total_commits_' . $month_flag} += $core_commits;
		${'total_rollbacks_' . $month_flag} += $core_rollbacks;
		${'total_block_reads_' . $month_flag} += $core_block_reads;
		${'total_buffer_hits_' . $month_flag} += $core_buffer_hits;
		${'total_inserts_' . $month_flag} += $user_inserts;
		${'total_updates_' . $month_flag} += $user_updates;
		${'total_deletes_' . $month_flag} += $user_deletes;
		${'total_seq_scans_' . $month_flag} += $user_seq_scans;
		${'total_idx_scans_' . $month_flag} += $user_idx_scans;
		${'total_seq_rows_' . $month_flag} += $user_seq_rows;
		${'total_idx_rows_' . $month_flag} += $user_idx_rows;
	}

	################################
	#START CREATING OUR INITIAL HTML
	################################
$stats = <<<AJR
<div class="stat_div_bg">
<div class="orange_13" style="font-weight:bold; margin:0 0 10px 0;">Target Statistics:</div>
<table class="table_chart" style="width:auto;">
<tr>
AJR;

	########################################################
	#IDENTIFY OUR PEAK STAT MONTH FOR CALCULATING BARS LATER
	########################################################
	for($i=1; $i<13; $i++)
	{
		if(${'total_' . $yearly_chartting . '_' . $i} > $peak_stat)
		{
			################################
			#RECORD PEAK STAT AND MONTH FLAG
			################################
			$peak_stat = ${'total_' . $yearly_chartting . '_' . $i};
			$peak_month = $i;
		}
	}

	#####################################################################################
	#PUT TOGETHER THE MONTH TABLEWORK - ITERATING THROUGH OUR DB VARS - CHECKING EACH DAY
	#####################################################################################
	for($i=1; $i<13; $i++)
	{
		################################
		#INITIATE/RESET VARS IN THE LOOP
		################################
		$tooltip = "";
		$bar_height_percent = 0;
		$bar_height = 0;
		$bar_height_final = 0;
		$bar_height_alt = 0;

		#####################
		#CHECK EACH MONTH NOW
		#####################
		if(${"total_" . $yearly_chartting . "_" . $i} <= 0)
		{
			############################
			#HANDLE DAYS WITH ZERO STATS
			############################
			$bar_height_alt = $bar_height_vert;
		}
		else
		{
			##################################
			#FIRST PREP OUR COMMIT TOOLTIP VAR
			##################################
			$tt_commits = ${"total_commits_$i"};
			if($tt_commits == 0 || empty($tt_commits)) $tt_commits = "0";
			else $tt_commits = number_format($tt_commits);
			
			###############################
			#PREP OUR ROLLBACKS TOOLTIP VAR
			###############################
			$tt_rollbacks = ${"total_rollbacks_$i"};
			if($tt_rollbacks == 0 || empty($tt_rollbacks)) $tt_rollbacks = "0";
			else $tt_rollbacks = number_format($tt_rollbacks);
			
			#################################
			#PREP OUR BLOCK READS TOOLTIP VAR
			#################################
			$tt_block_reads = ${"total_block_reads_$i"};
			if($tt_block_reads == 0 || empty($tt_block_reads)) $tt_block_reads = "0";
			else $tt_block_reads = number_format($tt_block_reads);
			
			#################################
			#PREP OUR BUFFER HITS TOOLTIP VAR
			#################################
			$tt_buffer_hits = ${"total_buffer_hits_$i"};
			if($tt_buffer_hits == 0 || empty($tt_buffer_hits)) $tt_buffer_hits = "0";
			else $tt_buffer_hits = number_format($tt_buffer_hits);

			############################
			#PREP OUR INSERT TOOLTIP VAR
			############################
			$tt_inserts = ${"total_inserts_$i"};
			if($tt_inserts == 0 || empty($tt_inserts)) $tt_inserts = "0";
			else $tt_inserts = number_format($tt_inserts);
			
			############################
			#PREP OUR UPDATE TOOLTIP VAR
			############################
			$tt_updates = ${"total_updates_$i"};
			if($tt_updates == 0 || empty($tt_updates)) $tt_updates = "0";
			else $tt_updates = number_format($tt_updates);
			
			############################
			#PREP OUR DELETE TOOLTIP VAR
			############################
			$tt_deletes = ${"total_deletes_$i"};
			if($tt_deletes == 0 || empty($tt_deletes)) $tt_deletes = "0";
			else $tt_deletes = number_format($tt_deletes);

			####################################
			#PREP OUR SEQUENCE SCANS TOOLTIP VAR
			####################################
			$tt_seq_scans = ${"total_seq_scans_$i"};
			if($tt_seq_scans == 0 || empty($tt_seq_scans)) $tt_seq_scans = "0";
			else $tt_seq_scans = number_format($tt_seq_scans);
			
			#################################
			#PREP OUR INDEX SCANS TOOLTIP VAR
			#################################
			$tt_idx_scans = ${"total_idx_scans_$i"};
			if($tt_idx_scans == 0 || empty($tt_idx_scans)) $tt_idx_scans = "0";
			else $tt_idx_scans = number_format($tt_idx_scans);

			################
			#PUT IT TOGETHER
			################
			$tooltip = "<div style=line-height:17px;>";

			########
			#COMMITS
			########
			if($yearly_chartting == "commits") $tooltip .= "<span class=orange_12><strong>Commits:&nbsp;" . $tt_commits . "</strong></span><br>";
			else $tooltip .= "Commits:&nbsp;<strong>" . $tt_commits . "</strong>" . "<br>";

			##########
			#ROLLBACKS
			##########
			if($yearly_chartting == "rollbacks") $tooltip .= "<span class=orange_12><strong>Rollbacks:&nbsp;" . $tt_rollbacks . "</strong></span><br>";
			else $tooltip .= "Rollbacks:&nbsp;<strong>" . $tt_rollbacks . "</strong>" . "<br>";

			############
			#BLOCK READS
			############
			if($yearly_chartting == "block_reads") $tooltip .= "<span class=orange_12><strong>Block&nbsp;Reads:&nbsp;" . $tt_block_reads . "</strong></span><br>";
			else $tooltip .= "Block&nbsp;Reads:&nbsp;<strong>" . $tt_block_reads . "</strong>" . "<br>";

			############
			#BUFFER HITS
			############
			if($yearly_chartting == "buffer_hits") $tooltip .= "<span class=orange_12><strong>Buffer&nbsp;Hits:&nbsp;" . $tt_buffer_hits . "</strong></span><br>";
			else $tooltip .= "Buffer&nbsp;Hits:&nbsp;<strong>" . $tt_buffer_hits . "</strong>" . "<br>";

			########
			#INSERTS
			########
			if($yearly_chartting == "inserts") $tooltip .= "<span class=orange_12><strong>Inserts:&nbsp;" . $tt_inserts . "</strong></span><br>";
			else $tooltip .= "Inserts:&nbsp;<strong>" . $tt_inserts . "</strong>" . "<br>";

			########
			#UPDATES
			########
			if($yearly_chartting == "updates") $tooltip .= "<span class=orange_12><strong>Updates:&nbsp;" . $tt_updates . "</strong></span><br>";
			else $tooltip .= "Updates:&nbsp;<strong>" . $tt_updates . "</strong>" . "<br>";

			########
			#DELETES
			########
			if($yearly_chartting == "deletes") $tooltip .= "<span class=orange_12><strong>Deletes:&nbsp;" . $tt_deletes . "</strong></span><br>";
			else $tooltip .= "Deletes:&nbsp;<strong>" . $tt_deletes . "</strong>" . "<br>";

			##########
			#SEQ SCANS
			##########
			if($yearly_chartting == "seq_scans") $tooltip .= "<span class=orange_12><strong>Sequence&nbsp;Scans:&nbsp;" . $tt_seq_scans . "</strong></span><br>";
			else $tooltip .= "Sequence&nbsp;Scans:&nbsp;<strong>" . $tt_seq_scans . "</strong>" . "<br>";

			##########
			#IDX SCANS
			##########
			if($yearly_chartting == "idx_scans") $tooltip .= "<span class=orange_12><strong>Index&nbsp;Scans:&nbsp;" . $tt_idx_scans . "</strong></span><br>";
			else $tooltip .= "Index&nbsp;Scans:&nbsp;<strong>" . $tt_idx_scans . "</strong>" . "<br>";

			#########################
			#COMPLETE THE TOOLTIP DIV
			#########################
			$tooltip .= "</div>";

			#############################################################
			#GET THE PERCENTAGE NOW SO WE CAN PUT OUR BAR / DATA TOGETHER
			#############################################################
			if(!empty($peak_stat))
			{
				$stat_percent = ${'total_' . $yearly_chartting . '_' . $i} / $peak_stat;
				$bar_height_percent = $stat_percent;
			}
			else
			{
				$bar_height_percent = 0;
			}

			#################################
			#COMPLETE OUR MATH FOR THE HEIGHT
			#################################
			$bar_height = $bar_height_vert * $bar_height_percent;
			$bar_height_final = number_format($bar_height, 0, '.', '');

			############################
			#CHECK THE HEIGHT - FOR SAFE
			############################
			if($bar_height_final > $bar_height_vert) $bar_height_final = $bar_height_vert;

			####################################################################################
			#CREATE THE HEIGHT FOR THE ALT LIGHT GREY BAR WHICH SITS ON TOP OF THE DARK GREY BAR
			####################################################################################
			$bar_height_alt = $bar_height_vert - $bar_height_final;

			###########################################################
			#HANDLE THE FINAL SOURCE GRAPHIC AND CHECK FOR THE PEAK DAY
			###########################################################
			if($peak_stat == ${'total_' . $yearly_chartting . '_' . $i}) $bar_vert_color_final = $bar_vert_peak_color;
			else $bar_vert_color_final = $bar_vert_color;
		}

		$stats .= "<td align='center' valign='bottom' width=\"30\">";
		
		#######################################################
		#START UP THE TABLEWORK WHICH WILL HOUSE THE BAR ITSELF
		#######################################################
		$stats .= "<table>";
		
		############################
		#DETERMINE BORDER STYLES NOW
		############################
		$bar_border = "border:1px solid $bar_border_color;";
		if($bar_height_final <= 0) $bar_alt_border = "border:1px solid $bar_border_color;";
		else $bar_alt_border = "border-color:$bar_border_color; border-width:1px 1px 0px 1px; border-style:solid;";

		#####################################################################################
		#HANDLE THE ALT COLOR - WILL EITHER BE THE ENTIRE BAR (NO DATA) OR THE TOP OF THE BAR
		#####################################################################################
		if($bar_height_alt > 0)
		{
			#############################
			#CREATE FINAL CELL DIMENSIONS
			#############################
			$bar_width_px = $bar_width . "px";
			$bar_height_alt_px = $bar_height_alt . "px";

			#############
			#DISPLAY CELL
			#############
			$stats .= "<tr><td style=\"width:$bar_width_px; height:$bar_height_alt_px; background-color:$bar_vert_alt_color; $bar_alt_border\"></td></tr>";
		}

		################################################
		#HANDLE THE BOTTOM OF THE BAR WHERE WE HAVE DATA
		################################################
		if($bar_height_final > 0)
		{
			#############################
			#CREATE FINAL CELL DIMENSIONS
			#############################
			$bar_width_px = $bar_width . "px";
			$bar_height_final_px = $bar_height_final . "px";

			#############
			#DISPLAY CELL
			#############
			$stats .= "<tr><td style=\"width:$bar_width_px; height:$bar_height_final_px; background-color:$bar_vert_color_final; $bar_border\" onMouseOver=\"tooltip.show('$tooltip')\" onMouseOut='tooltip.hide()'></td></tr>";
		}

		$stats .= "</table>";
	}

########################################
#THE ACTUAL TABLEWORK FOR THE RIGHT SIDE
########################################
$stats .= <<<AJR
</td>
</tr>
<tr>
AJR;

	###############################################################################################
	#CREATE THE MONTH NUMBERS AND IF THERE ARE COMMITS FOR EACH DAY - MAKE A QUICK LINK TO THAT DAY
	###############################################################################################
	for($i=1; $i<13; $i++)
	{
		switch($i)
		{
			case 1: $month = "Jan"; break;
			case 2: $month = "Feb"; break;
			case 3: $month = "Mar"; break;
			case 4: $month = "Apr"; break;
			case 5: $month = "May"; break;
			case 6: $month = "Jun"; break;
			case 7: $month = "Jul"; break;
			case 8: $month = "Aug"; break;
			case 9: $month = "Sep"; break;
			case 10: $month = "Oct"; break;
			case 11: $month = "Nov"; break;
			case 12: $month = "Dec"; break;
		}

		#######################
		#HANDLE THE TOOLTIP MSG
		#######################
		$tooltip = "Retrieve&nbsp;Stats";
		$stats .= "<td style=\"text-align:center; padding-top:5px;\">";

		##################################################
		#CHECK STAT AND SET QUICK LINK TO MONTHLY SNAPSHOT
		##################################################
		if(${"total_" . $yearly_chartting . "_" . $i} > 0)
		{
			if(strlen($i) == 1) { $month_link = "0$i"; } else { $month_link = $i; }
			$stats .= "<span onMouseOver=\"tooltip.show('$tooltip')\" onMouseOut='tooltip.hide()'><a href=javascript:monthly_snap_retrieve('$month_link','$year')>$month</a></span>";
		}
		else
		{
			$stats .= $month;
		}

		$stats .= "</td>";
	}

#######################################
#TARGET STATS COMPLETE - FINISH UP HTML
#######################################
$stats .= <<<AJR
</tr>
</table>
</div>
AJR;

	##############################
	#PUT TOGETHER RECAP STATISTICS
	##############################
	$recap_average_month = ${'total_' . $yearly_chartting} / $total_months_tracked;
	$recap_average_month = number_format($recap_average_month, 0, '', ',');
	$recap_peak = number_format(${'total_' . $yearly_chartting . "_" . $peak_month}, 0, '', ',');
	$recap_total = number_format(${'total_' . $yearly_chartting});

	###################################################################
	#CAPS THE FIRST LETTER IN THE YEARLY_CHARTTING VAR FOR A NICE TITLE
	###################################################################
	switch($yearly_chartting)
	{
		case "commits"; $stat_title = "Commits"; break;
		case "rollbacks"; $stat_title = "Roll&nbsp;Backs"; break;
		case "block_reads"; $stat_title = "Block&nbsp;Reads"; break;
		case "buffer_hits"; $stat_title = "Buffer&nbsp;Hits"; break;
		case "inserts"; $stat_title = "Inserts"; break;
		case "updates"; $stat_title = "Updates"; break;
		case "deletes"; $stat_title = "Deletes";
		case "seq_scans"; $stat_title = "SEQ&nbsp;Scans"; break;
		case "idx_scans"; $stat_title = "IDX&nbsp;Scans";
	}

	###########################################
	#CREATE A FRIENDLY TITLE FOR THE PEAK MONTH
	###########################################
	$recap_peak_month = "";
	switch($peak_month)
	{
		case "1": $recap_peak_month = "January"; break;
		case "2": $recap_peak_month = "February"; break;
		case "3": $recap_peak_month = "March"; break;
		case "4": $recap_peak_month = "April"; break;
		case "5": $recap_peak_month = "May"; break;
		case "6": $recap_peak_month = "June"; break;
		case "7": $recap_peak_month = "July"; break;
		case "8": $recap_peak_month = "August"; break;
		case "9": $recap_peak_month = "September"; break;
		case "10": $recap_peak_month = "October"; break;
		case "11": $recap_peak_month = "November"; break;
		case "12": $recap_peak_month = "December";
	}

	#########################
	#START HTML FOR RECAP DIV
	#########################
	$stats .= "<div class=\"stat_div_bg\" style=\"margin:20px 0 20px 0;\">";

############
#RECAP TOTAL
############
$stats .= <<<AJR
<div class="orange_13" style="font-weight:bold; margin:0 0 10px 0;">Statistics Overview:&nbsp;</div>
<div class="black_12" style="padding:10px; float:left; border:1px solid $bar_border_color; background-color:#FFFFFF;"><span style="font-weight:bold;">Total $stat_title:&nbsp;</span>$recap_total</div>
AJR;

#################
#RECAP PEAK MONTH
#################
$stats .= <<<AJR
<div class="black_12" style="margin-left:5px; padding:10px; float:left; border:1px solid $bar_border_color; background-color:#FFFFFF;"><span style="font-weight:bold;">Peak Month:&nbsp;</span> 
AJR;
	
	if(strlen($peak_month == 1)) $peak_month = "0$peak_month";
	if($recap_peak > 0) $stats .= "<a href=javascript:monthly_snap_retrieve('$peak_month','$year')>$recap_peak_month</a> / $recap_peak";
	else $stats .= "N/A";
	$stats .= "</div>";

###################
#SHOW AVERAGE / DAY
###################
$stats .= <<<AJR
<div class="black_12" style="margin-left:5px; padding:10px; float:left; border:1px solid $bar_border_color; background-color:#FFFFFF;"><span style="font-weight:bold;">Average / Month:&nbsp;</span>
AJR;

	if($recap_average_month > 0) $stats .= $recap_average_month;
	else $stats .= "N/A";
	$stats .= "</div>";

	############
	#CLAR FLOATS
	############
	$stats .= "<div style=\"clear:both;\"></div>";

	##########################
	#END OF OF RECAP STATS DIV
	##########################
	$stats .= "</div>";

#################
#START OF IUD DIV
#################
$stats .= <<<AJR
<div class="stat_div_bg" style="margin:0 0 20px 0;">
<div class="orange_13" style="font-weight:bold; margin:0 0 10px 0;">Insert / Update / Delete Quick View:</div>
AJR;

	##############################################################
	#PUT TOGETHER OUR IUD STATS - FIRST INITIATE SOME GENERAL VARS
	##############################################################
	$total_iud = $total_inserts + $total_updates + $total_deletes;

	##############################################
	#GET THE PERCENTAGES OF EACH AGAINST THE TOTAL
	##############################################
	if(!empty($total_iud)) { $iud_ins_percent = number_format($total_inserts / $total_iud, 2, '.', ','); } else { $iud_ins_percent = 0; }
	if(!empty($total_iud)) { $iud_upd_percent = number_format($total_updates / $total_iud, 2, '.', ','); } else { $iud_upd_percent = 0; }
	if(!empty($total_iud)) { $iud_del_percent = number_format($total_deletes / $total_iud, 2, '.', ','); } else { $iud_del_percent = 0; }

	#################################################
	#PREPARE THE BAR WIDTHS AND ROUND THE NUMBERS OUT
	#################################################
	$iud_ins_bar_w = number_format($iud_bar_width * $iud_ins_percent);
	$iud_upd_bar_w = number_format($iud_bar_width * $iud_upd_percent);
	$iud_del_bar_w = number_format($iud_bar_width * $iud_del_percent);

	#######################################################################################################
	#TALLY UP THE WIDTHS AND TAKE ANY NOMINAL REMAINDER +/- IUD_BAR_WIDTH AND +/- IT FROM THE LARGEST SCORE
	#######################################################################################################
	$iud_bar_total = $iud_ins_bar_w + $iud_upd_bar_w + $iud_del_bar_w;

	if($iud_bar_total < $iud_bar_width && $iud_bar_total > 0) 
	{
		###################
		#GET THE DIFFERENCE
		###################
		$iud_remain = $iud_bar_width-$iud_bar_total;

		############################
		#ADD IT TO HIGHEST IUD SCORE
		############################
		if($total_inserts > $total_updates && $total_inserts > $total_deletes) $iud_ins_bar_w += $iud_remain;
		elseif($total_updates > $total_inserts && $total_updates > $total_deletes) $iud_upd_bar_w += $iud_remain;
		else $iud_del_bar_w += $iud_remain;
	}
	elseif($iud_bar_total > $iud_bar_width) 
	{
		###################
		#GET THE DIFFERENCE
		###################
		$iud_remain = $iud_bar_total-$iud_bar_width;

		###################################
		#SUBTRACT IT FROM HIGHEST IUD SCORE
		###################################
		if($total_inserts > $total_updates && $total_inserts > $total_deletes) $iud_ins_bar_w -= $iud_remain;
		elseif($total_updates > $total_inserts && $total_updates > $total_deletes) $iud_upd_bar_w -= $iud_remain;
		else $iud_del_bar_w -= $iud_remain;
	}

	##################################
	#PUT TOGETHER OUR IUD TOOLTIP VARS
	##################################
	$iud_tt_ins = "<div style=line-height:17px;>";
	$iud_tt_ins .= "Total Inserts:&nbsp;<strong class=orange_12>" . number_format($total_inserts) . "</strong>";
	$iud_tt_ins .= "</div>";

	$iud_tt_upd = "<div style=line-height:17px;>";
	$iud_tt_upd .= "Total Updates:&nbsp;<strong class=orange_12>" . number_format($total_updates) . "</strong>";
	$iud_tt_upd .= "</div>";

	$iud_tt_del = "<div style=line-height:17px;>";
	$iud_tt_del .= "Total Deletes:&nbsp;<strong class=orange_12>" . number_format($total_deletes) . "</strong>";
	$iud_tt_del .= "</div>";

	###########################################################################################
	#SHOW EITHER THE THREE IUD BARS TOGETHER OR THE DEFAULT NO-DATA BAR IF THERE IS NO IUD DATA
	###########################################################################################

	#####################
	#PREP CELL DIMENSIONS
	#####################
	$iud_bar_width_px = $iud_bar_width . "px";
	$iud_bar_height_px = $iud_bar_height . "px";

	################
	#BEGIN TABLEWORK
	################
	$stats .= "<table style=\"width:$iud_bar_width_px; max-width:$iud_bar_width_px;\">";
	$stats .= "<tr>";

	if($total_iud > 0)
	{
		###########
		#INSERT BAR
		###########
		if($iud_ins_bar_w > 0)
		{
			$ins_border = "border:1px solid $bar_border_color;";
			$iud_ins_bar_w_px = $iud_ins_bar_w . "px";
			$stats .= "<td style=\"width:$iud_ins_bar_w_px; height:$iud_bar_height_px; background-color:$iud_insert_color; $ins_border\" onMouseOver=\"tooltip.show('$iud_tt_ins')\" onMouseOut='tooltip.hide()'></td>";
		}

		###########
		#UPDATE BAR
		###########
		if($iud_upd_bar_w > 0)
		{
			if($iud_ins_bar_w > 0) $upd_border = "border-color:$bar_border_color; border-width:1px 1px 1px 0px; border-style:solid;";
			else $upd_border = "border:1px solid $bar_border_color;";
			$iud_upd_bar_w_px = $iud_upd_bar_w . "px";
			$stats .= "<td style=\"width:$iud_upd_bar_w_px; height:$iud_bar_height_px; background-color:$iud_update_color; $upd_border\" onMouseOver=\"tooltip.show('$iud_tt_upd')\" onMouseOut='tooltip.hide()'></td>";
		}

		###########
		#DELETE BAR
		###########
		if($iud_del_bar_w > 0) 
		{
			if($iud_upd_bar_w > 0 || $iud_ins_bar_w > 0) $del_border = "border-color:$bar_border_color; border-width:1px 1px 1px 0px; border-style:solid;";
			else $del_border = "border:1px solid $bar_border_color;";
			$iud_del_bar_w_px = $iud_del_bar_w . "px";
			$stats .= "<td style=\"width:$iud_del_bar_w_px; height:$iud_bar_height_px; background-color:$iud_delete_color; $del_border\" onMouseOver=\"tooltip.show('$iud_tt_del')\" onMouseOut='tooltip.hide()'></td>";
		}
	}
	else
	{
		##################################
		#DEFAULT THE NO-DATA BAR AND WIDTH
		##################################
		$stats .= "<td style=\"width:$iud_bar_width_px; height:$iud_bar_height_px; background-color:$iud_nodata_color; border:1px solid $bar_border_color;\" onMouseOver=\"tooltip.show('No data to report.')\" onMouseOut='tooltip.hide()'></td>";
	}

	##############################################
	#COMPLETE OUR HTML TABLE WORK FOR THE IUD AREA
	##############################################
	$stats .= "</tr>";
	$stats .= "</table>";

##################
#CREATE IUD LEGEND
##################
$stats .= <<<AJR
<div class="grey_12" style="margin:15px 0 0 0;">
<div style="float:left; height:15px; width:15px; background-color:$iud_nodata_color; border:1px solid $bar_border_color; margin-right:5px;"></div>
<div style="float:left; height:15px; margin-right:10px;">No Data</div>
<div style="float:left; height:15px; width:15px; background-color:$iud_insert_color; border:1px solid $bar_border_color; margin-right:5px;"></div>
<div style="float:left; height:15px; margin-right:10px;">Inserts</div>
<div style="float:left; height:15px; width:15px; background-color:$iud_update_color; border:1px solid $bar_border_color; margin-right:5px;"></div>
<div style="float:left; height:15px; margin-right:10px;">Updates</div>
<div style="float:left; height:15px; width:15px; background-color:$iud_delete_color; border:1px solid $bar_border_color; margin-right:5px;"></div>
<div style="float:left; height:15px; margin-right:10px;">Deletes</div>
<div style="clear:both;"></div>
</div>
AJR;

	##################
	#COMPLETE IUD AREA
	##################
	$stats .= "</div>";

####################################
#START THE CORE STATISTICS DIV BELOW
####################################
$stats .= <<<AJR
<div class="stat_div_bg">
<div class="orange_13" style="font-weight:bold; margin:0 0 10px 0;">Core Statistics:</div>
AJR;

	#########################################
	#FORMAT ALL OF THE MONTH VARS DYNAMICALLY
	#########################################
	for($i=1; $i<13; $i++)
	{
		${'total_commits_' . $i} = number_abbr(${'total_commits_' . $i},1);
		${'total_rollbacks_' . $i} = number_abbr(${'total_rollbacks_' . $i},1);
		${'total_block_reads_' . $i} = number_abbr(${'total_block_reads_' . $i},1);
		${'total_buffer_hits_' . $i} = number_abbr(${'total_buffer_hits_' . $i},1);
		${'total_inserts_' . $i} = number_abbr(${'total_inserts_' . $i},1);
		${'total_updates_' . $i} = number_abbr(${'total_updates_' . $i},1);
		${'total_deletes_' . $i} = number_abbr(${'total_deletes_' . $i},1);
		${'total_seq_scans_' . $i} = number_abbr(${'total_seq_scans_' . $i},1);
		${'total_idx_scans_' . $i} = number_abbr(${'total_idx_scans_' . $i},1);
		${'total_seq_rows_' . $i} = number_abbr(${'total_seq_rows_' . $i},1);
		${'total_idx_rows_' . $i} = number_abbr(${'total_idx_rows_' . $i},1);
	}

	###################################################
	#FORMAT THE REST OF OUR VARS FOR THE BOTTOM SECTION
	###################################################
	$total_commits = number_abbr($total_commits,3);
	$total_rollbacks = number_abbr($total_rollbacks,3);
	$total_block_reads = number_abbr($total_block_reads,3);
	$total_buffer_hits = number_abbr($total_buffer_hits,3);
	$total_inserts = number_abbr($total_inserts,3);
	$total_updates = number_abbr($total_updates,3);
	$total_deletes = number_abbr($total_deletes,3);
	$total_seq_scans = number_abbr($total_seq_scans,3);
	$total_idx_scans = number_abbr($total_idx_scans,3);
	$total_seq_rows = number_abbr($total_seq_rows,3);
	$total_idx_rows = number_abbr($total_idx_rows,3);

$stats .= <<<AJR
<table style="width:100%">
<tr>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Statistic</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Jan</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Feb</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Mar</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Apr</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">May</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Jun</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Jul</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Aug</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Sep</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Oct</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Nov</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Dec</td>
<td class="black_12" style="padding-bottom:10px; font-weight:bold;">Combined</td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">Commits:</td>
<td>$total_commits_1</td>
<td>$total_commits_2</td>
<td>$total_commits_3</td>
<td>$total_commits_4</td>
<td>$total_commits_5</td>
<td>$total_commits_6</td>
<td>$total_commits_7</td>
<td>$total_commits_8</td>
<td>$total_commits_9</td>
<td>$total_commits_10</td>
<td>$total_commits_11</td>
<td>$total_commits_12</td>
<td class="orange_12" style="font-weight:bold;">$total_commits</td>
</tr>
<tr>
<td colspan="14" style="height:30px;"><hr size="1"/></td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">Rollbacks:</td>
<td>$total_rollbacks_1</td>
<td>$total_rollbacks_2</td>
<td>$total_rollbacks_3</td>
<td>$total_rollbacks_4</td>
<td>$total_rollbacks_5</td>
<td>$total_rollbacks_6</td>
<td>$total_rollbacks_7</td>
<td>$total_rollbacks_8</td>
<td>$total_rollbacks_9</td>
<td>$total_rollbacks_10</td>
<td>$total_rollbacks_11</td>
<td>$total_rollbacks_12</td>
<td class="orange_12" style="font-weight:bold;">$total_rollbacks</td>
</tr>
<tr>
<td colspan="14" style="height:30px;"><hr size="1"/></td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">Block&nbsp;Reads:</td>
<td>$total_block_reads_1</td>
<td>$total_block_reads_2</td>
<td>$total_block_reads_3</td>
<td>$total_block_reads_4</td>
<td>$total_block_reads_5</td>
<td>$total_block_reads_6</td>
<td>$total_block_reads_7</td>
<td>$total_block_reads_8</td>
<td>$total_block_reads_9</td>
<td>$total_block_reads_10</td>
<td>$total_block_reads_11</td>
<td>$total_block_reads_12</td>
<td class="orange_12" style="font-weight:bold;">$total_block_reads</td>
</tr>
<tr>
<td colspan="14" style="height:30px;"><hr size="1"/></td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">Buffer&nbsp;Hits:</td>
<td>$total_buffer_hits_1</td>
<td>$total_buffer_hits_2</td>
<td>$total_buffer_hits_3</td>
<td>$total_buffer_hits_4</td>
<td>$total_buffer_hits_5</td>
<td>$total_buffer_hits_6</td>
<td>$total_buffer_hits_7</td>
<td>$total_buffer_hits_8</td>
<td>$total_buffer_hits_9</td>
<td>$total_buffer_hits_10</td>
<td>$total_buffer_hits_11</td>
<td>$total_buffer_hits_12</td>
<td class="orange_12" style="font-weight:bold;">$total_buffer_hits</td>
</tr>
<tr>
<td colspan="14" style="height:30px;"><hr size="1"/></td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">User&nbsp;Inserts:</td>
<td>$total_inserts_1</td>
<td>$total_inserts_2</td>
<td>$total_inserts_3</td>
<td>$total_inserts_4</td>
<td>$total_inserts_5</td>
<td>$total_inserts_6</td>
<td>$total_inserts_7</td>
<td>$total_inserts_8</td>
<td>$total_inserts_9</td>
<td>$total_inserts_10</td>
<td>$total_inserts_11</td>
<td>$total_inserts_12</td>
<td class="orange_12" style="font-weight:bold;">$total_inserts</td>
</tr>
<tr>
<td colspan="14" style="height:30px;"><hr size="1"/></td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">User&nbsp;Updates:</td>
<td>$total_updates_1</td>
<td>$total_updates_2</td>
<td>$total_updates_3</td>
<td>$total_updates_4</td>
<td>$total_updates_5</td>
<td>$total_updates_6</td>
<td>$total_updates_7</td>
<td>$total_updates_8</td>
<td>$total_updates_9</td>
<td>$total_updates_10</td>
<td>$total_updates_11</td>
<td>$total_updates_12</td>
<td class="orange_12" style="font-weight:bold;">$total_updates</td>
</tr>
<tr>
<td colspan="14" style="height:30px;"><hr size="1"/></td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">User&nbsp;Deletes:</td>
<td>$total_deletes_1</td>
<td>$total_deletes_2</td>
<td>$total_deletes_3</td>
<td>$total_deletes_4</td>
<td>$total_deletes_5</td>
<td>$total_deletes_6</td>
<td>$total_deletes_7</td>
<td>$total_deletes_8</td>
<td>$total_deletes_9</td>
<td>$total_deletes_10</td>
<td>$total_deletes_11</td>
<td>$total_deletes_12</td>
<td class="orange_12" style="font-weight:bold;">$total_deletes</td>
</tr>
<tr>
<td colspan="14" style="height:30px;"><hr size="1"/></td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">SEQ&nbsp;Scans:</td>
<td>$total_seq_scans_1</td>
<td>$total_seq_scans_2</td>
<td>$total_seq_scans_3</td>
<td>$total_seq_scans_4</td>
<td>$total_seq_scans_5</td>
<td>$total_seq_scans_6</td>
<td>$total_seq_scans_7</td>
<td>$total_seq_scans_8</td>
<td>$total_seq_scans_9</td>
<td>$total_seq_scans_10</td>
<td>$total_seq_scans_11</td>
<td>$total_seq_scans_12</td>
<td class="orange_12" style="font-weight:bold;">$total_seq_scans</td>
</tr>
<tr>
<td class="grey_12" style="padding-right:10px;">Rows&nbsp;Used:</td>
<td class="grey_lt_12">$total_seq_rows_1</td>
<td class="grey_lt_12">$total_seq_rows_2</td>
<td class="grey_lt_12">$total_seq_rows_3</td>
<td class="grey_lt_12">$total_seq_rows_4</td>
<td class="grey_lt_12">$total_seq_rows_5</td>
<td class="grey_lt_12">$total_seq_rows_6</td>
<td class="grey_lt_12">$total_seq_rows_7</td>
<td class="grey_lt_12">$total_seq_rows_8</td>
<td class="grey_lt_12">$total_seq_rows_9</td>
<td class="grey_lt_12">$total_seq_rows_10</td>
<td class="grey_lt_12">$total_seq_rows_11</td>
<td class="grey_lt_12">$total_seq_rows_12</td>
<td class="grey_lt_12" style="font-weight:bold;">$total_seq_rows</td>
</tr>
<tr>
<td colspan="14" style="height:30px;"><hr size="1"/></td>
</tr>
<tr>
<td class="orange_12" style="padding-right:10px; font-weight:bold;">IDX&nbsp;Scans:</td>
<td>$total_idx_scans_1</td>
<td>$total_idx_scans_2</td>
<td>$total_idx_scans_3</td>
<td>$total_idx_scans_4</td>
<td>$total_idx_scans_5</td>
<td>$total_idx_scans_6</td>
<td>$total_idx_scans_7</td>
<td>$total_idx_scans_8</td>
<td>$total_idx_scans_9</td>
<td>$total_idx_scans_10</td>
<td>$total_idx_scans_11</td>
<td>$total_idx_scans_12</td>
<td class="orange_12" style="font-weight:bold;">$total_idx_scans</td>
</tr>
<tr>
<td class="grey_12" style="padding-right:10px;">Rows&nbsp;Used:</td>
<td class="grey_lt_12">$total_idx_rows_1</td>
<td class="grey_lt_12">$total_idx_rows_2</td>
<td class="grey_lt_12">$total_idx_rows_3</td>
<td class="grey_lt_12">$total_idx_rows_4</td>
<td class="grey_lt_12">$total_idx_rows_5</td>
<td class="grey_lt_12">$total_idx_rows_6</td>
<td class="grey_lt_12">$total_idx_rows_7</td>
<td class="grey_lt_12">$total_idx_rows_8</td>
<td class="grey_lt_12">$total_idx_rows_9</td>
<td class="grey_lt_12">$total_idx_rows_10</td>
<td class="grey_lt_12">$total_idx_rows_11</td>
<td class="grey_lt_12">$total_idx_rows_12</td>
<td class="grey_lt_12" style="font-weight:bold;">$total_idx_rows</td>
</tr>
</table>
AJR;

	#################################
	#COMPLETE THE CORE STATISTICS DIV
	#################################
	$stats .= "</div>";

	#############################
	#GET TOTAL SCRIPT PEAK MEMORY
	#############################
	$script_mem = number_format(((memory_get_peak_usage(true)/1024)/1024),3) . "M";

	######################
	#PREP ARRAY FOR RETURN
	######################
	$ajax_return[0] = 1;
	$ajax_return[] = $stats;
	$ajax_return[] = $script_mem;
	$ajax_return = json_encode($ajax_return);

	#######################################
	#RETURN IT ALL TO THE AJAX RESPONSE VAR
	#######################################
	echo $ajax_return;
	exit;
}
?>